/* RAFX */
version = '1.31d'

arg input, dir._prg
numeric digits 12

call prg_init_1
call check_arg            /* Kommandozeilenargumente prfen */
call read_prg_cfg         /* Konfiguration einlesen */
call open_logfile_sem     /* Logfile und Semaphore ffnen */
call read_squish_cfg      /* Squish-Cfg einlesen */
call prg_init_2
call check_idx            /* Index-Files/Area-Listen testen */
call expand_def_groups
call prg_init_3
call sq_init def._zone    /* RSQA initialisieren */

select
  when opt._nop
    then nop
  when opt._init_ptr
    then call init_ptr 1  /* LR-Pointer setzen */
  otherwise
    if opt._set_area > 0
      then call set_area_data
    if opt._rule_idx
      then call make_rule_idx

    if opt._autokill_days | opt._autokill_list
      then call autokill_areas

    if opt._rescan & \opt._scan_msgs & \opt._scan_bad
      then call init_ptr 0    /* nur LR-Pointer zurcksetzen */
      else
      do
        call read_rule_idx    /* Rules-Index einlesen */
        if opt._scan_bad      /* BadMail scannen und Autocreate */
          then call scan_badmail
        if opt._scan_msgs
          then
          do
            call scan_msg_base        /* Netmails bearbeiten */
            if area._changed <> ''    /* Areas abschalten/lschen */
              then call check_changed_areas
          end
      end

    if upl._cmd > 0                   /* Requests an Uplinks senden */
      then call proc_uplink

    if opt._sched                     /* Schedules ausfhren */
      then call execute_schedules

end

if new_area.0 > 0
  then call proc_autolink

if new_area.0 > 0 | del_area.0 > 0 | ren_area.0 > 0
  then call set_autokill_inhibit

if new_area.0 > 0 | del_area.0 > 0 | ren_area.0 > 0 | warn_area.0 > 0
  then call send_notify

do while sq._open_areas <> ''   /* Alle noch offenen Areas schliessen */
  call sq_close_area word(sq._open_areas, 1)
end

if new_area.0 > 0 | del_area.0 > 0 | ren_area.0 > 0 | warn_area.0 > 0
  then call send_announce

call save_msgid_next

select
  when squish._cfg._changed | opt._sort_area = 2 | opt._rebuild_sqcfg
    then call write_squish_cfg  /* Squish-Cfg schreiben */
  when squish._idx._changed
    then call write_squish_idx  /* Nur Squish-Index neu erstellen */
  otherwise
end

if prg_cfg._changed
  then call write_prg_cfg       /* Prg-Cfg schreiben */

if autokill._inhibit._changed
  then call write_autokill_inhibit

call write_echo_toss_log        /* EchoToss-Log aktualisieren */


if res._badmail > 0 & ext_cmd._toss_badmail <> ''
  then                          /* Badmail tossen */
  do
    call wlog def._log_str.100  /* Tosse Badmail */
    call directory ext_cmd._toss_badmail_dir
    call execute_prg '@'replace_str(ext_cmd._toss_badmail, '[%c]', squish._cfg._file)
    call directory dir._act
  end

if rescan._dnl_idx <> ''
  then call rescan_areas        /* Area-Rescans durchfhren */

  /* andere Area-Setups erstellen */
if opt._maximus = 2 | (squish._cfg._changed & opt._maximus = 1)
  then call write_max_msgarea_ctl
if opt._ext_area = 2 | (squish._cfg._changed & opt._ext_area = 1)
  then call write_ext_area_files

  /* *.DSC-files updaten */
if opt._update_dsc
  then call update_rules_2_dsc

call close_logfile_sem
call directory dir._act

exit sign(res._netmail) + 2* sign(res._echomail)

/************************************************************************/

prg_init_1:

say
say left(' -= RAFX.CMD v'version' =-', 57) '(c) 1996-98 R.Wilke'
say copies('-', 78)

log._file = ''

dir._act = translate(directory(), char._up, char._low)
parse upper source . . p
parse value reverse(p) with '\' p
select
  when p <> ''
    then dir._prg = reverse(p)
  when dir._prg = ''
    then signal error_255_1
  otherwise
    dir._prg = strip(dir._prg)
end

def. = ''                     /* verschiedene Vorgaben */

  /* Language-File einlesen */
y = dir._prg'\RAFX.LNG'
s = stream(y, 'c', 'query size')
if s < 1
  then signal error_255_2
s = charin(y,, s)
call stream y, 'c', 'close'
signal on error name error_255_99
signal on syntax name error_255_99
interpret s
signal off error
signal off syntax

if words(input) = 0           /* Hilfe aufrufen */
  then
  do
    do y = 1 to error._str.0.0
      say error._str.0.y
    end
    exit 0
  end

  /* REXXUTIL laden */
if rxfuncquery('sysloadfuncs') <> 0
  then
  do
    call rxfuncadd 'sysloadfuncs', 'rexxutil', 'sysloadfuncs'
    call sysloadfuncs
  end

  /* Verzeichnis fr temp. Files ermitteln */
dir._temp = s_directory(value('TMP',, 'os2environment'))
if dir._temp = ''
  then
  do
    dir._temp = s_directory(value('TEMP',, 'os2environment'))
    if dir._temp = ''
      then dir._temp = dir._prg
  end
call directory dir._act


prg_cfg._file    = dir._prg'\RAFX.CFG'
prg_cfg._changed = 0
res.             = 0          /* Statistik */

char._low  = xrange('61'x, '7a'x) || ''
char._up   = xrange('41'x, '5a'x) || ''
char._ctrl = xrange('00'x, '1f'x)
char._anum = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'
char._ver  = char._anum'_+-.#$%&~@'
char._high = xrange('80'x, 'ff'x)
char._hpfs = char._anum'_-#$%!~@'

crlf     = '0d0a'x            /* Zeilenwechsel */
cr       = '0d'x

def._str._78dash = copies('-', 78)


/* Voreinstellungen der Programm-Konfiguration */

log.               = ''       /* Log-File-Name, nur whrend Initialisierung */
alias._idx         = ' '      /* Liste aller RAFX-Namen */

squish._cfg._file       = ''  /* Squish-Konfiguration */
squish._cfg._changed    = 0   /* Flag nderung Squish-Cfg */

squish._idx._changed    = 0   /* Flag nderung Squish-Index, nur von
                                 Bedeutung, wenn SQUISH._CFG._CHANGED = 1 */

squish._cfg._full_addr  = 0   /* vollstndige Adressen in Squish-Cfg */
                              /* 0 = nein, 1 = ja */
squish._cfg._line_len   = 992 /* Max. Lnge einer Echoarea-Zeile */

squish._keyword_idx     = ''  /* Liste der Zeilen-Nr. mit Keywords */

squish._logfile         = ''
squish._logfile_ident   = 'SQSH' /* Kennung Logfile-Eintrge von Squish */


idx._dir              = ''       /* Verzeichnis fr Indizes Arealisten */
timestamp._file       = ''       /* Filename fr Timestamp in *.MSG-Areas */
usernumber            = 1        /* Offset in LR-Pointer */
ignore_msg_attr       = 0        /* MSG-Attribute beim Scannen beachten */
msgid.                = ''       /* Angabe zur MSGID */
rsp_file.             = ''       /* Antwort-Files */
keep.                 = 0        /* Zu erhaltene Files*/

sem.                  = ''       /* Daten zur Semaphore */
timeout_open_area     = 600      /* Timeout zum ffnen eine Area */
ext_cmd.              = ''       /* externe Kommandos */

def._area_use_hpfs    = 0        /* Neue Areas */
def._area_level       = 0
def._area_acs         = 0
def._area_group       = 'N_A'

def._dnl_level        = 0
def._dnl_flags        = '00000000'x
def._msg_length       = 14336    /* Max. Lnge einer Antwort-MSG */
def._dnl_notify.0     = 'NLLN'
def._dnl_notify.1     = 'ALLN'

def._group            = ' '
def._group.0          = 0
def._group_pattern.0  = 0
def._group_sort.0     = 0

dnl.                  = 0        /* Alle DNL.-Vars mit 0 initialisieren */
dnl._addr_idx         = ' '      /* Index aller Downlink-Adressen */
dnl._settings_idx     = ' '      /* Index Downlinks mit neuen Einstellungen */

dnl._name.0           = ''       /* Sysop-Name */
dnl._pw.0             = ''       /* Sysop-Passwort */
dnl._flags.0          = ''       /* Vorgabe-Flags fr Sysop */
dnl._msg_length.0     = ''       /* Max. Lnge einer Antwort-MSG */
dnl._language.0       = ''       /* Sprache fr MSGs an Sysop */

upl_area.             = ''
upl._addr_idx         = ' '
upl._cmd              = 0        /* Flag - Anzeige fr anliegende Forward-Requests */
upl._fwd_killsent     = 0        /* K/S fr Forward-Requests */


rescan.               = ''       /* ReScan-Variablen */


/* Ein- und Ausgabe-Areas */

netmail_in.0          = 0        /* Stem Eingangs-NetAreas */
netmail_out.          = ''       /* Variablen fr Ausgangsarea */




/* Voreinstellungen zur Squish-Konfiguration */

area.                 = ''
area._idx             = ' '      /* Index aller EchoArea-Tags */

area._changed         = ' '
net_area.             = ''
net_area.0            = 0        /* Stem NetArea-Tags */
net_area._idx         = ' '      /* Liste aller Netarea-Tags */
bad_area.             = ''
address._idx          = ' '      /* Liste der eigenen AKAs */

del_area._wait        = 1        /* Karenzzeit fr gelschte Areas */
del_area._idx         = ' '      /* Index aller Areas Gruppe DELETED_AREA */



/* Variablen zu nderungen bei Areas */

del_area._group       = ' '      /* Liste Gruppen mit gelschten Areas */
del_area.0            = 0        /* gelschte Areas */

new_area._group       = ' '      /* Liste Gruppen mit neuen Areas */
new_area.0            = 0        /* neue Areas */

warn_area._group      = ' '      /* Liste Gruppen mit angewarnten Areas */
warn_area.0           = 0        /* angewarnte Areas */

ren_area._group       = ' '      /* Liste Gruppen umbenannte Areas */
ren_area.0            = 0        /* Umbenannte Areas */


/* Rules */

rules.                = 0
rules._idx            = ''
rules._lines          = 10

rules._sdm_dsc        = '\DESCRIPT.BBS'
rules._sq_dsc         = '.DSC'


/* Announces */

ann.                  = ''

ann._dest_name        = 'All'
ann._from_name        = 'Sysop'
ann._language         = def._language
ann._msg_length       = 14336    /* Max. Lnge einer Announce-MSG */

ann._area.0           = 0


echotoss.             = ''


/* Autokill */

autokill.             = 0
autokill._delay       = 3
autokill._keys        = char._anum
autokill._level       = 65536

/* Dummy-Areas */

dummy.                = ''

/* Gruppen */

group.                = ''    /* Group-Index fr einen Downlink */
group_avail.0         = 0     /* verfgbare Gruppen fr Downlink */
group_all.            = 0     /* temp. */
group_all.N_A         = 1

/* externer Area-Setup */

max.                  = 0
max._work_dir         = ''
max._main_ctl         = ''
max._msgarea_ctl      = ''
max._msgarea_rafx     = ''
max._ctl_compiler     = ''
max._acs_keys         = ''
max._div_char         = ''
max._div_access       = ''



ext_area.             = ''    /* zus. Area-Files */
ext_area.0            = 0


/* Sonstige Vorgaben */

autokill._list._fwd   = 0
timestamp._base       = '1980/01/01-00:00:00'
def._tearline         = '--- RAFX v'version
def._origin           = ''
m_text.               = ''        /* Vorgaben fr gesplittete MSGs */
sched._mask.1         = 'LIST'    /* Namen der Schedule-Kommandos */
sched._mask.2         = 'AVAIL'
sched._mask.3         = 'QUERY'
sched._mask.4         = 'HELP'
sched._mask.5         = 'INFO'


common_var = 'char.'              ,
             'error.'             ,
             'prg_cfg.'           ,
             'log.'               ,
             'dir.'               ,
             'crlf'               ,
             'cr'                 ,
             'res.'               ,
             'version'            ,
             'opt.'               ,
             'idx.'               ,
             'rules.'             ,
             'rules_send.'        ,
             'found.'             ,
             'm_text.'            ,
             ''                   ,
              'msg.'              ,
              'sq.'               ,
             ''                   ,
             'ext_cmd.'           ,
             'timestamp.'         ,
             'usernumber'         ,
             'ignore_msg_attr'    ,
             'squish.'            ,
             'rsp_file.'          ,
             'keep.'              ,
             'timeout_open_area'  ,
             'sem.'               ,
             'alias.'             ,
             'netmail_in.'        ,
             'netmail_out.'       ,
             'msgid.'             ,
             'rescan.'            ,
             'def.'               ,
             'upl.'               ,
             'upl_area.'          ,
             'dnl.'               ,
             'mcmd.'              ,
             'ann.'               ,
             ''                   ,
             'address.'           ,
             'area.'              ,
             'area_idx.'          ,
             'area_root_idx.'     ,
             'kill_area_idx.'     ,
             'autokill.'          ,
             'dummy.'             ,
             'group.'             ,
             'group_all.'         ,
             'group_avail.'       ,
             'max.'               ,
             'temp.'              ,
             'ext_area.'          ,
             'bad_area.'          ,
             'net_area.'          ,
             'del_area.'          ,
             'warn_area.'         ,
             'new_area.'          ,
             'ren_area.'          ,
             'echotoss.'          ,
             'sched.'             ,
             ''
return


error_255_1:
call wlogq '* Unable to locate source directory'
exit 255

error_255_2:
call wlogq '* Error opening' y
exit 255

error_255_99:
call wlogq '* Error interpreting' y
call wlogq '* Error' rc',' errortext(rc)
exit 255

/************************************************************************/

prg_error: procedure expose (common_var)

arg flag, .
do y = 1 to error._str.flag.0
  call wlogq '*' replace_str(error._str.flag.y,,
                             '[%1]', arg(2),,
                             '[%2]', arg(3),,
                             '[%3]', arg(4),,
                             '[%4]', arg(5),,
                             '[%5]', arg(6))
end

return

/************************************************************************/

expand_def_groups: procedure expose (common_var)

grp = 0
do y = 1 to def._group_pattern.0

  select
    when def._group_pattern.y = '*'
      then
      do
        do v = 1 to group_avail.0
          g = group_avail.v
          if def._group_ptr.g < 1
            then call expand_def_groups_1
        end
        leave
      end
    when pos('*', def._group_pattern.y) > 0
      then
      do v = 1 to group_avail.0
        g = group_avail.v
        if def._group_ptr.g > 0
          then iterate
        string =  ' 'g' *'
        pattern = ' 'def._group_pattern.y' '
        res = 1
        do until res = 0 | pattern == ''
          parse var pattern pt'*'pattern
          parse var string (pt)rest
          res = rest \== ''
        end
        if res
          then call expand_def_groups_1
      end

    otherwise
      g = def._group_pattern.y
      if def._group_ptr.g < 1
        then call expand_def_groups_1
  end

end
def._group.0 = grp

return



expand_def_groups_1:
def._group_ptr.g = y
grp = grp +1
def._group.grp = g
return

/************************************************************************/

expand_dnl_groups: procedure expose (common_var)

arg dnl

dnl._group.dnl     = ' '
dnl._group_autolink.dnl = ''
dnl_grp. = 0

do g = 1 to dnl._wgroup.dnl.0
  if dnl._wgroup.dnl.g = '*'
    then
    do
      do y = 1 to group_avail.0
        z = group_avail.y
        if \dnl_grp.z
          then call expand_dnl_groups_1
      end
      leave
    end
    else
    do y = 1 to group_avail.0
      z = group_avail.y
      if \dnl_grp.z
        then
        do
          string  = ' 'z' *'
          pattern = ' 'dnl._wgroup.dnl.g' '
          res = 1
          do until res = 0 | pattern == ''
            parse var pattern pt'*'pattern
            parse var string (pt)rest
            res = rest \== ''
          end
          if res
            then call expand_dnl_groups_1
        end

    end

    /* todo: drop wgroup */
end

dnl._group_exp.dnl = 1

return



expand_dnl_groups_1:

if dnl._wgroup_addr.dnl.g = ''
  then
  do
    if def._group_ptr.z < 1
      then addr = dnl._addr.dnl.1
      else
      do
        v = def._group_ptr.z
        pattern = ' 'def._group_zone.v':'
        parse var dnl._addr.dnl (pattern) +0 addr .
      end
  end
  else addr = dnl._wgroup_addr.dnl.g

if addr <> ''
  then
  do
    dnl._group.dnl = dnl._group.dnl || z' '
    dnl._group_autolink.dnl = dnl._group_autolink.dnl dnl._wgroup_autolink.dnl.g

    dnl._group.dnl.0 = dnl._group.dnl.0 +1
    r = dnl._group.dnl.0
    dnl._group_acs.dnl.r = dnl._wgroup_acs.dnl.g
    dnl._group_addr.dnl.r = addr
  end

dnl_grp.z = 1


return

/************************************************************************/

prg_init_2: procedure expose (common_var)

  /* Eingangs-NetAreas testen */
do n = 1 to netmail_in.0
  if wordpos(netmail_in.n, net_area._idx) = 0
    then call error_251 45, netmail_in.n, squish._cfg._file
end

  /* Ausgangs-NetArea testen */
if netmail_out._ptr = ''
  then netmail_out._ptr = wordpos(netmail_in.1, net_area._idx)
  else
  do
    p = wordpos(netmail_out._ptr, net_area._idx)
    if p = 0
      then call error_251 45, netmail_out._ptr, squish._cfg._file
    netmail_out._ptr = p
  end


  /* DNL-Daten fr Sysop generieren */
dnl._addr.0   = address._idx
do y = 1 to address.0
  dnl._addr.0.y = address.y
end

  /* Zonen der vordefinierten Gruppen testen */
do y = 1 to def._group_pattern.0
  pattern = ' 'def._group_zone.y':'
  parse var address._idx (pattern) +0 paddr .
  if paddr = ''
    then call error_251 47, def._group_pattern.y, def._group_zone.y
end


do n = 1 to upl.0

  /* AKAs festlegen, die den Uplink-Areafixes prsentiert werden, wenn
     nicht explizit festgelegt wurde */

      /* wenn keine Absender-Aka angegebenen, dann auf Zone matchen */
  if upl._faddr.n = ''
    then
    do
      parse var upl._addr.n pattern':'.
      pattern = ' 'pattern':'
      parse var address._idx (pattern) +0 upl._faddr.n .
        /* Wenn keine passende Zonen-Aka gefunden, dann erste Adr einsetzen */
      if upl._faddr.n = ''
        then upl._faddr.n = address.1
    end

    /* Primary-Akas festlegen, wenn Areas angelegt werden */

  do m = 1 to upl_area.n.0
    paddr = set_primary_aka(upl_area._sep_paddr.n.m.0, upl_area._sep_group.n.m.0)
    if paddr = ''
      then call error_251 46, upl._addr.n, upl_area._file.n.m, upl_area._sep_paddr.n.m.0
    upl_area._sep_paddr.n.m.0 = paddr

    do y = 1 to upl_area._sep.n.m.0
      paddr = set_primary_aka(upl_area._sep_paddr.n.m.y, upl_area._sep_group.n.m.y)
      if paddr = ''
        then call error_251 61, upl._addr.n, upl_area._file.n.m, upl_area._sep_paddr.n.m.y
      upl_area._sep_paddr.n.m.y = paddr
    end
  end


end




/* Daten fr Announces aufschlsseln */

do y = 1 to ann._area.0
  area = ann._area.y
  a = area_idx.area

  if \datatype(a, 'w')
    then    /* Announce-Area nicht in Squish.Cfg */
    do
      call wlog replace_str(def._log_str.103, '[%a]', ann._area.y,,
                                              '[%f]', squish._cfg._file)
      call wlog replace_str(def._log_str.104, '[%a]', ann._area.y,,
                                              '[%f]', squish._cfg._file)
      ann._area.y = 0
      iterate y
    end
  ann._area.y = a

  if ann._from_addr.y = ''
    then ann._from_addr.y = area._paddr.a
    else
    do
      pattern = ' 'ann._from_addr.y
      parse var address._idx (pattern) +0 addr .
      if addr = ''
        then call error_251 50, area.a, ann._from_addr.y
      ann._from_addr.y = addr
    end
end

  /* Root-Name fr Dummy-Area festlegen */
if systempfilename(dummy._dir || '\@@@?????@@@') <> ''
  then dummy._root = 'RAFX_DUMMY_AREA_'
  else dummy._root = 'RDMA'

return



error_251:
arg error_flag, a3, a4, a5, a6
call prg_error error_flag, a3, a4, a5, a6
call directory dir._act
call close_logfile_sem
exit 251

/************************************************************************/

prg_init_3: procedure expose (common_var)


do n = 1 to upl.0

  do m = 1 to upl._ac_group.n.0

      /* Primary-AKA festlegen fr Autocreated Areas */

    if upl._ac_paddr.n.m = '' | upl._ac_paddr.n.m = '.'
      then
      do
        g = upl._ac_group.n.m
        p = def._group_ptr.g
        if p < 1
          then paddr = address.1
          else
          do
            pattern = ' 'def._group_zone.p':'
            parse var address._idx (pattern) +0 paddr .
          end
      end
      else
      do
        pattern = ' 'upl._ac_paddr.n.m
        parse var address._idx (pattern) +0 paddr .
      end
    if paddr = ''
      then call error_251 48, upl._addr.n, upl._ac_paddr.n.m
    upl._ac_paddr.n.m = paddr

  end
end


  /* Unbentige Variablen droppen */
drop error.

return


/************************************************************************/

set_primary_aka: procedure expose (common_var)

arg paddr, group

if paddr = '' | paddr = '.'
  then              /* keine Angabe zur Primary-Aka */
  do
    do p = 1 to def._group_pattern.0
      select
        when def._group_pattern.p = '*'
          then leave                      /* passt immer */
        when pos('*', def._group_pattern.p) = 0
          then if def._group_pattern.p = group
            then leave                    /* exakte Schreibweise */
        otherwise
          pattern = ' 'def._group_pattern.p' '
          string  = ' 'group' *'
          res = 1
          do until res = 0 | pattern == ''
            parse var pattern pt'*'pattern
            parse var string (pt)rest
            res = rest \== ''
          end
          if res
            then leave                    /* Match gefunden */
      end
    end
    if p > def._group_pattern.0   /* Keine Zone fr Gruppe definiert */
      then paddr = address.1
      else
      do
        pattern = ' 'def._group_zone.p':'
        parse var address._idx (pattern) +0 paddr .
      end
  end
  else              /* Angabe zur Primary-Aka */
  do
    pattern = ' 'paddr
    parse var address._idx (pattern) +0 paddr .
  end

return paddr

/************************************************************************/

/*======================================================================
max._work_dir           Startverzeichnis von Maximus
max._msgarea_ctl        MSGAREA.CTL
max._msgarea_rafx       File mit den von RAFX exportierten Areas. Zum
                        Einbinden mit INCLUDE in MSGARE.CTL
max._ctl_compiler       SILTP.EXE

max._aka_match.         Stem der AKA-Masken zum Matchen
max._aka_match_new.     Neue AKA dafr
max._aka_list           Liste der AKAs aus MAX.CTL (nur Maximus 2.0)

max._access.0           Anzahl der definierten ACS-Strings
max._access.n           RAFX-Level
max._access_str.n       Maximus-ACR-Strings dazu

max._acs_keys           RAFX-Keys, die nach Maximus bernommen werden drfen



  ; Divsions:  Index n = 0 = oberste Div (keine)

max._div                Anzahl der Definitionen

max._div_name.n           Name der Division
max._div_desc.n           Beschreibung der Division

max._div_group_exc.n.     Stem Exclude-Groups
max._div_group_inc.n.     Stem Include-Groups
max._div_group_inc_ro.n.  Stem ReadOnly-Flags dazu

max._div_area_exc.n.      Stem Exclude-Areas
max._div_area_inc.n.      Stem Include-Areas
max._div_area_inc_ro.n.   Stem ReadOnly-Flags dazu

max._div_aka.n.           Stem der Include-Akas, wenn keine definiert, dann alle

max._div_setting.n      Zeiger auf Settings, Format '<Origin> <Seen By> <Style>'
max._div_ptr.n.         Stem Zeiger auf Sub-Divs


max._set_origin.        Stem Origin
max._set_seenby.        Stem Seen-By
max._set_style.         stem Style

======================================================================*/
/*======================================================================

mdiv_path_idx.<path>    Index der der aus MSGAREA.CTL gelesenen Pfade

mdiv_idx.<div>          Index der bisher eingelesenen Divs

mdiv.0                  Anzahl der eingelesenen Divs

mdiv._name.n            Div-Name
mdiv._desc.n            Div-Beschreibung

mdiv.n.0                Anzahl der Areas innerhalb der Div

mdiv._area_name.n.m     Name der Area fr Maximus (ist nicht Area-Tag)
mdiv._area_ptr.n.m      Zeiger auf AREA.
mdiv._area_set.n.m      Zeiger MAX._SET.., MAX._ACCESS_STR.x  und ReadOnly-flag

======================================================================*/


write_max_msgarea_ctl: procedure expose (common_var)

mdiv.           = 0
mdiv_idx.       = 0
mdiv_path_idx.  = 0

  /* Testen, ob berhaupt Export nach Maximus mglich */

res = 1
select
  when max._support = 0
    then nop
  when directory(max._work_dir) = ''
    then nop
  otherwise
      /* Bei Maximus 2.0 ADDRESS-Statements einlesen */
    if max._support = 2
      then res = write_max_msgarea_ctl_2()
      else res = 0
      /* MSGAREA.CTL einlesen, damit schon definierte Pfade bercksichtigt werden */
    if res = 0
      then res = write_max_msgarea_ctl_1()
    call directory dir._act
end
if res
  then
  do
    call wlog def._log_str.178
    return
  end

  /* Areas filtern */

call wlogq def._log_str.177

do ipart = 1 to words(area._idx) by 100
  part_idx = subword(area._idx, ipart, 100)
  call charout, 'P:' format(ipart %2, 6) || cr

  do n = 1 to words(part_idx) by 2
    area = word(part_idx, n)
    a = area_idx.area

      /* Area auf passthrough testen */
    if wordpos('-0', area._sflags.a) > 0
      then iterate n

      /* Zugriffslevel der Area testen */
    do acs_ptr = 1 to max._access.0
      if area._level.a <= max._access.acs_ptr
        then leave
    end
    if acs_ptr > max._access.0
      then iterate n

      /* Root testen, ob schon in MSGAREA.CTL definiert */
    y = strip(directory(strip(filespec('d', area._root.a) || filespec('p', area._root.a), 't', '\')), 't', '\')
    call directory dir._act
    if y <> ''
      then
      do
        y = translate(y'\'filespec('n', area._root.a))
        select
          when length(y) > 200
            then iterate n          /* Root zu lang */
          when mdiv_path_idx.y
            then iterate n          /* Root schon belegt */
          otherwise
        end
      end

      /* Rekusiver Filter */
    call write_max_msgarea_ctl_rec 0, ''
  end

end

drop mdiv_path_idx.


  /* Divisions sortieren */

mdiv_idx.  = 0
echo_sort. = 0
do div = 1 to mdiv.0
  if mdiv.div.0 > 0   /* nur Divisions mit Areas bernehmen */
    then
    do
      echo_sort._div.0 = echo_sort._div.0 +1
      y = echo_sort._div.0
      echo_sort._div.y = mdiv._name.div div
    end
end
call r1sort 1, echo_sort._div.0, '_DIV'

  /* Area-Daten exportieren */

call sysfiledelete max._msgarea_rafx
call stream max._msgarea_rafx, 'c', 'open'
call wlog replace_str(def._log_str.135, '[%f]', max._msgarea_rafx)


if max._support = 3
  then
  do
      /* Hirarchie der Divisions festlegen */
    mdiv_idx. = 0
    mdiv_hir. = 0
    do y = 1 to echo_sort._div.0
      parse var echo_sort._div.y dname dptr
      call write_max_msgarea_ctl_rec_1 dname, dptr, '', 0
    end
    drop echo_sort. mdiv_idx.

    do y = 1 to mdiv_hir.0.0
      call write_max_msgarea_ctl_rec_2 mdiv_hir.0.y, 0
    end
    if mdiv.0.0 > 0
      then call write_max_msgarea_ctl_10 0, 0
  end
  else
  do
    if mdiv.0.0 > 0
      then call write_max_msgarea_ctl_10 0, 0
    do y = 1 to echo_sort._div.0
      parse var echo_sort._div.y dname dptr
      call wlogq replace_str(def._log_str.176, '[%d]', mdiv._name.dptr)
      call write_max_msgarea_ctl_10 dptr, 0
    end
  end


call stream max._msgarea_rafx, 'c', 'close'

if max._ctl_compiler <> ''
  then
  do
    call directory max._work_dir
    call wlog replace_str(def._log_str.101, '[%p]', max._ctl_compiler)
    call execute_prg '@'max._ctl_compiler
    call directory dir._act
  end


return

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

/*======================================================================
  Division- und Area-Daten nach Maximus 3.0 exportieren
======================================================================*/

write_max_msgarea_ctl_rec_2: procedure expose (common_var) mdiv_hir. mdiv.

arg hptr, indent

call wlogq replace_str(def._log_str.176, '[%d]', left('', indent) || mdiv_hir._name.hptr)

div = mdiv_hir._dptr.hptr

str = left('', indent) || 'MsgDivisionBegin' mdiv_hir._name.hptr max._div_access '.'
if div > 0
  then str = str mdiv._desc.div
call lineout max._msgarea_rafx, str || crlf

do y = 1 to mdiv_hir.hptr.0
  call write_max_msgarea_ctl_rec_2 mdiv_hir.hptr.y, indent +2
end

if mdiv_hir._dptr.hptr > 0
  then call write_max_msgarea_ctl_10 div, indent +2

call lineout max._msgarea_rafx, left('', indent) || 'MsgDivisionEnd' || crlf

return

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

/*======================================================================
  Hirachie der Divisions festlegen
======================================================================*/

write_max_msgarea_ctl_rec_1: procedure expose mdiv_idx. mdiv_hir.

arg dname.0, dptr, root, hptr

parse var dname.0 dname.1 '.' dname.0
root = root'.'dname.1
select
  when mdiv_idx.root > 0
    then call write_max_msgarea_ctl_rec_1 dname.0, dptr, root, mdiv_idx.root
  otherwise
    mdiv_hir.0 = mdiv_hir.0 +1

    mdiv_hir.hptr.0 = mdiv_hir.hptr.0 +1
    y = mdiv_hir.hptr.0
    mdiv_hir.hptr.y = mdiv_hir.0
    mdiv_idx.root   = mdiv_hir.0

    y = mdiv_hir.0
    mdiv_hir._name.y = dname.1

    if dname.0 = ''
      then mdiv_hir._dptr.y = dptr
      else
      do
        mdiv_hir._dptr.y = 0
        call write_max_msgarea_ctl_rec_1 dname.0, dptr, root, mdiv_idx.root
      end
end

return

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

write_max_msgarea_ctl_10: procedure expose (common_var) mdiv.

arg div, indent

istr = left(' ', indent)

echo_sort.0.0 = mdiv.div.0
do y = 1 to mdiv.div.0
  echo_sort.0.y = mdiv._area_name.div.y y
end
call r1sort 1, echo_sort.0.0, 0


do z = 1 to echo_sort.0.0
  if z // 10 = 0
    then call charout, 'W:' format(z, 6) || cr

  ma = word(echo_sort.0.z, 2)
  a = mdiv._area_ptr.div.ma

  parse var mdiv._area_set.div.ma p_orig p_seenby p_style p_acs ro_flag

  keys = space(translate(area._keys.a, max._acs_keys, max._acs_keys || char._anum), 0)
  if keys <> ''
    then keys = '/'keys

  if area._format.a = '$'
    then aformat = 'Squish'
    else aformat = '*.MSG'

  do y = 1 to max._aka_match.0 until abbrev(area._paddr.a, max._aka_match.y)
  end

  if max._support = 3
    then
    do
      if y <= max._aka_match.0
        then aka = max._aka_match_new.y
        else aka = area._paddr.a
      if right(aka, 2) = '.0'
        then parse var aka aka '.0' .

      if ro_flag
        then style = max._set_style.p_style 'ReadOnly'
        else style = max._set_style.p_style

      call lineout max._msgarea_rafx,,
           istr || 'MsgArea ' mdiv._area_name.div.ma        || crlf ||,
           istr || '  Tag   ' area.a                        || crlf ||,
           istr || '  ACS   ' max._access_str.p_acs || keys || crlf ||,
           istr || '  Desc  ' area._desc.a                  || crlf ||,
           istr || '  Origin' aka max._set_seenby.p_seenby max._set_origin.p_orig || crlf ||,
           istr || '  Path  ' area._root.a                  || crlf ||,
           istr || '  Style ' aformat style                 || crlf ||,
           istr || 'End MsgArea'                            || crlf
    end
    else
    do
      if y <= max._aka_match.0
        then aka = max._aka_match_new.y
        else
        do
          aka = wordpos(area._paddr.a, max._aka_list)
          if aka = 0
            then ro_flag = 1
            else aka = aka -1
        end

      if div > 0
        then marea = mdiv._name.div || z
        else marea = z

      call lineout max._msgarea_rafx,,
           'Area        ' marea                         || crlf ||,
           '  MsgName   ' area.a                        || crlf ||,
           '  MsgAccess ' max._access_str.p_acs || keys || crlf ||,
           '  MsgInfo   ' area.a':' area._desc.a        || crlf ||,
           '  Origin    ' aka max._set_origin.p_orig    || crlf ||,
           '  EchoMail  ' area._root.a                  || crlf ||,
           '  Type      ' aformat

      style = max._set_style.p_style
      do while style <> ''
        parse var style data ',' style
        data = space(data)
        if \ro_flag
          then call lineout max._msgarea_rafx, '  'data
          else
          do
            parse upper var data t .
            if t <> 'PRIVATE' & t <> 'PUBLIC'
              then call lineout max._msgarea_rafx, '  'data
          end
      end
      if ro_flag
        then call lineout max._msgarea_rafx, '  Read-Only'
      call lineout max._msgarea_rafx, 'End Area' || crlf
    end
end

return



/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

/*======================================================================
  MAX.CTL einlesen
======================================================================*/

write_max_msgarea_ctl_2:

call wlogq replace_str(def._log_str.131, '[%f]', max._main_ctl)

res = 1
max._aka_list = ''
do z = 1 to 10 while stream(max._main_ctl, 'c', 'open read') <> 'READY:'
  call syssleep 1
end
select
  when z > 10
    then call wlog replace_str(def._log_str.105, '[%f]', max._main_ctl)
  otherwise
    parse upper value space(translate(charin(max._main_ctl,, chars(max._main_ctl)), ' ', '9'x)) with . 'MATRIX AND ECHOMAIL SECTION' . (crlf) str '1a'x
    call stream max._main_ctl, 'c', 'close'

    s_begin = 1
    do until rest == ''
      parse var str =(s_begin)data(crlf) +2 rest +1
      s_begin = s_begin +length(data) +2
      parse var data keyword kwdata .

      select
        when kwdata = ''
          then iterate
        when keyword = 'END'
          then leave
        when keyword = 'ADDRESS'
          then
          do
            parse var kwdata . '.' z
            if z = ''
              then max._aka_list = max._aka_list strip(kwdata)'.0'
              else max._aka_list = max._aka_list kwdata
          end
        otherwise
      end
    end
    drop str

    if max._aka_list = ''
      then call wlog def._log_str.180
      else
      do
        do y = 1 to max._aka_match.0
          z = wordpos(max._aka_match_new.y, max._aka_list)
          if z = 0
            then
            do
              call wlog replace_str(def._log_str.181, '[%a]', max._aka_match_new.y)
              leave
            end
          max._aka_match_new.y = z -1
        end
        res = y <= max._aka_match.0
      end
end

return res

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

/*======================================================================
  MSGAREA.CTL einlesen
======================================================================*/

write_max_msgarea_ctl_1:

res = 0
y = 1
ifile = y
ifile.y = max._msgarea_ctl
do forever
  call wlogq replace_str(def._log_str.131, '[%f]', ifile.y)

  do z = 1 to 10 while stream(ifile.y, 'c', 'open read') <> 'READY:'
    call syssleep 1
  end
  if z > 10
    then
    do                        /* Fehler beim ffnen */
      call wlog replace_str(def._log_str.105, '[%f]', ifile.y)
      res = 1
      leave
    end

  parse value translate(charin(ifile.y,, chars(ifile.y)), ' ', '9'x) with str '1a'x
  call stream ifile.y, 'c', 'close'

  s_begin = 1
  do until rest == ''
    parse var str =(s_begin)data(crlf) +2 rest +1
    s_begin = s_begin +length(data) +2
    parse upper var data keyword kwdata .
    select
      when kwdata = ''
        then iterate
      when keyword = 'INCLUDE'
        then
        do
          z = translate(stream(kwdata, 'c', 'query exists'))
          if z <> max._msgarea_rafx & z <> ''
            then
            do
              ifile = ifile +1
              ifile.ifile = z
            end
        end
      when max._support = 3
        then if keyword = 'PATH'
          then call write_max_msgarea_ctl_1_1

           /* Maximus 2.0 */
      when keyword = 'LOCAL'
        then call write_max_msgarea_ctl_1_1
      when keyword = 'ECHOMAIL'
        then call write_max_msgarea_ctl_1_1
      when keyword = 'MATRIX'
        then call write_max_msgarea_ctl_1_1
      otherwise
    end

  end

  y = y +1
  if y > ifile
    then leave
end
drop ifile ifile. str

return res



write_max_msgarea_ctl_1_1:

z = s_directory(filespec('d', kwdata) || filespec('p', kwdata))
if z <> ''
  then
  do
    z = z'\'filespec('n', kwdata)
    if length(z) <= 200
      then mdiv_path_idx.z = 1
  end
call directory max._work_dir

return

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

/*======================================================================
  Rekursive Filterung der Areas
======================================================================*/

write_max_msgarea_ctl_rec: procedure expose (common_var) a mdiv. mdiv_idx. acs_ptr

arg mxdiv, divroot

res = 0

ro_flag = 0

if max._div_aka.mxdiv.0 > 0
  then
  do
    do y = 1 to max._div_aka.mxdiv.0 until abbrev(area._paddr.a, max._div_aka.mxdiv.y)
    end
    if y > max._div_aka.mxdiv.0
      then return 0             /* AKA ausgeschlossen */
  end


if max._div_group_inc.mxdiv.0 > 0
  then
  do
    do y = 1 to max._div_group_inc.mxdiv.0 until match(max._div_group_inc.mxdiv.y, area._group.a)
    end
    if y > max._div_group_inc.mxdiv.0
      then return 0             /* Gruppe ausgeschlossen */
    ro_flag = max._div_group_inc_ro.mxdiv.y
  end

if max._div_area_inc.mxdiv.0 > 0
  then
  do
    do y = 1 to max._div_area_inc.mxdiv.0 until match(max._div_area_inc.mxdiv.y, area.a)
    end
    if y > max._div_area_inc.mxdiv.0
      then return 0             /* Area ausgeschlossen */
    ro_flag = ro_flag | max._div_area_inc_ro.mxdiv.y
  end

if max._div_group_exc.mxdiv.0 > 0
  then
  do
    do y = 1 to max._div_group_exc.mxdiv.0 until match(max._div_group_exc.mxdiv.y, area._group.a)
    end
    if y <= max._div_group_exc.mxdiv.0
      then return 0                 /* Gruppe ausgeschlossen */
  end

if max._div_area_exc.mxdiv.0 > 0
  then
  do
    do y = 1 to max._div_area_exc.mxdiv.0 until match(max._div_area_exc.mxdiv.y, area.a)
    end
    if y <= max._div_area_exc.mxdiv.0
      then return 0                 /* Area ausgeschlossen */
  end

  /* Area matcht */

if mxdiv > 0
  then
  do

    if max._support = 3
      then
      do
        divdesc = max._div_name.mxdiv <> ''
        select
          when divdesc
            then divname = max._div_name.mxdiv
          when max._div_char = ''
            then divname = translate(space(translate(area._group.a, ' ', '.')), '_', ' ')
          otherwise
            divname = translate(space(translate(area._group.a, '', max._div_char, ' ')), '.', ' ')
        end
        if divroot <> ''
          then divname = divroot'.'divname
      end
      else divname = max._div_name.mxdiv

    do y = 1 to max._div_ptr.mxdiv.0
      res = write_max_msgarea_ctl_rec(max._div_ptr.mxdiv.y , divname)
      if res = 1
        then leave    /* Area wurde verarbeitet */
    end

    div = mdiv_idx.divname
    if div = 0
      then
      do
        mdiv.0 = mdiv.0 +1
        div = mdiv.0
        mdiv_idx.divname = div
        mdiv._name.div = divname
        mdiv._desc.div = ''
          /* Beschreibung fr Division setzen */
        select
          when max._support = 2
            then nop    /* keine Div-Beschreibung fr Max 2.0 */
          when \divdesc
            then
            do
              gdesc = area._group.a
              gdesc = def._group_ptr.gdesc
              mdiv._desc.div = def._group_desc.gdesc
            end
          when mdiv._desc.div = ''
            then mdiv._desc.div = max._div_desc.mxdiv
          otherwise
        end
      end
  end
  else
  do
      /* Rekursion */
    do y = 1 to max._div_ptr.mxdiv.0
      res = write_max_msgarea_ctl_rec(max._div_ptr.mxdiv.y , '')
      if res
        then leave    /* Area wurde verarbeitet */
    end
    div = 0
  end


if res = 0        /* Area wurde noch nicht verarbeitet */
  then
  do
    if max._div_group_dis.mxdiv.0 > 0
      then
      do
        do y = 1 to max._div_group_dis.mxdiv.0 until match(max._div_group_dis.mxdiv.y, area._group.a)
        end
        res = y <= max._div_group_dis.mxdiv.0
      end

    if max._div_area_dis.mxdiv.0 > 0
      then
      do
        do y = 1 to max._div_area_dis.mxdiv.0 until match(max._div_area_dis.mxdiv.y, area.a)
        end
        if y <= max._div_area_dis.mxdiv.0
          then res = 1
      end

    if \res
      then
      do
        mdiv.div.0 = mdiv.div.0 +1
        z = mdiv.div.0
        if max._support = 3
          then mdiv._area_name.div.z = translate(area.a, '_'char._up, '.'char._low)
          else mdiv._area_name.div.z = area.a
        mdiv._area_ptr.div.z = a    /* Zeiger auf AREA. */
                                    /* Zeiger auf MAX._SET.. und MAX._ACCESS_STR. */
        mdiv._area_set.div.z = max._div_setting.mxdiv acs_ptr (ro_flag | area._acs.a)
        res = 1
      end

  end

return res

/************************************************************************/

write_ext_area_files: procedure expose (common_var)

do y = 1 to ext_area.0
  call wlog replace_str(def._log_str.135, '[%f]', ext_area._file.y)
  select
    when sysfiledelete(ext_area._file.y) > 2
      then call wlog replace_str(def._log_str.105, '[%f]', ext_area._file.y)
    when stream(ext_area._file.y, 'c', 'open') <> 'READY:'
      then call wlog replace_str(def._log_str.105, '[%f]', ext_area._file.y)
    otherwise
      call write_ext_area_files_1

      do ipart = 1 to words(area._idx) by 100
        part_idx = subword(area._idx, ipart, 100)
        do n = 1 to words(part_idx) by 2
          area = word(part_idx, n)
          a = area_idx.area

          if a // 10 = 0
            then call charout, 'W:'format(a, 6)cr

          if \ext_area._pt.y
            then if wordpos('-0', area._sflags.a) > 0
              then iterate n  /* Passthrough Areas nicht ausgeben */


          do z = 1 to ext_area._exc.y.0 until match(ext_area._exc.y.z, area._group.a)
          end
          if z <= ext_area._exc.y.0
            then iterate n        /* Area nicht ausgeben */

          do z = 1 to ext_area._inc.y.0 until match(ext_area._inc.y.z, area._group.a)
          end
          if z > ext_area._inc.y.0
            then iterate n        /* Area nicht ausgeben */

          if ext_area._inc_subst.y.z <> ''
            then i.1 = ext_area._inc_subst.y.z
            else i.1 = area._group.a


          insdata.1 = area.a
          insdata.2 = area._desc.a

          data = ''
          do str = 1 to data.0
            dtype = data._type.str
            select
              when data._len.str = 0
                then insdata = insdata.dtype
              when data._len.str > 0
                then insdata = left(insdata.dtype, data._len.str)
              when length(insdata.dtype) < -data._len.str
                then insdata = left(insdata.dtype, -data._len.str)
              otherwise
                insdata = insdata.dtype
            end
            data = data || data.str || insdata
          end
          data = data || data._last

          if area._format.a = '$'
            then i.2 = ext_area._format_sq.y
            else i.2 = ext_area._format_sdm.y

          call lineout ext_area._file.y, replace_str(data, '[%format]', i.2,,
                                                           '[%group]' , i.1,,
                                                           '[%root]'  , area._root.a,,
                                                           '[%aka]'   , area._paddr.a)





        end
      end
      call stream ext_area._file.y, 'c', 'close'
  end
end

return




write_ext_area_files_1:

data = ext_area._mask.y
str = 0
pattern.1     = '[%AREA '
pattern_len.1 = length(pattern.1)
pattern.2     = '[%DESC '
pattern_len.1 = length(pattern.2)

s_begin = 1
do forever
  datat = translate(data)
  p.1 = pos(pattern.1, datat, s_begin)
  p.2 = pos(pattern.2, datat, s_begin)
  if p.1 = 0 & p.2 = 0
    then leave
  select
    when p.1 = 0
      then p = 2
    when p.2 = 0
      then p = 1
    when p.1 < p.2
      then p = 1
    otherwise
      p = 2
  end
  parse var datat d.1 (pattern.p) len']' +0 d.2
  if \datatype(len, 'w')
    then
    do
      s_begin = s_begin + pattern_len.p
      iterate
    end
  l.1 = length(d.1)
  l.2 = length(d.2) -1
  str = str +1
  data.str = left(data, length(d.1))
  data._type.str = p
  data._len.str  = len
  data = right(data, length(d.2) -1)
end
data._last = data
data.0 = str

return

/************************************************************************/

read_rule_idx: procedure expose (common_var)

select
  when rules._idx <> ''
    then nop
  when rules._file.0 = 0
    then nop
  otherwise
    s = stream(rules._idx_file, 'c', 'query size')
    select
      when s < 1
        then nop
      when stream(rules._idx_file, 'c', 'open read') <> 'READY:'
        then call wlog replace_str(def._log_str.105, '[%f]', rules._idx_file)
      otherwise
                   /* Einlesen und Versionprfung */
        parse value charin(rules._idx_file,, s) with y . 'RAFX' z (crlf) r
        call stream rules._idx_file, 'c', 'close'

        if s <> y | z <> version
          then call make_rule_idx
          else
          do
            parse var r r ' **' rules._idx
            y = 0
            s_begin = 1
            do y = 1 until rest == ''
              parse var r =(s_begin)rules._path_idx.y'*' +1 rest +1
              s_begin = s_begin +length(rules._path_idx.y) +1
            end
            rules._path_idx.0 = y
          end

    end
end

return

/************************************************************************/

make_rule_idx: procedure expose (common_var)

select
  when rules._file.0 = 0 | rules._search.0 = 0
    then call wlog def._log_str.106   /* Erstellung nicht mglich */
  when sysfiledelete(rules._idx_file) > 2
    then call wlog def._log_str.107   /* Fehler beim Lschen */
  when stream(rules._idx_file, 'c', 'open') <> 'READY:'
    then call wlog def._log_str.108   /* Fehler beim ffnen */
  otherwise
    call wlog def._log_str.109   /* Erstelle Rules-Index */
    call lineout rules._idx_file, copies(' ', 12)'RAFX 'version

    cfilter = space(translate(xrange('00'x, 'ff'x), ' ', char._ver), 0)
    ridx. = 0
    pidx  = ''
    r = ''
    do f = 1 to rules._file.0
      if rules._file_sub.f
        then sft_opt = 'fos'
        else sft_opt = 'fo'
      call sysfiletree rules._path.f'\'rules._file.f, 'data', sft_opt
      do y = 1 to data.0
        if y // 10 = 0
          then call charout, 'F:'format(y, 6)cr

        area = ''
        do l = 1 to rules._lines until area <> ''
          parse upper value space(translate(linein(data.y), ' ', '09'x)) with data
          do z = 1 to rules._search.0 until area <> ''
            p = pos(rules._search.z, data)
            if p > 0
              then
              do
                p = p + length(rules._search.z)
                area = word(translate(substr(data, p), ' ', cfilter), 1)
                if length(area) > 200
                  then area = ''
              end
          end
        end
        call stream data.y, 'c', 'close'

        select
          when area = ''
            then nop
          when ridx.area
            then nop
          otherwise
            ridx.area = 1
            parse upper value reverse(data.y) with file'\'path
            file = reverse(file)
            path = reverse(path)
            tpath = translate(path, '*', ' ')
            p = wordpos(tpath, pidx)
            if p = 0
              then
              do
                pidx = pidx tpath
                rules._path_idx.0 = rules._path_idx.0 +1
                p = rules._path_idx.0
                rules._path_idx.p = path
              end
            if length(r) > 3800
              then
              do
                rules._idx = rules._idx || r
                r = ''
              end
            r = r area '*'p'\'file
        end
      end
    end
    rules._idx = rules._idx || r
    do y = 1 to rules._path_idx.0
      call charout rules._idx_file, rules._path_idx.y'*'
    end
    call charout rules._idx_file, ' **'
    call charout rules._idx_file, rules._idx
    call stream rules._idx_file, 'c', 'close'
    call stream rules._idx_file, 'c', 'open'
    call charout rules._idx_file, stream(rules._idx_file, 'c', 'query size')

    call stream rules._idx_file, 'c', 'close'
end

return

/************************************************************************/

set_autokill_inhibit: procedure expose (common_var)

if \autokill._inhibit._read
  then call read_autokill_inhibit

act_date = date('b') -719162

do g = 1 to new_area.0
  do n = 1 to new_area.g.0
    a = new_area.g.n
    area = translate(area.a)
    ak_inh = autokill._inh._idx.area
    if ak_inh = 0
      then
      do
        autokill._inh.0 = autokill._inh.0 +1
        ak_inh = autokill._inh.0
        autokill._inh._idx.area = ak_inh
        autokill._inh._area.ak_inh = area
      end
    autokill._inh._date.ak_inh = act_date
  end
end

do g = 1 to ren_area.0
  do n = 1 to ren_area.g.0
    area_old = translate(ren_area._old.g.n)
    ak_inh = autokill._inh._idx.area_old
    if ak_inh > 0
      then
      do
        a = ren_area.g.n
        area = translate(area.a)
        autokill._inh._idx.area_old = 0
        autokill._inh._idx.area     = ak_inh
        autokill._inh._area.ak_inh  = area
      end
  end
end

do g = 1 to del_area.0
  do n = 1 to del_area.g.0
    a = del_area.g.n
    area = translate(area.a)
    ak_inh = autokill._inh._idx.area
    if ak_inh > 0
      then autokill._inh._date.ak_inh = 0
  end
end

autokill._inhibit._changed = 1

return

/************************************************************************/

write_autokill_inhibit: procedure expose (common_var)


if sysfiledelete(autokill._inhibit) > 2     /* Fehler beim Lschen */
  then call wlog replace_str(def._log_str.166, '[%f]', autokill._inhibit)

select
  when stream(autokill._inhibit, 'c', 'open') <> 'READY:'
    then call wlog replace_str(def._log_str.105, '[%f]', autokill._inhibit)
  otherwise
    call stream autokill._inhibit, 'c', 'seek <0'
    do ak_inh = 1 to autokill._inh.0
      if autokill._inh._date.ak_inh > 0
        then call lineout autokill._inhibit, autokill._inh._area.ak_inh autokill._inh._date.ak_inh
    end
    call stream autokill._inhibit, 'c', 'close'
end

return

/************************************************************************/

read_autokill_inhibit: procedure expose (common_var)

act_date = date('b') -719162
inh_date = act_date - autokill._days

status = 0

if stream(autokill._inhibit, 'c', 'query exists') <> ''
  then
  do
    do y = 1 to 10 while stream(autokill._inhibit, 'c', 'open read') <> 'READY:'
      call syssleep 1
    end
    if y > 10
      then
      do
        call wlog replace_str(def._log_str.105, '[%f]', autokill._inhibit)
        status = 1
      end
      else
      do
        call wlogq replace_str(def._log_str.131, '[%f]', autokill._inhibit)
        do while lines(autokill._inhibit) > 0
          parse upper value linein(autokill._inhibit) with area cdate .
          select
            when area = ''
              then iterate
            when length(area) > 200
              then autokill._inhibit._changed = 1
            when \datatype(cdate, 'w') | cdate < inh_date | cdate > act_date
              then autokill._inhibit._changed = 1
            when \datatype(area_idx.area, 'w')
              then autokill._inhibit._changed = 1

            otherwise
              if autokill._inh._idx.area > 0
                then
                do
                  ak_inh = autokill._inh._idx.area
                  autokill._inhibit._changed = 1
                end
                else
                do
                  autokill._inh.0 = autokill._inh.0 +1
                  ak_inh = autokill._inh.0
                  autokill._inh._area.ak_inh = area
                  autokill._inh._idx.area = ak_inh
                end
              autokill._inh._date.ak_inh = cdate
          end
        end
        call stream autokill._inhibit, 'c', 'close'
        autokill._inhibit._read = 1
      end

  end

return status

/************************************************************************/

autokill_areas: procedure expose (common_var)

if autokill_areas_1() = 0
  then call autokill_areas_2

return



autokill_areas_2:

  /* Aktuelles Jahr, Monat und Tage seit 01.01.1970 ermitteln */
parse value (date('s') date('b')) with act_year +4 act_month +2 . act_date
act_date = act_date -719162
kill_date = min(act_date + autokill._delay, 99998)

ak      = 0     /* Zhler fr zu lschende Areas */
ak.     = 0
ak_idx. = 0

  /*========== Autokill-Areas nach Listen feststellen ==========*/
select
  when \opt._autokill_list
    then nop
  when autokill._list.0 = 0
    then call wlog def._log_str.163    /* Keine Listen angegeben */
  otherwise
    if autokill._list._read = 0
      then call read_autokill_list
    select
      when autokill._list._read < 0
        then call wlog def._log_str.164    /* Keine Areas eingelesen */
      otherwise

          /* Alle lokal vorhandenen Areas mit Kill-Listen vergleichen */

        do ipart = 1 to words(area._idx) by 100
          part_idx = subword(area._idx, ipart, 100)
          do n = 1 to words(part_idx) by 2
            area = word(part_idx, n)
            a = area_idx.area

            if a // 20 = 0
              then call charout, 'A:'format(a, 6)cr

            if kill_area_idx.area = ''
              then
              do
                ak          = ak +1
                ak.ak       = a
                ak._flag.ak = 1
                ak_idx.area = ak
              end
          end
        end
    end
end

  /*========== Autokill-Areas nach Zeit feststellen ==========*/
select
  when \opt._autokill_days
    then nop
  when autokill._days = 0
    then call wlog def._log_str.162
  otherwise
    call autokill_areas_3
end


  /*========== Autokill-Areas filtern ==========*/
ak_idx. = 0   /* Index-Stem Kill-Areas lschen */
z       = 0
do y = 1 to ak
  if y // 10 = 0
    then call charout, 'K:'format(y, 6)cr
  a = ak.y

  do v = 1 to autokill._group_inc.0 until match(autokill._group_inc.v, area._group.a)
  end
  if v > autokill._group_inc.0
    then iterate      /* Areas dieser Gruppe nicht lschen */
  do v = 1 to autokill._group_exc.0 until match(autokill._group_exc.v, area._group.a)
  end
  if v <= autokill._group_exc.0
    then iterate      /* Areas dieser Gruppe nicht lschen */
  do v = 1 to autokill._area_inc.0 until match(autokill._area_inc.v, area.a)
  end
  if v > autokill._area_inc.0
    then iterate      /* Diese Area nicht lschen */
  do v = 1 to autokill._area_exc.0 until match(autokill._area_exc.v, area.a)
  end
  if v <= autokill._area_exc.0
    then iterate      /* Diese Area nicht lschen */

  select
    when  wordpos('-K', area._rflags.a) > 0
      then iterate      /* Area ist geschtzt */
    when area._level.a > autokill._level
      then iterate      /* Level ist zu gro */
    when  verify(area._keys.a, autokill._keys) > 0
      then iterate      /* Zuviele Keys */

    when area._upl_addr.a <> ''
      then nop
    when \autokill._local
      then iterate      /* lokale Area nicht bearbeiten */
    otherwise
  end

  area  = translate(area.a)
  z = z +1
  ak.z = ak.y
  ak._flag.z = ak._flag.y
  ak_idx.area = z
end
ak = z

/*========================================================================
ak                    Anzahl der zum Lschen gefundenen Areas
ak.n                  Zeiger auf Area-Vars
ak._flag.n            1   Area in Kill-Liste
                      2   Area nach Zeit
                      3   Area in Kill-Liste und nach Zeit
ak_idx.<tag>          Index-Stem der Kill-Areas. Variable ist jeweils
                      mit Zeiger auf AK. (> 0) initialisiert
========================================================================*/
/*========================================================================
ak_his._changed       0 = Keine nderung
                      1 = History mu neu erstellt werden
ak_his                Anzahl der in Kill-History aufgefhrten aktuellen Areas
ak_his._area.n        Area-Tags
ak_his._date.1.n      Lschdatum nach Kill-Liste (ohne Angabe = 99999)
ak_his._date.2.n      Lschdatum nach Zeit (ohne Angabe = 99999)
ak_his_idx.<tag>      Index-Stem der Kill-History. Variable ist jeweils
                      mit Zeiger auf AK_HIS. (> 0) initialisiert.

========================================================================*/

ak_warn = 0
select
  when ak = 0 | autokill._delay = 0
    then       /* Keine Area zum Lschen/Warnen gefunden */
    do
      /*==========  Nicht zu bearbeitende History-Eintrge filtern ==========*/
      select
        when \opt._autokill_days
          then call autokill_areas_53 1, 2
        when \opt._autokill_list
          then call autokill_areas_53 2, 1
        otherwise    /* Keine der History-Eintrge erhalten */
          drop ak_his.
          ak_his = 0
      end
      drop ak_his_idx.
      drop ak_idx.
      ak_his._changed = 1
    end
  otherwise

    /*==========  Nicht zu bearbeitende History-Eintrge filtern ==========*/
    select
      when \opt._autokill_days
        then call autokill_areas_50 1, 2
      when \opt._autokill_list
        then call autokill_areas_50 2, 1
      otherwise
        do y = 1 to ak_his
          area = ak_his._area.y
          if ak_idx.area = 0      /* History-Eintrag entfllt */
            then
            do
              ak_his._area.y  = ''
              drop ak_his._date.1.y,
                   ak_his._date.2.y
              ak_his._changed = 1
              ak_his_idx.area = 0
            end
        end
    end
    drop ak_idx.

    ak_del  = 0
    do y = 1 to ak
      a    = ak.y
      area = translate(area.a)

      his  = ak_his_idx.area
      select
        when his = 0
          then   /* Noch kein History-Eintrag vorhanden -> Warnung */
          do
            ak_his = ak_his +1
            ak_his._area.ak_his = area
            if ak._flag.y = 1
              then ak_his._date.2.ak_his = 99999
              else ak_his._date.2.ak_his = kill_date
            if ak._flag.y = 2
              then ak_his._date.1.ak_his = 99999
              else ak_his._date.1.ak_his = kill_date
            ak_his._changed = 1

            ak_warn = ak_warn +1
            ak_warn.ak_warn      = ak.y
            ak_warn._flag.ak_warn = ak._flag.y
          end

                 /* History-Eintrag schon vorhanden */

        when ak._flag.y = 1
          then   /* Area nur in Kill-Liste */
          do
            select
              when ak_his._date.1.his <= act_date
                then call autokill_areas_51 1   /* Area jetzt lschen */
              when kill_date < ak_his._date.1.his
                then call autokill_areas_52 1   /* Neues Lschdatum */
              otherwise
            end                                 /* Keine Aktion */
          end
        when ak._flag.y = 2
          then   /* Area nur nach Zeit */
          do
            select
              when ak_his._date.2.his <= act_date
                then call autokill_areas_51 2   /* Area jetzt lschen */
              when kill_date < ak_his._date.2.his
                then call autokill_areas_52 2   /* Neues Lschdatum */
              otherwise
            end                                 /* Keine Aktion */
          end

                 /* Area in Kill-Liste und nach Zeit */

        when ak_his._date.1.his <= act_date
          then call autokill_areas_51 1   /* Area jetzt lschen */
        when ak_his._date.2.his <= act_date
          then call autokill_areas_51 2   /* Area jetzt lschen */

        when kill_date < ak_his._date.1.his

          then     /* Neues Lschdatum */
          do
            ak_warn = ak_warn +1
            ak_warn.ak_warn = ak.y

            ak_his._date.1.his = kill_date
            if kill_date < ak_his._date.2.his
              then
              do
                ak_his._date.2.his = kill_date
                ak_warn._flag.ak_warn = 3
              end
              else ak_warn._flag.ak_warn = 1
            ak_his._changed = 1
          end
        when kill_date < ak_his._date.2.his
          then call autokill_areas_52 2   /* Neues Lschdatum */
        otherwise
                   /* Keine Aktion */
      end


    end

    drop ak_his_idx.
    ak = ak_del
end

  /*========== Autokill-History neu erstellen ==========*/
if ak_his._changed = 1
  then
  do
    call wlogq replace_str(def._log_str.135, '[%f]', autokill._history)
    res = sysfiledelete(autokill._history)
    select
      when res > 2
        then call wlog replace_str(def._log_str.166, '[%f]', autokill._history)
      when stream(autokill._history, 'c', 'open') <> 'READY:'
        then call wlog replace_str(def._log_str.150, '[%f]', autokill._history)
      otherwise
        do y = 1 to ak_his
          if ak_his._area.y <> ''
            then call lineout autokill._history,,
                    ak_his._area.y ak_his._date.1.y'/'ak_his._date.2.y
        end
        call stream autokill._history, 'c', 'close'
    end
  end


if ak_warn > 0                      /* Warnungen */
  then call autokill_areas_notify
if ak > 0                           /* Lschungen */
  then
  do
    call wlog def._log_str.175
    do i = 1 to ak
      if i // 10 = 0
        then call charout, 'A:'format(i, 6)cr
      a = ak.i
      flag = ak._flag.i + 171
      call wlog ':' left(area.a, max(length(area.a) +1, 27)) ||,
                def._log_str.flag
      call unlink_area a, ak._flag.i, 1
      area._sqdata.a = ''
      area._rafx.a   = ''
      squish._cfg._changed = 1
    end
  end

return



  /* Lschdatum in History ndern, Warnung registrieren */
autokill_areas_52:
arg flag
ak_his._date.flag.his = kill_date
ak_his._changed = 1

ak_warn = ak_warn +1
ak_warn.ak_warn       = ak.y
ak_warn._flag.ak_warn = ak._flag.y
return



  /* Eintrag aus History lschen, Lschung registrieren */
autokill_areas_51:
arg flag
ak_his_idx.area  = 0
ak_his._area.his = ''
drop ak_his._date.1.his,
     ak_his._date.2.his
ak_his._changed = 1

ak_del = ak_del +1
ak.ak_del       = ak.y
ak._flag.ak_del = flag
return




  /* History-Eintrge filtern, die nicht ausgewertet werden */
autokill_areas_53:
arg flag1, flag2
do y = 1 to ak_his
  if ak_his._date.flag2.y < 99999
    then ak_his._date.flag1.y = 99999     /* Eintrag bleibt erhalten */
    else
    do
      ak_his._area.y  = ''
      drop ak_his._date.1.y,
           ak_his._date.2.y
    end
end
return



  /* History-Eintrge filtern, die nicht ausgewertet werden */
autokill_areas_50:
arg flag1, flag2
do y = 1 to ak_his
  area = ak_his._area.y
  if ak_idx.area = 0         /* Eintrag nicht weiter auswerten */
    then
    do
      select
        when ak_his._date.flag2.y = 99999
          then                          /* History-Eintrag entfllt */
          do
            ak_his._area.y  = ''
            drop ak_his._date.1.y,
                 ak_his._date.2.y
            ak_his._changed = 1
          end
        when ak_his._date.flag1.y = 99999
          then nop                      /* History-Eintrag nicht gendert */
        otherwise
          ak_his._date.flag1.y = 99999  /* Eintrag wird aktualisert */
          ak_his._changed = 1
      end

      ak_his_idx.area = 0
    end
end
return



  /* Squish-Logfile auswerten */
autokill_areas_3:

kill_area_stat_idx. = ''
months    = 'JAN FEB MAR APR MAY JUN JUL AUG SEP OCT NOV DEC'
log_day1  = ''
log_year  = 100

call close_logfile
do y = 1 to 10 while stream(squish._logfile, 'c', 'open read') <> 'READY:'
  call syssleep 1
end
if y <= 10
  then
  do
      /* In diesem Block keine Ausgaben ins Logfile ! */
    call wlogq replace_str(def._log_str.131, '[%f]', squish._logfile)

      /* Datum der ersten Aufzeichnung ermitteln */
    do while lines(squish._logfile) > 0
      parse upper value linein(squish._logfile) with . +1 l_day log_month1 . ident .
      select
        when ident <> squish._logfile_ident
          then nop
        when \datatype(l_day, 'w')
          then nop
        otherwise
          old_month_name = log_month1
          log_month1     = wordpos(log_month1, months)
          if log_month1 > 0
            then
            do
              log_day1      = l_day
              old_month_num = log_month1
              log_month     = log_month1
              leave
            end
      end
    end
    call stream squish._logfile, 'c', 'seek =1'

      /* Wenn auswertbar, dann Squish-Logfile zeilenweise auswerten */
    if log_day1 <> ''
      then
      do l = 1 while lines(squish._logfile) > 0
        data = linein(squish._logfile)
        if l // 200 = 0
          then call charout , 'R:'format(l, 6) || cr

        parse upper var data log_level +1 l_day l_month . ident log_data
        if ident <> squish._logfile_ident
          then iterate                      /* Keine Zeile von Squish */
        if \datatype(l_day, 'w')
          then iterate                      /* Ungltige Zeile */

        if l_month <> old_month_name
          then                              /* Monatswechsel */
          do
            l_month = wordpos(l_month, months)
            if l_month = 0
              then iterate
            log_month = l_month
            if abs(log_month - old_month_num) > 6
              then log_year = log_year +1   /* Jahreswechsel */
            old_month_num  = log_month
            old_month_name = l_month
          end

        log_day = l_day
        if log_level <> ':'
          then iterate                  /* Zeile nicht auswerten */

        parse var log_data area . '('log_toss')'

        if log_toss = '' | area = ''
          then iterate                  /* Ungltige Zeile */
        if length(area) > 200
          then iterate                  /* Ungltige Zeile */

        parse var log_toss 'TOSS=' log_toss . =1 . 'SENT=' log_sent .
        log_toss = log_toss || log_sent
        if log_toss = ''
          then iterate                  /* Keine Daten zu Toss und Sent */
        if verify(log_toss, '0123456789') > 0
          then iterate                  /* Unerlaubtes Zeichen bei Toss oder Sent */
        if verify(log_toss, '0') = 0
          then iterate                  /* Nichts getossed oder versandt */

                                        /* Datum letztes Tossen/Senden */
        kill_area_stat_idx.area = log_year'/'right(log_month, 2, 0)'/'right(log_day, 2, 0)
      end

    call stream squish._logfile, 'c', 'close'
    call open_logfile
  end
  else
  do
    call open_logfile
    call wlog replace_str(def._log_str.105, '[%f]', squish._logfile)
  end


if log_day1 <> ''
  then
  do
    if act_month < log_month
      then log_year = log_year +1
    dd = act_date -autokill._days +1
    z = (dd -0.5) %365.25
    yy = z +1970
    dd = dd -(z *365.25 +0.25) %1
    do mm = 12 to 1 by -1
      z = word('0 31 60 91 121 152 182 213 244 274 305 335',
           '0 31 59 90 120 151 181 212 243 273 304 334',sign(yy//4)*12+mm)
      if dd > z
        then
        do
          dd = dd -z
          leave
        end
    end
    yy = yy -act_year +log_year
    min_date =  right(yy, 3, 0)'/'right(mm, 2, 0)'/'right(dd, 2, 0)

    if '100/'right(log_month1, 2, 0)'/'right(log_day1, 2, 0) <= min_date
      then             /* Log-File reicht lang genug zurck */
      do
        if \autokill._inhibit._read
          then call read_autokill_inhibit

        do ipart = 1 to words(area._idx) by 100
          part_idx = subword(area._idx, ipart, 100)
          do n = 1 to words(part_idx) by 2
            area = word(part_idx, n)
            a = area_idx.area

            if a // 20 = 0
              then call charout, 'A:'format(a, 6) || cr

            select
              when kill_area_stat_idx.area >= min_date
                then nop                          /* Area mit traffic */
              when autokill._inh._idx.area > 0
                then nop                          /* Area erst krzlich erstellt */

              when ak_idx.area > 0
                then      /* Area schon aufgrund Kill-Liste registriert */
                do
                  p = ak_idx.area
                  ak._flag.p = 3
                end
              otherwise
                ak          = ak +1
                ak.ak       = a
                ak._flag.ak = 2
                ak_idx.area = ak
            end
          end
        end
      end

  end
  else call wlog replace_str(def._log_str.165, '[%f]', squish._logfile)

drop kill_area_stat_idx.

return




  /* Autokill-History einlesen */
autokill_areas_1:

status          = 0
ak_his._changed = 0
ak_his          = 0
ak_his_idx.     = 0
if stream(autokill._history, 'c', 'query exists') <> ''
  then
  do
    do y = 1 to 10 while stream(autokill._history, 'c', 'open read') <> 'READY:'
      call syssleep 1
    end
    if y > 10
      then
      do
        call wlog replace_str(def._log_str.105, '[%f]', autokill._history)
        status = 1
      end
      else
      do
        call wlogq replace_str(def._log_str.131, '[%f]', autokill._history)
        v = 0
        do while lines(autokill._history) > 0
          data = linein(autokill._history)
          if data = ''
            then iterate
          v = v +1
          ak_his._area.v = data
        end
        call stream autokill._history, 'c', 'close'
        do y = 1 to v
          parse upper var ak_his._area.y area date1'/'date2
          select
            when length(area) > 200
              then ak_his._changed = 1

            when \datatype(area_idx.area, 'w')
              then ak_his._changed = 1
            when \datatype(date1, 'w') | \datatype(date2, 'w')
              then ak_his._changed = 1
            when date1 < 0 | date2 < 0
              then ak_his._changed = 1
            when date1 > 99999 | date2 > 99999
              then ak_his._changed = 1
            otherwise
              ak_his = ak_his +1
              ak_his._area.ak_his   = area
              ak_his._date.1.ak_his = date1
              ak_his._date.2.ak_his = date2
              ak_his_idx.area       = ak_his
          end
        end
      end
  end

return status




/* Warnungen registrieren */

autokill_areas_notify:

warn_area._date = autokill_areas_notify_1(kill_date)
parse var warn_area._date kill_date_year kill_date_month kill_date_day
call wlog replace_str(def._log_str.170,,
                      '[%d]', kill_date_day,,
                      '[%m]', kill_date_month,,
                      '[%y]', kill_date_year)

do i = 1 to ak_warn
  a = ak_warn.i
  flag = ak_warn._flag.i + 171
  call wlog ':' left(area.a, max(length(area.a) +1, 27)) || def._log_str.flag

     /* angewarnte Area registrieren */
  grp = wordpos(area._group.a, warn_area._group)
  if grp = 0
    then
    do
      warn_area._group = warn_area._group || area._group.a' '
      warn_area.0 = warn_area.0 +1
      grp = warn_area.0
      warn_area.grp.0 = 1
    end
    else warn_area.grp.0 = warn_area.grp.0 +1

  p = warn_area.grp.0
  warn_area.grp.p = a
  warn_area._init.grp.p = ak_warn._flag.i

end

return




/* Kill-Datum nach Tag, Monat und Jahr wandeln */

autokill_areas_notify_1: procedure

arg dd
dd = dd +1
z = (dd -0.5) %365.25
yy = z +1970
dd = dd -(z *365.25 +0.25) %1
do mm = 12 to 1 by -1
  z = word('0 31 60 91 121 152 182 213 244 274 305 335',
       '0 31 59 90 120 151 181 212 243 273 304 334',sign(yy//4)*12+mm)
  if dd > z
    then
    do
      dd = dd -z
      leave
    end
end
res =  yy right(mm, 2, '0') right(dd, 2, '0')

return res

/************************************************************************/

read_autokill_list: procedure expose (common_var)

autokill._list._read = -1
do y = 1 to autokill._list.0
  if stream(autokill._list.y, 'c', 'open read') <> 'READY:'
    then call wlog replace_str(def._log_str.105, '[%f]', autokill._list.y)
    else
    do
      call wlogq replace_str(def._log_str.131, '[%f]', autokill._list.y)
      parse value translate(charin(autokill._list.y,, chars(autokill._list.y)), ' ', '9'x) with fstr '1a'x
      call stream autokill._list.y, 'c', 'close'
      s_begin = 1
      do until rest == ''
        parse var fstr =(s_begin)data(crlf) +2 rest +1
        s_begin = s_begin +length(data) +2
        parse upper var data area . ';' .
        select
          when area = ''
            then nop
          when length(area) > 200
            then nop
          otherwise
            kill_area_idx.area = ''
            autokill._list._read = 1
        end
      end
    end
end

return autokill._list._read > 0

/************************************************************************/

match: procedure

/*======================================================================
arg pattern, string
select
  when pattern == '*'
    then res = 1
  when pattern == ''
    then res = 0
  otherwise
    pattern = ' 'pattern' '
    string  = ' 'string' *'
    res = 1
    do until res = 0 | pattern == ''
      parse var pattern pt'*'pattern
      parse var string (pt)rest
      res = rest \== ''
    end
end
======================================================================*/
arg pattern, string

if pattern == ''
  then return 0

if pattern == '*'
  then return 1

pattern = ' 'pattern' '
string  = ' 'string' *'
do until \res | pattern == ''
  parse var pattern pt'*'pattern
  parse var string (pt)rest
  res = rest \== ''
end

return res

/************************************************************************/

check_changed_areas: procedure expose (common_var)

do n = 1 to words(area._changed)
  a = word(area._changed, n)
  call charout, 'D:'format(a, 6)cr
  select
    when wordpos('-0', area._sflags.a) = 0
      then nop                        /* keine Passthrough-Area */

    when area._upl_addr.a = '' |,     /* Lokale EchoArea */
        (words(area._node_l.a) +,     /* mehr als 1 Link */
         words(area._node_p.a) >= 2)
      then call del_area_files a, 1
    otherwise                         /* Echo nur mit Uplink */
      call unlink_area a, 0
  end
end

return

/************************************************************************/

del_area_files: procedure expose (common_var)

arg a, flag

select
  when area._format.a = '$'
    then                          /* Squish-Area */
    do
      root = filespec('n', area._root.a)
      l = length(root) +2
      call sysfiletree area._root.a'.*', 'data', 'fo'
      do z = 1 to data.0
        data = translate(filespec('n', data.z))
        if pos('.', data, l) > 0
          then iterate z
        do v = 1 to keep._file_sq.flag.0
          if root || keep._file_sq.flag.v = data
            then iterate z
        end
        call sysfiledelete data.z
      end
    end
                                  /* *.MSG-Area */
  when directory(area._root.a) = ''
    then call directory dir._act
  otherwise
    do z = 1 to keep._file_sdm.flag.0
      call sysfiletree keep._file_sdm.flag.z, 'data', 'f', '*-**-', '*-++-'
    end
    '@del * /n 2>nul >nul'
    call sysfiletree '*', 'data', 'f', '*-++-', '*----'
    if flag = 2
      then
      do
        call directory '\'
        call sysrmdir area._root.a
      end
    call directory dir._act

end

return

/************************************************************************/

/* Area lschen */

unlink_area: procedure expose (common_var)

arg a, del_init, dnl_flag

call del_area_files a, 2      /* Area-Files lschen */

  /* Area-Definitionen lschen */

area = translate(area.a)
p = wordpos(area, area._idx)
if p > 0   /* Area-Index aktualisieren */
  then area._idx = delword(area._idx, p , 2)
drop area_idx.area

     /* Unlink-Kommando fr Uplink festhalten */
upl = wordpos(' 'area._upl_addr.a, upl._addr_idx)
if upl > 0
  then
  do
    p = wordpos('+'area, upl._cmd.upl)
    if p > 0
      then upl._cmd.upl = delword(upl._cmd.upl, p, 1)
      else upl._cmd.upl = upl._cmd.upl || '-'area' '
    upl._cmd = 1
  end

     /* aktuell gelschte Area registrieren */
grp = wordpos(area._group.a, del_area._group)
if grp = 0
  then
  do
    del_area._group = del_area._group || area._group.a' '
    del_area.0 = del_area.0 +1
    grp = del_area.0
    del_area.grp.0 = 1
  end
  else del_area.grp.0 = del_area.grp.0 +1

p = del_area.grp.0
del_area.grp.p = a
del_area._init.grp.p = del_init

if dnl_flag <> ''
  then           /* Bisherige Downlinks erhalten Nachricht */
  do
    upl = wordpos(' 'area._upl_addr.a, area._node_l.a)
    if upl = 0
      then del_area._dnl.grp.p = area._node_l.a area._node_p.a
      else del_area._dnl.grp.p = delword(area._node_l.a, upl, 1) area._node_p.a
  end
  else del_area._dnl.grp.p   = ''

     /* Del-Area-Index aktualisieren */
if wordpos(area, del_area._idx) = 0
  then
  do
    del_area._idx     = del_area._idx || area '*'a' '
    area._deadline.a  = xd2datetime(unix_date() +del_area._wait *86400)
    area._node_l.a    = area._upl_addr.a
    area._node_x.a    = ' '
    area._node_u.a    = ' '
    area._group.a     = 'DELETED_AREA'
    if wordpos('-0', area._sflags.a) = 0
      then area._sflags.a = area._sflags.a '-0'

     /* unbentigte Varaiblen droppen */
    drop area._upl_addr.a,
         area._line.a    ,
         area._rflags.a  ,
         area._node_p.a  ,
         area._acs.a     ,
         area._desc.a
/*======================================================================
         area._level.a   ,
         area._keys.a    ,
======================================================================*/
  end


return

/************************************************************************/

set_area_data: procedure expose (common_var)

call wlogq def._log_str.110   /* berprfe Area-Daten */

do ipart = 1 to words(area._idx) by 100
  part_idx = subword(area._idx, ipart, 100)
  do n = 1 to words(part_idx) by 2
    area = word(part_idx, n)
    a = area_idx.area

    if a // 10 = 0
      then call charout, 'A:'format(a, 6)cr

    select
      when (area._group.a = 'N_A' & opt._set_area = 2) | opt._set_area = 3
        then
        do upl = 1 to upl.0
          do m = 1 to upl._area.upl.0

            if query_area_file(area.a, upl, m) > 0
              then
              do
                call wlog replace_str(def._log_str.111, '[%a]', area.a)
                area._group.a = upl._area_group.upl.m
                area._level.a = upl._area_level.upl.m
                area._acs.a   = upl._area_acs.upl.m
                area._keys.a  = upl._area_keys.upl.m
                if area._upl_addr.a = ''
                  then area._upl_addr.a = upl._addr.upl
                if found.2.1 <> ''
                  then area._desc.a = found.2.1
                  else area._desc.a = def._area_desc

                area._sqdata.a = ''
                area._rafx.a = ''
                squish._cfg._changed = 1
                leave upl
              end
          end
        end
      when opt._set_area > 1
        then nop
      when area._desc.a <> '' & area._desc.a <> def._area_desc
        then nop
      otherwise
        do upl = 1 to upl.0
          do m = 1 to upl._area.upl.0
            select
              when query_area_file(area.a, upl, m) = 0
                then nop
              when found.2.1 <> ''
                then
                do
                  call wlog replace_str(def._log_str.111, '[%a]', area.a)
                  area._desc.a = found.2.1
                  area._sqdata.a = ''
                  area._rafx.a = ''
                  squish._cfg._changed = 1
                  leave upl
                end
              when area._desc <> ''
                then nop
              otherwise
                call wlog replace_str(def._log_str.111, '[%a]', area.a)
                area._desc.a = def._area_desc
                area._sqdata.a = ''
                area._rafx.a = ''
                squish._cfg._changed = 1
                leave upl
            end
          end
        end

    end

  end
end

return

/************************************************************************/

proc_autolink: procedure expose (common_var)

if open_area_nm_out(netmail_out._ptr) = 0  /* Ausgangs-Netarea schon offen */
  then
  do dnl = 1 to dnl.0   /* alle Downlinks */
    autolink. = 0

    if \dnl._group_exp.dnl
      then call expand_dnl_groups dnl

    grp = wordpos(1, dnl._group_autolink.dnl)
    if grp = 0
      then iterate dnl  /* Downlink ist bei keiner Gruppe Autolink */

    do while grp > 0
      call charout, 'G:'format(grp, 6)cr

      g = wordpos(word(dnl._group.dnl, grp), new_area._group)
      if g > 0
        then  /* Gruppe mit neuen Areas und Downlink hat Autolink */
        do
          do y = 1 to new_area.g.0

            a = new_area.g.y
            if word(query_area_link(dnl, a), 1) <> 0
              then iterate y    /* Nicht schalten, wenn schon geschaltet */

            if area._level.a > dnl._level.dnl |,
               verify(area._keys.a, dnl._keys.dnl) > 0
              then iterate y    /* Zugriffslevel nicht ausreichend */

            call proc_req_ins_addr a, dnl._group_addr.dnl.grp /* Link hinzufgen */
            if dnl._group_acs.dnl.grp | area._acs.a           /* Read-Only */
              then area._node_x.a = area._node_x.a || dnl._group_addr.dnl.grp || ' '

              /* Passthrough-Flag testen */
            if bitand(dnl._flags.dnl, '00000004'x) = '00000000'x
              then
              do
                p = wordpos('-0', area._sflags.a)
                if p > 0
                  then area._sflags.a = space(delword(area._sflags.a, p, 1))
              end

            area._sqdata.a = ''
            area._rafx.a   = ''
            squish._cfg._changed = 1

            autolink.0 = autolink.0 +1
            autolink.grp.0 = autolink.grp.0 +1
            z = autolink.grp.0
            autolink.grp.z = a

          end
        end
      grp = wordpos(1, dnl._group_autolink.dnl, grp +1)
    end

    if autolink.0 = 0
      then iterate dnl

    /* Autolink-Report an Downlink */

    call wlog replace_str(def._log_str.112, '[%a]', dnl._addr.dnl.1)

    lng = dnl._language.dnl
    m_text._subject = def._str.lng.134
    m_text._part = m_text._part || cr || def._str.lng.100 || cr
    do grp = 1 to words(dnl._group.dnl)
      if autolink.grp.0 = 0
        then iterate grp

      call set_msg_text_group_hdr word(dnl._group.dnl, grp), lng
      do z = 1 to autolink.grp.0
        a = autolink.grp.z
        call wlog ':' area.a
        m_text._part = m_text._part'  'wrap_area_desc(area.a, area._desc.a) || cr
        call send_rsp_split_msg_part dnl, address.1, dnl._addr.dnl.1
      end
    end

    m_text._part = m_text._part || cr || cr ||,
                   def._str._78dash || cr ||,
                   replace_str(def._str.lng.101, '[%n]', autolink.0) || cr
    call send_rsp_split_msg dnl, address.1, dnl._addr.dnl.1

  end   /* dnl */

return

/************************************************************************/

send_echo_split_msg_part: procedure expose (common_var)

parse arg from_addr, from_name, dest_name, lng

select
  when length(m_text._part) < 1024
    then nop
  when length(m_text._all) < ann._msg_length
    then
    do
      m_text._all = m_text._all || m_text._part
      m_text._part = ''
    end
  otherwise
    msg._text.1 = m_text._all ||,
                  m_text._part || cr ||,
                  def._str.lng.152 || cr || cr
    call send_echo_split_msg_1
    m_text._all  = ''
    m_text._part = def._str.lng.153 || cr || cr
end
return

/************************************************************************/

send_echo_split_msg: procedure expose (common_var)

parse arg from_addr, from_name, dest_name
msg._text.1 = m_text._all || m_text._part || cr
call send_echo_split_msg_1
m_text. = ''

return

send_echo_split_msg_1:
m_text._num  = ('0'm_text._num) +1
if m_text._num = 1
  then
  do
    msg._subject.1 = m_text._subject
    msg._from_addr.1    = from_addr
    msg._from_name.1    = from_name
    msg._dest_name.1    = dest_name
    msg._dest_addr.1    = '0:0/0.0'
    msg._attr.1         = '00000100'x  /* LOC */
    msg._date_written.1 = ''
    msg._date_arrived.1 = ''
    msg._ftsc_date.1    = ''
    msg._replyto.1      = 0
    msg._replies.1.0    = 0
    msg._utc_ofs.1      = 0
    msg._times_read.1   = 0
    msg._cost.1         = 0
  end
  else msg._subject.1 = m_text._subject '('m_text._num')'
msg._ctrl.1 = 'MSGID:' msg._from_addr.1 d2x(set_msgid_next(), 8)
parse value (from_addr' ') with addr'.0 '
addr = strip(addr)
msg._text.1 = msg._text.1 || def._tearline || cr ||,
  delstr(' * Origin: 'def._origin, 77 -length(addr))' ('addr')' || cr
if sq_create_msg(2, 1) < 0
  then call log_rsqa_error 'sq_create_msg send_echo_split_msg'
res._echomail = res._echomail +1
msg._text.1 = ''
return

/************************************************************************/

/* Neue Areas in Echos ankndigen */

send_announce: procedure expose (common_var)

act_hdr_ftr = ''      /* aktuelles Header-Footer-File */

do n = 1 to ann._area.0
  if ann._area.n = 0
    then iterate

  ann_new  = 0
  ann_del  = 0
  ann_ren  = 0
  ann_warn = 0

  if new_area.0 > 0 & ann._group._new.n.0 > 0
    then
    do g = 1 to new_area.0
      gname = word(new_area._group, g)
      if g_name = 'N_A'
        then iterate g
      do t = 1 to ann._group._new.n.0 until match(ann._group._new.n.t, gname)
      end
      if t > ann._group._new.n.0
        then iterate g
      ann_new = ann_new +1
      ann_new.ann_new = g
    end

  if del_area.0 > 0 & ann._group._del.n.0 > 0
    then
    do g = 1 to del_area.0
      gname = word(del_area._group, g)
      if g_name = 'N_A'
        then iterate g
      do t = 1 to ann._group._del.n.0 until match(ann._group._del.n.t, gname)
      end
      if t > ann._group._del.n.0
        then iterate g
      ann_del = ann_del +1
      ann_del.ann_del = g
    end

  if ren_area.0 > 0 & ann._group._ren.n.0 > 0
    then
    do g = 1 to ren_area.0
      gname = word(ren_area._group, g)
      if g_name = 'N_A'
        then iterate g
      do t = 1 to ann._group._ren.n.0 until match(ann._group._ren.n.t, gname)
      end
      if t > ann._group._ren.n.0
        then iterate g
      ann_ren = ann_ren +1
      ann_ren.ann_ren = g
    end

  if warn_area.0 > 0 & ann._group._warn.n.0 > 0
    then
    do g = 1 to warn_area.0
      gname = word(warn_area._group, g)
      if g_name = 'N_A'
        then iterate g
      do t = 1 to ann._group._warn.n.0 until match(ann._group._warn.n.t, gname)
      end
      if t > ann._group._warn.n.0
        then iterate g
      ann_warn = ann_warn +1
      ann_warn.ann_warn = g
    end

  if ann_new = 0 & ann_del = 0 & ann_ren = 0 & ann_warn = 0
    then iterate n      /* nichts zum Announcen, nchste Area */

  a = ann._area.n
  lng = ann._language.n
    /* Announce in Area' area.a */
  call wlog replace_str(def._log_str.113, '[%a]', area.a)

  select
    when area._group.a = 'DELETED_AREA'
      then call wlog def._log_str.114
    when wordpos('-0', area._sflags.a) > 0
      then call wlog def._log_str.115

    when send_announce_1() > 0
      then iterate n   /* Announce in dieser Area abbrechen */

    when open_area(2, area._root.a, area._format.a, 'n') < 0
      then nop          /* Fehler beim ffnen */

    otherwise

      if ann_new > 0
        then
        do
          m_text._subject = def._str.lng.143
          m_text._part = text._header_new
          do g = 1 to ann_new
            grp = ann_new.g
            call set_msg_text_group_hdr word(new_area._group, grp), lng
            do na = 1 to new_area.grp.0
              pna = new_area.grp.na
              m_text._part = m_text._part || '  ' || wrap_area_desc(area.pna, area._desc.pna) || cr
              call send_echo_split_msg_part ann._from_addr.n, ann._from_name.n, ann._dest_name.n, lng
            end
          end
          m_text._part = m_text._part || cr || text._footer_new
          call send_echo_split_msg ann._from_addr.n, ann._from_name.n, ann._dest_name.n
        end

      if ann_del > 0
        then
        do
          m_text._subject = def._str.lng.197
          m_text._part = text._header_del
          do g = 1 to ann_del
            grp = ann_del.g
            call set_msg_text_group_hdr word(del_area._group, grp), lng
            do na = 1 to del_area.grp.0
              pna = del_area.grp.na
              flag = del_area._init.grp.na +200
              m_text._part = m_text._part ||,
                        replace_str(def._str.lng.112, '[%a]', area.pna) || cr ||,
                        replace_str(def._str.lng.175, '[%r]', def._str.lng.flag) || cr || cr
              call send_echo_split_msg_part ann._from_addr.n, ann._from_name.n, ann._dest_name.n, lng
            end
          end
          m_text._part = m_text._part || cr || text._footer_del
          call send_echo_split_msg ann._from_addr.n, ann._from_name.n, ann._dest_name.n
        end

      if ann_ren > 0
        then
        do
          m_text._subject = def._str.lng.198
          m_text._part = text._header_ren
          do g = 1 to ann_ren
            grp = ann_ren.g
            call set_msg_text_group_hdr word(ren_area._group, grp), lng
            do na = 1 to ren_area.grp.0
              pna = ren_area.grp.na
              m_text._part = m_text._part ||,
                  replace_str(def._str.lng.178, '[%a]', area.pna) || cr ||,
                  replace_str(def._str.lng.179, '[%a]', ren_area._old.grp.na) || cr || cr
            end
          end
          m_text._part = m_text._part || cr || text._footer_ren
          call send_echo_split_msg ann._from_addr.n, ann._from_name.n, ann._dest_name.n
        end

      if ann_warn > 0
        then
        do
          m_text._subject = def._str.lng.199
          m_text._part = replace_str(text._header_warn,,
                                     '[%d]', word(warn_area._date, 3),,
                                     '[%m]', word(warn_area._date, 2),,
                                     '[%y]', word(warn_area._date, 1))
          do g = 1 to ann_warn
            grp = ann_warn.g
            call set_msg_text_group_hdr word(warn_area._group, grp), lng
            do na = 1 to warn_area.grp.0
              pna = warn_area.grp.na
              flag = warn_area._init.grp.na +200
              m_text._part = m_text._part ||,
                        replace_str(def._str.lng.112, '[%a]', area.pna) || cr ||,
                        replace_str(def._str.lng.175, '[%r]', def._str.lng.flag) || cr || cr
            end
          end
          m_text._part = m_text._part || cr || text._footer_warn
          call send_echo_split_msg ann._from_addr.n, ann._from_name.n, ann._dest_name.n
        end

      call sq_close_area 2        /* Area schliessen */
  end
  if wordpos(translate(area.a), echotoss._new) = 0
    then echotoss._new = echotoss._new translate(area.a)
end

return



send_announce_1:
res = 0
select
  when ann._header_footer.n = ''
    then text. = ''
  when act_hdr_ftr = ann._header_footer.n
    then nop
  when stream(ann._header_footer.n , 'c', 'open read') <> 'READY:'
    then
    do
      res = 1
      call wlog replace_str(def._log_str.105, '[%f]', ann._header_footer.n)
      act_hdr_ftr = ''
    end
  otherwise
    act_hdr_ftr = ann._header_footer.n
    text. = ''
    tail  = ''
    do while lines(ann._header_footer.n) > 0
      data = linein(ann._header_footer.n)
      parse upper var data keyword .
      select
        when abbrev(keyword, '[%')
          then
          do
            parse var keyword '[%' +2 y +6 z ']' w +1 .
            select
              when (y = 'HEADER' | y = 'FOOTER') & w == ']' &,
                   wordpos(z, '_NEW _DEL _REN _WARN') > 0
                then tail = '_'y || z
              when tail <> ''
                then text.tail = text.tail || data || cr
              otherwise
            end
          end
        when tail <> ''
          then text.tail = text.tail || data || cr
        otherwise
      end
    end
    call stream ann._header_footer.n, 'c', 'close'
end

return res

/************************************************************************/

set_msg_text_group_hdr: procedure expose (common_var)

arg gname, lng

gdesc = def._group_ptr.gname
m_text._part = m_text._part || cr || cr ||,
    replace_str(def._str.lng.102, '[%g]', gname, '[%d]', def._group_desc.gdesc) || cr ||,
    def._str._78dash || cr || cr

return

/************************************************************************/

write_echo_toss_log: procedure expose (common_var)

select
  when res._echomail < 1
    then nop
  when echotoss._file = ''
    then nop
  otherwise
           /* ': Aktualisiere' echotoss._file */
    call wlog replace_str(def._log_str.117, '[%f]', echotoss._file)
    size = stream(echotoss._file, 'c', 'query size')
    if stream(echotoss._file, 'c', 'open') <> 'READY:'
      then call wlog replace_str(def._log_str.105, '[%f]', echotoss._file)
      else
      do
        if size < 1
          then
          do y = 1 to words(echotoss._new)
            call lineout echotoss._file, word(echotoss._new, y)
          end
          else
          do
            et_str = translate(charin(echotoss._file,, size),,
                               char._up'  ', char._low||'0d0a'x)
            do y = 1 to words(echotoss._new)
              z = word(echotoss._new, y)
              if wordpos(z, et_str) = 0
                then call lineout echotoss._file, z
            end
          end
        call stream echotoss._file, 'c', 'close'
      end
end

return

/************************************************************************/

send_notify: procedure expose (common_var)

if open_area_nm_out(netmail_out._ptr) = 0 /* Ausgangs-Netarea ffnen */
  then
  do
    if new_area.0 > 0 | del_area.0 > 0 | warn_area.0 > 0
      then call send_sysop_notify

    do dnl = 1 to dnl.0
      notify_flag_1 = bitand(dnl._flags.dnl, '00000400'x) <> '00000000'x

      ann_new = 0
      ann_del = 0
      ann_ren = 0
      ann_warn = 0

      if new_area.0 > 0
        then
        do
          notify_flag_2 = substr(dnl._notify.notify_flag_1.dnl, 1, 1)
          if notify_flag_2 <> 'N'
            then call send_downlink_notify_new      /* neue Areas melden */
        end
      if del_area.0 > 0
        then
        do
          notify_flag_2 = substr(dnl._notify.notify_flag_1.dnl, 2, 1)
          if notify_flag_2 <> 'N'
            then call send_downlink_notify_del      /* gelschte Areas melden */
        end
      if ren_area.0 > 0
        then
        do
          notify_flag_2 = substr(dnl._notify.notify_flag_1.dnl, 3, 1)
          if notify_flag_2 <> 'N'
            then call send_downlink_notify_ren      /* umbenannte Areas melden */
        end
      if warn_area.0 > 0
        then
        do
          notify_flag_2 = substr(dnl._notify.notify_flag_1.dnl, 4, 1)
          if notify_flag_2 <> 'N'
            then call send_downlink_notify_warn     /* Autokill-Warnungen melden */
        end

      if ann_new > 0 | ann_del > 0 | ann_ren > 0 | ann_warn > 0
        then call send_downlink_notify

    end

  end

return

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

send_downlink_notify_new:

if \dnl._group_exp.dnl
  then call expand_dnl_groups dnl

if notify_flag_2 = 'A'           /* alle neuen Areas melden */
  then
  do g = 1 to new_area.0
    aflag = 0
    if wordpos(word(new_area._group, g), dnl._group.dnl) > 0
      then
      do a = 1 to new_area.g.0
        select
          when word(query_area_link(dnl, new_area.g.a), 1) <> 0
            then call send_downlink_notify_new_90
          otherwise
            ap = new_area.g.a
            if dnl._level.dnl >= area._level.ap &,
               verify(dnl._keys.dnl, area._keys.ap) = 0
              then call send_downlink_notify_new_90
        end
      end
      else call send_downlink_notify_new_1
  end
  else              /* nur gelinkte Areas melden */
  do g = 1 to new_area.0
    aflag = 0
    call send_downlink_notify_new_1
  end

return



send_downlink_notify_new_1:
do a = 1 to new_area.g.0
  if word(query_area_link(dnl, new_area.g.a), 1) <> 0
    then call send_downlink_notify_new_90
end
return


send_downlink_notify_new_90:
if \aflag
  then
  do
    ann_new = ann_new +1
    ann_new.ann_new = g
    ann_new.ann_new.0 = 1
    aflag = 1
  end
  else ann_new.ann_new.0 = ann_new.ann_new.0 +1
y = ann_new.ann_new.0
ann_new.ann_new.y = new_area.g.a

return





send_downlink_notify_del:

if \dnl._group_exp.dnl
  then call expand_dnl_groups dnl

if notify_flag_2 = 'A'           /* alle gelschten Areas melden */
  then
  do g = 1 to del_area.0
    aflag = 0
    if wordpos(word(del_area._group, g), dnl._group.dnl) > 0
      then
      do a = 0 to del_area.g.0
        select
          when send_downlink_notify_del_2()
            then call send_downlink_notify_del_90
          otherwise
            ap = del_area.g.a
            if dnl._level.dnl >= area._level.ap &,
               verify(dnl._keys.dnl, area._keys.ap) = 0
              then call send_downlink_notify_del_90
        end
      end
      else call send_downlink_notify_del_1
  end
  else
  do g = 1 to del_area.0
    aflag = 0
    call send_downlink_notify_del_1
  end

return


send_downlink_notify_del_1:
do a = 1 to del_area.g.0
  if send_downlink_notify_del_2()
    then call send_downlink_notify_del_90
end
return



send_downlink_notify_del_2:
res = 0
do m = 1 to dnl._addr.dnl.0 until res
  res = wordpos(dnl._addr.dnl.m, del_area._dnl.g.a) > 0
end
return res



send_downlink_notify_del_90:
if \aflag
  then
  do
    ann_del = ann_del +1
    ann_del.ann_del = g
    ann_del.ann_del.0 = 1
    aflag = 1
  end
  else ann_del.ann_del.0 = ann_del.ann_del.0 +1
y = ann_del.ann_del.0
ann_del.ann_del.y = del_area.g.a
ann_del._init.ann_del.y = del_area._init.g.a
return








send_downlink_notify_ren:

if \dnl._group_exp.dnl
  then call expand_dnl_groups dnl

if notify_flag_2 = 'A'           /* alle umbenannten Areas melden */
  then
  do g = 1 to ren_area.0
    aflag = 0
    if wordpos(word(ren_area._group, g), dnl._group.dnl) > 0
      then
      do a = 1 to ren_area.g.0
        select
          when word(query_area_link(dnl, ren_area.g.a), 1) <> 0
            then call send_downlink_notify_ren_90
          otherwise
            ap = ren_area.g.a
            if dnl._level.dnl >= area._level.ap &,
               verify(dnl._keys.dnl, area._keys.ap) = 0
              then call send_downlink_notify_ren_90
        end
      end
      else call send_downlink_notify_ren_1
  end
  else
  do g = 1 to ren_area.0
    aflag = 0
    call send_downlink_notify_ren_1
  end

return



send_downlink_notify_ren_1:
do a = 1 to ren_area.g.0
  if word(query_area_link(dnl, ren_area.g.a), 1) <> 0
    then call send_downlink_notify_ren_90
end
return


send_downlink_notify_ren_90:
if \aflag
  then
  do
    ann_ren = ann_ren +1
    ann_ren.ann_ren = g
    ann_ren.ann_ren.0 = 1
    aflag = 1
  end
  else ann_ren.ann_ren.0 = ann_ren.ann_ren.0 +1
y = ann_ren.ann_ren.0
ann_ren.ann_ren.y = ren_area.g.a
ann_ren._old.ann_ren.y = ren_area._old.g.a
return



send_downlink_notify_warn:

if \dnl._group_exp.dnl
  then call expand_dnl_groups dnl

if notify_flag_2 = 'A'           /* alle Warnungen melden */
  then
  do g = 1 to warn_area.0
    aflag = 0
    if wordpos(word(warn_area._group, g), dnl._group.dnl) > 0
      then
      do a = 1 to warn_area.g.0
        select
          when word(query_area_link(dnl, warn_area.g.a), 1) <> 0
            then call send_downlink_notify_warn_90
          otherwise
            ap = warn_area.g.a
            if dnl._level.dnl >= area._level.ap &,
               verify(dnl._keys.dnl, area._keys.ap) = 0
              then call send_downlink_notify_warn_90
        end
      end
      else call send_downlink_notify_warn_1
  end
  else
  do g = 1 to warn_area.0
    aflag = 0
    call send_downlink_notify_warn_1
  end

return



send_downlink_notify_warn_1:
do a = 1 to warn_area.g.0
  if word(query_area_link(dnl, warn_area.g.a), 1) <> 0
    then call send_downlink_notify_warn_90
end
return


send_downlink_notify_warn_90:
if \aflag
  then
  do
    ann_warn = ann_warn +1
    ann_warn.ann_warn = g
    ann_warn.ann_warn.0 = 1
    aflag = 1
  end
  else ann_warn.ann_warn.0 = ann_warn.ann_warn.0 +1
y = ann_warn.ann_warn.0
ann_warn.ann_warn.y = warn_area.g.a
ann_warn._init.ann_warn.y = warn_area._init.g.a
return

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

send_downlink_notify:

lng = dnl._language.dnl
call wlog replace_str(def._log_str.119, '[%a]', dnl._addr.dnl.1)


if ann_new   > 0                  /* Mitteilung an Downlink ber neue Areas */
  then
  do
    m_text._subject = def._str.lng.161
    m_text._part = cr || replace_str(def._str.lng.162, '[%a]', address.1) || cr
    do grp = 1 to ann_new
      call set_msg_text_group_hdr word(new_area._group, ann_new.grp), lng
      do y = 1 to ann_new.grp.0
        a = ann_new.grp.y
        m_text._part = m_text._part || '  ' || wrap_area_desc(area.a, area._desc.a) || cr
        call send_rsp_split_msg_part dnl, address.1, dnl._addr.dnl.1
      end
    end
    call send_rsp_split_msg dnl, address.1, dnl._addr.dnl.1
  end


if ann_del > 0                  /* Mitteilung an Downlink ber gelschte Areas */
  then
  do
    m_text._subject = def._str.lng.135
    m_text._part = cr || def._str.lng.105 || cr
    do grp = 1 to ann_del
      call set_msg_text_group_hdr word(del_area._group, ann_del.grp), lng
      do y = 1 to ann_del.grp.0
        a = ann_del.grp.y
        flag = ann_del._init.grp.y +180

        m_text._part = m_text._part ||,
            replace_str(def._str.lng.112, '[%a]', area.a) || cr ||,
            replace_str(def._str.lng.175, '[%r]', def._str.lng.flag) || cr || cr

        call send_rsp_split_msg_part dnl, address.1, dnl._addr.dnl.1
      end
    end
    call send_rsp_split_msg dnl, address.1, dnl._addr.dnl.1
  end


if ann_ren > 0                  /* Mitteilung an Downlink ber umbenannte Areas */
  then
  do
    m_text._subject = def._str.lng.195
    m_text._part = cr || def._str.lng.103 || cr
    do grp = 1 to ann_ren
      call set_msg_text_group_hdr word(ren_area._group, ann_ren.grp), lng
      do y = 1 to ann_ren.grp.0
        a = ann_ren.grp.y
        m_text._part = m_text._part ||,
            replace_str(def._str.lng.178, '[%a]', area.a) || cr ||,
            replace_str(def._str.lng.179, '[%a]', ann_ren._old.grp.y) || cr || cr
        call send_rsp_split_msg_part dnl, address.1, dnl._addr.dnl.1
      end
    end
    call send_rsp_split_msg dnl, address.1, dnl._addr.dnl.1
  end


if ann_warn > 0                 /* Mitteilung an Downlink Autokill-Warning  */
  then
  do
    m_text._subject = def._str.lng.196
    m_text._part = cr || replace_str(def._str.lng.171,,
                                     '[%d]', word(warn_area._date, 3),,
                                     '[%m]', word(warn_area._date, 2),,
                                     '[%y]', word(warn_area._date, 1)) || cr
    do grp = 1 to ann_warn
      call set_msg_text_group_hdr word(warn_area._group, ann_warn.grp), lng
      do y = 1 to ann_warn.grp.0
        a = ann_warn.grp.y
        flag = ann_warn._init.grp.y +180

        m_text._part = m_text._part ||,
            replace_str(def._str.lng.112, '[%a]', area.a) || cr ||,
            replace_str(def._str.lng.175, '[%r]', def._str.lng.flag) || cr || cr

        call send_rsp_split_msg_part dnl, address.1, dnl._addr.dnl.1
      end
    end
    call send_rsp_split_msg dnl, address.1, dnl._addr.dnl.1
  end

return

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

send_sysop_notify:

call wlog def._log_str.120

lng = dnl._language.0

if del_area.0 > 0
  then
  do
    m_text._subject = def._str.lng.136
    m = 0
    m_text._part = cr || def._str.lng.105 || cr
    do grp = 1 to del_area.0
      call set_msg_text_group_hdr word(del_area._group, grp), lng
      do i = 1 to del_area.grp.0
        m = m +1
        if m // 10 = 0
          then call charout, 'A:'format(m, 6)cr
        a = del_area.grp.i
        flag = del_area._init.grp.i + 163
        m_text._part = m_text._part ||,
            replace_str(def._str.lng.112, '[%a]', area.a) || cr ||,
            replace_str(def._str.lng.175, '[%r]', def._str.lng.flag) || cr || cr
        call send_rsp_split_msg_part 0, address.1, address.1
      end
    end
    m_text._part = m_text._part || cr || def._str._78dash || cr ||,
                  replace_str(def._str.lng.108, '[%n]', m) || cr || cr || cr

    call send_rsp_split_msg 0, address.1, address.1
  end

if new_area.0 > 0
  then
  do
    m_text._subject = def._str.lng.193
    m = 0
    m_text._part = cr || def._str.lng.109 || cr

    do grp = 1 to new_area.0
      call set_msg_text_group_hdr word(new_area._group, grp), lng
      do i = 1 to new_area.grp.0
        m = m +1
        if m // 10 = 0
          then call charout, 'A:'format(m, 6)cr
        a = new_area.grp.i
        node_l = area._node_l.a
        p = wordpos(area._upl_addr.a, node_l)
        if p > 0
          then node_l = delword(node_l, p, 1)
        z = new_area._init.grp.i
        select
          when z = 0
            then z = def._str.lng.110    /* Sysop */
          when z > 0
            then z = dnl._addr.z.1
          otherwise
            z = def._str.lng.111         /* Autocreated */
        end
        m_text._part = m_text._part ||,
              replace_str(def._str.lng.112, '[%a]', area.a) || cr ||,
              replace_str(def._str.lng.113, '[%a]', z) || cr ||,
              replace_str(def._str.lng.114, '[%a]', area._upl_addr.a) || cr
        z = words(node_l)
        if z > 0
          then
          do
            m_text._part = m_text._part ||,
                  replace_str(def._str.lng.115, '[%a]', word(node_l, 1)) || cr
            do y = 2 to z
              m_text._part = m_text._part ||,
                    replace_str(def._str.lng.154, '[%a]', word(node_l, y)) || cr
            end
          end
        m_text._part = m_text._part || cr

        call send_rsp_split_msg_part 0, address.1, address.1
      end
    end
    m_text._part = m_text._part || def._str._78dash || cr ||,
                   replace_str(def._str.lng.116, '[%n]', m) || cr || cr

    call send_rsp_split_msg 0, address.1, address.1
  end


if warn_area.0 > 0
  then
  do
    m_text._subject = def._str.lng.170
    m = 0

    m_text._part = cr || replace_str(def._str.lng.171,,
                                     '[%d]', word(warn_area._date, 3),,
                                     '[%m]', word(warn_area._date, 2),,
                                     '[%y]', word(warn_area._date, 1)) || cr

    do grp = 1 to warn_area.0
      call set_msg_text_group_hdr word(warn_area._group, grp), lng
      do i = 1 to warn_area.grp.0
        m = m +1
        if m // 10 = 0
          then call charout, 'A:'format(m, 6)cr
        a = warn_area.grp.i
        flag = warn_area._init.grp.i + 171
        m_text._part = m_text._part ||,
            replace_str(def._str.lng.112, '[%a]', area.a) || cr ||,
            replace_str(def._str.lng.175, '[%r]', def._str.lng.flag) || cr || cr
        call send_rsp_split_msg_part 0, address.1, address.1
      end

    end
    m_text._part = m_text._part || cr || def._str._78dash || cr ||,
                  replace_str(def._str.lng.194, '[%n]', m) || cr || cr || cr

    call send_rsp_split_msg 0, address.1, address.1
  end


return

/************************************************************************/

proc_uplink: procedure expose (common_var)

if open_area_nm_out(netmail_out._ptr) = 0  /* Ausgangs-Netarea ffnen */
  then
  do upl = 1 to upl.0
    if upl._cmd.upl <> ''
      then
      do
                    /* Kommandos an' upl._addr.upl */
        call wlog replace_str(def._log_str.121, '[%a]', upl._addr.upl)

        msg._dest_name.1 = upl._name.upl
        msg._dest_addr.1 = upl._addr.upl
        msg._from_name.1 = dnl._name.0
        msg._from_addr.1 = upl._faddr.upl
        msg._subject.1   = upl._pw.upl
        if upl._fwd_killsent
          then msg._attr.1      = '00000181'x  /* PVT, LOC, K/S */
          else msg._attr.1      = '00000101'x  /* PVT, LOC */
        msg._date_written.1 = ''
        msg._date_arrived.1 = ''
        msg._ftsc_date.1    = ''
        msg._replyto.1      = 0
        msg._replies.1.0    = 0
        msg._utc_ofs.1      = 0
        msg._times_read.1   = 0
        msg._cost.1         = 0

        msg._text.1 = ''
        do z = 1 to words(upl._cmd.upl)
          a_req = word(upl._cmd.upl, z)
          call wlog ':' a_req
          msg._text.1 = msg._text.1 || a_req || cr
          if length(msg._text.1) > 7000   /* MSGs mit knapp 8kB Lnge */
            then call proc_uplink_send_req
        end
        if msg._text.1 <> ''
          then  call proc_uplink_send_req
        drop upl._cmd.upl
      end
  end

return



proc_uplink_send_req:

msg._ctrl.1 = 'MSGID:' upl._faddr.upl d2x(set_msgid_next(), 8)
msg._text.1 = msg._text.1 || cr || def._tearline || cr
if sq_create_msg(2, 1, 2) < 0
  then call log_rsqa_error 'sq_create_msg proc_uplink_send_req'
msg._text.1 = ''
res._netmail = res._netmail +1

return


/************************************************************************/

rescan_areas: procedure expose (common_var)

today = date('b') -719162   /* Tage seit 01.01.1970 */
h_src = 90
h_dest = 91
temp_dir = ''


temp_area = 0    /* Zhler fr temporre Areas */
temp_sqcfg = ''  /* temp. Squish.Cfg */

do i = 1 to words(rescan._dnl_idx)
           /* Zeiger auf Downlink und Zeiger auf seine AKA */
  parse value word(rescan._dnl_idx, i) with dnl'/'aka
           /* Rescan fr dnl._addr.dnl.aka */
  call wlog replace_str(def._log_str.122, '[%a]', dnl._addr.dnl.aka)

  tosslog. = ''
  do n = 1 to words(rescan.dnl.aka)
                                        /* Zeiger auf Area und Rescan-Cmd */
    parse value word(rescan.dnl.aka, n) with a'/'r_num

    if r_num = 'ALL'
      then
      do              /* Kompletter Rescan */
        tosslog._all = tosslog._all a
        iterate
      end
    if \datatype(r_num, 'w') | r_num = 0
      then iterate    /* Falsches Format (darf nicht vorkommen) */

    if sq_open_area(h_src, area._root.a, area._format.a) = 0
      then
      do
        if area._format.a = '$'
          then last = sq._hdr_num_msg.h_src
          else last = sq._sdm_high.h_src
        if last = 0
          then
          do             /* Rescan nicht mglich, da Area leer */
            call sq_close_area h_src
            iterate
          end

        if r_num > 0
          then first = max(1, last -r_num +1)     /* Anzahl der MSGs */
                                                  /* Anzahl der Tage */
          else first = rescan_areas_1(xd2date(max(3652, today +r_num)), 1, last)

        select
          when first = 1
            then tosslog._all = tosslog._all a     /* Kompletter Rescan */
          when first > last
            then nop          /* Kein Rescan, da keine MSGs selektiert */
          when rescan_areas_2() <> 0
            then nop          /* temp. Area kann nicht angelegt werden */
          when sq_open_area(h_dest, temp_area.temp_area, area._format.a, 'c') <> 0
            then nop          /* Fehler beim Erstellen der temp. Area */
          otherwise
            call wlogq replace_str(def._log_str.129, '[%a]', area.a, '[%n]', last -first +1)
            do y = first to last
              if y // 10 = 0
                then call charout, 'C:' format(y, 6) || cr

              res = sq_read_msg_frame(h_src, 1, y)
              if res >= 0
                then res = sq_write_msg_frame(h_dest, 1)
              if res < 0
                then leave
            end
            call sq_close_area h_dest
            tosslog._sel = tosslog._sel a'/'temp_area
        end
        call sq_close_area h_src
      end

  end

  call rescan_areas_3     /* temp. Files erstellen */
  call directory ext_cmd._rescan_dir

  if tosslog._file_all <> ''
    then
    do
      call execute_prg '@'replace_str(ext_cmd._rescan          ,,
                                      '[%c]', squish._cfg._file,,
                                      '[%f]', tosslog._file_all,,
                                      '[%n]', dnl._addr.dnl.aka)

      call sysfiledelete tosslog._file_all
    end

  if tosslog._file_sel <> '' & temp_sqcfg <> ''
    then call execute_prg '@'replace_str(ext_cmd._rescan          ,,
                                         '[%c]', temp_sqcfg       ,,
                                         '[%f]', tosslog._file_sel,,
                                         '[%n]', dnl._addr.dnl.aka)
  if tosslog._file_sel <> ''
    then call sysfiledelete tosslog._file_sel
  if temp_sqcfg <> ''
    then call sysfiledelete temp_sqcfg

    /* temp. Areas lschen */
  select
    when temp_dir = ''
      then nop
    when directory(temp_dir) = ''
      then nop
    otherwise
      call sysfiletree temp_dir'\*', 'data', 'fos'
      do y = 1 to data.0
        call sysfiledelete data.y
      end
      call sysfiletree temp_dir'\*', 'data', 'do'
      do y = 1 to data.0
        call sysrmdir data.y
      end
      call directory '\'
  end
  call directory dir._act

end

if temp_dir <> ''
  then call sysrmdir temp_dir
rescan. = ''

return


/*======================================================================
  Temporres Tosslog und ggfl. Squish.Cfg erstellen
======================================================================*/

rescan_areas_3:

if tosslog._all <> ''
  then
  do
    y = systempfilename(dir._temp'\RAFX????.TLG')
    select
      when y = ''
        then call wlog def._log_str.123
      when stream(y, 'c', 'open') <> 'READY:'
        then call wlog def._log_str.123
      otherwise
        tosslog._file_all = y
        do n = 1 to words(tosslog._all)
          a = word(tosslog._all, n)
          call lineout tosslog._file_all, translate(area.a)
        end
        call stream tosslog._file_all, 'c', 'close'
    end
  end

if tosslog._sel <> ''
  then
  do
    y = systempfilename(dir._temp'\RAFX????.TSC')
    select
      when y = ''
        then call wlog def._log_str.124
      when stream(y, 'c', 'open') <> 'READY:'
        then call wlog def._log_str.124
      otherwise
        temp_sqcfg = y
        do y = 1 to words(squish._keyword_idx)
          l = word(squish._keyword_idx, y)
          call lineout temp_sqcfg, squish._cfg.l
        end

        y = systempfilename(dir._temp'\RAFX????.TLG')
        select
          when y = ''
            then call wlog def._log_str.123
          when stream(y, 'c', 'open') <> 'READY:'
            then call wlog def._log_str.123
          otherwise
            tosslog._file_sel = y
            do n = 1 to words(tosslog._sel)
              parse value word(tosslog._sel, n) with a '/' t
              call lineout tosslog._file_sel, translate(area.a)
              call lineout temp_sqcfg, 'ECHOAREA' area.a  ,
                                        temp_area.t       ,
                                        area._sflags.a    ,
                                        '-p'area._paddr.a ,
                                        area._upl_addr.a  ,
                                        dnl._addr.dnl.aka
            end
            call stream tosslog._file_sel, 'c', 'close'
        end
        call stream temp_sqcfg, 'c', 'close'
    end

  end

return



/*======================================================================
  Temp-Dir anlegen und neuen temp. Root-Namen festlegen
======================================================================*/

rescan_areas_2:

res = 0
if temp_dir = ''
  then
  do
    temp_dir = systempfilename(dir._temp'\RAFX????')
    select
      when temp_dir = ''
        then res = -1
      when sysmkdir(temp_dir) = 0
        then res = 0
      otherwise
        temp_dir = ''
        res = -1
    end
  end
if res = 0
  then
  do
    temp_area = temp_area +1
    temp_area.temp_area = temp_dir'\RAFX' || right(temp_area, 4, 0)
  end

return res




/*======================================================================
  Binrsuche nach Datum
======================================================================*/

rescan_areas_1: procedure expose msg. sq. h_src

arg data, ug, og

ug = ug -1
og = og + 1
do forever
  t = (og - ug) % 2 + ug      /* testwert */
  if ug = t
    then
    do                        /* nicht gefunden */
      res = og
      leave
    end
  call sq_open_msg h_src, 10, t
  call sq_close_msg h_src
  select
    when data < msg._date_arrived.10
      then og = t
    when data > msg._date_arrived.10
      then ug = t
    otherwise
      res = t                 /* gefunden */
      leave
  end
end
return res

/************************************************************************/

execute_schedules: procedure expose (common_var)

parse value (date('s') date('b')) with act_year +4 act_month +2 act_day +2 act_date .
act_weekday = act_date // 7       /* Wochentag, 0 = Montag */
act_date    = act_date -719162    /* Tage seit 01.01.1970 */

do dnl = 1 to dnl.0
  mcmd = 0
  if dnl._sched.dnl = ''
    then iterate dnl

  do sched = 1 to 5

    if dnl._sched.sched.dnl = 0         /* Schedule nicht definiert */
      then iterate sched
    if dnl._sched.sched.dnl > act_date  /* Schedule noch nicht ausfhren */
      then iterate sched

    mcmd = mcmd +1
    mcmd._dnl.mcmd       = dnl
    mcmd._dest_dnl.mcmd  = dnl
    mcmd._dest_addr.mcmd = dnl._addr.dnl.1
    mcmd._from_addr.mcmd = address.1
    mcmd._acs.mcmd       = 0
    mcmd._msgid.mcmd     = ''
    m_sched.mcmd         = sched

    parse var dnl._sched._per.sched.dnl s1 s2 s3 .
    select
      when s2 = 'DAY'     /* tglich */
        then dnl._sched.sched.dnl = xd2date(act_date + s1)
      when s2 = 'MONTH'   /* monatlich */
        then
        do
          if s3 > act_day
            then s1 = s1 -1
          new_month = act_month +s1 -1        /* 0...11 */
          new_year = act_year + new_month %12
          new_month = new_month // 12 +1      /* 1...12 */
          new_day = min(word('31' new_year//4+28 '31 30 31 30 31 31 30 31 30 31', new_month), s3)
          dnl._sched.sched.dnl = new_year'/'right(new_month, 2, 0)'/'right(new_day, 2, 0)
        end
                          /* wchentlich */
      when s3 <= act_weekday
        then dnl._sched.sched.dnl = xd2date(act_date + s1 *7 + s3 - act_weekday)
      otherwise
        dnl._sched.sched.dnl = xd2date(act_date + s1 *7 -7 + s3 - act_weekday)
    end
    if wordpos(dnl._addr.dnl.1, dnl._settings_idx) = 0
      then dnl._settings_idx = dnl._settings_idx || dnl._addr.dnl.1 dnl' '
    dnl._settings.dnl = overlay('E', dnl._settings.dnl, 7)
    prg_cfg._changed = 1
  end

  select
    when mcmd = 0
      then nop
    when open_area_nm_out(netmail_out._ptr) <> 0    /* Ausgabe-Area ffnen */
      then nop
    otherwise

      call wlog replace_str(def._log_str.168, '[%a]', mcmd._dest_addr.mcmd)
      do m = 1 to mcmd
        select
          when m_sched.m = 1                /* Liste lokal verfgbarer Areas */
            then call send_area_list m
          when m_sched.m = 2                /* Liste aller verfgbarer Areas */
            then call send_avail_list m
          when m_sched.m = 3                /* Liste der geschalteten Areas */
            then call send_query_list m
          when m_sched.m = 4                /* Hilfe angefordert */
            then call send_rsp_help m
          otherwise                         /* Info angefordert */
            call send_rsp_info m
        end
      end
  end


end
drop mcmd.

return

/************************************************************************/

/* Areas umbenennen */

proc_area_rename: procedure expose (common_var)

arg m

lng = value('dnl._language.'mcmd._dest_dnl.m)
m_text._subject = def._str.lng.137
do n = 1 to mcmd._rename.m.0

  logstr = '> #'mcmd._rename.m.n
  call wlog ':' logstr
  m_text._part = m_text._part || cr || logstr || cr
  parse var mcmd._rename.m.n tag_old tag_new
  ttag_new = translate(tag_new)

  select
    when tagold <> ttag_new & datatype(ttag_new, 'w')
      then
      do
        m_text._part = m_text._part || def._str.lng.27 || cr
        call wlog def._log_str.27
      end
    when \datatype(area_idx.tag_old, 'w')
      then m_text._part = m_text._part || def._str.lng.0 || cr
    otherwise

      p = wordpos(ttag_new, del_area._idx)
      if p > 0          /* Area aus Del-Area-Index streichen und Reste lschen */
        then
        do
          a = substr(word(del_area._idx, p +1), 2)
          z = translate(filespec('n', area._root.a))
          drop area_root_idx.z
          del_area._idx = delword(del_area._idx, p, 2)
          call del_area_files a, 2
          drop area.a           ,
               area._deadline.a ,
               area._line.a     ,
               area._group.a    ,
               area._root.a     ,
               area._format.a   ,
               area._paddr.a    ,
               area._node_u.a   ,
               area._node_x.a   ,
               area._node_l.a   ,
               area._sflags.a   ,
               area._rafx.a     ,
               area._sqdata.a
          squish._cfg._changed = 1
        end

      found = area_idx.tag_old
      z = translate(filespec('n', area._root.found))
      drop area_root_idx.z

      root = search_root_name(tag_new, area._format.found, 0,,
                              filespec('d', area._root.found) ||,
                              filespec('p', area._root.found))
      select
        when root = ''
          then res = 1
        when area._format.found = '$'
          then
          do
            res = 0
            v = 0
            l = length(filespec('n', area._root.found)) +2
            call sysfiletree area._root.found'.*', 'data', 'fo'
            do z = 1 to data.0
              ext  = substr(filespec('n', data.z), l)
              if pos('.', ext) > 0
                then iterate z
              v = v +1
              data.v = data.z
              ndata.v = root'.'ext
              res = rename_file(data.v, ndata.v)
              if res <> 0
                then
                do  /* Umbenennung rckgngig bei Fehler */
                  do v = 1 to v
                    call rename_file ndata.v, data.v
                  end
                  leave z
                end
            end
          end
        when directory(area._root.found) = ''
          then res = 0
        otherwise
          call directory '\'
          call directory dir._act
          res = rename_file(area._root.found, root)
      end

      if res = 0
        then
        do
          p = wordpos(area._group.found, ren_area._group)
          if p = 0
            then
            do
              ren_area._group = ren_area._group || area._group.found' '
              ren_area.0 = ren_area.0 +1
              p = ren_area.0
              ren_area.p.0 = 1
            end
            else ren_area.p.0 = ren_area.p.0 +1
          z = ren_area.p.0
          ren_area.p.z      = found
          ren_area._old.p.z = tag_old

          area.found          = tag_new
          area._root.found    = root
          squish._cfg._mlroot = max(squish._cfg._mlroot, length(area._root.found))
          squish._cfg._mltag  = max(squish._cfg._mltag,  length(area.found))

          area._sqdata.found = ''
          area._rafx.found   = ''
          squish._cfg._changed = 1

          tag_new = translate(tag_new)
          p = wordpos(tag_old, area._idx)
          area._idx = delword(area._idx, p, 2) || tag_new '*'found' '
          drop area_idx.tag_old
          area_idx.tag_new = found

          m_text._part = m_text._part ||,
                replace_str(def._str.lng.26, '[%r]', root) || cr
          call wlog replace_str(def._log_str.26, '[%r]', root)

        end
        else
        do
          m_text._part = m_text._part || def._str.lng.25 || cr
          call wlog def._log_str.25
          if root <> ''
            then drop area_root_idx.root
          z = translate(filespec('n', area._root.found))
          area_root_idx.z = ''
        end


  end
  drop mcmd._rename.m.n
  call send_rsp_split_msg_part mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m
end
call send_rsp_split_msg mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m

return

/************************************************************************/

/* Areas erstellen */

proc_area_create: procedure expose (common_var)

arg m

lng = value('dnl._language.'mcmd._dest_dnl.m)
m_text._subject = def._str.lng.138
do n = 1 to mcmd._create.m.0
  parse var mcmd._create.m.n area group acs level'/'keys '"'desc'"'

  logstr = '> &'area group left('-', acs)level'/'keys '"'desc'"'
  call wlog ':' logstr
  m_text._part = m_text._part || cr || logstr || cr

  if query_area_local(area) = 0
    then
    do

      p = wordpos(translate(area), del_area._idx)
      if p > 0          /* Area aus Del-Area-Index streichen und Reste lschen */
        then
        do
          a = substr(word(del_area._idx, p +1), 2)
          z = translate(filespec('n', area._root.a))
          drop area_root_idx.z
          del_area._idx = delword(del_area._idx, p, 2)
          call del_area_files a, 2
          drop area._deadline.a
        end
        else            /* Area-Stem und Area-Index erweitern */
        do
          area.0 = area.0 +1
          a = area.0
        end

      area.a    = area
      area      = translate(area)
      area._idx = area._idx || area '*'a' '
      area_idx.area = a
      if opt._sort_area = 0
        then
        do
          squish._cfg.0 = squish._cfg.0 +1 /* Squish-Cfg neue Zeile */
          area._line.a = squish._cfg.0
        end
      area._group.a = group
      area._level.a = level
      area._acs.a   = acs
      area._keys.a  = keys
      area._paddr.a = address.1
      if desc = ''
        then area._desc.a  = def._area_desc
        else area._desc.a  = desc

      area._node_u.a      = ' '
      area._node_x.a      = ' '
      area._node_l.a      = ' '
      area._node_p.a      = ' '
      area._rflags.a      = ''
      area._upl_addr.a    = ''
      call set_area_sflags a, area._group.a
      area._root.a        = search_root_name(area.a, area._format.a, 1, area._group.a)
      squish._cfg._mlroot = max(squish._cfg._mlroot, length(area._root.a))
      squish._cfg._mltag  = max(squish._cfg._mltag,  length(area.a))

      area._sqdata.a = ''
      area._rafx.a   = ''
      squish._cfg._changed = 1

          /* Neue Area registrieren */
      call add_new_area_stem group, a, 0

      if rules._copy_2_dsc > 0
        then call copy_rules_2_dsc a

      m_text._part = m_text._part || def._str.lng.46 || cr
      call wlog def._log_str.46
    end
    else
    do
      m_text._part = m_text._part || def._str.lng.45 || cr
      call wlog def._log_str.45
    end

  drop mcmd._create.m.n
  call send_rsp_split_msg_part mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m
end
call send_rsp_split_msg mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m

return

/************************************************************************/

/* Area lschen */

proc_area_delete: procedure expose (common_var)

arg m

lng = value('dnl._language.'mcmd._dest_dnl.m)
m_text._subject = def._str.lng.139

do n = 1 to mcmd._delete.m.0

  logstr = '> ~'mcmd._delete.m.n
  call wlog ':' logstr
  m_text._part = m_text._part || cr || logstr || cr

  if search_area_local(mcmd._delete.m.n) > 0
    then
    do found = 1 to found.0
      a = found.found

      logstr = left(area.a, max(length(area.a) +1, 27))
      call wlog ':' logstr || def._log_str.40    /* Area gelscht */
      m_text._part = m_text._part ||,
                     '  'logstr ||,
                     def._str.lng.40 || cr
      call send_rsp_split_msg_part mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m

      call unlink_area a, 4, 1
      area._sqdata.a = ''
      area._rafx.a   = ''
      squish._cfg._changed = 1
    end
    else
    do
      m_text._part = m_text._part || def._str.lng.0 || cr
      call send_rsp_split_msg_part mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m
    end

  drop mcmd._delete.m.n
end
call send_rsp_split_msg mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m

return

/************************************************************************/

rename_file: procedure

arg src, dest
'@rename' src filespec('n', dest) '>nul 2>nul'

return rc

/************************************************************************/

/* Rules angefordert */

send_rules: procedure expose (common_var)

arg m

dnl = mcmd._dnl.m
lng = value('dnl._language.'mcmd._dest_dnl.m)

rules_send. = 0
rules_send._idx = ''

m_text._subject = def._str.lng.140

do req = 1 to mcmd._rules.m.0
  logstr = '> %RULES' mcmd._rules.m.req
  call wlog ':' logstr
  m_text._part = m_text._part || cr || logstr || cr

  dnl_req = 0

  select
    when \rules._send_dsc
      then nop
    when search_area_local(mcmd._rules.m.req) = 0
      then nop
    otherwise
      do found = 1 to found.0
        a = found.found
        if pos('-0', area._sflags.a) > 0
          then iterate found          /* Passthrough-Area */
        if area._format.a = '$'
          then file = area._root.a || rules._sq_dsc
          else file = area._root.a || rules._sdm_dsc
        if stream(file, 'c', 'query exists') <> ''
          then call send_rules_1 area.a
      end
  end


  if search_area_rules(mcmd._rules.m.req) > 0
    then
    do found = 1 to found.0
      parse var found.2.found y'\'file
      if wordpos(found.1.found, rules_send._idx) > 0
        then iterate found
      file = rules._path_idx.y'\'file
      if stream(file, 'c', 'query exists') <> ''
        then call send_rules_1 found.1.found
    end

  if dnl_req = 0
    then
    do
      m_text._part = m_text._part || def._str.lng.14 || cr
      call send_rsp_split_msg_part mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m
    end
  drop mcmd._rules.m.req

end
call send_rsp_split_msg mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m
if rules_send.0 > 0
  then call send_rules_netmail mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m

return



send_rules_1:
arg area

dnl_req = dnl_req +1
rules_send._idx = rules_send._idx area
rules_send.0 = rules_send.0 +1
y = rules_send.0
rules_send.y = file
call wlog ':' area                      /* Meldung ber Rules-Versand geben */
logstr = '  'left(area, max(length(area) +1, 27))
if bitand(dnl._flags.dnl, '00000200'x) = '00000000'x
  then m_text._part = m_text._part || logstr || def._str.lng.16 || cr
  else m_text._part = m_text._part || logstr || def._str.lng.15 || cr
call send_rsp_split_msg_part mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m

return

/************************************************************************/

update_rules_2_dsc: procedure expose (common_var)

call read_rule_idx    /* Rules-Index einlesen */

do ipart = 1 to words(area._idx) by 100
  part_idx = subword(area._idx, ipart, 100)
  call charout, 'P:' format(ipart %2, 6) || cr

  do n = 1 to words(part_idx) by 2
    area = word(part_idx, n)
    a = area_idx.area
    if wordpos('-0', area._sflags.a) = 0
      then call copy_rules_2_dsc a, 1
  end
end

return

/************************************************************************/

copy_rules_2_dsc: procedure expose (common_var)

arg a, opt

if area._format.a <> '$'
  then dest_file = area._root.a || rules._sdm_dsc
  else dest_file = area._root.a || rules._sq_dsc

p = wordpos(translate(area.a), rules._idx)
if p > 0
  then
  do                  /* Rules fr die Area vorhanden */
    parse value word(rules._idx, p +1) with '*'y'\'p
    src_file = rules._path_idx.y'\'p
    select
      when src_file = dest_file
        then nop                          /* Rules = *.DSC */
      when stream(src_file, 'c', 'query exists') = ''
        then nop                          /* Rules nicht vorhanden  */
      when stream(dest_file, 'c', 'query exists') = ''
        then call copy_rules_2_dsc_1
      when opt < 1
        then if rules._copy_2_dsc > 1
          then call copy_rules_2_dsc_1
      when (stream(src_file, 'c', 'query size'),
            stream(src_file, 'c', 'query datetime')) <> ,
           (stream(dest_file, 'c', 'query size'),
            stream(dest_file, 'c', 'query datetime'))
        then call copy_rules_2_dsc_1
      otherwise
    end
  end

return


copy_rules_2_dsc_1:
if opt = 1
  then call wlog replace_str(def._log_str.179, '[%a]', area.a)
if area._format.a = '$'
  then '@copy' src_file dest_file '2>nul 1>nul'
  else
  do
    if s_directory(area._root.a) = ''
      then call sysmkdir area._root.a
      else call directory dir._act
    '@copy' src_file dest_file '2>nul 1>nul'
  end
return

/************************************************************************/

send_rules_netmail: procedure expose (common_var)

arg dest_dnl, from_addr, dest_addr

msg._dest_name.1    = dnl._name.dest_dnl
msg._dest_addr.1    = dest_addr
msg._from_name.1    = 'RAFX'
msg._from_addr.1    = from_addr
msg._date_written.1 = ''
msg._date_arrived.1 = ''
msg._ftsc_date.1    = ''
msg._replyto.1      = 0
msg._replies.1.0    = 0
msg._utc_ofs.1      = 0
msg._times_read.1   = 0
msg._cost.1         = 0

lng = dnl._language.dest_dnl
if bitand(dnl._flags.dest_dnl, '00000200'x) = '00000000'x
  then
  do
    msg._attr.1         = '00000181'x  /* PVT, LOC, K/S */
    do y = 1 to rules_send.0
      call wlog replace_str(def._log_str.128, '[%f]', rules_send.y)
      atag = word(rules_send._idx, y)
      msg._subject.1  = replace_str(def._str.lng.210, '[%a]', atag)

      msg._text.1     = cr || replace_str(def._str.lng.211, '[%a]', atag) || cr ||,
                        def._str._78dash || cr || cr

      rdata = charin(rules_send.y,, chars(rules_send.y))
      call stream rules_send.y, 'c', 'close'
      data = ''
      line_begin = 1
      line_next  = pos(crlf, rdata, line_begin)
      do while line_next > 0
        data = data || substr(rdata, line_begin, line_next -line_begin) || cr
        line_begin = line_next + 2
        line_next = pos(crlf, rdata, line_begin)
        if length(data) > 3800
          then
          do
            msg._text.1 =  msg._text.1 || data
            data = ''
          end
      end
      msg._text.1 =  msg._text.1 || data || cr || def._tearline || cr
      msg._ctrl.1    = 'MSGID:' from_addr d2x(set_msgid_next(), 8)
      if sq_create_msg(2, 1, 2) < 0
        then call log_rsqa_error 'sq_create_msg send_rules_netmail'
    end
  end
  else
  do
    msg._text.1 = ''
    msg._attr.1         = '00000191'x  /* PVT, LOC, ATT, K/S */
    do y = 1 to rules_send.0
      call wlog replace_str(def._log_str.125, '[%f]', rules_send.y)
      msg._subject.1 = rules_send.y
      msg._ctrl.1    = 'MSGID:' from_addr d2x(set_msgid_next(), 8)
      if sq_create_msg(2, 1, 2) < 0
        then call log_rsqa_error 'sq_create_msg send_rules_netmail'
    end
  end
res._netmail = res._netmail +rules_send.0
rules_send. = 0
rules_send._idx = ''

return

/************************************************************************/

/* Areas aktiv/passiv schalten */

proc_tempreq: procedure expose (common_var)

arg m

dnl = mcmd._dnl.m
lng = value('dnl._language.'mcmd._dest_dnl.m)
if dnl <> mcmd._dest_dnl.m
  then m_text._subject = def._str.lng.141 '('dnl._addr.dnl.1')'
  else m_text._subject = def._str.lng.141

call scan_groups_local dnl

do req = 1 to mcmd._tempreq.m.0

  parse var mcmd._tempreq.m.req flag._req +1 flag._grp +1 tag
  logstr = '>' word('%PAUSE %RESUME', (flag._req = '+') +1),
      left('@', (flag._grp = 'G')) || tag
  call wlog ':' logstr
  m_text._part = m_text._part || cr || logstr || cr

  dnl_req = 0
  select
    when flag._grp = 'G'
      then
      do
        grp = wordpos(tag, group._idx)
        if grp > 0
          then
          do z = 1 to group.grp.0
            a = group.grp.z
            parse value query_area_link(dnl, a) with aptr daptr
            if aptr <> 0
              then call proc_tempreq_1
          end
      end
    when search_area_local(tag) = 0
      then nop
    otherwise
      do found = 1 to found.0
        a = found.found
        parse value query_area_link(dnl, a) with aptr daptr
        select
          when aptr = 0     /* Area ist nicht geschaltet */
            then nop
                            /* Zugriff testen */
          when area._level.a > dnl._level.dnl |,
               verify(area._keys.a, dnl._keys.dnl) > 0 |,
               wordpos(area._group.a, dnl._group.dnl) = 0
                            /* Area ist Pflicht-Area */
            then
            do
              dnl_req = dnl_req +1
              logstr = left(area.a, max(length(area.a) +1, 27))
              call wlog ':' logstr || def._log_str.7
              m_text._part = m_text._part ||,
                             '  'logstr ||,
                             def._str.lng.7 || cr
              call send_rsp_split_msg_part mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m
            end
          otherwise
            call proc_tempreq_1
        end
      end
  end

  if dnl_req = 0
    then
    do
      m_text._part = m_text._part || def._str.lng.20 || cr
      call send_rsp_split_msg_part mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m
    end

  drop mcmd._tempreq.m.req
end

call send_rsp_split_msg mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m

return



proc_tempreq_1:

dnl_req = dnl_req +1
select
  when aptr > 0         /* Area ist aktiv */
    then
    do
      if flag._req = '+'
        then flag = 1
        else
        do
          area._node_l.a = delword(area._node_l.a, aptr, 1)
          call proc_req_ins_addr a, dnl._addr.dnl.daptr, 'P'
          flag = 22
          area._sqdata.a = ''
          area._rafx.a   = ''
          squish._cfg._changed = 1
        end
    end
                        /* Area ist passiv */
  when flag._req = '-'
    then flag = 21
  otherwise
    area._node_p.a = delword(area._node_p.a, abs(aptr), 1)
    call proc_req_ins_addr a, dnl._addr.dnl.daptr, 'L'
    flag = 2
    area._sqdata.a = ''
    area._rafx.a   = ''
    squish._cfg._changed = 1
end
logstr = left(area.a, max(length(area.a) +1, 27))
call wlog ':' logstr || def._log_str.flag
m_text._part = m_text._part || '  'logstr || def._str.lng.flag || cr
call send_rsp_split_msg_part mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m

return

/************************************************************************/

/* Area-Requests bearbeiten */

proc_request: procedure expose (common_var)

arg m

/* dnl    Zeiger akt. Downlink */
/* upl    Zeiger akt. Uplink */
/* list   Zeiger akt. Area-Liste */
/* req    Zeiger akt. Befehl */

dnl = mcmd._dnl.m
lng = value('dnl._language.'mcmd._dest_dnl.m)
if dnl <> mcmd._dest_dnl.m
  then m_text._subject = def._str.lng.142 '('dnl._addr.dnl.1')'
  else m_text._subject = def._str.lng.142

rules_send. = 0
rules_send._idx = ''

select
     /* Meldung an Sysop oder Requests vom Sysop */
  when mcmd._dest_dnl.m = 0
    then flag._rules = 0
                     /* Normale Requests */
  when bitand(dnl._flags.dnl, '00000008'x) <> '00000000'x & rules._idx <> ''
    then flag._rules = 1
  otherwise
    flag._rules = 0
end

  /* flag._fwd = 1, wenn Forward-Request erlaubt */
flag._fwd      = bitand(dnl._flags.dnl, '00000001'x) = '00000001'x
  /* flag._fwd_wild = 1, wenn Forward-Request mit Wildcard erlaubt */
flag._fwd_wild = bitand(dnl._flags.dnl, '00000101'x) = '00000001'x

do req = 1 to mcmd._req.m.0

  call wlog ': >' mcmd._req.m.req
  m_text._part = m_text._part || cr || '>' mcmd._req.m.req || cr

  /* Request bearbeiten */

  parse var mcmd._req.m.req flag._req +1 area_tag
  drop mcmd._req.m.req

  dnl_req = 0
  flag._wild = pos('*', area_tag) > 0
  select
    when flag._req = '+'
      then                  /* Link */
      do
        if dnl > 0
          then call proc_req_link_dl
          else call proc_req_link_sysop
      end
                            /* Unlink */
    when dnl > 0
      then call proc_req_unlink_dl
    otherwise
      call proc_req_unlink_sysop
  end


  /* Meldung senden */

  if dnl_req = 0
    then
    do
      m_text._part = m_text._part || def._str.lng.0 || cr
      call send_rsp_split_msg_part mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m
    end
    else
    do z = 1 to dnl_req
      parse var dnl_req.z a flag1 flag2
      logstr = left(area.a, max(length(area.a) +1, 27))
      call wlog ':' logstr || def._log_str.flag1
      m_text._part = m_text._part || '  'logstr || def._str.lng.flag1 || cr
      if flag2 <> ''
        then
        do
          call wlog ':' copies(' ', 27) || def._log_str.flag2
          m_text._part = m_text._part ||,
                         copies(' ', 29) || def._str.lng.flag2 || cr
        end

          /* Testen, ob Rules gesendet werden sollen */
      select
        when \flag._rules             /* Rules nicht senden */
          then nop
        when flag1 < 3 | flag1 > 4    /* Area wurde nicht neu geschaltet */
          then nop
        otherwise
          select
            when \rules._send_dsc
              then rfile = ''
            when area._format.a = '$'
              then rfile = stream(area._root.a || rules._sq_dsc, 'c', 'query exists')
            otherwise
              rfile = stream(area._root.a || rules._sdm_dsc, 'c', 'query exists')
          end
          if rfile = ''
            then
            do
              p = wordpos(translate(area.a), rules._idx)
              if p > 0
                then
                do
                  parse value word(rules._idx, p +1) with '*'y'\'p
                  rfile = stream(rules._path_idx.y'\'p, 'c', 'query exists')
                end
            end
          if rfile <> ''
            then
            do
              if bitand(dnl._flags.dnl, '00000200'x) = '00000000'x
                then m_text._part = m_text._part || copies(' ', 29) || def._str.lng.16 || cr
                else m_text._part = m_text._part || copies(' ', 29) || def._str.lng.15 || cr
              rules_send._idx = rules_send._idx translate(area.a)
              rules_send.0 = rules_send.0 +1
              y = rules_send.0
              rules_send.y = rfile
            end
      end
      call send_rsp_split_msg_part mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m
    end
  drop dnl_req.

end
call send_rsp_split_msg mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m

if rules_send.0 > 0
  then call send_rules_netmail mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m

return

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

proc_req_unlink_dl:

if \dnl._group_exp.dnl
  then call expand_dnl_groups dnl

if search_area_local(area_tag) > 0
  then
  do found = 1 to found.0
    if found // 10 = 0
      then call charout, 'U:'format(found, 6)cr

    a = found.found
    parse value query_area_link(dnl, a) with aptr daptr
    select
      when aptr = 0     /* Area ist nicht geschaltet */
        then nop
                        /* Zugriff testen */
      when (area._level.a > dnl._level.dnl |,
           verify(area._keys.a, dnl._keys.dnl) > 0 |,
           wordpos(area._group.a, dnl._group.dnl) = 0) & mcmd._acs.m = 0
                        /* Area ist Pflicht-Area */
        then
        do
          dnl_req = dnl_req +1
          dnl_req.dnl_req = a 7
        end

      otherwise

        if aptr > 0
                      /* Adresse in Link-Liste lschen */
          then area._node_l.a = delword(area._node_l.a, aptr, 1)
                      /* Adresse in Passiv-Liste lschen */
          else area._node_p.a = delword(area._node_p.a, abs(aptr), 1)
        p = wordpos(dnl._addr.dnl.daptr, area._node_x.a)
        if p > 0        /* Read-Only lschen */
          then area._node_x.a = delword(area._node_x.a, p, 1)

        dnl_req = dnl_req +1
        dnl_req.dnl_req = a 8
        area._sqdata.a = ''
        area._rafx.a   = ''
        squish._cfg._changed = 1
        if wordpos(a, area._changed) = 0
          then area._changed = area._changed || a' '
    end
  end

return

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

proc_req_unlink_sysop:

if search_area_local(area_tag) > 0
  then
  do found = 1 to found.0
    if found // 10 = 0
      then call charout, 'U:'format(found, 6)cr

    a = found.found
    select
      when wordpos('-0', area._sflags.a) > 0  /* Area ist schon Passthrough */
        then
        do
          dnl_req = dnl_req +1
          dnl_req.dnl_req = a 9
        end
      otherwise
        area._sflags.a = '-0 'area._sflags.a
        dnl_req = dnl_req +1
        dnl_req.dnl_req = a 10
        area._sqdata.a = ''
        area._rafx.a   = ''
        squish._cfg._changed = 1
        if wordpos(a, area._changed) = 0
          then area._changed = area._changed || a' '
    end
  end

return

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

proc_req_link_dl:

if \dnl._group_exp.dnl
  then call expand_dnl_groups dnl

if search_area_local(area_tag) > 0
  then
  do found = 1 to found.0
    if found // 10 = 0
      then call charout, 'A:'format(found, 6)cr
    a = found.found
    parse value query_area_link(dnl, a) with aptr daptr
    select
      when aptr > 0      /* Area ist schon aktiv */
        then
        do
          dnl_req = dnl_req +1
          dnl_req.dnl_req = a 1
          if mcmd._rescan.m.req <> 0
            then call proc_req_link_dl_rescan daptr
        end
                      /* Zugriff testen */
      when (area._level.a > dnl._level.dnl |,
           verify(area._keys.a, dnl._keys.dnl) > 0) & mcmd._acs.m = 0
        then nop

      when aptr < 0    /* Area von passiv auf aktiv schalten */
        then
        do
          area._node_p.a = delword(area._node_p.a, abs(aptr), 1)
          call proc_req_ins_addr a, dnl._addr.dnl.daptr
          dnl_req = dnl_req +1
          dnl_req.dnl_req = a 2
          area._sqdata.a = ''
          area._rafx.a   = ''
          squish._cfg._changed = 1

          if mcmd._rescan.m.req <> 0
            then call proc_req_link_dl_rescan daptr

        end

      otherwise
        grp = wordpos(area._group.a, dnl._group.dnl)
        if grp > 0    /* Area aufschalten */
          then
          do

            call proc_req_ins_addr a, dnl._group_addr.dnl.grp    /* Link hinzufgen */
            if dnl._group_acs.dnl.grp | area._acs.a          /* Read-Only */
              then area._node_x.a = area._node_x.a || dnl._group_addr.dnl.grp' '

              /* Passthrough-Flag testen */
            if bitand(dnl._flags.dnl, '00000004'x) = '00000000'x
              then
              do
                p = wordpos('-0', area._sflags.a)
                if p > 0
                  then
                  do
                    area._sflags.a = space(delword(area._sflags.a, p, 1))
                    if rules._copy_2_dsc > 0
                      then call copy_rules_2_dsc a
                  end
              end

            dnl_req = dnl_req +1
            dnl_req.dnl_req = a 3
            area._sqdata.a = ''
            area._rafx.a   = ''
            squish._cfg._changed = 1

            if mcmd._rescan.m.req <> 0
              then call proc_req_link_dl_rescan wordpos(dnl._group_addr.dnl.grp, dnl._addr.dnl)
          end
    end

  end

   /* Forward-Requests */

select
  when mcmd._acs.m
    then res = 1
  when \flag._fwd
    then res = 0
  when flag._wild
    then res = flag._fwd_wild
  otherwise
    res = found.0 = 0
end
if res
  then
  do upl = 1 to upl.0               /* alle Uplinks ... */
    do list = 1 to upl._area.upl.0  /* ... und alle Listen */
      if upl._area_file.upl.list = ''
        then iterate       /* Liste nicht vorhanden */
      grp = wordpos(upl._area_group.upl.list, dnl._group.dnl)
      select
        when grp = 0 /* Gruppe nicht geschaltet */
          then iterate
                     /* Zugriff testen */
        when (upl._area_level.upl.list > dnl._level.dnl |,
             verify(upl._area_keys.upl.list, dnl._keys.dnl) > 0) & mcmd._acs.m = 0
          then nop
        when proc_req_search_area() = 1
          then leave upl
        otherwise
      end

    end
  end

return

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

proc_req_link_dl_rescan:

arg daptr
select
  when wordpos(a, rescan.dnl.daptr) > 0
                      /* Rescan bereits durchgefhrt */
    then dnl_req.dnl_req = dnl_req.dnl_req 32
  when wordpos('-0', area._sflags.a) > 0
                      /* Rescan nicht mglich, Passthrough-Area */
    then dnl_req.dnl_req = dnl_req.dnl_req 33
  otherwise
                      /* Rescan durchfhren */
    dnl_req.dnl_req = dnl_req.dnl_req 31
    rescan.dnl.daptr = rescan.dnl.daptr a'/'mcmd._rescan.m.req
    if wordpos(dnl'/'daptr, rescan._dnl_idx) = 0
      then rescan._dnl_idx = rescan._dnl_idx dnl'/'daptr
end

return

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

proc_req_link_sysop:

if search_area_local(area_tag) > 0
  then
  do found = 1 to found.0
    if found // 10 = 0
      then call charout, 'A:'format(found, 6)cr
    a = found.found
    p = wordpos('-0', area._sflags.a)
    select
      when p = 0    /* Area ist schon aktiv */
        then
        do
          dnl_req = dnl_req +1
          dnl_req.dnl_req = a 5
        end
      otherwise
        area._sflags.a = space(delword(area._sflags.a, p, 1))
        dnl_req = dnl_req +1
        dnl_req.dnl_req = a 6
        area._sqdata.a = ''
        area._rafx.a   = ''
        squish._cfg._changed = 1

        if rules._copy_2_dsc > 0
          then call copy_rules_2_dsc a
    end
  end

if found.0 = 0 | flag._wild
  then
  do upl = 1 to upl.0               /* alle Uplinks ... */
    do list = 1 to upl._area.upl.0  /* ... und alle Listen */
      if upl._area_file.upl.list = ''
        then iterate       /* Liste nicht vorhanden */
      if proc_req_search_area() = 1
        then leave upl
    end
  end

return

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

proc_req_search_area:

if search_area_file(area_tag, upl, list) > 0
  then
  do found = 1 to found.0
    call charout, 'N:'format(found, 6)cr
      /* Nur Areas, die lokal noch nicht vorhanden sind */
    area_found = translate(found.1.found)
    if \datatype(area_idx.area_found, 'w')
      then call proc_req_create_area
  end

return \flag._wild & found.0 > 0

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

/* Adresse zu Liste der Linked Nodes hinzufgen */

proc_req_ins_addr: procedure expose (common_var)

              /* Zeiger auf Area, Adresse, Liste */
arg a, addr =1 t.2'.'tp =1 t.3'/' =1 t.4':', nodes

if nodes = 'P'
  then nodes = '_NODE_P'  /* Liste Passive Nodes */
  else nodes = '_NODE_L'  /* Liste Linked Nodes */

t.2 = ' 't.2'.'
t.3 = ' 't.3'/'
t.4 = ' 't.4':'

s = ''
w = length(area.nodes.a)
select
  when proc_req_ins_addr_1(t.2||'0') > 0
    then r = r - length(test)
  when proc_req_ins_addr_1(t.2) > 0
    then nop
  when proc_req_ins_addr_1(t.3) > 0
    then parse value(' 'area._paddr.a) with (t.2) +0 s
  when proc_req_ins_addr_1(t.4) > 0
    then parse value(' 'area._paddr.a) with (t.3) +0 s
  otherwise
    parse value(' 'area._paddr.a) with (t.4) +0 s
end

select
  when s <> ''
    then area.nodes.a = ' 'addr || area.nodes.a
  when r = 0
    then area.nodes.a = area.nodes.a || addr' '
  otherwise
    r = w -r
    area.nodes.a = insert(' 'addr, area.nodes.a, r)
end

return


proc_req_ins_addr_1:
arg test
parse var area.nodes.a (test) +0 r
r = length(r)
return r

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */

proc_req_create_area:

p = wordpos(area_found, del_area._idx)
if p > 0          /* Area aus Del-Area-Index streichen und Reste lschen */
  then
  do
    a = substr(word(del_area._idx, p +1), 2)

    z = translate(filespec('n', area._root.a))
    drop area_root_idx.z

    del_area._idx = delword(del_area._idx, p, 2)
    call del_area_files a, 2
    drop area._deadline.a
  end
  else            /* Area-Stem und Area-Index erweitern */
  do
    area.0 = area.0 +1
    a = area.0
  end

area.a = found.1.found
area._idx = area._idx || area_found '*'a' '
area_idx.area_found = a


                    /* Neue Area am Ende Squish-Cfg anhngen */
if opt._sort_area = 0
  then
  do
    squish._cfg.0 = squish._cfg.0 +1 /* Squish-Cfg neue Zeile */
    area._line.a = squish._cfg.0
  end

                    /* Area-Beschreibung */
if found.2.found = ''
  then area._desc.a = def._area_desc
  else area._desc.a = found.2.found
                    /* Primary-AKA, Uplink und Downlink festlegen */
area._paddr.a     = upl._area_paddr.upl.list
area._node_l.a    = ' 'upl._addr.upl' '


                      /* Einstellungen der Area */
area._group.a     = upl._area_group.upl.list
area._level.a     = upl._area_level.upl.list
area._acs.a       = upl._area_acs.upl.list
area._keys.a      = upl._area_keys.upl.list
area._upl_addr.a  = upl._addr.upl
area._rflags      = ''
call set_area_sflags a, area._group.a
area._node_p.a    = ' '
area._node_u.a    = ' '

if dnl = 0
  then area._node_x.a = ' '     /* Sysop */
  else                          /* Downlink */
  do
                                /* Passthrough-Flag testen */
    if bitand(dnl._flags.dnl, '00000004'x) <> '00000000'x
      then area._sflags.a = '-0 'area._sflags.a
                                /* Link hinzufgen */
    call proc_req_ins_addr a, dnl._group_addr.dnl.grp
    if dnl._group_acs.dnl.grp | upl._area_acs.upl.list
      then area._node_x.a = ' 'dnl._group_addr.dnl.grp' '
      else area._node_x.a = ' '
  end

                      /* Root festlegen */
area._root.a        = search_root_name(area.a, area._format.a, 1, area._group.a)

                      /* Format-Variablen aktualisieren */
squish._cfg._mlroot = max(squish._cfg._mlroot, length(area._root.a))
squish._cfg._mltag  = max(squish._cfg._mltag,  length(area.a))

area._sqdata.a      = ''
area._rafx.a        = ''
squish._cfg._changed = 1

call add_new_area_stem area._group.a, a, dnl

if pos('-0', area._sflags.a) = 0
  then
  do
    if rules._copy_2_dsc > 0
      then call copy_rules_2_dsc a
  end

                      /* Forward-Request festhalten */
upl._cmd = 1
p = wordpos('-'area_found, upl._cmd.upl)
if p > 0
  then upl._cmd.upl = delword(upl._cmd.upl, p, 1) || '+'area_found' '
  else upl._cmd.upl = upl._cmd.upl || '+'area_found' '


                      /* Meldung an Downlink festhalten */
dnl_req = dnl_req +1
dnl_req.dnl_req     = a 4
if mcmd._rescan.m.req <> 0
  then dnl_req.dnl_req = dnl_req.dnl_req 30

return

/************************************************************************/

send_avail_list: procedure expose (common_var)

arg m

dnl = mcmd._dnl.m
lng = value('dnl._language.'mcmd._dest_dnl.m)
if dnl <> mcmd._dest_dnl.m
  then m_text._subject = def._str.lng.144 '('dnl._addr.dnl.1')'
  else m_text._subject = def._str.lng.144

call wlog ': > %AVAIL'

if \dnl._group_exp.dnl
  then call expand_dnl_groups dnl
z = 0
do u = 1 to upl.0
  grp_idx = ''
  g = 0
  do y = 1 to upl._area.u.0
    select
      when upl._area_file.u.y = ''
        then nop               /* Liste nicht vorhanden */

      when dnl = 0             /* Sysop */
        then call send_avail_list_1
                               /* Downlink */
      when wordpos(upl._area_group.u.y, dnl._group.dnl) = 0
        then nop
      when dnl._level.dnl < upl._area_level.u.y
        then nop
      when verify(upl._area_keys.u.y, dnl._keys.dnl) > 0
        then nop
      otherwise
        call send_avail_list_1
    end
  end

  if g > 0
    then
    do
      m_text._part = m_text._part || cr ||,
            replace_str(def._str.lng.117, '[%a]', upl._addr.u) || cr
      do g = 1 to g
        call set_msg_text_group_hdr word(grp_idx, g), lng
        do h = 1 to grp.g.0
          do while lines(grp.g.h) > 0
            parse value linein(grp.g.h) with atag adesc
            m_text._part = m_text._part || '  ' || wrap_area_desc(atag, adesc) || cr
            z = z +1
            if z // 10 = 0
              then call charout, 'A:'format(z, 6)cr
            call send_rsp_split_msg_part mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m
          end
          call stream grp.g.h, 'c', 'close'
        end
        m_text._part = m_text._part || cr
      end
    end

end

m_text._part = m_text._part || cr || def._str._78dash || cr ||,
               replace_str(def._str.lng.118, '[%n]', z) || cr
call send_rsp_split_msg mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m

return



send_avail_list_1:
p = wordpos(upl._area_group.u.y, grp_idx)
if p = 0
  then
  do
    g = g +1
    grp_idx = grp_idx upl._area_group.u.y
    grp.g.0 = 1
    grp.g.1 = upl._area_file.u.y
  end
  else
  do
    grp.p.0 = grp.p.0 +1
    h = grp.p.0
    grp.p.h = upl._area_file.u.y
  end
return


/************************************************************************/

/* Liste der lokal verfgbaren Areas senden */

send_area_list: procedure expose (common_var)

arg m

call wlog ': > %LIST'
dnl = mcmd._dnl.m
lng = value('dnl._language.'mcmd._dest_dnl.m)
m_text._subject = replace_str(def._str.lng.145, '[%a]', address.1)
if dnl <> mcmd._dest_dnl.m
  then m_text._subject = m_text._subject '('dnl._addr.dnl.1')'

m_text._part    = cr || replace_str(def._str.lng.117, '[%a]', address.1) || cr

call scan_groups_local dnl

z1 = 0 ; z2 = 0
do grp = 1 to group.0
  call set_msg_text_group_hdr word(group._idx, grp), lng
  do h = 1 to group.grp.0
    z1 = z1 +1
    if z1 // 10 = 0
      then call charout, 'A:'format(z1, 6)cr
    a = group.grp.h
    select
      when dnl > 0
        then
        do
          if word(query_area_link(dnl, a), 1) <> 0
            then                  /* Area ist geschaltet */
            do
              z2 = z2 +1
              flag = '* '
            end
            else flag = '  '      /* Area nicht geschaltet */
        end
      when wordpos('-0', area._sflags.a) > 0
        then flag = '  '      /* Area nicht geschaltet */
      otherwise
        z2 = z2 +1
        flag = '* '
    end
    m_text._part = m_text._part || flag || wrap_area_desc(area.a, area._desc.a) || cr
    call send_rsp_split_msg_part mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m
  end

end

m_text._part = m_text._part || cr || cr || def._str._78dash || cr ||,
      replace_str(def._str.lng.118, '[%n]', z1) || cr ||,
      replace_str(def._str.lng.119, '[%n]', format(z2, length(z1))) || cr

call send_rsp_split_msg mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m

return

/************************************************************************/

wrap_area_desc: procedure expose (common_var)

parse arg atag, adesc

if adesc <> ''
  then adata = left(atag, max(length(atag) +1, 27)) || adesc
  else adata = atag
if length(adata) > 74
  then
  do
    p = lastpos(' ', adata, 75)
    if p = 0
      then
      do
        str = substr(adata, 75)
        adata = delstr(adata, 75)
      end
      else
      do
        str = substr(adata, p +1)
        adata = delstr(adata, p)
      end
    fillstr = copies(' ', 29)
    do while length(str) > 47
      p = lastpos(' ', str, 48)
      if p = 0
        then
        do
          adata = adata || cr || fillstr || delstr(str, 48)
          str = substr(str, 48)
        end
        else
        do
          adata = adata || cr || fillstr || delstr(str, p)
          str = substr(str, p +1)
        end
    end
    adata = adata || cr || fillstr || str
  end

return adata

/************************************************************************/

/* Liste der geschalteten Areaas senden */

send_query_list: procedure expose (common_var)

arg m

dnl = mcmd._dnl.m
lng = value('dnl._language.'mcmd._dest_dnl.m)
if dnl <> mcmd._dest_dnl.m
  then m_text._subject = def._str.lng.146 '('dnl._addr.dnl.1')'
  else m_text._subject = def._str.lng.146

call wlog ': > %QUERY'
m_text._part = cr || def._str.lng.120 || cr || cr ||,
               def._str.lng.121 || cr || def._str._78dash || cr
z = 0

do ipart = 1 to words(area._idx) by 100
  part_idx = subword(area._idx, ipart, 100)
  do n = 1 to words(part_idx) by 2
    area = word(part_idx, n)
    a = area_idx.area
    if a // 20 = 0
      then call charout, 'A:'format(a, 6)cr
    select
      when dnl > 0       /* Downlink */
        then
        do
          parse value query_area_link(dnl, a) with aptr daptr
          if aptr <> 0
            then         /* Area geschaltet */
            do
              if aptr > 0
                then pflag = '        '
                else pflag = left(def._str.lng.122, 8)
              z = z +1
              if wordpos(dnl._addr.dnl.daptr, area._node_x.a) > 0
                then rflag = 'R/-'
                else rflag = 'R/W'
              m_text._part = m_text._part || ' ' ||,
                             left(area.a, max(length(area.a) +3, 35)) ||,
                             pflag'  'rflag'    'dnl._addr.dnl.daptr || cr
              call send_rsp_split_msg_part mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m
            end
        end
                         /* Sysop */
      when wordpos('-0', area._sflags.a) > 0
        then nop
      otherwise       /* Area geschaltet */
        z = z +1
        m_text._part = m_text._part || ' ' ||,
                       left(area.a, max(length(area.a) +3, 35)) ||,
                       '        R/W     'area._paddr.a || cr
        call send_rsp_split_msg_part mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m
    end

  end
end

m_text._part = m_text._part || def._str._78dash || cr ||,
              replace_str(def._str.lng.123, '[%n]', z) || cr
call send_rsp_split_msg mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m

return

/************************************************************************/

/* Antwort auf fehlerhafte Kommandos senden */

confirm_cmd_err: procedure expose (common_var)

arg m
call wlog replace_str(def._log_str.126, '[%n]', mcmd._error.0)

lng = value('dnl._language.'mcmd._dest_dnl.m)
m_text._subject = def._str.lng.147
m_text._part    = cr || def._str.lng.124 || cr || cr || def._str._78dash || cr
do y = 1 to mcmd._error.0
  if y // 10 = 0
    then call charout, 'P:'format(y, 6)cr

  m_text._part = m_text._part || mcmd._error.y || cr
  drop mcmd._error.y
  call send_rsp_split_msg_part mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m
end
m_text._part = m_text._part || def._str._78dash || cr || cr ||,
               replace_str(def._str.lng.125, '[%n]', mcmd._error.0) || cr
call send_rsp_split_msg mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m

return

/************************************************************************/

/* Antwort auf Passwortfehler senden */

confirm_pw_err: procedure expose (common_var)

arg m
call wlog def._log_str.127    /* Passwortfehler */

lng = value('dnl._language.'mcmd._dest_dnl.m)
m_text._subject = def._str.lng.148

attr1 = x2b(c2x(right(msg._attr.1, 2)))
attr2 = 'URQ ARQ RRC RRQ FRQ XX2 HLD LOC K/S ORP TRS ATT SNT RCV CRA PVT'
attr3 = ''
do y = 1 to length(attr1)
  if substr(attr1, y, 1)
    then attr3 = attr3 word(attr2, y)
end

ctrl = ''
do while msg._ctrl.1 \== ''
  parse var msg._ctrl.1 =1 '' z '' +0 msg._ctrl.1
  ctrl = ctrl || '@' || z || cr
end

m_text._part = cr || def._str.lng.126 || cr || cr || copies('=', 78)     || cr ||,
       replace_str(def._str.lng.127, '[%n]', left(msg._from_name.1, 36),,
                   '[%a]', msg._from_addr.1)                             || cr ||,
       replace_str(def._str.lng.128, '[%n]', left(msg._dest_name.1, 36),,
                   '[%a]', msg._dest_addr.1)                             || cr ||,
       replace_str(def._str.lng.129, '[%d]', msg._date_written.1)        || cr ||,
       replace_str(def._str.lng.130, '[%a]', attr3)                      || cr ||,
       replace_str(def._str.lng.131, '[%s]', delstr(msg._subject.1, 72)) || cr ||,
       copies('=', 78) || cr ||,
       ctrl || translate(msg._text.1, '@', '') || cr ||,
       copies('=', 78) || cr || cr ||,
       def._str.lng.132 || cr

call send_rsp_split_msg mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m

return

/************************************************************************/

/* Neue Einstellungen, Besttigung an Downlink */

proc_new_settings: procedure expose (common_var)

arg m

dnl = mcmd._dnl.m
lng = value('dnl._language.'mcmd._dest_dnl.m)
if dnl <> mcmd._dest_dnl.m
  then m_text._subject = def._str.lng.149 '('dnl._addr.dnl.1')'
  else m_text._subject = def._str.lng.149

  /* Neues Passwort */
if pos('P', mcmd._settings.m) > 0
  then
  do
    call wlog ': > %PWD' mcmd._pw_new.m
    dnl._pw.dnl = mcmd._pw_new.m
    call proc_new_settings_1 'P', 1,,
        replace_str(def._str.lng.133, '[%p]', dnl._pw.dnl)
  end

  /* Neue Sprache */
if pos('L', mcmd._settings.m) > 0
  then
  do
    call wlog ': > %LANGUAGE' mcmd._language.m
    p = wordpos(mcmd._language.m, def._language._idx)
    if p = 0
      then m_text._part = m_text._part || cr ||,
          replace_str(def._str.lng.155, '[%l]', mcmd._language.m) || cr
      else
      do
        dnl._language.dnl = substr(word(def._language._idx, p +1), 2)
        call proc_new_settings_1 'L', 2,,
            replace_str(def._str.lng.156, '[%l]', mcmd._language.m)
      end
  end

  /* Notify On/Off */
select
  when pos('+N', mcmd._settings.m) > 0  /* Notify On */
    then
    do
      call wlog ': > %NOTIFY ON'
      dnl._flags.dnl = bitor(dnl._flags.dnl, '00000400'x)
      call proc_new_settings_1 '+N', 5, def._str.lng.157
    end
  when pos('-N', mcmd._settings.m) > 0  /* Notify Off */
    then
    do
      call wlog ': > %NOTIFY OFF'
      dnl._flags.dnl = bitand(dnl._flags.dnl, 'fffffbff'x)
      call proc_new_settings_1 '-N', 5, def._str.lng.158
    end
  otherwise
end

  /* Rules per Fileattach On/Off */
select
  when pos('+A', mcmd._settings.m) > 0  /* Rules per Fileattach */
    then
    do
      call wlog ': > %RULES @FILEATTACH'
      dnl._flags.dnl = bitor(dnl._flags.dnl, '00000200'x)
      call proc_new_settings_1 '+A', 3, def._str.lng.159
    end
  when pos('-A', mcmd._settings.m) > 0  /* Ruels per Netmail */
    then
    do
      call wlog ': > %RULES @NETMAIL'
      dnl._flags.dnl = bitand(dnl._flags.dnl, 'fffffdff'x)
      call proc_new_settings_1 '-A', 3, def._str.lng.160
    end
  otherwise
end

  /* Schedules gendert */

if pos('E', mcmd._settings.m) > 0
  then
  do
    do sched = 1 to 5
      select
        when mcmd._sched.m.sched = 0
          then iterate sched      /* nicht definiert */
        when mcmd._sched.m.sched = -1
          then                    /* Schedule abschalten */
          do
            call wlog ': > %SCHEDULE' sched._mask.sched 'OFF'
            dnl._sched.sched.dnl = 0
            call proc_new_settings_1 'E', 7,,
                 replace_str(def._str.lng.190, '[%s]', sched._mask.sched)
          end
        otherwise                 /* Schedule ndern */
          call wlog ': > %SCHEDULE' sched._mask.sched mcmd._sched.m.sched

          parse value (date('s') date('b')) with act_year +4 act_month +2 act_day +2 act_date .
          act_weekday = act_date // 7       /* Wochentag, 0 = Montag */
          act_date    = act_date -719162    /* Tage seit 01.01.1970 */

          parse var mcmd._sched.m.sched s1 s2 s3 .

          dnl._sched._per.sched.dnl = s1 s2

          select
            when s2 = 'DAY'     /* tglich */
              then dnl._sched.sched.dnl = xd2date(act_date + s1)
            when s2 = 'MONTH'   /* monatlich */
              then
              do
                select
                  when s3 = ''
                    then s3 = act_day
                  when s3 > act_day
                    then s1 = s1 -1
                  otherwise
                end
                new_month = act_month +s1 -1        /* 0...11 */
                new_year = act_year + new_month %12
                new_month = new_month // 12 +1      /* 1...12 */
                new_day = min(word('31' new_year//4+28 '31 30 31 30 31 31 30 31 30 31', new_month), s3)
                dnl._sched.sched.dnl = new_year'/'right(new_month, 2, 0)'/'right(new_day, 2, 0)
              end
                                /* wchentlich */
            otherwise
              select
                when s3 = ''
                  then s3 = act_weekday
                when s3 > act_weekday
                  then s1 = s1 -1
                otherwise
              end
              dnl._sched.sched.dnl = xd2date(act_date + s1 *7 + s3 - act_weekday)
          end
          dnl._sched._per.sched.dnl = dnl._sched._per.sched.dnl s3

          call proc_new_settings_1 'E', 7,,
               replace_str(def._str.lng.191, '[%s]', sched._mask.sched) || cr ||,
               replace_str(def._str.lng.192, '[%p]', dnl._sched._per.sched.dnl)
      end
      dnl._sched.dnl = overlay(substr('LVQHI', sched, 1), dnl._sched.dnl, sched)

    end


  end

call send_rsp_split_msg mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m

return


proc_new_settings_1:
m_text._part = m_text._part || cr || arg(3) || cr
if wordpos(dnl._addr.dnl.1, dnl._settings_idx) = 0
  then dnl._settings_idx = dnl._settings_idx || dnl._addr.dnl.1 dnl' '
dnl._settings.dnl = overlay(arg(1), dnl._settings.dnl, arg(2))
prg_cfg._changed = 1    /* Prg-Cfg mu angepat werden */
return

/************************************************************************/

/* Hilfetest zusenden */

send_rsp_help: procedure expose (common_var)

arg m

dnl = mcmd._dnl.m
lng = value('dnl._language.'mcmd._dest_dnl.m)
if dnl <> mcmd._dest_dnl.m
  then m_text._subject = def._str.lng.150 '('dnl._addr.dnl.1')'
  else m_text._subject = def._str.lng.150

call wlog ': > %HELP'

if rsp_file._help.lng = ''
  then file = rsp_file._help.0
  else file = rsp_file._help.lng
do y = 1 to 10 while stream(file, 'c', 'open read') <> 'READY:'
  call syssleep 1
end
if y > 10
  then call wlog replace_str(def._log_str.105, '[%f]', file)
  else
  do
    m_text._part = ''
    do while lines(file) > 0
      m_text._part = m_text._part || linein(file) || cr
    end
    call stream file, 'c', 'close'
    call send_rsp_split_msg mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m
  end

return

/************************************************************************/

send_rsp_info: procedure expose (common_var)

arg m

call wlog ': > %INFO'

dnl = mcmd._dnl.m
lng = value('dnl._language.'mcmd._dest_dnl.m)
if dnl <> mcmd._dest_dnl.m
  then m_text._subject = def._str.lng.151 '('dnl._addr.dnl.1')'
  else m_text._subject = def._str.lng.151

if rsp_file._info.lng = ''
  then file = rsp_file._info.0
  else file = rsp_file._info.lng
do y = 1 to 10 while stream(file, 'c', 'open read') <> 'READY:'
  call syssleep 1
end
if y > 10
  then call wlog replace_str(def._log_str.105, '[%f]', file)
  else
  do
    if \dnl._group_exp.dnl
      then call expand_dnl_groups dnl

    flag_pattern = '+F] +W] +P] +R] +M] +O] +C] +K] +L] +A] +N]',
                   '-F] -W] -P] -R] -M] -O] -C] -K] -L] -A] -N]'
    test_pattern = '[%NAME]'      ,
                   '[%LEVEL]'     ,
                   '[%KEYS]'      ,
                   '[%PWD]'       ,
                   '[%AKA.1]'     ,
                   '[%R_AKA.1]'   ,
                   '[%LANGUAGE]'  ,
                   '[%LANGUAGE.1]',
                   '[%ALIAS.1]'

    m_text._part = ''
    do while lines(file) > 0
      data  = linein(file)
      select
        when pos('[%', data) = 0
          then m_text._part = m_text._part || data || cr
        when send_rsp_info_1() = 0
          then m_text._part = m_text._part || data || cr
        otherwise
          datat = translate(data)
          select
            when pos('[%GROUP_BEGIN]', datat) > 0
              then
              do
                grp_data = ''
                do while lines(file) > 0
                  data  = linein(file)
                  datat = translate(data)
                  select
                    when pos('[%GROUP_END]', datat) = 0
                      then grp_data = grp_data || data || cr
                    otherwise
                      do z = 1 to words(dnl._group.dnl)
                        data  = grp_data
                        datat = translate(data)

                        group = word(dnl._group.dnl, z)

                        p = def._group_ptr.group
                        call send_rsp_info_3 '[%GROUP_DESC', def._group_desc.p
                        call send_rsp_info_3 '[%GROUP_NAME', group
                        call send_rsp_info_3 '[%GROUP_AKA',  dnl._group_addr.dnl.z
                        p = pos('[%GROUP_ACS', datat)
                        if p > 0
                          then
                          do
                            parse var data =(p) . '"'acs'"]' +0 test +2 .
                            if test = '"]'
                              then
                              do
                                if \dnl._group_acs.dnl.z
                                  then acs = copies(' ', length(acs))
                                data = left(data, p -1) || acs ||,
                                       substr(data, pos('"]', data, p +1) +2)
                                datat = translate(data)
                              end
                          end
                        m_text._part = m_text._part || data
                      end
                      leave
                  end
                end
              end

            when pos('[%SCHEDULE_BEGIN]', datat) > 0
              then
              if dnl._sched.dnl <> ''
                then call send_rsp_info_4
                else call send_rsp_info_5
            when send_rsp_info_2() = 0
              then nop

            when pos('[%AKA.N]', datat) > 0
              then
              do z = 2 to dnl._addr.dnl.0
                m_text._part = m_text._part ||,
                        replace_str(data, '[%aka.n]', dnl._addr.dnl.z) || cr
              end
            when pos('[%R_AKA.N]', datat) > 0
              then
              do z = 2 to address.0
                m_text._part = m_text._part ||,
                        replace_str(data, '[%r_aka.n]', address.z) || cr
              end
            when pos('[%ALIAS.N]', datat) > 0
              then
              do z = 2 to words(alias._idx)
                m_text._part = m_text._part ||,
                        replace_str(data, '[%alias.n]', word(alias._idx, z)) || cr
              end
            when pos('[%LANGUAGE.N]', datat) > 0
              then
              do z = 3 to words(def._language._idx) by 2
                m_text._part = m_text._part ||,
                        replace_str(data, '[%language.n]', word(def._language._idx, z)) || cr
              end
            otherwise
              m_text._part = m_text._part || data || cr
          end
      end
    end

    call stream file, 'c', 'close'
    call send_rsp_split_msg mcmd._dest_dnl.m, mcmd._from_addr.m, mcmd._dest_addr.m, mcmd._msgid.m
  end

return



send_rsp_info_5:
do while lines(file) > 0
  data  = linein(file)
  datat = translate(data)
  select
    when pos('[%SCHEDULE_END]', datat) > 0
      then leave
    when pos('[%SCHEDULE]'  , datat) > 0 |,
         pos('[%PER_DAY]'   , datat) > 0 |,
         pos('[%PER_DAYS]'  , datat) > 0 |,
         pos('[%PER_WEEK]'  , datat) > 0 |,
         pos('[%PER_WEEKS]' , datat) > 0 |,
         pos('[%PER_MONTH]' , datat) > 0 |,
         pos('[%PER_MONTHS]', datat) > 0
      then nop
    otherwise
      p = pos('[%SCHEDULE_NONE]', datat)
      if p > 0
        then m_text._part = m_text._part || delstr(data, p, 16) || cr
  end
end
return






send_rsp_info_4:
sched_data. = ''
do while lines(file) > 0
  data  = linein(file)
  datat = translate(data)
  select
    when pos('[%SCHEDULE_END]', datat) = 0
      then
      do
        p = pos('[%PER_', datat)
        select
          when p > 0
            then
            do
              parse var datat =(p) z ']' .
              select
                when z == '[%PER_DAY'
                  then sched_data.1 = sched_data.1 || delstr(data, p, 10) || cr
                when z == '[%PER_DAYS'
                  then sched_data.2 = sched_data.2 || delstr(data, p, 11) || cr
                when z == '[%PER_WEEK'
                  then
                  do
                    data = delstr(data, p, 11)
                    p = pos('[%DAY', translate(data))
                    if p > 0
                      then
                      do
                        p = p +4
                        parse var data data1 +(p) str ']' +0 data2
                        do y = 0 to 6
                          parse var str sched_data.3.y',' str
                        end
                        sched_data.3 = data1 || data2 || cr
                      end
                      else sched_data.3 = sched_data.3 || data || cr
                  end
                when z == '[%PER_WEEKS'
                  then
                  do
                    data = delstr(data, p, 12)
                    p = pos('[%DAY', translate(data))
                    if p > 0
                      then
                      do
                        p = p +4
                        parse var data data1 +(p) str ']' +0 data2
                        do y = 0 to 6
                          parse var str sched_data.4.y',' str
                        end
                        sched_data.4  = data1 || data2 || cr
                      end
                      else sched_data.4 = sched_data.4 || data || cr
                  end
                when z == '[%PER_MONTH'
                  then
                  do
                    data = delstr(data, p, 12)
                    p = pos('[%DAY', translate(data))
                    if p > 0
                      then
                      do
                        p = p +4
                        parse var data data1 +(p) str ']' +0 data2
                        do y = 0 to 31
                          parse var str sched_data.5.y',' str
                        end
                        sched_data.5  = data1 || data2 || cr
                      end
                      else sched_data.5 = sched_data.5 || data || cr
                  end
                when z == '[%PER_MONTHS'
                  then
                  do
                    data = delstr(data, p, 13)
                    p = pos('[%DAY', translate(data))
                    if p > 0
                      then
                      do
                        p = p +4
                        parse var data data1 +(p) str ']' +0 data2
                        do y = 0 to 31
                          parse var str sched_data.6.y',' str
                        end
                        sched_data.6  = data1 || data2 || cr
                      end
                      else sched_data.6 = sched_data.6 || data || cr
                  end
                otherwise
                  do z = 1 to 6
                    sched_data.z = sched_data.z || data || cr
                  end
              end
            end
          when pos('[%SCHEDULE_NONE]', datat) > 0
            then nop
          otherwise
            p = pos('[%SCHEDULE]', datat)
            if p > 0
              then sched_data._hdr = sched_data._hdr || delstr(data, p, 11) || cr
              else
              do z = 1 to 6
                sched_data.z = sched_data.z || data || cr
              end
        end
      end

    otherwise
      m_text._part = m_text._part || sched_data._hdr
      do sched = 1 to 5
        if dnl._sched.sched.dnl = 0
          then iterate sched
        if datatype(dnl._sched.sched.dnl, 'w')
          then parse value xd2date(dnl._sched.sched.dnl) with d3'/'d2'/'d1
          else parse var dnl._sched.sched.dnl d3'/'d2'/'d1
        parse var dnl._sched._per.sched.dnl s1 s2 s3 .
        select
          when s2 = 'DAY'
            then
            do
              str = (s1 > 1) +1
              m_text._part = m_text._part || replace_str(sched_data.str,,
                             '[%cmd]', sched._mask.sched,,
                             '[%num]', s1,,
                             '[%y]', d3, '[%m]', d2, '[%d]', d1)
            end
          when s2 = 'WEEK'
            then
            do
              str = (s1 > 1) + 3
              m_text._part = m_text._part || replace_str(sched_data.str,,
                             '[%cmd]', sched._mask.sched,,
                             '[%num]', s1,,
                             '[%y]', d3, '[%m]', d2, '[%d]', d1,,
                             '[%day]', strip(sched_data.str.s3))
            end
          otherwise
            str = (s1 > 1) + 5
            z = strip(sched_data.str.s3)
            if z = ''
              then z = s3 || strip(sched_data.str.0)
            m_text._part = m_text._part || replace_str(sched_data.str,,
                           '[%cmd]', sched._mask.sched,,
                           '[%num]', s1,,
                           '[%y]', d3, '[%m]', d2, '[%d]', d1,,
                           '[%day]', z)
        end
      end
      leave
  end
end
return



send_rsp_info_3:
parse arg mask, insstr
p = pos(mask, datat)
if p > 0
  then
  do
    parse var datat =(p) . len']' +0 test +1 .
    if datatype(len, 'w') & len >= 0 & test = ']'
      then
      do
        if len > 0
          then insstr = left(insstr, len)
        data = left(data, p -1) || insstr ||,
               substr(data, pos(']', data, p +1) +1)
        datat = translate(data)
      end
  end
return



/* Flag-Zeilen auswerten */
send_rsp_info_2:
s_begin = 1
res = 1
do until res = 0
  p1 = pos('[%FLAG.', datat, s_begin)
  if p1 = 0
    then leave

  test = substr(datat, p1 +7, 3)
  p2 = wordpos(test, flag_pattern)

  if p2 = 0
    then s_begin = p1 +7
    else
    do
      if p2 > 11
        then res = bitand(dnl._flags.dnl, d2c(2 **(p2 -12), 4)) =  '00000000'x
        else res = bitand(dnl._flags.dnl, d2c(2 **(p2 -1),  4)) <> '00000000'x
      if res = 1     /* Zeile ausgeben */
        then
        do
          data = delstr(data, p1, 10)
          datat = translate(data)
        end
    end
end
return res


/* einfache Platzhalter */
send_rsp_info_1:
s_begin = 1
do forever
  p1 = pos('[%', data, s_begin)
  if p1 = 0
    then leave

  parse upper var data =(p1)test']'.
  p2 = wordpos(test']', test_pattern)
  if p2 > 0
    then
    do
      len = length(word(test_pattern, p2))
      select
        when p2 < 8
          then str = value(word('dnl._name.dnl dnl._level.dnl',
                                'dnl._keys.dnl dnl._pw.dnl',
                                'dnl._addr.dnl.1 address.1',
                                'def._language.lng', p2))
        when p2 = 8
          then str = word(def._language._idx, 1)
        otherwise
          str = word(alias._idx, 1)
      end
      data = left(data, p1 -1) || str || substr(data, p1 +len)
    end

  s_begin = s_begin + 1
end

return pos('[%', data)

/************************************************************************/

set_rsp_msg_hdr: procedure expose (common_var)

arg dnl, from_addr, dest_addr

if from_addr = ''
  then msg._from_addr.1 = address.1
  else msg._from_addr.1 = from_addr
if dest_addr = ''
  then msg._dest_addr.1 = dnl._addr.dnl.1
  else msg._dest_addr.1 = dest_addr
msg._dest_name.1 = dnl._name.dnl
msg._from_name.1 = 'RAFX'
if bitand(dnl._flags.dnl, '00000080'x) = '00000000'x
  then msg._attr.1      = '00000101'x  /* PVT, LOC */
  else msg._attr.1      = '00000181'x  /* PVT, LOC, K/S */
msg._date_written.1 = ''
msg._date_arrived.1 = ''
msg._ftsc_date.1    = ''
msg._replyto.1      = 0
msg._replies.1.0    = 0
msg._utc_ofs.1      = 0
msg._times_read.1   = 0
msg._cost.1         = 0

return

/************************************************************************/

send_rsp_split_msg_part: procedure expose (common_var)

parse arg dnl, from_addr, dest_addr, reply

select
  when length(m_text._part) < 1024
    then nop
  when length(m_text._all) < dnl._msg_length.dnl
    then
    do
      m_text._all = m_text._all || m_text._part
      m_text._part = ''
    end
  otherwise
    lng = dnl._language.dnl
    msg._text.1 = m_text._all ||,
                  m_text._part || cr ||,
                  def._str.lng.152 || cr || cr ||,
                  def._tearline || cr           /* [Fortsetzung folgt] */
    call send_rsp_split_msg_1
    m_text._all  = ''
    m_text._part = def._str.lng.153 || cr || cr /* [Fortsetzung] */
end
return

/************************************************************************/

send_rsp_split_msg: procedure expose (common_var)

parse arg dnl, from_addr, dest_addr, reply
msg._text.1 = m_text._all || m_text._part || cr || def._tearline || cr
call send_rsp_split_msg_1
m_text. = ''

return

send_rsp_split_msg_1:
m_text._num  = ('0'm_text._num) +1
if m_text._num = 1
  then
  do
    msg._subject.1 = m_text._subject
    call set_rsp_msg_hdr dnl, from_addr, dest_addr
  end
  else msg._subject.1 = m_text._subject '('m_text._num')'
msg._ctrl.1 = 'MSGID:' msg._from_addr.1 d2x(set_msgid_next(), 8)
if reply <> ''
  then msg._ctrl.1 = msg._ctrl.1 || 'REPLY:' reply

if sq_create_msg(2, 1, 2) < 0
  then call log_rsqa_error 'sq_create_msg send_rsp_split_msg'
res._netmail = res._netmail +1
msg._text.1 = ''
return

/************************************************************************/

set_msgid_next: procedure expose (common_var)

if msgid._next = ''
  then
  do
    s = stream(msgid._file, 'c', 'query size')
    select
      when s < 9 | s > 10
        then msgid._next = unix_date()
      when stream(msgid._file, 'c', 'open read') <> 'READY:'
        then msgid._next = unix_date()
      otherwise
        msgid._next = charin(msgid._file,, s)
        call stream msgid._file, 'c', 'close'
        if \datatype(msgid._next, 'w') | msgid._next > 2 **32 -2
          then msgid._next = unix_date()
          else msgid._next = max(msgid._next +1, unix_date())
    end
  end
  else msgid._next = msgid._next +1

return msgid._next

/************************************************************************/

scan_groups_local: procedure expose (common_var)

arg dnl

if \dnl._group_exp.dnl
  then call expand_dnl_groups dnl
if group._downlink <> dnl
  then
  do
    g = 0
    group. = ''
    group._idx = ' '
    group._downlink = dnl

    do ipart = 1 to words(area._idx) by 100
      call charout, 'G:'format(ipart, 6)cr
      part_idx = subword(area._idx, ipart, 100)
      do n = 1 to words(part_idx) by 2
        area = word(part_idx, n)
        a = area_idx.area

        select
          when dnl = 0
            then call scan_groups_local_1
          when wordpos(area._group.a, dnl._group.dnl) = 0
            then nop
          when area._level.a > dnl._level.dnl
            then nop
          when verify(area._keys.a, dnl._keys.dnl) > 0
            then nop
          otherwise
            call scan_groups_local_1
        end
      end
    end
    group.0 = g
  end

return group.0



scan_groups_local_1:
p = wordpos(area._group.a, group._idx)
if p = 0
  then
  do
    g = g +1
    group._idx = group._idx || area._group.a' '
    group.g.0 = 1
    group.g.1 = a
  end
  else
  do
    group.p.0 = group.p.0 +1
    z = group.p.0
    group.p.z = a
  end
return res

/************************************************************************/

query_area_link: procedure expose (common_var)

arg d, a       /* Zeiger auf Downlink und Area */

res = 0
do n = 1 to dnl._addr.d.0
  res = wordpos(dnl._addr.d.n, area._node_l.a)
  if res > 0
    then leave
  res = wordpos(dnl._addr.d.n, area._node_p.a)
  if res > 0
    then
    do
      res = res *-1
      leave
    end
end

return res n  /* 0 n = Area unlinked, n = ungltig
              -res n = passiv
               res n = aktive
            abs(res) = Zeiger auf AKA in der jeweiligen Link-Liste
                   n = Zeiger auf die AKA des Downlinks
               */
/************************************************************************/

save_msgid_next: procedure expose (common_var)

if msgid._next <> ''
  then
  do
    call sysfiledelete msgid._file
    call charout msgid._file, msgid._next
    call stream msgid._file, 'c', 'close'
  end

return

/************************************************************************/

set_area_sflags: procedure expose (common_var)

arg a, group

g = def._group_ptr.group
if g >= 1
  then area._sflags.a = space(def._area_sflags def._group_sflags.g)
  else area._sflags.a = def._area_sflags

if pos('-$', area._sflags.a) > 0
   then area._format.a = '$'
   else area._format.a = ''

return

/************************************************************************/

search_root_name: procedure expose (common_var)

arg root, format, flag, path

select
  when flag         /* ARG(4) ist Gruppenname */
    then
    do
      path = def._group_ptr.path
      if path < 1
        then
        do
          hpfs = def._area_hpfs
          path = def._area_path
        end
        else
        do
          hpfs = def._group_hpfs.path
          path = def._group_path.path
        end
    end
                    /* angegebenen Pfad verwenden */
  when s_directory(path) = ''
    then root = ''        /* Verzeichnis nicht gefunden */
  when def._area_use_hpfs = 0
    then hpfs = 0         /* FAT-Namen erwnscht */
  otherwise
    hpfs = systempfilename('@@@?????@@@') <> ''
end
call directory dir._act

if root <> ''
  then
  do
    if hpfs = 1
      then root = delstr(translate(root, char._hpfs, char._hpfs || xrange('0'x, 'ff'x), '_'), 41)
      else root = delstr(space(translate(root, char._anum, char._anum || xrange('0'x, 'ff'x), ' '), 0), 9)
    if search_root_name_1() = 1
      then
      do
        if hpfs = 1
          then troot = delstr(root, 36)'_'
          else troot = delstr(root, 5)

        do y = 0 to 9999 until search_root_name_1() = 0
          root = troot || right(y, 4, 0)
        end
        if y = 10000
          then root = ''                /* Kein Name gefunden */
      end
    if root <> ''
      then
      do
        area_root_idx.root = ''     /* Neuen Namen in Index aufnehmen */
        root = path || root
      end
  end

return root




search_root_name_1:

select
  when area_root_idx.root = ''
    then s = 1                /* Rootname existiert schon in Squish.Cfg */
  otherwise
    s = directory(path || root) <> ''
    call directory dir._act
    select
      when format = '$' & \s
        then
        do
          l = length(root) +1
          call sysfiletree path || root'.*', 'data', 'fo'
          do z = 1 to data.0
            ext = translate(substr(filespec('n', data.z), l))
            if pos('.', ext, 2) > 0
              then iterate z
            do v = 1 to keep._file_sq.2.0 until keep._file_sq.2.v = ext
            end
            if v > keep._file_sq.2.0
              then leave z
          end
          s = z <= data.0
        end
      when format <> '$' & s
        then
        do
          call sysfiletree path || root'\*', 'data', 'fo'
          do z = 1 to data.0 until v > keep._file_sdm.2.0
            do v = 1 to keep._file_sdm.2.0 until keep._file_sdm.2.v = translate(filespec('n', data.z))
            end
          end
          s = z <= data.0
        end
      otherwise
    end

end
return s

/************************************************************************/

search_area_file: procedure expose (common_var)

arg pattern, i, j

/* Area-Index einlesen, wenn nicht schon geschehen */
if upl._area_istr.i.j == ''
  then
  do
    call stream upl._area_idx.i.j, 'c', 'open read'
    upl._area_istr.i.j = charin(upl._area_idx.i.j,, chars(upl._area_idx.i.j))
    call stream upl._area_idx.i.j, 'c', 'close'
  end

call stream upl._area_file.i.j, 'c', 'open read'

pattern = prep_pattern(pattern)

l = length(upl._area_istr.i.j)
r = 1
z = 0

interpret ,
'do forever                                             ;'||,
'  parse var upl._area_istr.i.j =(r)' pattern '"*"n r   ;'||, /* Index parsen */
'  r = l - length(r)                                    ;'||,
'  if \datatype(n, "x") | n = ""                        ;'||,
'    then leave                                         ;'||, /* nichts gefunden */
'  n = x2d(n)                                           ;'||,
'  call stream upl._area_file.i.j, "c", "seek ="n       ;'||, /* Area-liste lesen */
'  parse value linein(upl._area_file.i.j) with tag desc ;'||,
'  parse upper value(" "tag" *") with 'pattern't        ;'||, /* Gegenprobe */
'  if t <> ""                                           ;'||,
'    then                                               ;'||,
'    do                                                 ;'||,
'      z = z +1                                         ;'||,
'      found.1.z = tag                                  ;'||,
"      found.2.z = space(translate(desc, ' ', '"|| '22'x ||"'));"||,
'    end                                                ;'||,
'end                                                    ;'

found.0 = z
call stream upl._area_file.i.j, 'c', 'close'

return z

/************************************************************************/

search_area_local: procedure expose (common_var)

arg pattern

pattern = prep_pattern(pattern)
l = length(area._idx)
r = 1
z = 0

interpret ,
'do forever                                             ;'||,
'  parse var area._idx =(r)' pattern '"*"n r            ;'||, /* Index parsen */
'  r = l - length(r)                                    ;'||,
'  if \datatype(n, "w")                                 ;'||,
'    then leave                                         ;'||, /* nichts gefunden */
'  parse upper value(" "translate(area.n)" *") with 'pattern't     ;'||, /* Gegenprobe */
'  if t <> ""                                           ;'||,
'    then                                               ;'||,
'    do                                                 ;'||,
'      z = z +1                                         ;'||,
'      found.z = n                                      ;'||,
'    end                                                ;'||,
'end                                                    ;'
found.0 = z

return z

/************************************************************************/

search_area_rules: procedure expose (common_var)

arg pattern

pattern = prep_pattern(pattern)
l = length(rules._idx)
w = words(rules._idx)
r = 1
z = 0

interpret ,
'do forever                                             ;'||,
'  parse var rules._idx =(r)' pattern '"*"n r           ;'||,
'  if n = ""                                            ;'||,
'    then leave                                         ;'||,
'  p = word(rules._idx, w -words(r) -1)                 ;'||,
'  parse value(" "p" *") with 'pattern't                ;'||,
'  if t <> ""                                           ;'||,
'    then                                               ;'||,
'    do                                                 ;'||,
'      z = z +1                                         ;'||,
'      found.1.z = p                                    ;'||,
'      found.2.z = n                                    ;'||,
'    end                                                ;'||,
'  r = l - length(r)                                    ;'||,
'end                                                    ;'
found.0 = z

return z

/************************************************************************/

prep_pattern: procedure           /* Suchmaske fr PARSE aufbereiten */

arg pattern
pattern = '" 'pattern' "'
do forever
  parse var pattern pattern'*'r
  if r = ''
    then leave
  pattern = pattern'"."'r
end
return pattern

/************************************************************************/

query_area_file: procedure expose (common_var)

arg pattern, i, j

/* Area-Index einlesen, wenn nicht schon geschehen */

found.0 = 0

if upl._area_file.i.j <> ''
  then
  do
    if upl._area_istr.i.j == ''
      then
      do
        call stream upl._area_idx.i.j, 'c', 'open read'
        upl._area_istr.i.j = charin(upl._area_idx.i.j,, chars(upl._area_idx.i.j))
        call stream upl._area_idx.i.j, 'c', 'close'
      end

    call stream upl._area_file.i.j, 'c', 'open read'
    pattern = ' 'pattern' '
    parse var upl._area_istr.i.j (pattern) '*'n .
    if datatype(n, 'x') & n <> ''
      then
      do
        call stream upl._area_file.i.j, 'c', 'seek ='x2d(n)
        parse value linein(upl._area_file.i.j) with tag desc
        parse upper value(' 'tag' *') with (pattern)t
        if t <> ""
          then
          do
            found.0 = 1
            found.1.1 = tag
            found.2.1 = space(translate(desc, ' ', '"'))
          end
      end
    call stream upl._area_file.i.j, 'c', 'close'
  end

return found.0

/************************************************************************/

query_area_local: procedure expose (common_var)

arg area
found.1 = area_idx.area
found.0 = datatype(found.1, 'w')

return found.0

/************************************************************************/

check_idx: procedure expose (common_var)

      /* Teste Indizes der Arealisten */
call wlogq def._log_str.130

/*======================================================================
u                             Zeiger auf Uplink
area_lst.u.0                  Anzahl der Quell-Listen pro Uplink
area_lst._file.u.al           Name Hauptliste
area_lst._file_dt.u.al        Daten der Hauptliste

area_lst._sep.u.al.0          Anzahl durch Masken definierter Listen (AREAS_SEP)
area_lst.sep_masks.u.al.n     Liste der Area-Masken
area_lst._sep_file.u.al.n     Name Ausgangsliste  (Index 0 = zu Quell-Liste)
area_lst._sep_file_dt.u.al.n  Daten Ausgangsliste (Index 0 = zu Quell-Liste)
area_lst._sep_idx.u.al.n      Name Index          (Index 0 = zu Quell-Liste)
area_lst._sep_idx_dt.u.al.n   Daten Index         (Index 0 = zu Quell-Liste)

area_lst._add.u.al.0          Anzahl direkt in Quell-Liste definierter Gruppen

area_lst._add_file.u.al.n     Name Ausgangsliste
area_lst._add_file_dt.u.al.n  Daten Ausgangsliste
area_lst._add_idx.u.al.n      Name Index
area_lst._add_idx_dt.u.al.n   Daten Index

area_lst._add_group.u.al.n    Gruppe
area_lst._add_acs.u.al.n      Zugriff
area_lst._add_level.u.al.n    Level
area_lst._add_keys.u.al.n     Keys
area_lst._add_paddr.u.al.n    Primary-AKA
======================================================================*/

/*======================================================================
  UPLINK
  SOURCE       <File-Daten>|<File>
  INDEX        <List-Daten>|<List>|<Index-Daten>|<Index>

  SEP_MASKS    <Masken>
  INDEX        <List-Daten>|<List>|<Index-Daten>|<Index>

  ADD_INDEX    <List-Daten>|<List>|<Index-Daten>|<Index>
  ADD_SETTING  <group>|<acs>|<level>|<keys>|<paddr>
======================================================================*/

changed = 0             /* 0  keine nderungen */
                        /* 1  alles neu erstellen */
kill = 0
kill_idx = ''

up  = 0
area_lst. = ''

/*======================================================================
  AREALIST.DAT einlesen
======================================================================*/

if stream(idx._data, 'c', 'open read') = 'READY:'
  then
  do
    parse value linein(idx._data) with y . 'RAFX' z     /* Versionsprfung */
    if y <> stream(idx._data, 'c', 'query size') | z <> version
      then changed = 1      /* alte Version */

      /* Index-Daten-File einlesen und auswerten */
    do while lines(idx._data) > 0 & \changed
      parse upper value space(linein(idx._data)) with keyword kwdata

      select
        when keyword = 'UPLINK'
          then
          do
            up = up +1
            area_lst.up.0 = 0
          end
        when keyword = 'SOURCE'
          then
          do
            area_lst.up.0 = area_lst.up.0 +1
            al = area_lst.up.0
            parse var kwdata area_lst._file_dt.up.al '|' area_lst._file.up.al
            area_lst._sep.up.al.0 = 0
            area_lst._add.up.al.0 = 0
          end
        when keyword = 'INDEX'
          then
          do
            al = area_lst.up.0
            y = area_lst._sep.up.al.0
            parse var kwdata area_lst._sep_file_dt.up.al.y '|',
                             area_lst._sep_file.up.al.y    '|',
                             area_lst._sep_idx_dt.up.al.y  '|',
                             area_lst._sep_idx.up.al.y
          end
        when keyword = 'SEP_MASKS'
          then
          do
            al = area_lst.up.0
            area_lst._sep.up.al.0 = area_lst._sep.up.al.0 +1
            y = area_lst._sep.up.al.0
            area_lst.sep_masks.up.al.y = kwdata
          end
        when keyword = 'ADD_INDEX'
          then
          do
            al = area_lst.up.0
            area_lst._add.up.al.0 = area_lst._add.up.al.0 +1
            y = area_lst._add.up.al.0
            parse var kwdata area_lst._add_file_dt.up.al.y '|',
                             area_lst._add_file.up.al.y    '|',
                             area_lst._add_idx_dt.up.al.y  '|',
                             area_lst._add_idx.up.al.y
          end
        when keyword = 'ADD_SETTING'
          then
          do
            al = area_lst.up.0
            y = area_lst._add.up.al.0
            parse var kwdata area_lst._add_group.up.al.y '|',
                             area_lst._add_acs.up.al.y   '|',
                             area_lst._add_level.up.al.y '|',
                             area_lst._add_keys.up.al.y  '|',
                             area_lst._add_paddr.up.al.y
          end

        when keyword = 'KILL'
          then
          do
            parse var kwdata kill_data '|' kill_file
            select
              when autokill._list._fwd  /* aufgefhrte Kill-Listen ignorieren */
                then changed = 1
              when kill_file = ''       /* Fehlerhafter Eintrag */
                then changed = 1
              when stream(kill_file, 'c', 'query exists') = ''
                then changed = 1
              when kill_data <> space(stream(kill_file, 'c', 'query size'),
                                      stream(kill_file, 'c', 'query datetime'))
                then changed = 1
              otherwise
                kill = kill +1
                kill_file.kill = kill_file
                kill_data.kill = kill_data
                kill_idx = kill_idx kill_file
            end
          end
        otherwise
          changed = 1
      end
    end
    call stream idx._data, 'c', 'close'
  end


/*======================================================================
  Eintrge testen
======================================================================*/


if \changed
  then
  do u = 1 to up until changed
    do a = 1 to area_lst.u.0 until changed
      select
        when area_lst._file.u.a <> ''
          then
          do

            select
              when stream(area_lst._file.u.a, 'c', 'query exists') = ''
                then changed = 1      /* Quell-Liste nicht mehr vorhanden */
              when area_lst._file_dt.u.a <> space(stream(area_lst._file.u.a, 'c', 'query size'),
                                                  stream(area_lst._file.u.a, 'c', 'query datetime'))
                then changed = 1      /* Quell-Liste aktualisiert worden */
              otherwise

                  /* Index der Quell-Liste testen */
                if area_lst._sep_file_dt.u.a.0 <> ''
                  then
                  do          /* Index wurde erstellt */
                    select
                      when area_lst._sep_file.u.a.0 = ''
                        then changed = 1    /* Eintrag fehlerhaft */
                      when area_lst._sep_file_dt.u.a.0 <>,
                           space(stream(area_lst._sep_file.u.a.0, 'c', 'query size'),
                                 stream(area_lst._sep_file.u.a.0, 'c', 'query datetime'))
                        then changed = 1    /* Ausgangsliste manipuliert */
                      when area_lst._sep_idx.u.a.0 = ''
                        then changed = 1    /* Eintrag fehlerhaft */
                      when area_lst._sep_idx_dt.u.a.0 <>,
                           space(stream(area_lst._sep_idx.u.a.0, 'c', 'query size'),
                                 stream(area_lst._sep_idx.u.a.0, 'c', 'query datetime'))
                        then changed = 1    /* Index manipuliert */
                      otherwise
                    end
                  end

                  /* Index der durch Masken definierten Listen testen */
                if \changed
                  then
                  do y = 1 to area_lst._sep.u.a.0
                    select
                      when area_lst.sep_masks.u.a.y = ''
                        then changed = 1    /* Eintrag fehlerhaft */
                      when area_lst._sep_file_dt.u.a.y = ''
                        then nop            /* kein Index erstellt */
                      when area_lst._sep_file.u.a.y = ''
                        then changed = 1    /* Eintrag fehlerhaft */
                      when area_lst._sep_file_dt.u.a.y <>,
                           space(stream(area_lst._sep_file.u.a.y, 'c', 'query size'),
                                 stream(area_lst._sep_file.u.a.y, 'c', 'query datetime'))
                        then changed = 1    /* Ausgangsliste manipuliert */
                      when area_lst._sep_idx.u.a.y = ''
                        then changed = 1    /* Eintrag fehlerhaft */
                      when area_lst._sep_idx_dt.u.a.y <>,
                           space(stream(area_lst._sep_idx.u.a.y, 'c', 'query size'),
                                 stream(area_lst._sep_idx.u.a.y, 'c', 'query datetime'))
                        then changed = 1    /* Index manipuliert */
                      otherwise
                    end
                  end

                  /* Index der innerhalb der Quell-Liste definierten Gruppen testen */
                if \changed
                  then
                  do y = 1 to area_lst._add.u.a.0 until changed
                    select
                      when area_lst._add_file_dt.u.a.y = ''
                        then nop            /* kein Index erstellt */
                      when area_lst._add_file.u.a.y = ''
                        then changed = 1    /* Eintrag fehlerhaft */
                      when area_lst._add_file_dt.u.a.y <>,
                           space(stream(area_lst._add_file.u.a.y, 'c', 'query size'),
                                 stream(area_lst._add_file.u.a.y, 'c', 'query datetime'))
                        then changed = 1    /* Ausgangsliste manipuliert */
                      when area_lst._add_idx.u.a.y = ''
                        then changed = 1    /* Eintrag fehlerhaft */
                      when area_lst._add_idx_dt.u.a.y <>,
                           space(stream(area_lst._add_idx.u.a.y, 'c', 'query size'),
                                 stream(area_lst._add_idx.u.a.y, 'c', 'query datetime'))
                        then changed = 1    /* Index manipuliert */
                      when verify(area_lst._add_group.u.a.y, char._ver) > 0   |,
                           length(area_lst._add_group.u.a.y) > 200            |,
                           area_lst._add_group.u.a.y = 'DELETED_AREA'         |,
                           verify(area_lst._add_keys.u.a.y, char._anum) > 0   |,
                           \datatype(area_lst._add_level.u.a.y, 'w')          |,
                           area_lst._add_level.u.a.y < 0                      |,
                           (area_lst._add_acs.u.a.y <> 0 & area_lst._add_acs.u.a.y <> 1) |,
                           wordpos(area_lst._add_paddr.u.a.y, address._idx) = 0
                        then changed = 1    /* ungltige Settings */
                      otherwise
                    end
                  end


            end

          end    /* when area_lst._file.a <> '' */

        when area_lst._add.u.a.0 > 0
          then
          do
            changed = 1    /* Eintrag Quell-Liste fehlerhaft */
          end
        otherwise
          do y = 1 to area_lst._sep.u.a.0 until changed
            if area_lst._sep_file_dt.u.a.y <> ''
              then changed = 1  /* Es drfte kein Index vorhanden sein */
          end


      end /* select */


    end /* a */
  end   /* u */

/*======================================================================
  Eintrge mit Konfiguration vergleichen
======================================================================*/

select
  when changed
    then nop            /* hat keinen Sinn mehr */
  when upl.0 <> up
    then changed = 1    /* Anzahl Uplinks unterschiedlich */
  otherwise

    do upl = 1 to upl.0 until changed                /* alle Uplinks */
      if upl_area.upl.0 <> area_lst.upl.0
        then changed = 1    /* Anzahl Quell-Listen unterschiedlich */
        else
        do m = 1 to  upl_area.upl.0 until changed    /* alle Listen */
          select
            when stream(upl_area._file.upl.m, 'c', 'query exists') = ''
              then if area_lst._file.upl.m <> ''
                then changed = 1
            when upl_area._file.upl.m <> area_lst._file.upl.m
              then changed = 1      /* CFG gendert */
            when upl_area._sep.upl.m.0 <> area_lst._sep.upl.m.0
              then changed = 1      /* Anzahl AREAS_SEP gendert */
            otherwise

              do y = 1 to area_lst._sep.upl.m.0 until changed = 1
                if upl_area._sep_masks.upl.m.y <> area_lst.sep_masks.upl.m.y
                  then changed = 1    /* Masken gendert */
              end

          end
        end
    end


end

/*======================================================================
  Kill-Listen testen
======================================================================*/

if \changed
  then
  do
    if kill > 0 & autokill._list._fwd
      then changed = 1    /* Kill-Listen jetzt nicht mehr beachten */
      else
      do
        ak_idx = ''
        do y = 1 to autokill._list.0
          select
            when stream(autokill._list.y, 'c', 'query exists') = ''
              then iterate y
            when wordpos(autokill._list.y, kill_idx) = 0
              then changed = 1      /* Kill-Liste noch nicht bercksichtigt */
            otherwise
          end
          ak_idx = ak_idx autokill._list.y
        end
        do y = 1 to kill while changed < 2
          if wordpos(kill_file.y, ak_idx) = 0
            then changed = 1
        end
        drop ak_idx
      end
  end


/*======================================================================
  Aufbau entsprechend den Tests
======================================================================*/

if changed
  then
  do        /* Neuaufbau */

    dupe. = 0   /* Stem fr Dupe-Check initialisieren */

      /* alle bisherigen Ausgangslisten und Indizes lschen */
    call sysfiletree idx._dir'\RAFX????.IDX', 'data.1', 'fo'
    call sysfiletree idx._dir'\RAFX????.LST', 'data.2', 'fo'
    do y = 1 to 2
      do z = 1 to data.y.0
        if verify(substr(filespec('n', data.y.z), 5, 4), '0123456789') = 0
          then call sysfiledelete data.y.z
      end
    end

      /* Autokill-Listen bercksichtigen */
    if \autokill._list._fwd & autokill._list._read = 0
      then call read_autokill_list
    kill = 0
    if \autokill._list._fwd
      then
      do y = 1 to autokill._list.0
        if autokill._list.y <> ''
          then
          do
            kill = kill +1
            kill_file.kill = autokill._list.y
            kill_data.kill = space(stream(kill_file.kill, 'c', 'query size'),
                                   stream(kill_file.kill, 'c', 'query datetime'))

          end
      end

      /* Ausgangslisten neu aufbauen */
    do n = 1 to upl.0
      do m = 1 to upl_area.n.0
        upl_area._add.n.m.0   = 0
        if stream(upl_area._file.n.m, 'c', 'query exists') = ''
          then upl_area._file.n.m = ''   /* Area-Liste nicht vorhanden */
          else call check_idx_1300
      end
    end
    call check_idx_1400   /* Datenfile neu erstellen */

  end

  else
  do      /* Abgleich */

    do n = 1 to upl.0
      do m = 1 to upl_area.n.0

        do y = 0 to upl_area._sep.n.m.0
          upl_area._sep_file.n.m.y = area_lst._sep_file.n.m.y
          upl_area._sep_idx.n.m.y  = area_lst._sep_idx.n.m.y
        end
        upl_area._add.n.m.0 = area_lst._add.n.m.0
        do z = 1 to upl_area._add.n.m.0
          y = z +upl_area._sep.n.m.0
          upl_area._sep_file.n.m.y  = area_lst._add_file.n.m.z
          upl_area._sep_idx.n.m.y   = area_lst._add_idx.n.m.z

          upl_area._sep_group.n.m.y = area_lst._add_group.n.m.z
          upl_area._sep_acs.n.m.y   = area_lst._add_acs.n.m.z
          upl_area._sep_level.n.m.y = area_lst._add_level.n.m.z
          upl_area._sep_keys.n.m.y  = area_lst._add_keys.n.m.z
          upl_area._sep_paddr.n.m.y = area_lst._add_paddr.n.m.z
        end

      end
    end

  end


/* UPL.-Vars setzen */

do n = 1 to upl.0
  a = 0
  do m = 1 to upl_area.n.0
    do y = 0 to (upl_area._sep.n.m.0 + upl_area._add.n.m.0)
      if upl_area._sep_file.n.m.y <> ''
        then
        do
          a = a +1
          upl._area_file.n.a  = upl_area._sep_file.n.m.y
          upl._area_group.n.a = upl_area._sep_group.n.m.y
          upl._area_acs.n.a   = upl_area._sep_acs.n.m.y
          upl._area_level.n.a = upl_area._sep_level.n.m.y
          upl._area_keys.n.a  = upl_area._sep_keys.n.m.y
          upl._area_paddr.n.a = upl_area._sep_paddr.n.m.y
          upl._area_idx.n.a   = upl_area._sep_idx.n.m.y
          upl._area_istr.n.a  = ''

        end
    end
  end
  upl._area.n.0 = a
end


return



/*===== Ausgangslisten und Indizes fr eine Hauptliste erstellen =====*/

check_idx_1300:

call wlogq replace_str(def._log_str.132, '[%f]', upl_area._file.n.m)

group_flag = 0

upl_area._file_dt.n.m = space(stream(upl_area._file.n.m, 'c', 'query size'),
                              stream(upl_area._file.n.m, 'c', 'query datetime'))

call stream upl_area._file.n.m, 'c', 'open read'      /* Hauptliste ffnen */
do j = 0 while lines(upl_area._file.n.m) > 0
  call charout, 'P:'format(j, 6)cr

  line.  = ''     /* temp. Puffer fr Zeilen */
  pline. = 0      /* Zeiger auf Zeilen */

    /* 100 Zeilen lesen */
  do l = 0 to 99 while lines(upl_area._file.n.m) > 0
    line._data.l = space(translate(linein(upl_area._file.n.m), ' ', '09'x))
  end

    /* Zeilen bearbeiten */
  do l = 0 to l

    if left(line._data.l, 1) = ';'
      then
      do
        parse upper var line._data.l . keyword kwdata
        select
          when keyword <> '*RAFX*'
            then nop                /* Kommentar ignorieren */
          when kwdata = ''
            then group_flag = 0     /* Gruppen-Def. aufheben */
          otherwise

            group_flag = 0
            parse value space(kwdata) with grp_name grp_level grp_paddr
            parse var grp_level grp_level '/' grp_keys
            select
              when verify(grp_name, char._ver) > 0 |,
                   length(grp_name) > 200       |,
                   grp_name = 'DELETED_AREA'
                then call prg_error 63, upl_area._file.n.m, j *100 +l
              when verify(grp_keys, char._anum) > 0
                then call prg_error 64, upl_area._file.n.m, j *100 +l
              when grp_level = ''
                then
                do
                  grp_acs   = 0
                  grp_level = 0
                  group_flag = 1
                end
              when \datatype(grp_level, 'w')
                then call prg_error 65, upl_area._file.n.m, j *100 +l
              otherwise
                grp_acs   = grp_level < 0
                grp_level = abs(grp_level)
                group_flag = 1
            end
            if group_flag > 0
              then
              do
                paddr = set_primary_aka(grp_paddr, grp_name)
                if paddr = ''
                  then
                  do
                    call prg_error 66, upl_area._file.n.m, j *100 +l, grp_paddr
                    group_flag = 0
                  end
                  else grp_paddr = paddr
              end

            if group_flag > 0
              then
              do
                upl_area._add.n.m.0 = upl_area._add.n.m.0 +1
                a = upl_area._add.n.m.0 +upl_area._sep.n.m.0
                upl_area._sep_group.n.m.a = grp_name
                upl_area._sep_acs.n.m.a   = grp_acs
                upl_area._sep_level.n.m.a = grp_level
                upl_area._sep_keys.n.m.a  = grp_keys
                upl_area._sep_paddr.n.m.a = grp_paddr

                z = upl_area._sep_group.n.m.a
                if \group_all.z
                  then
                  do
                    group_all.z = 1
                    group_avail.0 = group_avail.0 +1
                    call value 'group_avail.'group_avail.0, z
                  end

                group_flag = a

              end
        end
        iterate   /* nchste Zeile */
      end

    parse var line._data.l line._area.l line._data.l

    if line._area.l = ''
      then iterate                 /* Leerzeile ignorieren */
    if length(line._area.l) > 200
      then iterate                 /* Area-Tag zu lang */


    area = translate(line._area.l)

    if dupe.area
      then iterate            /* Area ist Dupe */

    if \autokill._list._fwd   /* Kill-Listen beachten */
      then
      do
        if kill_area_idx.area = ''
          then iterate        /* Area in Kill-Liste -> ignorieren */

      end

    dupe.area = 1
    line._tarea.l = area

    /* =============== */

    if group_flag > 0
      then s = group_flag
      else
      do
        do s = 1 to upl_area._sep.n.m.0
          do t = 1 to words(upl_area._sep_masks.n.m.s)
            if match(word(upl_area._sep_masks.n.m.s, t), area)
              then leave s
          end
        end
        if s > upl_area._sep.n.m.0
          then s = 0                        /* Area matcht nicht */

      end

    pline.s.0 = pline.s.0 +1
    t = pline.s.0
    pline.s.t = l
  end

    /* Zeiger verarbeiten */
  do s = 0 to upl_area._sep.n.m.0 +upl_area._add.n.m.0
    if pline.s.0 = 0
      then iterate            /* keine Areas gematcht */

    if upl_area._sep_idx.n.m.s = ''
      then upl_area._sep_idx.n.m.s = systempfilename(idx._dir'\RAFX????.IDX')
    call stream upl_area._sep_idx.n.m.s, 'c', 'open'
    call stream upl_area._sep_idx.n.m.s, 'c', 'seek <0'

    if upl_area._sep_file.n.m.s = ''
      then
      do
        upl_area._sep_file.n.m.s = systempfilename(idx._dir'\RAFX????.LST')
        call stream  upl_area._sep_file.n.m.s, 'c', 'open'
        call charout upl_area._sep_file.n.m.s, ' '
        call stream  upl_area._sep_file.n.m.s, 'c', 'open'
      end
      else
      do
        call stream upl_area._sep_file.n.m.s, 'c', 'open'
        call stream upl_area._sep_file.n.m.s, 'c', 'seek <0'
      end

    do t = 1 to pline.s.0
      l = pline.s.t
      i = stream(upl_area._sep_file.n.m.s, 'c', 'seek +0')
      call lineout upl_area._sep_file.n.m.s, line._area.l space(strip(line._data.l,, '"'))
      call charout upl_area._sep_idx.n.m.s, ' 'line._tarea.l' *'d2x(i)
    end

    call stream upl_area._sep_file.n.m.s, 'c', 'close'
    call stream upl_area._sep_idx.n.m.s , 'c', 'close'
    upl_area._sep_file_dt.n.m.s  = space(stream(upl_area._sep_file.n.m.s, 'c', 'query size'),
                                         stream(upl_area._sep_file.n.m.s, 'c', 'query datetime'))
    upl_area._sep_idx_dt.n.m.s   = space(stream(upl_area._sep_idx.n.m.s, 'c', 'query size'),
                                         stream(upl_area._sep_idx.n.m.s, 'c', 'query datetime'))

  end

end
call stream upl_area._file.n.m, 'c', 'close'

return




/*===== neuen Data-File erstellen ======*/

/*======================================================================
  UPLINK
  SOURCE       <File-Daten>|<File>
  INDEX        <List-Daten>|<List>|<Index-Daten>|<Index>

  SEP_MASKS    <Masken>
  INDEX        <List-Daten>|<List>|<Index-Daten>|<Index>

  ADD_INDEX    <List-Daten>|<List>|<Index-Daten>|<Index>
  ADD_SETTING  <group>|<acs>|<level>|<keys>|<paddr>
======================================================================*/

check_idx_1400:

call sysfiledelete idx._data
call stream idx._data, 'c', 'open'
call lineout idx._data, copies(' ', 12)'RAFX 'version
do n = 1 to upl.0
  call lineout idx._data, 'UPLINK'
  do m = 1 to upl_area.n.0

    if upl_area._file.n.m = ''
      then
      do
        call lineout idx._data, 'SOURCE'
        call lineout idx._data, 'INDEX'
      end
      else
      do
        call lineout idx._data, 'SOURCE' upl_area._file_dt.n.m'|'upl_area._file.n.m
        call lineout idx._data, 'INDEX' upl_area._sep_file_dt.n.m.0'|' ||,
                                       upl_area._sep_file.n.m.0'|'    ||,
                                       upl_area._sep_idx_dt.n.m.0'|'  ||,
                                       upl_area._sep_idx.n.m.0

        do a = 1 to upl_area._sep.n.m.0
          call lineout idx._data, 'SEP_MASKS' upl_area._sep_masks.n.m.a
          if upl_area._sep_idx.n.m.a <> ''
            then call lineout idx._data, 'INDEX' upl_area._sep_file_dt.n.m.a'|' ||,
                                                upl_area._sep_file.n.m.a'|'    ||,
                                                upl_area._sep_idx_dt.n.m.a'|'  ||,
                                                upl_area._sep_idx.n.m.a
            else call lineout idx._data, 'INDEX'
        end

        do a = (upl_area._sep.n.m.0 +1) to (upl_area._sep.n.m.0 + upl_area._add.n.m.0)
          if upl_area._sep_idx.n.m.a <> ''
            then
            do
              call lineout idx._data, 'ADD_INDEX' upl_area._sep_file_dt.n.m.a'|' ||,
                                                 upl_area._sep_file.n.m.a'|'    ||,
                                                 upl_area._sep_idx_dt.n.m.a'|'  ||,
                                                 upl_area._sep_idx.n.m.a
              call lineout idx._data, 'ADD_SETTING' upl_area._sep_group.n.m.a'|'   ||,
                                                    upl_area._sep_acs.n.m.a'|'   ||,
                                                    upl_area._sep_level.n.m.a'|'   ||,
                                                    upl_area._sep_keys.n.m.a'|'   ||,
                                                    upl_area._sep_paddr.n.m.a
            end
        end
      end
  end
end

do n = 1 to kill
  call lineout idx._data, 'KILL' kill_data.n ||'|'|| kill_file.n
end

call stream idx._data, 'c', 'close'
call stream idx._data, 'c', 'open'
call charout idx._data, stream(idx._data, 'c', 'query size')
call stream idx._data, 'c', 'close'

return

/************************************************************************/

read_prg_cfg: procedure expose (common_var)

read_prg_cfg_var = 'u d m'       ,
                   'a_idx'       ,
                   'define.'     ,
                   'define_idx.' ,
                   'mxdivhigh'   ,
                   'mxdiv'       ,
                   'mxhir'       ,
                   'mxhir.'      ,
                   'max_set.'    ,
                   'group_path'  ,
                   'group_sflags'

u = 0  /* temp. fr upl.0 */
d = 0  /* temp. fr dnl.0 */
m = 0  /* Einlese-Modus, 0 = allgemein, 1 = uplink, 2 = downlink */


mxdivhigh  = 0    /* hchste Div, temporr fr MAX.DIV */
mxdiv      = 0    /* akuelle Div */

mxhir      = 0    /* Hirarchie */
mxhir.     = 0

max._div_setting.0 = '1 1 1'
max._div_name.0    = ''

max._set_origin.0 = 1
max._set_origin.1 = ''
max._set_seenby.0 = 1
max._set_seenby.1 = '.'
max._set_style.0  = 1
max._set_style.1  = ''


a_idx = '' /* Index der Area-listen, temp. */
group_path = ''     /* temporr fr Gruppen-Pfad */
group_sflags = ''   /* temporr fr Gruppen-spezifische Squish-Flags */

define.     = 0
define_idx. = 0




prg_cfg = prg_cfg._file
call read_prg_cfg_rec prg_cfg

errstr = ''
select
  when dnl._name.0 = ''
    then errstr = 'SYSOP'
  when alias._idx = ''
    then errstr = 'ALIAS'
  when netmail_in.0 = 0
    then errstr = 'NETMAIL_IN'
  when timestamp._file = ''
    then errstr = 'TIMESTAMP'
  when squish._cfg._file = ''
    then errstr = 'SQUISH_CFG'
  when rsp_file._help.0 = ''
    then errstr = 'HELP_FILE'
  when rsp_file._info.0 = ''
    then errstr = 'INFO_FILE'
  when msgid._file = ''
    then errstr = 'MSGID_FILE'
  when idx._dir = ''
    then errstr = 'IDX_DIR'
  otherwise
end

call directory dir._act
if errstr <> ''
  then call error_253 37

if read_prg_cfg_6(dnl._flags.0, def._dnl_flags) = ''
  then call error_253 38
dnl._flags.0 = flags

select
  when mxhir <> 0
    then call error_253 71
  when max._support = 0
    then nop       /* Kein Export der Area-Daten nach Maximus */
  when max._msgarea_ctl = ''
    then errstr = 'MAX_MSGAREA_CTL'
  when max._msgarea_rafx = ''
    then errstr = 'MAX_MSGAREA_RAFX'
  when max._msgarea_rafx = max._msgarea_ctl
    then call error_253 74
  when max._main_ctl = '' & max._support = 2
    then errstr = 'MAX_MAIN_CTL'
  when max._access.0 = 0
    then errstr = 'MAX_ACCESS'
  when max._div_access = '' & maxdivhigh > 0 & max._support = 3
    then errstr = 'MAX_DIV_ACCESS'
  otherwise
end
if errstr <> ''
  then call error_253 37


/* DEF._AREA_PATH testen */
select
  when def._area_path = ''
    then nop
  when right(def._area_path, 1) <> '\'
    then def._area_path = def._area_path'\'
  otherwise
end

if def._area_use_hpfs = 2
  then char._hpfs = char._hpfs'.'
def._area_use_hpfs = sign(def._area_use_hpfs)

/* Dateisystem von DEF._AREA_PATH testen */
if def._area_use_hpfs = 0
  then def._area_hpfs = 0
  else def._area_hpfs = systempfilename(def._area_path || '@@@?????@@@') <> ''

do y = 1 to def._group_pattern.0
  if def._group_path.y = ''
    then
    do
      def._group_path.y = def._area_path
      def._group_hpfs.y = def._area_hpfs
    end
    else
    do
      if right(def._group_path.y, 1) <> '\'
        then def._group_path.y = def._group_path.y'\'
      if def._area_use_hpfs = 0
        then def._group_hpfs.y = 0
        else def._group_hpfs.y = systempfilename(def._group_path.y || '@@@?????@@@') <> ''
    end
end

if dnl._msg_length.0 = ''
  then dnl._msg_length.0 = def._msg_length
if dnl._language.0 = ''
  then dnl._language.0 = def._language

if idx._dir = ''
  then idx._dir = dir._prg

select
  when dummy._area_tag = ''
    then dummy._dir = ''
  when dummy._dir = ''
    then dummy._dir = idx._dir
  otherwise
end


def._group_sort.0 = def._group_sort.0 +1
z = def._group_sort.0
def._group_sort.z = '*'

upl.0 = u
dnl.0 = d

max._div = mxdivhigh
max._set_origin.1 = strip(def._origin)

ext_cmd._rescan       = read_prg_cfg_1(ext_cmd._rescan)
ext_cmd._toss_badmail = read_prg_cfg_1(ext_cmd._toss_badmail)
max._ctl_compiler     = read_prg_cfg_1(max._ctl_compiler)

squish._idx._file = idx._dir'\SQ_DATA.IDX'    /* Squish-Index */
rules._idx_file   = idx._dir'\RULES.IDX'      /* Rules-Index */
autokill._history = idx._dir'\AUTOKILL.DLY'   /* Autokill-History */
autokill._inhibit = idx._dir'\AUTOKILL.INH'   /* Verhinderung Autokill */
idx._data         = idx._dir'\AREALIST.DAT'   /* Daten der Arealisten und -indizes */

return



read_prg_cfg_rec_1: procedure expose define.

parse arg r, data

do y = 1 to define.0
  do forever
    p = lastpos(define.y, translate(data))
    select
      when p = 0
        then leave                      /* keine weiteren Variablen vorhanden */
      when pos('{', define._str.y) = 0
        then idata = define._str.y      /* keine Varaiblen im Ersatz-String */
      when r >= 20
        then return '09'x               /* Rekusionstiefe berschritten */
      otherwise
        idata = read_prg_cfg_rec_1(r +1, define._str.y)  /* Rekursion */
        if idata = '09'x
          then return '09'x             /* Rekusionstiefe berschritten */
      end
    data = insert(idata, delstr(data, p, define._len.y), p -1)
  end
end

return data




read_prg_cfg_rec: procedure expose (common_var) (read_prg_cfg_var)

arg prg_cfg
y = stream(prg_cfg, 'c', 'query exists')
if y = ''
  then call error_253 2
prg_cfg = y

call wlog replace_str(def._log_str.131, '[%f]', prg_cfg)

do y = 1 to 10 while stream(prg_cfg, 'c', 'open read') <> 'READY:'
  call syssleep 1
end
if y > 10
  then call error_253 3

parse value translate(charin(prg_cfg,, chars(prg_cfg)), ' ', '9'x) with cfgstr '1a'x
call stream prg_cfg, 'c', 'close'

s_begin = 1
do l = 1 until rest == ''
  parse var cfgstr =(s_begin)data(crlf) +2 rest +1
  s_begin = s_begin +length(data) +2

  parse var data data ';' .
  if data = ''
    then iterate

  if pos('{', data) > 0
    then
    do
      data = read_prg_cfg_rec_1(0, data)    /* DEFINE-Variablen ersetzen */
      if data = '09'x
        then call error_253 75
    end

  parse var data keyword kwdata
  keyword = translate(keyword)
  kwdata  = strip(kwdata)
  kwdatat = translate(kwdata, char._up, char._low)

  select

    when keyword = 'UPLINK'
      then
      do
        m = 1
        u = u +1
        upl._pw.u   = word(kwdata, 2)
        upl._name.u = subword(kwdata, 3)
        upl._addr.u = read_prg_cfg_3(word(kwdata, 1))
        if upl._pw.u = '' | upl._name.u = ''
          then call error_253 4
        upl._faddr.u      = ''

        upl_area.u.0      = 0

        upl._ac_group.u.0 = 0
        upl._cmd.u        = ' '
        upl._addr_idx     = upl._addr_idx || upl._addr.u' '
      end

    when keyword = 'DOWNLINK'
      then
      do
        m = 2
        d = d +1
        dnl._pw.d     = word(kwdatat, 2)
        dnl._name.d   = space(subword(kwdata, 3))
        dnl._addr.d.0 = 1
        dnl._addr.d.1 = read_prg_cfg_3(word(kwdata, 1))
        dnl._addr.d   = ' 'dnl._addr.d.1' '
        dnl._addr_idx = dnl._addr_idx || dnl._addr.d.1 d' '
        if dnl._pw.d = '' | dnl._name.d = ''
          then call error_253 4
        dnl._flags.d           = def._dnl_flags
        dnl._keys.d            = def._dnl_keys
        dnl._level.d           = def._dnl_level
        dnl._notify.0.d        = def._dnl_notify.0
        dnl._notify.1.d        = def._dnl_notify.1

        dnl._group_exp.d       = 0
        dnl._group.d.0         = 0

        dnl._msg_length.d      = def._msg_length
        dnl._language.d        = def._language
        dnl._sched.d           = ''
      end

    when keyword = 'INCLUDE'
      then
      do
        if kwdatat = ''
          then call error_253 21
        call read_prg_cfg_rec kwdatat
      end

    when keyword = 'DEFINE'
      then
      do
        v = word(kwdatat, 1)
        if v = '' | length(v) > 200 | verify(v, char._ver) > 0
          then call error_253 21
        y = define_idx.v
        if y = 0
          then
          do
            define.0 = define.0 +1
            y = define.0
            define.y = '{'v'}'
            define_idx.v = y
          end
        define._len.y = length(define.y)
        define._str.y = subword(kwdata, 2)
        parse upper var define._str.y y .
      end


    /* Allgemeiner Abschnitt */

    when m = 0
      then
      do
        select

          /* ========== Sysop-Daten ========== */

          when keyword = 'SYSOP'
            then
            do
              if kwdatat = ''
                then call error_253 5
              dnl._name.0 = space(kwdata)
            end
          when keyword = 'PASSWORD'
            then
            do
              if words(kwdatat) > 1
                then call error_253 6
              dnl._pw.0 = kwdatat
            end
          when keyword = 'FLAGS'
            then dnl._flags.0 = dnl._flags.0 kwdatat
          when keyword = 'MSG_LENGTH'
            then
            do
              if \datatype(kwdatat, 'w')
                then call error_253 7
              dnl._msg_length.0 = kwdatat *1024 -2048
            end
          when keyword = 'LANGUAGE'
            then
            do
              p = wordpos(kwdatat, def._language._idx)
              if p = 0
                then call error_253 36
              dnl._language.0 = substr(word(def._language._idx, p +1), 2)
            end


          /* ========== Message-Base ========== */

          when keyword = 'NETMAIL_IN'
            then
            do
              if kwdatat = ''
                then call error_253 8
              do z = 1 to words(kwdatat)
                netmail_in.0 = netmail_in.0 +1
                y = netmail_in.0
                netmail_in.y = word(kwdatat, z)
                if length(netmail_in.y) > 200
                  then call error_253 54
              end
            end
          when keyword = 'NETMAIL_OUT'
            then
            do
              if length(kwdatat) > 200
                then call error_253 54
              netmail_out._ptr = kwdatat
            end
          when keyword = 'USERNUMBER'
            then
            do
              if \datatype(kwdatat, 'w') | kwdatat < 0
                then call error_253 8
              usernumber = kwdatat
            end
          when keyword = 'TIMESTAMP'
            then
            do
              if verify(kwdatat, ':\*?&"|<>,', 'm') > 0
                then call error_253 26
              timestamp._file = kwdatat
            end
          when keyword = 'IGNORE_MSG_ATTR'
            then ignore_msg_attr = 1
          when keyword = 'TIMEOUT'
            then
            do
              if \datatype(kwdatat, 'w') | kwdatat < 0
                then call error_253 9
              timeout_open_area = kwdatat
            end
          when keyword = 'DEL_AREA_WAIT'
            then
            do
              if \datatype(kwdatat, 'w')
                then call error_253 7
              del_area._wait = kwdatat
            end
          when keyword = 'KEEP_FILE_SQ'
            then
            do
              if verify(kwdatat, ':\*?&"|<>,', 'm') > 0
                then call error_253 35
              do z = 1 to words(kwdatat)
                keep._file_sq.1.0 = keep._file_sq.1.0 +1
                y = keep._file_sq.1.0
                keep._file_sq.1.y = word(kwdatat, z)
              end
            end
          when keyword = 'KEEP_FILE_SDM'
            then
            do
              if verify(kwdatat, ':\*?&"|<>,', 'm') > 0
                then call error_253 35
              do z = 1 to words(kwdatat)
                keep._file_sdm.1.0 = keep._file_sdm.1.0 +1
                y = keep._file_sdm.1.0
                keep._file_sdm.1.y = word(kwdatat, z)
              end
            end
          when keyword = 'SAVE_FILE_SQ'
            then
            do
              if verify(kwdatat, ':\*?&"|<>,', 'm') > 0
                then call error_253 35
              do z = 1 to words(kwdatat)
                do v = 1 to 2
                  keep._file_sq.v.0 = keep._file_sq.v.0 +1
                  y = keep._file_sq.v.0
                  keep._file_sq.v.y = word(kwdatat, z)
                end
              end
            end
          when keyword = 'SAVE_FILE_SDM'
            then
            do
              if verify(kwdatat, ':\*?&"|<>,', 'm') > 0
                then call error_253 35
              do z = 1 to words(kwdatat)
                do v = 1 to 2
                  keep._file_sdm.v.0 = keep._file_sdm.v.0 +1
                  y = keep._file_sdm.v.0
                  keep._file_sdm.v.y = word(kwdatat, z)
                end
              end
            end


          /* ========== System ========== */

          when keyword = 'DEF_LANGUAGE'
            then
            do
              p = wordpos(kwdatat, def._language._idx)
              if p = 0
                then call error_253 36
              def._language = substr(word(def._language._idx, p +1), 2)
            end
          when keyword = 'LOGFILE'
            then log._prg = kwdatat
          when keyword = 'SEMAPHORE'
            then
            do
              parse value space(kwdatat) with sem._timeout sem._name
              if \datatype(sem._timeout, 'w') | sem._timeout < 0
                then call error_253 10
              if sem._name = ''
                then call error_253 11
              if set_full_name('sem._name') = ''
                then call error_253 13
            end
          when keyword = 'SQUISH_CFG'
            then
            do
              squish._cfg._file = kwdatat
              if set_full_name('squish._cfg._file', 'f') = ''
                then call error_253 14
            end
          when keyword = 'SQUISH_CFG_FULL_ADDR'
            then squish._cfg._full_addr = 1
          when keyword = 'SQUISH_CFG_LINE_LEN'
            then
            do
              if \datatype(kwdatat, 'w') | kwdatat > 1024
                then call error_253 51
              squish._cfg._line_len = kwdatat -32
            end
          when keyword = 'SQUISH_LOGFILE'
            then
            do
              squish._logfile = kwdatat
              if set_full_name('squish._logfile') = ''
                then call error_253 16
            end
          when keyword = 'RESCAN_CMD'
            then
            do
              ext_cmd._rescan = word(kwdatat, 1)
              if set_full_name('ext_cmd._rescan', 'f') = ''
                then call error_253 14
              ext_cmd._rescan = ext_cmd._rescan subword(kwdata, 2)
            end
          when keyword = 'TOSS_BADMAIL_CMD'
            then
            do
              ext_cmd._toss_badmail = word(kwdatat, 1)
              if set_full_name('ext_cmd._toss_badmail', 'f') = ''
                then call error_253 14
              ext_cmd._toss_badmail = ext_cmd._toss_badmail subword(kwdata, 2)
            end

          when keyword = 'RESCAN_CMD_DIR'
            then
            do
              ext_cmd._rescan_dir = kwdatat
              if set_full_name('ext_cmd._rescan_dir', 'p') = ''
                then call error_253 16
            end
          when keyword = 'TOSS_BADMAIL_CMD_DIR'
            then
            do
              ext_cmd._toss_badmail_dir = kwdatat
              if set_full_name('ext_cmd._toss_badmail_dir', 'p') = ''
                then call error_253 16
            end


          /* ========== Dateien und Pfade ========== */

          when keyword = 'HELP_FILE'
            then call read_prg_cfg_5 '_HELP'
          when keyword = 'INFO_FILE'
            then call read_prg_cfg_5 '_INFO'
          when keyword = 'MSGID_FILE'
            then
            do
              msgid._file = kwdatat
              if set_full_name('msgid._file') = ''
                then call error_253 16
            end
          when keyword = 'IDX_DIR'
            then
            do
              idx._dir = kwdatat
              select
                when idx._dir = ''
                  then idx._dir = dir._prg
                when set_full_name('idx._dir', 'p') = ''
                  then call error_253 16
                otherwise
              end
            end

          /* ========== zus. Area-Listen ========== */

          when keyword = 'EXT_AREA_FILE'
            then
            do
              if kwdatat = ''
                then call error_253 21
              ext_area.0 = ext_area.0 +1
              y = ext_area.0
              ext_area._file.y = kwdatat
              if set_full_name('ext_area._file.'y) = ''
                then call error_253 16
              ext_area._pt.y = 0
              ext_area._inc.y.0 = 0
              ext_area._exc.y.0 = 0
            end
          when keyword = 'EXT_AREA_FILE_MASK'
            then
            do
              if ext_area.0 = 0
                then call error_253 21
              y = ext_area.0
              ext_area._mask.y = kwdata
            end
          when keyword = 'EXT_AREA_PT'
            then
            do
              if ext_area.0 = 0
                then call error_253 21
              y = ext_area.0
              ext_area._pt.y = 1
            end
          when keyword = 'EXT_AREA_FORMAT'
            then
            do
              if ext_area.0 = 0
                then call error_253 21
              y = ext_area.0
              parse var kwdata '"'ext_area._format_sdm.y'"'z'"'ext_area._format_sq.y'"'v
              if z <> '' | v <> ''
                then call error_253 21    /* todo: Fehlermeldung */
            end
          when keyword = 'EXT_AREA_GROUP_INC'
            then
            do
              if ext_area.0 = 0
                then call error_253 21
              y = ext_area.0
              ext_area._inc.y.0 = ext_area._inc.y.0 +1

              if abbrev(kwdata, '"')
                then
                do
                  parse var kwdata '"'grp_subst'"'pattern
                  pattern = translate(pattern)
                end
                else
                do
                  grp_subst = ''
                  pattern   = kwdatat
                end

              do v = 1 to words(pattern)
                ext_area._inc.y.0 = ext_area._inc.y.0 +1
                z = ext_area._inc.y.0
                ext_area._inc.y.z = word(pattern, v)
                if grp_subst <> ''
                  then ext_area._inc_subst.y.z = grp_subst
              end
            end
          when keyword = 'EXT_AREA_GROUP_EXC'
            then
            do
              if ext_area.0 = 0
                then call error_253 21
              y = ext_area.0
              do v = 1 to words(kwdatat)
                ext_area._exc.y.0 = ext_area._exc.y.0 +1
                z = ext_area._exc.y.0
                ext_area._exc.y.z = word(kwdatat, v)
              end
            end

          /* ========== Maximus ========== */

          when keyword = 'MAX_SUPPORT'
            then
            do
              if max._support <> 0
                then call error_253 76
              if kwdata <> 2 & kwdata <> 3
                then call error_253 21
              max._support = kwdata
            end

          when abbrev(keyword, 'MAX_')
            then
            do
              select
                when max._support = 0
                  then call error_253 77


                when keyword = 'MAX_WORK_DIR'
                  then
                  do
                    max._work_dir = kwdatat
                    if set_full_name('max._work_dir', 'p') = ''
                      then call error_253 16
                  end

                when keyword = 'MAX_MAIN_CTL'
                  then
                  do
                    if max._support = 2
                      then
                      do
                        max._main_ctl = kwdatat
                        if set_full_name('max._main_ctl', 'f') = ''
                          then call error_253 14
                      end
                  end

                when keyword = 'MAX_MSGAREA_CTL'
                  then
                  do
                    max._msgarea_ctl = kwdatat
                    if set_full_name('max._msgarea_ctl', 'f') = ''
                      then call error_253 14
                  end

                when keyword = 'MAX_CTL_COMPILER'
                  then
                  do
                    max._ctl_compiler = word(kwdatat, 1)
                    if set_full_name('max._ctl_compiler', 'f') = ''
                      then call error_253 14
                    max._ctl_compiler = max._ctl_compiler subword(kwdata, 2)
                  end

                when keyword = 'MAX_MSGAREA_RAFX'
                  then
                  do
                    max._msgarea_rafx = kwdatat
                    if set_full_name('max._msgarea_rafx') = ''
                      then call error_253 16
                  end

                when keyword = 'MAX_ACCESS'
                  then
                  do
                    z = max._access.0
                    max._access.0 = max._access.0 +1
                    y = max._access.0
                    max._access.y = word(kwdata, 1)
                    max._access_str.y = word(kwdata, 2)
                    if \datatype(max._access.y, 'w') | max._access.y < 0 |,
                       max._access_str.y = ''
                      then call error_253 31
                    if y > 1 & max._access.y < max._access.z
                      then call error_253 72
                  end

                when keyword = 'MAX_AKA_MATCH'
                  then
                  do
                    max._aka_match.0 = max._aka_match.0 +1
                    y = max._aka_match.0
                    max._aka_match.y = word(kwdatat, 1)
                    max._aka_match_new.y = strip(word(kwdatat, 2), 't', '.')

                    parse var max._aka_match_new.y t1':'t2'/'t3'.'t4
                    select
                      when \datatype(t1, 'w') | t1 < 1 |,
                           \datatype(t2, 'w') | t2 < 0 |,
                           \datatype(t3, 'w') | t3 < 0
                        then call error_253 21
                      when t4 = ''
                        then max._aka_match_new.y = max._aka_match_new.y'.0'
                      when \datatype(t4, 'w') | t4 < 0
                        then call error_253 21
                      otherwise
                    end
                  end

                when keyword = 'MAX_ACS_KEYS'
                  then
                  do
                    max._acs_keys = space(kwdatat, 0)
                    if verify(max._acs_keys, char._anum) > 0 |,
                       verify(max._acs_keys, '09YZ', 'm') > 0
                      then call error_253 21
                  end



                when keyword = 'MAX_AKA_INC'
                  then
                  do y = 1 to words(kwdatat)
                    max._div_aka.mxdiv.0 = max._div_aka.mxdiv.0 +1
                    z = max._div_aka.mxdiv.0
                    max._div_aka.mxdiv.z = word(kwdatat, y)
                  end

                when keyword = 'MAX_GROUP_INC'
                  then
                  do
                    ro_flag = word(kwdatat, 1) = '-R'
                    do y = (1 +ro_flag) to words(kwdatat)
                      max._div_group_inc.mxdiv.0 = max._div_group_inc.mxdiv.0 +1
                      z = max._div_group_inc.mxdiv.0
                      max._div_group_inc.mxdiv.z = word(kwdatat, y)
                      max._div_group_inc_ro.mxdiv.z = ro_flag
                    end
                  end

                when keyword = 'MAX_GROUP_EXC'
                  then
                  do y = 1 to words(kwdatat)
                    max._div_group_exc.mxdiv.0 = max._div_group_exc.mxdiv.0 +1
                    z = max._div_group_exc.mxdiv.0
                    max._div_group_exc.mxdiv.z = word(kwdatat, y)
                  end

                when keyword = 'MAX_GROUP_DIS'
                  then
                  do y = 1 to words(kwdatat)
                    max._div_group_dis.mxdiv.0 = max._div_group_dis.mxdiv.0 +1
                    z = max._div_group_dis.mxdiv.0
                    max._div_group_dis.mxdiv.z = word(kwdatat, y)
                  end

                when keyword = 'MAX_AREA_INC'
                  then
                  do
                    ro_flag = word(kwdatat, 1) = '-R'
                    do y = (1 +ro_flag) to words(kwdatat)
                      max._div_area_inc.mxdiv.0 = max._div_area_inc.mxdiv.0 +1
                      z = max._div_area_inc.mxdiv.0
                      max._div_area_inc.mxdiv.z = word(kwdatat, y)
                      max._div_area_inc_ro.mxdiv.z = ro_flag
                    end
                  end

                when keyword = 'MAX_AREA_EXC'
                  then
                  do y = 1 to words(kwdatat)
                    max._div_area_exc.mxdiv.0 = max._div_area_exc.mxdiv.0 +1
                    z = max._div_area_exc.mxdiv.0
                    max._div_area_exc.mxdiv.z = word(kwdatat, y)
                  end

                when keyword = 'MAX_AREA_DIS'
                  then
                  do y = 1 to words(kwdatat)
                    max._div_area_dis.mxdiv.0 = max._div_area_dis.mxdiv.0 +1
                    z = max._div_area_dis.mxdiv.0
                    max._div_area_dis.mxdiv.z = word(kwdatat, y)
                  end

                when keyword = 'MAX_ORIGIN'
                  then
                  do
                    max._set_origin.0 = max._set_origin.0 +1
                    z = max._set_origin.0
                    max._set_origin.z = space(kwdata)

                    max._div_setting.mxdiv = z subword(max._div_setting.mxdiv, 2)
                  end

                when keyword = 'MAX_SEENBY'
                  then
                  do
                    if max._support = 3
                      then
                      do
                        max._set_seenby.0 = max._set_seenby.0 +1
                        z = max._set_seenby.0
                        if kwdatat <> '.' & kwdatat <> ''
                          then max._set_seenby.z = kwdata
                          else max._set_seenby.z = '.'
                        max._div_setting.mxdiv = word(max._div_setting.mxdiv, 1) z
                                                 word(max._div_setting.mxdiv, 3)
                      end
                  end

                when keyword = 'MAX_STYLE'
                  then
                  do
                    max._set_style.0 = max._set_style.0 +1
                    z = max._set_style.0
                    if wordpos('READONLY' , kwdatat) > 0 |,
                       wordpos('READ-ONLY', kwdatat) > 0 |,
                       wordpos('*.MSG'    , kwdatat) > 0 |,
                       wordpos('SQUISH'   , kwdatat) > 0
                      then call error_253 21
                    if max._support = 3
                      then max._set_style.z = space(translate(kwdata, ' ', ','))
                      else max._set_style.z = space(kwdata)
                    max._div_setting.mxdiv = subword(max._div_setting.mxdiv, 1, 2) z
                  end

                when keyword = 'MAX_DIV_CHAR'
                  then max._div_char = space(kwdatat, 0)

                when keyword = 'MAX_DIV_ACCESS'
                  then max._div_access = word(kwdata, 1)

                when keyword = 'MAX_DIV'
                  then
                  do
                      /* neue Division */
                    mxdivhigh   = mxdivhigh +1
                    max._div_name.mxdivhigh = word(kwdatat, 1)
                    max._div_desc.mxdivhigh = space(subword(kwdata, 2))

                    select
                      when max._support = 3
                        then
                        do
                          if pos('.', max._div_name.mxdivhigh) > 0
                            then call error_253 73
                        end
                      when length(max._div_name.mxdivhigh) < 1 |,
                           length(max._div_name.mxdivhigh) > 8
                        then call error_253 21
                      otherwise
                    end

                      /* Zeiger in der bergeordneten Division setzen */
                    max._div_ptr.mxdiv.0 = max._div_ptr.mxdiv.0 +1
                    y = max._div_ptr.mxdiv.0
                    max._div_ptr.mxdiv.y = mxdivhigh

                      /* Settings vererben */
                    max._div_setting.mxdivhigh = max._div_setting.mxdiv

                      /* Hirarchie setzen */
                    mxhir       = mxhir +1
                    mxhir.mxhir = mxdivhigh
                    mxdiv       = mxdivhigh

                  end

                when keyword = 'MAX_DIV_END'
                  then
                  do
                    mxhir = mxhir -1
                    if mxhir < 0
                      then call error_253 70    /* berzhlig */

                      /* in der Hirarchie wieder eine Ebene zurck */
                    mxdiv = mxhir.mxhir
                  end

                otherwise
                  call error_253 39   /* Keyword nicht bekannt */
              end
            end

          /* ========== Rules ========== */

          when keyword = 'RULES'
            then
            do
              rules._file.0 = rules._file.0 +1
              y = rules._file.0
              rules._file_sub.y = word(kwdatat, 1) = '-S'
              if rules._file_sub.y
                then rules._file.y = subword(kwdatat, 2)
                else rules._file.y = kwdatat
              if rules._file.y = ''
                then call error_253 21
              if words(rules._file.y) > 1
                then call error_253 15
              rules._path.y = filespec('d', rules._file.y) || filespec('p', rules._file.y)
              rules._file.y = filespec('n', rules._file.y)
              if set_full_name('rules._path.'y, 'p') = ''
                then call error_253 16
            end

          when keyword = 'RULES_SEARCH_STR'
            then
            do while kwdatat <> ''
              parse upper var kwdatat '"'str'"' kwdatat
              if str <> ''
                then
                do
                  rules._search.0 = rules._search.0 +1
                  y = rules._search.0
                  rules._search.y = str
                end
            end
          when keyword = 'RULES_SEARCH_LINES'
            then
            do
              if kwdatat = ''
                then call error_253 21
              if \datatype(kwdatat, 'w') | kwdatat < 1
                then call error_253 68
              rules._lines = kwdatat
            end
          when keyword = 'RULES_COPY_2_DSC'
            then rules._copy_2_dsc = (word(kwdatat, 1) = '-O') +1
          when keyword = 'RULES_SEND_DSC'
            then rules._send_dsc = 1



          /* ========== AreaFix ========== */

          when keyword = 'ALIAS'
            then
            do
              if kwdatat = ''
                then call error_253 17
              alias._idx = alias._idx || space(kwdatat)' '
            end
          when keyword = 'REQUEST_KILLSENT'
            then upl._fwd_killsent = 1


          when keyword = 'GROUP_PATH'
            then
            do
              group_path = kwdatat
              if s_directory(group_path) = ''
                then call error_253 16
              call directory dir._act
            end

          when keyword = 'GROUP'
            then
            do
              group = word(kwdatat, 1)
              if verify(group, char._ver'*') > 0 | group = '' |,
                 length(group) > 200 | pos('**', group) > 0
                then call error_253 18
              zone = word(kwdata, 2)
              if \datatype(zone, 'w') | zone < 0
                then call error_253 19
              def._group_pattern.0 = def._group_pattern.0 +1
              y = def._group_pattern.0
              def._group_pattern.y = group
              def._group_zone.y    = zone
              def._group_desc.y    = delstr(strip(strip(subword(kwdata, 3),, '"')), 49)
              def._group_path.y    = group_path
              def._group_sflags.y  = group_sflags

            end

          when keyword = 'GROUP_AREA_FLAGS'
            then
            do
              p = wordpos('-0', kwdata)   /* Passthrough-Flag filtern */
              if p > 0
                then group_sflags = space(delword(kwdata, p, 1))
                else group_sflags = space(kwdata)
            end

          when keyword = 'GROUP_SORT'
            then
            do y = 1 to words(kwdatat)
              def._group_sort.0 = def._group_sort.0 +1
              z = def._group_sort.0
              def._group_sort.z = word(kwdatat, y)
            end

          when keyword = 'DUMMY_DIR'
            then
            do
              dummy._dir = kwdatat
              if set_full_name('dummy._dir', 'p') = ''
                then call error_253 16
            end
          when keyword = 'DUMMY_AREA'
            then
            do
              parse var kwdata dummy._area_tag dummy._area_len dummy._area_fill
              select
                when pos('[%G]', translate(dummy._area_tag)) = 0
                  then call error_253 21
                when dummy._area_len = ''
                  then dummy._area_len = 0
                when \datatype(dummy._area_len, 'w')
                  then call error_253 21
                when dummy._area_fill = ''
                  then dummy._area_fill = '-'
                when length(dummy._area_fill) > 1
                  then call error_253 21
                otherwise
              end
            end

          when keyword = 'AUTOKILL_LIST_FWD'
            then autokill._list._fwd = 1

          when keyword = 'AUTOKILL_LIST'
            then
            do
              if kwdatat = ''
                then call error_253 21
              autokill._list.0 = autokill._list.0 +1
              y = autokill._list.0
              autokill._list.y = kwdatat
              if set_full_name('autokill._list.'y) = ''
                then call error_253 22
            end

          when keyword = 'AUTOKILL_DAYS'
            then
            do
              if \datatype(kwdatat, 'w') | kwdata < 0
                then call error_253 9
              autokill._days = kwdatat
            end
          when keyword = 'AUTOKILL_DELAY'
            then
            do
              if \datatype(kwdatat, 'w') | kwdata < 0
                then call error_253 9
              autokill._delay = kwdatat
            end
          when keyword = 'AUTOKILL_GROUP_INC'
            then
            do y = 1 to words(kwdatat)
              autokill._group_inc.0 = autokill._group_inc.0 +1
              z = autokill._group_inc.0
              autokill._group_inc.z = word(kwdatat, y)
            end
          when keyword = 'AUTOKILL_GROUP_EXC'
            then
            do y = 1 to words(kwdatat)
              autokill._group_exc.0 = autokill._group_exc.0 +1
              z = autokill._group_exc.0
              autokill._group_exc.z = word(kwdatat, y)
            end
          when keyword = 'AUTOKILL_AREA_INC'
            then
            do y = 1 to words(kwdatat)
              autokill._area_inc.0 = autokill._area_inc.0 +1
              z = autokill._area_inc.0
              autokill._area_inc.z = word(kwdatat, y)
              if length(autokill._area_inc.z) > 200
                then call error_253 54
            end
          when keyword = 'AUTOKILL_AREA_EXC'
            then
            do y = 1 to words(kwdatat)
              autokill._area_exc.0 = autokill._area_exc.0 +1
              z = autokill._area_exc.0
              autokill._area_exc.z = word(kwdatat, y)
              if length(autokill._area_exc.z) > 200
                then call error_253 54
            end
          when keyword = 'AUTOKILL_LEVEL'
            then
            do
              parse var kwdatat autokill._level'/'autokill._keys
              select
                when verify(autokill._keys, char._anum) > 0
                  then call error_253 30
                when autokill._level = ''
                  then autokill._level = 0
                when \datatype(autokill._level, 'w')
                  then call error_253 31
                otherwise
                  autokill._level = abs(autokill._level)
              end
            end
          when keyword = 'AUTOKILL_LOCAL'
            then autokill._local = 1


          /* ========== Neue Areas ========== */

          when keyword = 'AREA_DESC'
            then def._area_desc = strip(strip(kwdata,, '"'))
          when keyword = 'NEW_AREA_PATH'
            then
            do
              def._area_path = kwdatat
              if s_directory(def._area_path) = ''
                then call error_253 16
              call directory dir._act
            end

          when keyword = 'NEW_AREA_FLAGS'
            then
            do
              p = wordpos('-0', kwdata)   /* Passthrough-Flag filtern */
              if p > 0
                then def._area_sflags = space(delword(kwdata, p, 1))
                else def._area_sflags = space(kwdata)
            end
          when keyword = 'NEW_AREA_LEVEL'
            then
            do
              call read_prg_cfg_2 kwdatat
              def._area_level = level
              def._area_acs   = acs
              def._area_keys  = keys
            end
          when keyword = 'NEW_AREA_GROUP'
            then
            do
              def._area_group = word(kwdatat, 1)
              if verify(def._area_group, char._ver) > 0 | def._area_group = '' |,
                 length(def._area_group) > 200
                then call error_253 18

              z = def._area_group
              if \group_all.z
                then
                do
                  group_all.z = 1
                  group_avail.0 = group_avail.0 +1
                  call value 'group_avail.'group_avail.0, z
                end

            end
          when keyword = 'NEW_AREA_HPFS'
            then
            do
              select
                when kwdata = ''
                  then def._area_use_hpfs = 1
                when length(kwdata) > 1 | verify(kwdata, '123') > 0
                  then call error_253 34
                otherwise
                  def._area_use_hpfs = kwdata
              end
            end

          /* ========== Ankndigungen neuer Areas ========== */

          when keyword = 'ANN_HEADER_FOOTER'
            then
            do
              ann._header_footer = kwdatat
              if set_full_name('ann._header_footer', 'f') = ''
                then call error_253 14
            end
          when keyword = 'ANN_DEST_NAME'
            then ann._dest_name = delstr(kwdata, 37)
          when keyword = 'ANN_FROM_NAME'
            then ann._from_name = delstr(kwdata, 37)
          when keyword = 'ANN_MSG_LENGTH'
            then
            do
              if \datatype(kwdatat, 'w')
                then call error_253 9
              ann._msg_length = kwdatat *1024 -2048
            end
          when keyword = 'ANN_LANGUAGE'
            then
            do
              p = wordpos(kwdatat, def._language._idx)
              if p = 0
                then call error_253 36
              ann._language = substr(word(def._language._idx, p +1), 2)
            end


          when keyword = 'ANN_AREA'
            then
            do
              if kwdatat = ''
                then call error_253 32
              ann._area.0 = ann._area.0 +1
              y = ann._area.0
              ann._area.y          = word(kwdatat, 1)
              ann._from_addr.y     = word(kwdatat, 2)
              ann._dest_name.y     = ann._dest_name
              ann._from_name.y     = ann._from_name
              ann._msg_length.y    = ann._msg_length
              ann._language.y      = ann._language
              ann._header_footer.y = ann._header_footer
              ann._group._new.y.0  = 0
              ann._group._del.y.0  = 0
              ann._group._ren.y.0  = 0
              ann._group._warn.y.0 = 0
              ann_event  = 0
            end

          when keyword = 'ANN_EVENT'
            then
            do
              if ann._area.0 = 0
                then call error_253 33
              parse value (' 'kwdatat) with ' N' +0 t.1 . =1 ' D' +0 t.2 . =1 ' R' +0 t.3 . =1 ' W' +0 t.4 .
              ann_event = 0
              s.1 = '_NEW' ; s.2 = '_DEL' ; s.3 = '_REN' ; s.4 = '_WARN'
              do y = 1 to 4
                if t.y = ''
                  then iterate
                ann_event = ann_event +1
                ann_event.ann_event = s.y
              end
            end

          when keyword = 'ANN_GROUP'
            then
            do
              if ann_event = 0
                then call error_253 67
              y = ann._area.0
              do v = 1 to words(kwdatat)
                w = word(kwdatat, v)
                do t = 1 to ann_event
                  tail = ann_event.t
                  ann._group.tail.y.0 = ann._group.tail.y.0 +1
                  z = ann._group.tail.y.0
                  ann._group.tail.y.z = w
                end
              end
            end

          when keyword = 'ORIGIN'
            then def._origin = strip(kwdata,, '"')
          when keyword = 'ECHO_TOSS_LOG'
            then
            do
              echotoss._file = kwdatat
              if set_full_name('echotoss._file') = ''
                then call error_253 16
            end

          /* ========== Vorgabe fr Downlinks ========== */

          when keyword = 'DEF_MSG_LENGTH'
            then
            do
              if \datatype(kwdatat, 'w')
                then call error_253 9
              def._msg_length = kwdatat *1024 -2048
            end

          when keyword = 'DEF_LEVEL'
            then
            do
              call read_prg_cfg_2 kwdatat
              def._dnl_level = level
              def._dnl_keys  = keys
            end
          when keyword = 'DEF_FLAGS'
            then
            do
              if read_prg_cfg_6(kwdatat, def._dnl_flags) = ''
                then call error_253 20
              def._dnl_flags = flags
            end
          when keyword = 'DEF_NOTIFY_OFF'
            then def._dnl_notify.0 = read_prg_cfg_7(def._dnl_notify.0)
          when keyword = 'DEF_NOTIFY_ON'
            then def._dnl_notify.1 = read_prg_cfg_7(def._dnl_notify.1)

          otherwise
            call error_253 39
        end
      end

    /* ========== Uplink-Daten ========== */

    when m = 1
      then
      do
        select
          when keyword = 'ORIG_ADDR'
            then upl._faddr.u = read_prg_cfg_3(kwdatat)

          when keyword = 'AREAS'
            then
            do
              upl_area.u.0 = upl_area.u.0 +1
              y = upl_area.u.0

              upl_area._file.u.y = word(kwdatat, 4)
              if upl_area._file.u.y = ''
                then call error_253 21
              if set_full_name('upl_area._file.'u'.'y) = ''
                then call error_253 22
              if wordpos(upl_area._file.u.y, a_idx) > 0
                then call error_253 23
              a_idx = a_idx upl_area._file.u.y

              upl_area._sep_group.u.y.0  = word(kwdatat, 1)
              if verify(upl_area._sep_group.u.y.0, char._ver) > 0 |,
                 length(upl_area._sep_group.u.y.0) > 200
                then call error_253 18
              if upl_area._sep_group.u.y.0 = 'DELETED_AREA'
                then call error_253 24

              call read_prg_cfg_2 word(kwdatat, 2)
              upl_area._sep_level.u.y.0  = level
              upl_area._sep_acs.u.y.0    = acs
              upl_area._sep_keys.u.y.0   = keys
              upl_area._sep_paddr.u.y.0  = word(kwdata, 3)

              upl_area._sep.u.y.0  = 0

              v = upl_area._sep_group.u.y.0
              if \group_all.v
                then
                do
                  group_all.v = 1
                  group_avail.0 = group_avail.0 +1
                  call value 'group_avail.'group_avail.0, v
                end

            end

          when keyword = 'AREAS_SEP'
            then
            do
              if upl_area.u.0 = 0
                then call error_253 59
              y = upl_area.u.0
              upl_area._sep.u.y.0 = upl_area._sep.u.y.0 +1
              z = upl_area._sep.u.y.0

              upl_area._sep_group.u.y.z = word(kwdatat, 1)
              if verify(upl_area._sep_group.u.y.z, char._ver) > 0 |,
                 length(upl_area._sep_group.u.y.z) > 200
                then call error_253 18

              call read_prg_cfg_2 word(kwdatat, 2)

              upl_area._sep_acs.u.y.z     = acs
              upl_area._sep_level.u.y.z   = level
              upl_area._sep_keys.u.y.z    = keys
              upl_area._sep_paddr.u.y.z   = word(kwdata, 3)
              upl_area._sep_masks.u.y.z   = space(subword(kwdatat, 4))
              if upl_area._sep_masks.u.y.z = ''
                then call error_253 60

              v = upl_area._sep_group.u.y.z
              if \group_all.v
                then
                do
                  group_all.v = 1
                  group_avail.0 = group_avail.0 +1
                  call value 'group_avail.'group_avail.0, v
                end

            end


          when keyword = 'AUTOCREATE'
            then
            do
              upl._ac_group.u.0 = upl._ac_group.u.0 +1
              z = upl._ac_group.u.0

              upl._ac_group.u.z  = word(kwdatat, 1)
              if verify(upl._ac_group.u.z, char._ver) > 0 |,
                 upl._ac_group.u.z = '' |,
                 length(upl._ac_group.u.z) > 200
                then call error_253 18
              if upl._ac_group.u.z = 'DELETED_AREA'
                then call error_253 24
              call read_prg_cfg_2 word(kwdatat, 2)
              upl._ac_level.u.z  = level
              upl._ac_acs.u.z    = acs
              upl._ac_keys.u.z   = keys
              upl._ac_paddr.u.z  = word(kwdata, 3)
              upl._ac_masks.u.z  = space(subword(kwdatat, 4))
              if upl._ac_masks.u.z = ''
                then upl._ac_masks.u.z = '*'

              v = upl._ac_group.u.z
              if \group_all.v
                then
                do
                  group_all.v = 1
                  group_avail.0 = group_avail.0 +1
                  call value 'group_avail.'group_avail.0, v
                end

            end
          otherwise
            call error_253 39
        end
      end


    /* ========== Downlink Daten ========== */

    when keyword = 'GROUP'
      then
      do
        group = word(kwdatat, 1)
        if group = '' | verify(group, char._ver'*') > 0 | length(group) > 200
          then call error_253 18
        if wordpos(group, 'N_A DELETED_AREA') > 0
          then call error_253 24
        acs = 0
        autolink = 0
        addr = ''
        do y = 2 to words(kwdatat)
          z = word(kwdatat, y)
          select
            when z = '-R'
              then acs = 1
            when z = '-A'
              then autolink = 1
            when addr <> ''
              then call error_253 25
            otherwise
              addr = z
          end
        end

        dnl._wgroup.d.0 = dnl._wgroup.d.0 +1
        z = dnl._wgroup.d.0
        dnl._wgroup.d.z          = group
        dnl._wgroup_acs.d.z      = acs
        dnl._wgroup_autolink.d.z = autolink

        if addr <> ''       /* Angabe zur Group-AKA */
          then
          do
            pattern = ' 'addr
            parse var dnl._addr.d (pattern) +0 addr .
            if addr = ''
              then call error_253 27
          end
        dnl._wgroup_addr.d.z = addr
      end
    when keyword = 'AKA'
      then
      do z = 1 to words(kwdatat)
        dnl._addr.d.0 = dnl._addr.d.0 +1
        y = dnl._addr.d.0
        dnl._addr.d.y = read_prg_cfg_3(word(kwdatat, z))
        dnl._addr.d   = dnl._addr.d || dnl._addr.d.y' '
        dnl._addr_idx = dnl._addr_idx || dnl._addr.d.y d' '
      end
    when keyword = 'LEVEL'
      then
      do
        call read_prg_cfg_2 kwdatat
        dnl._level.d = level
        dnl._keys.d  = keys
      end
    when keyword = 'MSG_LENGTH'
      then
      do
        if \datatype(kwdatat, 'w')
          then call error_253 7
        dnl._msg_length.d = kwdatat *1024 -2048
      end
    when keyword = 'FLAGS'
      then
      do
        if read_prg_cfg_6(kwdatat, dnl._flags.d) = ''
          then call error_253 20
        dnl._flags.d = flags
      end
    when keyword = 'LANGUAGE'
      then
      do
        p = wordpos(kwdatat, def._language._idx)
        if p = 0
          then call error_253 36
        dnl._language.d = substr(word(def._language._idx, p +1), 2)
      end

    when keyword = 'SCHEDULE'
      then
      do
        parse var kwdatat s1 s2 s3 s4 s5 .
        s1 = wordpos(s1, 'LIST AVAIL QUERY HELP INFO')
        if s1 = 0
          then call error_253 57
        s2 = date2xd(s2)
        if s2 < 0
          then call error_253 58
        if \datatype(s3, 'w') | s3 < 1
          then call error_253 58
        select
          when wordpos(s4, 'MONTH WEEK DAY') = 0
            then call error_253 58
          when s4 = 'MONTH'    /* Monatlich */
            then
            do
              if \datatype(s5, 'w') | s5 < 1 | s5 > 31
                then call error_253 58
              s3 = min(48, s3)
            end
          when s4 = 'DAY'      /* Tglich */
            then
            do
              s5 = ''
              s3 = min(1461, s3)
            end
          when s5 < 0 | s5 > 6 /* Wchentlich */
            then call error_253 58
          otherwise
            s3 = min(209, s3)
        end

        dnl._sched.d    = overlay(substr('LVQHI', s1, 1), dnl._sched.d, s1)
        dnl._sched.s1.d = s2   /* nchste Ausfhrung */
        dnl._sched._per.s1.d = s3 s4 s5

      end

    when keyword = 'NOTIFY_OFF'
      then dnl._notify.0.d = read_prg_cfg_7(dnl._notify.0.d)
    when keyword = 'NOTIFY_ON'
      then dnl._notify.1.d = read_prg_cfg_7(dnl._notify.1.d)
    otherwise
      call error_253 39
  end

end

return





read_prg_cfg_7:
arg z
do y = 1 to words(kwdatat)
  parse value word(kwdatat, y) with p +1 . ':' +1 flag +1 .
    /* New|Del|Ren|Warn:All|Linked|None */
  p = pos(p, 'NDRW')
  if p = 0 | pos(flag, 'ALN') = 0
    then call error_253 21
  z = overlay(flag, z, p)
end
return z



read_prg_cfg_6:                    /* Flags bearbeiten */
arg z, flags
z = translate(z, ' ', '+')
do y = 1 to words(z) until flags == ''
  p = wordpos(word(z, y), 'F W P R M O C K L A N')
  if p = 0
    then
    do
      p = wordpos(word(z, y), '-F -W -P -R -M -O -C -K -L -A -N')
      if p = 0
        then flags = ''
        else flags = bitand(flags, bitxor(d2c(2 ** (p -1), 4), 'ffffffff'x))
    end
    else flags = bitor(flags, d2c(2 ** (p -1), 4))
end

return flags


/* Angaben zu Hilfe und Info-File testen */
read_prg_cfg_5:
arg trail
z = words(kwdatat)
select
  when z = 2
    then
    do
      p = wordpos(word(kwdatat, 2), def._language._idx)
      if p = 0      /* Ungltige Angabe zur Sprache */
        then call error_253 36
      z = substr(word(def._language._idx, p +1), 2)
    end
  when z = 1        /* Keine Angabe zur Sprache */
    then z = 0
  otherwise
    call error_253 21
end
rsp_file.trail.z = word(kwdatat, 1)
if set_full_name('rsp_file.'trail'.'z, 'f') = ''
  then call error_253 14
if rsp_file.trail.0 = ''
  then rsp_file.trail.0 = rsp_file.trail.z
return




read_prg_cfg_3:                     /* Adresse testen */
parse arg zone':'net'/'node'.'point
select
  when \datatype(zone,  'w') | zone  < 0 |,
       \datatype(net,   'w') | net   < 0 |,
       \datatype(node,  'w') | node  < 0
    then call error_253 29
  when point = ''
    then point = 0
  when \datatype(point, 'w') | point < 0
    then call error_253 29
  otherwise
end
return zone':'net'/'node'.'point



read_prg_cfg_2:                     /* level/keys parsen und testen */
parse arg level'/'keys
select
  when verify(keys, char._anum) > 0
    then call error_253 30
  when level = ''
    then
    do
      level = 0
      acs = 0
    end
  when \datatype(level, 'w')
    then call error_253 31
  otherwise
    acs = level < 0
    level = abs(level)
end
return



read_prg_cfg_1:
parse arg y
ext = right(word(y, 1), 4)
select
  when y = ''
    then nop
  when ext = '.CMD'
    then y = 'call' y
  when ext <> '.EXE' & ext <> '.COM' & ext <> '.BAT'
    then y = 'cmd.exe /c' y
  otherwise
end
return y



error_253:
arg error_flag
call prg_error error_flag, prg_cfg, l, keyword, errstr
call directory dir._act
exit 253

/************************************************************************/

/* Squish.Cfg einlesen und auswerten */

read_squish_cfg: procedure expose (common_var)

        /* Lese' squish._cfg._file */
call wlogq replace_str(def._log_str.131, '[%f]', squish._cfg._file)

if stream(squish._cfg._file, 'c', 'query exists') = ''
  then call error_252 41
do y = 1 to 10 while stream(squish._cfg._file, 'c', 'open read') <> 'READY:'
  call syssleep 1
end
if y > 10
  then call error_252 42

  /* ========== Squish-Index einlesen ========== */
__sq. = ''
__sq = 0  /* Anzahl der Areas im Index */
if stream(squish._idx._file, 'c', 'open read') = 'READY:'
  then
  do
    sq_data = charin(squish._idx._file,, chars(squish._idx._file))
    call stream squish._idx._file, 'c', 'close'
    s_begin = 1
    parse var sq_data =(s_begin)data(crlf) +2 rest +1
    s_begin = s_begin +length(data) +2
    parse var data data1 . 'RAFX 'data2
    if data1 = length(sq_data) & data2 = version       /* Versions-Prfung */
      then
      do while rest \== ''
        __sq = __sq +1
        parse var sq_data =(s_begin)data(crlf)
        s_begin = s_begin +length(data) +2
        parse var data area'|'__sq._paddr.area

        parse var sq_data =(s_begin)__sq._sdata.area(crlf)
        s_begin = s_begin +length(__sq._sdata.area) +2

        parse var sq_data =(s_begin)__sq._line.area(crlf)
        s_begin = s_begin +length(__sq._line.area) +2

        parse var sq_data =(s_begin)__sq._rafx.area(crlf)
        s_begin = s_begin +length(__sq._rafx.area) +2

        parse var sq_data =(s_begin)data(crlf) +2 rest +1
        s_begin = s_begin +length(data) +2
        parse var data __sq._group.area'|'__sq._rdata.area
      end
      else squish._idx._changed = 1

    drop sq_data
  end


squish._cfg._mltag   = 0
squish._cfg._mlroot  = 0

ad        = 0         /* temp fr address.0 */
address.1 = '0:0/0.0' /* Dummy-Eintrag fr die erste Adresse */

echo_cnt  = 0         /* Echozhler, temp. fr AREA.0 */
echo_pre  = ''        /* Area-Tag zuletzt gelesene Echoarea */
echo_loc_area = ''    /* Area-Tag zuletzt gelesene Localarea */
echo_loc_line = 0     /* Zeile der zuletzt gelesenen Localarea */

l         = 0         /* Zeilenzhler, temp. fr squish._cfg.0 */
echo_idx. = ''        /* temporrer Area-Index zur Fehlerprfung */
tarea_idx = ''        /* temporrer Area-Index */

/* aktulles Datum und Zeit */
act_datetime = insert('/', insert('/', date('s'), 6), 4)'-'time('n')

parse value translate(charin(squish._cfg._file,, chars(squish._cfg._file)), ' ', '9'x) with sq_str '1a'x
call stream squish._cfg._file, 'c', 'close'

signal on syntax name error_252_sig1

zz = 0
s_begin = 1
do until rest == ''
  parse var sq_str =(s_begin)sqline(crlf) +2 rest +1
  s_begin = s_begin +length(sqline) +2

  if s_begin >= zz
    then
    do
      call charout, 'R:'format(s_begin %1024, 6)cr
      zz = zz + 4096
    end


  parse var sqline keyword kwdata1 kwdata2 kwdata3 ';'
    /* sqline     aktuelle Zeile         */
    /* keyword    Schlsselwort          */
    /* kwdata1    Daten 1. Wort          */
    /* kwdata2    Daten 2. Wort          */
    /* kwdata3    Daten Rest             */

  select
    when keyword <> ''
      then
      do
        keyword = translate(keyword)
        select
          when keyword = 'ECHOAREA'
            then
            do
              echo_act = translate(kwdata1)
              select
                when echo_pre = echo_act
                  then
                  do
                            /* Echo-Area, noch eine Zeile */
                    area.echo_cnt       = kwdata1
                    area._root.echo_cnt = kwdata2
                    echo_line = echo_line +1
                    echo_line.echo_line = strip(kwdata3)
                    area._sqdata.echo_cnt = area._sqdata.echo_cnt || echo_line.echo_line || '|'

                  end

                when datatype(area_idx.echo_act, 'w')
                  then call error_252 56    /* Schon alle Zeilen gelesen */

                otherwise                   /* Neue Echoarea */

                  if echo_pre <> '' /* vorherige Echoarea-Daten aufschlsseln */
                    then
                    do
                      call read_squish_cfg_10
                      call read_squish_cfg_11
                    end
                  echo_pre = echo_act
                  echo_cnt = echo_cnt +1

                  l = l +1
                  area._line.echo_cnt = l
                  /*
                  echo_idx.echo_act   = echo_cnt
                   */
                  area.echo_cnt       = kwdata1
                  area._root.echo_cnt = kwdata2
                  echo_line = 1
                  echo_line.1 = strip(kwdata3)
                  area._sqdata.echo_cnt = area._sqdata.echo_cnt || echo_line.1 || '|'
              end
            end

          otherwise

            if echo_pre <> '' /* vorherige Echoarea-Daten aufschlsseln */
              then
              do
                call read_squish_cfg_10
                call read_squish_cfg_11
                echo_pre = ''
              end
            l = l +1
            squish._cfg.l = sqline
            squish._keyword_idx = squish._keyword_idx l

            select
              when keyword = 'NETAREA'
                then
                do
                  net_area.0 = net_area.0 +1
                  y = net_area.0
                  net_area.y        = translate(kwdata1)
                  net_area._root.y  = translate(kwdata2)
                  net_area._idx     = net_area._idx || net_area.y' '
                  if pos('-$', kwdata3) > 0
                    then net_area._format.y = '$'
                  y = filespec('n', net_area._root.y)
                  area_root_idx.y = ''
                end

              when keyword = 'BADAREA'
                then
                do
                  bad_area._tag  = translate(kwdata1)
                  bad_area._root = translate(kwdata2)
                  if pos('-$', kwdata3) > 0
                    then bad_area._format = '$'
                  y = filespec('n', bad_area._root)
                  area_root_idx.y = ''
                end

              when keyword = 'LOCALAREA'
                then
                do
                  y = translate(filespec('n', kwdata2))
                  area_root_idx.y = ''

                  echo_loc_area = kwdata1
                  echo_loc_line = l  /* new */

                end
              when keyword = 'DUPEAREA'
                then
                do
                  y = translate(filespec('n', kwdata2))
                  area_root_idx.y = ''
                end

              when keyword = 'LOGFILE'
                then
                do
                  if squish._logfile = ''
                    then
                    do
                      squish._logfile = translate(kwdata1)
                      select
                        when \opt._autokill_days & \opt._autokill_list & \opt._nop
                          then nop
                        when set_full_name('squish._logfile') = ''
                          then call error_252 52
                        otherwise
                      end
                    end
                end
              when keyword = 'LOGLEVEL'
                then
                do
                  select
                    when \opt._autokill_days & \opt._nop
                      then nop
                    when kwdata1 < 5 | kwdata1 > 6
                      then call error_252 53
                    otherwise
                  end
                end
              when keyword = 'ADDRESS'
                then
                do
                  if echo_cnt > 0
                    then call error_252 40
                  parse var kwdata1 node'@'
                  parse var node zone':'net'/'node'.'point
                  if point = ''
                    then point = 0
                  if \datatype(zone, 'w') | \datatype(net, 'w') |,
                     \datatype(node, 'w') | \datatype(point, 'w')
                    then call error_252 43
                  ad = ad +1
                  y = zone':'net'/'node'.'point
                  address.ad = y
                  address._idx = address._idx || y' '
                end

              otherwise

            end
        end
      end
              /* Kommentar- oder Leerzeile */
    when echo_pre = ''
      then                    /* Keine Echoarea zuvor */
      do

        select
          when echo_loc_line <> l
            then
            do
              l = l +1
              squish._cfg.l = sqline
            end
          when space(translate(sqline)) <> '; *RAFX* DUMMY_AREA'
            then
            do
              l = l +1
              squish._cfg.l = sqline
            end
          otherwise

            squish._cfg.l = squish._cfg.l || crlf || '; *RAFX* DUMMY_AREA'
            dummy._area._idx = dummy._area._idx echo_loc_area '*'l
            echo_loc_line = 0
        end
      end

    when left(sqline, 9) <> '; *RAFX* '
      then                    /* Normale Kommentarzeile */
      do
        if echo_pre <> '' /* vorherige Echoarea-Daten aufschlsseln */
          then
          do
            call read_squish_cfg_10
            call read_squish_cfg_11
          end
        l = l +1
        squish._cfg.l = sqline
        echo_pre = ''
      end


    otherwise                 /* RAFX-Zeile zur Echoarea */
      status = 0
                        /* vorherige Echoarea-Daten aufschlsseln */
      call read_squish_cfg_10

      if sqline = __sq._rafx.echo_act & \status
        then
        do
          area._group.echo_cnt = __sq._group.echo_act
          if area._group.echo_cnt = 'DELETED_AREA'
            then
            do
              area._deadline.echo_cnt = __sq._rdata.echo_act
              call read_squish_cfg_12
            end
            else
            do
              parse var __sq._rdata.echo_act area._acs.echo_cnt'|'area._level.echo_cnt'|'area._keys.echo_cnt'|'area._upl_addr.echo_cnt'|'area._rflags.echo_cnt'|'area._node_p.echo_cnt
              parse var sqline '"'area._desc.echo_cnt'"'
              area._rafx.echo_cnt = sqline
              y = translate(filespec('n', area._root.echo_cnt))
              area_root_idx.y = ''

              if echo_cnt // 50 = 0
                then
                do
                  area._idx = area._idx || tarea_idx || echo_act' *'echo_cnt' '
                  tarea_idx = ''
                end
                else tarea_idx = tarea_idx || echo_act' *'echo_cnt' '
              area_idx.echo_act = echo_cnt

              y = area._group.echo_cnt
              if \group_all.y
                then
                do
                  group_all.y = 1
                  group_avail.0 = group_avail.0 +1
                  call value 'group_avail.'group_avail.0, y
                end

            end
        end
        else
        do
          squish._idx._changed = 1
          status = 0
          parse var sqline . . area._group.echo_cnt gdata
          area._group.echo_cnt = translate(area._group.echo_cnt)
          select
            when area._group.echo_cnt = '' |,
                 verify(area._group.echo_cnt, char._ver) > 0 |,
                 length(area._group.echo_cnt) > 200 |,
                 gdata = ''
              then call read_squish_cfg_3   /* ungltige RAFX-Zeile */

            when area._group.echo_cnt = 'DELETED_AREA'
              then
              do
                area._deadline.echo_cnt = strip(gdata)  /* gelschte Area */
                call read_squish_cfg_12
              end
            otherwise                         /* normale RAFX-Zeile */

              parse var gdata gdata '"'area._desc.echo_cnt'"' area._node_p.echo_cnt
              parse upper value space(gdata) with area._level.echo_cnt flags

              parse var area._level.echo_cnt area._level.echo_cnt'/'area._keys.echo_cnt
              if area._level.echo_cnt = ''
                then area._level.echo_cnt = 0

                /* RAFX-Flags auswerten */
              do y = 1 to words(flags)
                flag = word(flags, y)
                select
                  when left(flag, 1) <> '-'
                    then area._upl_addr.echo_cnt = flag
                  otherwise
                    area._rflags.echo_cnt = area._rflags.echo_cnt flag
                end
              end

              select
                when (read_squish_cfg_1() = 1 |,
                      \datatype(area._level.echo_cnt, 'w') |,
                      verify(area._keys.echo_cnt, char._anum) > 0 |,
                      words(gdata) > 3)
                  then call read_squish_cfg_3  /* ungltige RAFX-Zeile */
                when area._level.echo_cnt >= 0
                  then area._acs.echo_cnt = 0
                otherwise
                  area._level.echo_cnt = abs(area._level.echo_cnt)
                  area._acs.echo_cnt = 1
              end
              if \status
                then
                do
                  /* Passive Nodes bearbeiten */
                  flags = area._node_p.echo_cnt
                  area._node_p.echo_cnt = ' '
                  l_addr = area._paddr.echo_cnt
                  do w = 1 to words(flags)
                    flag = word(flags, w)
                    l_addr = read_squish_cfg_20(l_addr, flag)
                      /* Dupes bei Linked- und Passive-Nodes filtern */
                    if wordpos(l_addr, area._node_l.echo_cnt) = 0
                      then area._node_p.echo_cnt = area._node_p.echo_cnt || l_addr' '
                      else
                      do
                        area._sqdata.echo_cnt = ''
                        squish._cfg._changed = 1
                        status = 1
                      end
                  end
                  area._rafx.echo_cnt = sqline
                  y = translate(filespec('n', area._root.echo_cnt))
                  area_root_idx.y = ''

                  if echo_cnt // 50 = 0
                    then
                    do
                      area._idx = area._idx || tarea_idx || echo_act' *'echo_cnt' '
                      tarea_idx = ''
                    end
                    else tarea_idx = tarea_idx || echo_act' *'echo_cnt' '
                  area_idx.echo_act = echo_cnt

                  y = area._group.echo_cnt
                  if \group_all.y
                    then
                    do
                      group_all.y = 1
                      group_avail.0 = group_avail.0 +1
                      call value 'group_avail.'group_avail.0, y
                    end


                end
          end

        end

      echo_pre = ''

  end

end
if echo_pre <> '' /* vorherige Echoarea-Daten aufschlsseln */
  then
  do
    call read_squish_cfg_10
    call read_squish_cfg_11
  end

signal off syntax

address.0 = ad
squish._cfg.0 = l
area.0 = echo_cnt

errstr = ''
select
  when address.0 = 0
    then errstr = 'ADDRESS'
  otherwise
end
if errstr <> ''
  then call error_252 44

parse var address.1 def._zone':'.

if tarea_idx \== ''
  then area._idx = area._idx || tarea_idx

if \squish._idx._changed
  then squish._idx._changed = __sq > area.0

return




read_squish_cfg_12:

if area._deadline.echo_cnt > act_datetime
  then
  do
    area._rafx.echo_cnt = sqline
    del_area._idx = del_area._idx || translate(area.echo_cnt)' *'echo_cnt' '
    drop area._line.echo_cnt
    y = translate(filespec('n', area._root.echo_cnt))
    area_root_idx.y = ''
  end
  else
  do
                          /* Del-Area komplett entfernen */
    call del_area_files echo_cnt, 2
    drop area.echo_cnt           ,
         area._deadline.echo_cnt ,
         area._line.echo_cnt     ,
         area._group.echo_cnt    ,
         area._root.echo_cnt     ,
         area._format.echo_cnt   ,
         area._paddr.echo_cnt    ,
         area._node_u.echo_cnt   ,
         area._node_x.echo_cnt   ,
         area._node_l.echo_cnt   ,
         area._sflags.echo_cnt   ,
         area._rafx.echo_cnt     ,
         area._sqdata.echo_cnt
    squish._cfg._changed = 1
  end

return





read_squish_cfg_11:

call wlog replace_str(def._log_str.134, '[%a]', area.echo_cnt)
area._group.echo_cnt    = 'N_A'
area._level.echo_cnt    = '65536'
area._acs.echo_cnt      = 0
area._keys.echo_cnt     = ''
area._desc.echo_cnt     = def._area_desc
area._node_p.echo_cnt   = ' '
area._rflags.echo_cnt   = ''
area._upl_addr.echo_cnt = ''

if echo_cnt // 50 = 0
  then
  do
    area._idx = area._idx || tarea_idx || echo_pre' *'echo_cnt' '
    tarea_idx = ''
  end
  else tarea_idx = tarea_idx || echo_pre' *'echo_cnt' '
area_idx.echo_pre = echo_cnt

y = translate(filespec('n', area._root.echo_cnt))
area_root_idx.y = ''

squish._cfg._changed = 1
area._rafx.echo_cnt = '; *RAFX* N_A 65536/  "'def._area_desc'"'

return







read_squish_cfg_10:

squish._cfg._mlroot  = max(squish._cfg._mlroot, length(area._root.echo_cnt))
squish._cfg._mltag   = max(squish._cfg._mltag,  length(area.echo_cnt))

if __sq._paddr.echo_pre = ''
  then status = 1
  else status = area._sqdata.echo_cnt <> __sq._line.echo_pre

if \status
  then
  do
    area._paddr.echo_cnt  = __sq._paddr.echo_pre
    parse var __sq._sdata.echo_pre area._sflags.echo_cnt'|'area._format.echo_cnt'|'area._node_u.echo_cnt'|'area._node_x.echo_cnt'|'area._node_l.echo_cnt
  end

  else
  do
    squish._idx._changed = 1

    area._paddr.echo_cnt  = address.1  /* Aktuelle Primary-Aka */
    area._node_u.echo_cnt = ' '        /* Liste Nodes mit U-Flags */
    area._node_x.echo_cnt = ' '        /* Liste Read-Only-Nodes */
    area._node_l.echo_cnt = ' '        /* Liste Linked Nodes */

    do n = 1 to echo_line
      flags = translate(echo_line.n)
      l_addr = area._paddr.echo_cnt    /* letzte Adr eines gelinkten Nodes */

      /* Flags und gelinkte Nodes bearbeiten */
      do w = 1 to words(flags)
        flag = word(flags, w)
        flag1 = translate(flag, '-', '+HDMS0123456789./:')

        select
          when flag1 = ''
            then
            do
              parse var flag ta'.'pnt
              if pnt = ''
                then pnt = 0
              select
                when ta = ''
                  then
                  do
                    parse var l_addr l_addr'.'
                    l_addr = l_addr'.'pnt
                  end
                when pos(':', ta) > 0
                  then l_addr = ta'.'pnt
                when pos('/', ta) = 0
                  then
                  do
                    parse var l_addr l_addr'/'
                    l_addr = l_addr'/'ta'.'pnt
                  end
                otherwise
                  parse var l_addr l_addr':'
                  l_addr = l_addr':'ta'.'pnt
              end
              area._node_l.echo_cnt = area._node_l.echo_cnt || l_addr' '
            end
          when flag1 = '-X'
            then
            do
              parse value substr(flag, 3) with ta'.'pnt
              if pnt = ''
                then pnt = 0
              select
                when ta = ''
                  then
                  do
                    parse var area._paddr.echo_cnt res'.'
                    res = res'.'pnt
                  end
                when pos(':', ta) > 0
                  then res = ta'.'pnt
                when pos('/', ta) = 0
                  then
                  do
                    parse var area._paddr.echo_cnt res'/'
                    res = res'/'ta'.'pnt
                  end
                otherwise
                  parse var area._paddr.echo_cnt res':'
                  res = res':'ta'.'pnt
              end
              area._node_x.echo_cnt = area._node_x.echo_cnt || res' '
            end
          when flag1 = '-P'
            then
            do
              parse value substr(flag, 3) with ta'.'pnt
              if pnt = ''
                then pnt = 0
              select
                when ta = ''
                  then
                  do
                    parse var area._paddr.echo_cnt l_addr'.'
                    l_addr = l_addr'.'pnt
                  end
                when pos(':', ta) > 0
                  then l_addr = ta'.'pnt
                when pos('/', ta) = 0
                  then
                  do
                    parse var area._paddr.echo_cnt l_addr'/'
                    l_addr = l_addr'/'ta'.'pnt
                  end
                otherwise
                  parse var area._paddr.echo_cnt l_addr':'
                  l_addr = l_addr':'ta'.'pnt
              end
              area._paddr.echo_cnt = l_addr
            end
          when flag1 = '-U'
            then
            do
              parse value substr(flag, 3) with ta'.'pnt
              if pnt = ''
                then pnt = 0
              select
                when ta = ''
                  then
                  do
                    parse var area._paddr.echo_cnt res'.'
                    res = res'.'pnt
                  end
                when pos(':', ta) > 0
                  then res = ta'.'pnt
                when pos('/', ta) = 0
                  then
                  do
                    parse var area._paddr.echo_cnt res'/'
                    res = res'/'ta'.'pnt
                  end
                otherwise
                  parse var area._paddr.echo_cnt res':'
                  res = res':'ta'.'pnt
              end
              area._node_u.echo_cnt = area._node_u.echo_cnt || res' '
            end

          when flag1 = '-$'
            then
            do
              area._format.echo_cnt = '$'
              if wordpos(flag, area._sflags.echo_cnt) = 0
                then area._sflags.echo_cnt = area._sflags.echo_cnt flag
            end
          when flag = '-F'
            then
            do
              area._format.echo_cnt = ''
              area._sflags.echo_cnt = area._sflags.echo_cnt flag
            end
          when wordpos(flag, area._sflags.echo_cnt) = 0
            then area._sflags.echo_cnt = area._sflags.echo_cnt flag
          otherwise
        end

      end
      area._sflags.echo_cnt = strip(area._sflags.echo_cnt)

    end
  end

return




/* Fehler in RAFX-Zeile */
read_squish_cfg_3:

call wlog replace_str(def._log_str.133, '[%a]', area.echo_cnt)
call read_squish_cfg_11
l = l +1
squish._cfg.l = sqline
status = 1
return



/* Uplink-Addr testen */
read_squish_cfg_1:
res = 0
if area._upl_addr.n <> ''
  then
  do
    parse var area._upl_addr.n zone':'net'/'node'.'point
    select
      when \datatype(zone,  'w') | zone  < 0 |,
           \datatype(net,   'w') | net   < 0 |,
           \datatype(node,  'w') | node  < 0
        then res = 1
      when point = ''
        then area._upl_addr.n = zone':'net'/'node'.0'
      when \datatype(point, 'w') | point < 0
        then res = 1
      otherwise
    end
  end
return res



read_squish_cfg_20: procedure    /* Abkrzungen bearbeiten */
parse arg rz':'rn'/'rd'.'., ta
if pos(':',ta) > 0
  then parse var ta rz':'ta
if pos('/', ta) > 0
  then parse var ta rn'/'ta
parse var ta ta'.'pnt
if ta <> ''
  then rd = ta
if pnt = ''
  then pnt = 0
return rz':'rn'/'rd'.'pnt



error_252_sig1:
erc = rc
if erc <> 30
  then call rexx_error erc, sigl  /* Sollte eigentlich nie ausgefhrt werden */
call prg_error 55, squish._cfg._file, keyword, kwdata1, kwdata2
call directory dir._act
call close_logfile_sem
exit 252



error_252:
arg error_flag
call prg_error error_flag, squish._cfg._file, keyword, kwdata1, errstr
call directory dir._act
call close_logfile_sem
exit 252

/************************************************************************/

rexx_error:

arg err_rc, sig_line
say format(sig_line,6) '+++  ' sourceline(sig_line)
say 'REX'right(err_rc, 4, 0)': Error' err_rc 'running RAFX.CMD, line' sig_line':' errortext(err_rc)

exit    /* Abbruch, weil echter Programmfehler */

/************************************************************************/

add_new_area_stem: procedure expose (common_var)

arg group, a, flag
grp = wordpos(group, new_area._group)
if grp = 0
  then
  do
    new_area._group = new_area._group || group' '
    new_area.0 = new_area.0 +1
    grp = new_area.0
    new_area.grp.0 = 1
    new_area.grp.1 = a
    new_area._init.grp.1 = flag
  end
  else
  do
    new_area.grp.0 = new_area.grp.0 +1
    z = new_area.grp.0
    new_area.grp.z = a
    new_area._init.grp.z = flag
  end

return

/************************************************************************/

write_prg_cfg: procedure expose (common_var)

/* RAFX.CFG schreiben */

call directory dir._act

status = 0

write_prg_cfg_var = 'cfile'          ,
                    'cfile.'         ,
                    'cflag.'         ,
                    'cline.'         ,
                    'cfg_pwd'        ,
                    'cfg_sysop'      ,
                    'cfg_dnl'        ,
                    'cfg_dnl_beg.'   ,
                    'cfg_dnl_addr.'  ,
                    'cfg_dnl_lng.'   ,
                    'cfg_dnl_flags.' ,
                    'cfg_dnl_sched.'


cfile          = 0    /* File-Zhler */
cfile.         = ''   /* File-Namen */
cflag.         = 0    /* nderung bei einem CFG-File */
cline.         = ''   /* Zeilen */
cfg_pwd        = ''   /* Zeiger Zeile PASSWORD */
cfg_sysop      = ''   /* Zeiger Zeile SYSOP    */
cfg_dnl        = 0    /* Downlinkzhler */
cfg_dnl_beg.   = ''   /* Zeiger Zeilen DOWNLINK */
cfg_dnl_addr.  = ''   /* Haupt-AKA des Downlinks */
cfg_dnl_lng.   = ''   /* Zeiger Zeile LANGUAGE */
cfg_dnl_flags. = 0    /* Stem Zeiger Zeilen FLAGS */
cfg_dnl_sched. = ''   /* Zeiger Schedule-Lines */
                      /* Index 0 ist Zeiger auf zuletzt gelesene Zeile */
                      /* Index 1 - 5 Zeiger auf Schedule-Zeilen */


status = write_prg_cfg_rec(prg_cfg._file)
if status = 0
  then call write_prg_cfg_10
  else call wlog replace_str(def._log_str.136, '[%f]', prg_cfg._file,,
                                               '[%n]', status)
prg_cfg._changed = 0

return



write_prg_cfg_rec: procedure expose (common_var) (write_prg_cfg_var)

arg prg_cfg
call wlogq replace_str(def._log_str.131, '[%f]', prg_cfg)
status = 0

cfile = cfile +1
cfile.cfile = stream(prg_cfg, 'c', 'query exists')
cf = cfile

select
  when cfile.cf = ''
    then status = 5       /* CFG ist nicht vorhanden */
  when stream(cfile.cf, 'c', 'open read') <> 'READY:'
    then status = 2       /* Fehler beim ffnen */
  otherwise
    cfg_size = stream(cfile.cf, 'c', 'query size')
    parse value translate(charin(cfile.cf,, cfg_size), ' ', '9'x) with cfg_str '1a'x
    call stream cfile.cf, 'c', 'close'
    s_begin = 1
    l = 0
    do until rest == '' | status > 0
      l = l +1
      if l // 10 = 0
        then call charout, 'L:'format(l, 6)cr

      parse var cfg_str =(s_begin)cline.cf.l(crlf) +2 rest +1
      s_begin = s_begin +length(cline.cf.l) +2
      cline.cf.l = strip(cline.cf.l, 't')

      parse upper var cline.cf.l keyword kwdata1 . ';' .
      select
        when keyword = ''
          then iterate
        when keyword = 'INCLUDE'
          then
          do
            if kwdata1 = ''
              then status = 7       /* Kein Include-File angegeben */
            status = write_prg_cfg_rec(kwdata1)
          end
        when keyword = 'DOWNLINK'
          then
          do
            cfg_dnl = cfg_dnl +1
            cfg_dnl_beg.cfg_dnl = cf l
            parse var cline.cf.l . cfg_dnl_addr.cfg_dnl .
            parse var cfg_dnl_addr.cfg_dnl node'.'pnt
            if pnt = ''
              then cfg_dnl_addr.cfg_dnl = node'.0'
          end
        when keyword = 'LANGUAGE'
          then cfg_dnl_lng.cfg_dnl = cf l
        when keyword = 'PASSWORD'
          then cfg_pwd = cf l
        when keyword = 'SYSOP'
          then cfg_sysop = cf l
        when keyword = 'FLAGS'
          then
          do
            cfg_dnl_flags.cfg_dnl.0 = cfg_dnl_flags.cfg_dnl.0 +1
            y = cfg_dnl_flags.cfg_dnl.0
            cfg_dnl_flags.cfg_dnl.y = cf l
          end
        when keyword = 'SCHEDULE'
          then
          do
            p = wordpos(kwdata1, 'LIST AVAIL QUERY HELP INFO')
            if p > 0
              then
              do
                cfg_dnl_sched.cfg_dnl.p = cf l
                cfg_dnl_sched.cfg_dnl.0 = cf l
              end
          end
        otherwise
      end
    end
    cline.cf.0 = l
end

if status <> 0
  then call wlog replace_str(def._log_str.136, '[%f]', prg_cfg, '[%n]', status)

return status




write_prg_cfg_10:

/* Sysop-Daten ersetzten */

if wordpos('0', dnl._settings_idx) > 0
  then
  do
      /* Passwort */
    select
      when pos('P', dnl._settings.0) = 0
        then nop
      when cfg_pwd <> ''
        then call write_prg_cfg_2 dnl._pw.0, 2, cfg_pwd
      otherwise
    end

      /* Language */
    select
      when pos('L', dnl._settings.0) = 0
        then nop
      when cfg_dnl_lng.0 <> ''
        then call write_prg_cfg_2 value('def._language.'dnl._language.0), 2, cfg_dnl_lng.0
      otherwise
        parse var cfg_sysop cf l
        cline.cf.l = cline.cf.l || crlf ||,
                     'LANGUAGE' value('def._language.'dnl._language.0)
        cflag.cf = 1
    end
  end


  /* Downlink-Daten */

do c_dnl = 1 to cfg_dnl
  dnl = wordpos(cfg_dnl_addr.c_dnl, dnl._settings_idx)

  if dnl > 0
    then
    do
      dnl = word(dnl._settings_idx, dnl +1)

        /* Passwort */
      if pos('P', dnl._settings.dnl) > 0
        then call write_prg_cfg_2 dnl._pw.dnl, 3, cfg_dnl_beg.c_dnl

        /* Language */
      select
        when pos('L', dnl._settings.dnl) = 0
          then nop
        when cfg_dnl_lng.dnl <> ''
          then call write_prg_cfg_2 value('def._language.'dnl._language.dnl), 2, cfg_dnl_lng.c_dnl
        otherwise
          parse var cfg_dnl_beg.dnl cf l
          cline.cf.l = cline.cf.l || crlf ||,
                       'LANGUAGE' value('def._language.'dnl._language.dnl)
          cflag.cf = 1
      end

        /* Notify On/Off (Flag N) */
      select
        when pos('+N', dnl._settings.dnl) > 0
          then call write_prg_cfg_1 '+', 'N'
        when pos('-N', dnl._settings.dnl) > 0
          then call write_prg_cfg_1 '-', 'N'
        otherwise
      end

        /* Rules per File Attach On/Off (Flag A) */
      select
        when pos('+A', dnl._settings.dnl) > 0
          then call write_prg_cfg_1 '+', 'A'
        when pos('-A', dnl._settings.dnl) > 0
          then call write_prg_cfg_1 '-', 'A'
        otherwise
      end

      if pos('E', dnl._settings.dnl) > 0
        then
        do
          sched_add = ''
          do p = 1 to 5
            parse var cfg_dnl_sched.c_dnl.p cf l
            select
              when dnl._sched.p.dnl = 0   /* Schedule-Zeile lschen */
                then if l <> ''
                  then
                  do
                    drop cline.cf.l
                    cflag.cf = 1
                  end
              when datatype(dnl._sched.p.dnl, 'w')
                then nop                  /* Keine nderung erfolgt */
              otherwise
                str = 'SCHEDULE' left(sched._mask.p, 8) dnl._sched.p.dnl'  'dnl._sched._per.p.dnl
                select
                  when l <> ''
                    then
                    do
                      cline.cf.l = str
                      cflag.cf = 1
                    end
                  when sched_add = ''
                    then sched_add = str
                  otherwise
                    sched_add = sched_add || crlf || str
                end
            end
          end
          if sched_add <> ''
            then
            do
              parse var cfg_dnl_sched.c_dnl.0 cf l
              select
                when l = ''
                  then
                  do
                    parse var cfg_dnl_beg.c_dnl cf l
                    cline.cf.l = cline.cf.l || crlf || sched_add
                  end
                when symbol('cline.'cf'.'l) = 'VAR'
                  then cline.cf.l = cline.cf.l || crlf || sched_add
                otherwise
                  cline.cf.l = sched_add
              end
              cflag.cf = 1
            end
        end
    end
end


/* Neue Cfg-Daten schreiben */

do cf = 1 to cfile
  if cflag.cf = 1
    then
    do
      call wlogq replace_str(def._log_str.135, '[%f]', cfile.cf)

      parse value reverse(cfile.cf) with t1'\'t3
      parse var t1 t1'.'t2
      if t2 = ''
        then cfg_backup = reverse('KAB.'t1'\'t3)
        else cfg_backup = reverse('KAB.'t2'\'t3)
      cfg_temp = systempfilename(reverse(t3)'\RAFX????.TMP')

      select
        when cfg_temp = ''
          then status = 1
        otherwise

          call sysfiledelete cfg_temp
          do l = 1 to cline.cf.0
            if symbol('cline.'cf'.'l) = 'VAR'
              then call lineout cfg_temp, cline.cf.l
          end
          call stream cfg_temp, 'c', 'close'

          call sysfiledelete cfg_backup
          select
            when rename_file(cfile.cf, cfg_backup) <> 0
              then status = 3
            when rename_file(cfg_temp, cfile.cf) <> 0
              then status = 4
            otherwise
          end
      end

      if status <> 0
        then call wlog replace_str(def._log_str.136, '[%f]', cfile.cf, '[%n]', status)
    end
end

return




write_prg_cfg_2:
arg istr, wpos, lpos
parse var lpos cf l
parse var cline.cf.l str';'comment +0
p = wordindex(str, wpos)
if p > 0
  then cline.cf.l = insert(istr, delstr(str, p, wordlength(str, wpos)), p -1) || comment
cflag.cf = 1
return



write_prg_cfg_1:
arg flag_st, flag_n
if cfg_dnl_flags.c_dnl.0 > 0
  then
  do
    do y = 1 to cfg_dnl_flags.c_dnl.0
      parse var cfg_dnl_flags.c_dnl.y cf l
      parse upper value translate(cline.cf.l, '  ', '+-') with data ';' .
      p = wordpos(flag_n, data, 2)
      if p > 0
        then cline.cf.l = delword(cline.cf.l, p, 1)
      cflag.cf = 1
    end
    z = cfg_dnl_flags.c_dnl.0
    parse var cfg_dnl_flags.c_dnl.z cf l
    parse var cline.cf.l cline.cf.l ';'comment +0
    cline.cf.l = strip(cline.cf.l, 't') flag_st || flag_n comment
    cflag.cf = 1
  end
  else
  do
    parse var cfg_dnl_beg.c_dnl cf l
    cline.cf.l = cline.cf.l || crlf || 'FLAGS' flag_st || flag_n
    cflag.cf = 1
  end
return

/************************************************************************/

write_squish_idx: procedure expose (common_var)

call wlogq replace_str(def._log_str.135, '[%f]', squish._idx._file)
call sysfiledelete squish._idx._file
call charout squish._idx._file, copies(' ', 12)'RAFX 'version ||crlf

do ipart = 1 to words(area._idx) by 100
  part_idx = subword(area._idx, ipart, 100)
  do i = 1 to words(part_idx) by 2
    area = word(part_idx, i)
    n = area_idx.area

    call charout squish._idx._file, area'|'area._paddr.n ||crlf
    call charout squish._idx._file, area._sflags.n'|'area._format.n'|'area._node_u.n'|'area._node_x.n'|'area._node_l.n ||crlf

    call charout squish._idx._file, area._sqdata.n ||crlf
    call charout squish._idx._file, area._rafx.n ||crlf

    call charout squish._idx._file, area._group.n'|'area._acs.n'|'area._level.n'|'area._keys.n'|'area._upl_addr.n'|'area._rflags.n'|'area._node_p.n ||crlf
  end
end

do i = 2 to words(del_area._idx) by 2
  n = substr(word(del_area._idx, i), 2)

  call charout squish._idx._file, translate(area.n)'|'area._paddr.n ||crlf
  call charout squish._idx._file, area._sflags.n'|'area._format.n'|'area._node_u.n'|'area._node_x.n'|'area._node_l.n ||crlf

  call charout squish._idx._file, area._sqdata.n ||crlf
  call charout squish._idx._file, area._rafx.n ||crlf

  call charout squish._idx._file, area._group.n'|'area._deadline.n ||crlf
end

call stream squish._idx._file, 'c', 'close'
call stream squish._idx._file, 'c', 'open'
call charout squish._idx._file, stream(squish._idx._file, 'c', 'query size')
call stream squish._idx._file, 'c', 'close'

return

/************************************************************************/

write_squish_cfg: procedure expose (common_var)

/* Squish.Cfg schreiben */
call wlogq replace_str(def._log_str.135, '[%f]', squish._cfg._file)

status = 0
parse value reverse(squish._cfg._file) with t1'\'t3
parse var t1 t1'.'t2
if t2 = ''
  then sqb = reverse('KAB.'t1'\'t3)
  else sqb = reverse('KAB.'t2'\'t3)
temp_file = systempfilename(reverse(t3)'\SQSH????.TMP')

select
  when temp_file = ''
    then status = 1
  otherwise

    call sysfiledelete squish._idx._file
    call charout squish._idx._file, copies(' ', 12)'RAFX 'version ||crlf

    pnt_pattern = '.0'

    if opt._sort_area > 0
      then call write_squish_cfg_2 0
      else

      do ipart = 1 to words(area._idx) by 100
        part_idx = subword(area._idx, ipart, 100)
        do i = 1 to words(part_idx) by 2
          area = word(part_idx, i)
          n = area_idx.area
          if n // 10 = 0
            then call charout, 'A:'format(n, 6)cr
          call write_squish_cfg_1 area._line.n, 0
        end
      end

    do i = 2 to words(del_area._idx) by 2
      n = substr(word(del_area._idx, i), 2)
      if i // 20 = 0
        then call charout, 'A:'format(i, 6)cr

      squish._cfg.0 = squish._cfg.0 +1
      call write_squish_cfg_1 squish._cfg.0, 1
    end

    do y = 1 to squish._cfg.0
      if y // 20 = 0
        then call charout, 'L:'format(y, 6)cr
      if symbol('squish._cfg.'y) = 'VAR'
        then call lineout temp_file, squish._cfg.y
    end
    call stream temp_file, 'c', 'close'

    call sysfiledelete sqb
    select
      when rename_file(squish._cfg._file, sqb) <> 0
        then status = 3
      when rename_file(temp_file, squish._cfg._file) <> 0
        then status = 4
      otherwise
    end

    call stream squish._idx._file, 'c', 'close'
    call stream squish._idx._file, 'c', 'open'
    call charout squish._idx._file, stream(squish._idx._file, 'c', 'query size')
    call stream squish._idx._file, 'c', 'close'

end

call directory dir._act
if status <> 0
  then call wlog replace_str(def._log_str.136, '[%f]', squish._cfg._file,,
                                               '[%n]' status)
/* squish._cfg._changed = 0 */

return




write_squish_cfg_2:

echo_sort. = 0
echo_sort_group.     = 0
echo_sort_bound.     = 0

do ipart = 1 to words(area._idx) by 100
  part_idx = subword(area._idx, ipart, 100)
  do i = 1 to words(part_idx) by 2
    area = word(part_idx, i)
    n = area_idx.area

    if n // 10 = 0
      then call charout, 'S:'format(n, 6)cr

    g = area._group.n
    p = echo_sort_group._idx.g

    if p = 0
      then
      do
        echo_sort_group.0 = echo_sort_group.0 +1
        p = echo_sort_group.0
        echo_sort_group.p = g
        echo_sort_group._idx.g = p
      end
    echo_sort.p.0 = echo_sort.p.0 +1
    y = echo_sort.p.0
    echo_sort.p.y = translate(area.n)
  end
end



flag = 0
lf = 1
do y = 1 to def._group_sort.0 until flag
  select
    when def._group_sort.y = '*'
      then
      do
        do v = 1 to echo_sort_group.0
          if echo_sort_group.v <> ''
            then call write_squish_cfg_100
        end
        flag = 1
      end
    when pos('*', def._group_sort.y) = 0
      then
      do v = 1 to echo_sort_group.0
        select
          when echo_sort_group.v = ''
            then nop
          when echo_sort_group.v = def._group_sort.y
            then call write_squish_cfg_100
          otherwise
        end
      end
    otherwise
      do v = 1 to echo_sort_group.0
        if echo_sort_group.v <> ''
          then
          do
            string =  ' 'echo_sort_group.v' *'
            pattern = ' 'def._group_sort.y' '
            res = 1
            do until res = 0 | pattern == ''
              parse var pattern pt'*'pattern
              parse var string (pt)rest
              res = rest \== ''
            end
            if res
              then call write_squish_cfg_100
          end
      end
  end
  if echo_sort._grp.0 >= lf
    then
    do
      echo_sort_bound.0 = echo_sort_bound.0 +1
      z = echo_sort_bound.0
      echo_sort_bound._left.z  = lf
      echo_sort_bound._right.z = echo_sort._grp.0
      lf = echo_sort._grp.0 +1
    end
end


  /* Gruppen-Namen sortieren */
do z = 1 to echo_sort_bound.0
  if echo_sort_bound._left.z < echo_sort_bound._right.z
    then call r1sort echo_sort_bound._left.z, echo_sort_bound._right.z, '_GRP'
end

da_cnt = 0 /* Hilfszhler zur Festlegung Root von Dummy-Area */

  /* Areas innerhalb der Gruppen sortieren und Zeilenreihenfolge setzen */

do k = 1 to echo_sort._grp.0
  gname = echo_sort._grp.k
  p = echo_sort_group._idx.gname
  call write_squish_cfg_2_1
end


/* unbentigte Dummy-Areas entfernen */

do y = 2 to words(dummy._area._idx) by 2
  r = substr(word(dummy._area._idx, y), 2)
  da_root = word(squish._cfg.r, 3)
  if da_root <> ''
    then
    do
      v = length(da_root) +2
      call sysfiletree da_root'.*', 'data', 'fo'
      do w = 1 to data.0
        if pos('.', data.w, v) = 0
          then call sysfiledelete data.w
      end
    end
  drop squish._cfg.r
end

return



write_squish_cfg_100:
echo_sort._grp.0 = echo_sort._grp.0 +1
z = echo_sort._grp.0
echo_sort._grp.z = echo_sort_group.v
echo_sort_group.v = ''
return




write_squish_cfg_2_1:

call wlogq replace_str(def._log_str.152, '[%g]', gname)

call r1sort 1, echo_sort.p.0, p

squish._cfg.0 = squish._cfg.0 +1
rsv    = squish._cfg.0   /* Reservierte Zeile fr Dummy-Area */
non_pt = 0               /* Flag, zeigt Vorhandensein von lokal bestellten Areas an */

do i = 1 to echo_sort.p.0
  n = echo_sort.p.i
  n = area_idx.n
  if wordpos('-0', area._sflags.n) = 0
    then non_pt = 1
  squish._cfg.0 = squish._cfg.0 +1
  call write_squish_cfg_1 squish._cfg.0, 0
end
if non_pt & dummy._area_tag <> ''
  then call write_squish_cfg_10

return








write_squish_cfg_10:

da_tag = replace_str(dummy._area_tag, '[%g]', gname)
select
  when dummy._area_len = 0
    then nop
  when abs(dummy._area_len) < length(da_tag)
    then nop
  when dummy._area_len < 0
    then da_tag = right(da_tag, -dummy._area_len, dummy._area_fill)
  otherwise
    da_tag = left(da_tag, dummy._area_len, dummy._area_fill)
end


y = wordpos(da_tag, dummy._area._idx)
if y > 0
  then
  do
    r = substr(word(dummy._area._idx, y +1), 2)
    dummy._area._idx = delword(dummy._area._idx, y, 2)
    squish._cfg.rsv = squish._cfg.r
    drop squish._cfg.r
  end
  else
  do
    do da_cnt = da_cnt to 9999
      da_root = dummy._root || right(da_cnt, 4, 0)
      if area_root_idx.da_root = ''
        then iterate da_cnt
      call sysfiletree dummy._dir'\'da_root'.*', 'data', 'o'
      do z = 1 to data.0 until pos('.', filespec('n', data.z), 10) = 0
      end
      if z > data.0
        then leave
    end
    if y < 10000
      then squish._cfg.rsv = 'LOCALAREA' da_tag dummy._dir'\'da_root,
                             '-$' || crlf || '; *RAFX* DUMMY_AREA'
    da_cnt = da_cnt +1
  end

return






write_squish_cfg_1:

arg l

call charout squish._idx._file, translate(area.n)'|'area._paddr.n ||crlf
call charout squish._idx._file, area._sflags.n'|'area._format.n'|'area._node_u.n'|'area._node_x.n'|'area._node_l.n ||crlf

if area._sqdata.n <> '' & \opt._rebuild_sqcfg
  then                  /* Alte Zeilen verwenden, nur neu formatieren */
  do
    out.0 = 'ECHOAREA',
            left(area.n, squish._cfg._mltag),
            left(area._root.n, squish._cfg._mlroot)

    squish._cfg.l = ''
    s_begin = 1

    do y = 1 until rest == ''
      parse var area._sqdata.n =(s_begin) data '|' +1 rest +1
      s_begin = length(data) + s_begin +1
      squish._cfg.l = squish._cfg.l || out.0 data || crlf
    end
    squish._cfg.l = squish._cfg.l || area._rafx.n

    call charout squish._idx._file, area._sqdata.n ||crlf
    call charout squish._idx._file, area._rafx.n ||crlf

    if arg(2)
      then call charout squish._idx._file, area._group.n'|'area._deadline.n ||crlf
      else call charout squish._idx._file, area._group.n'|'area._acs.n'|'area._level.n'|'area._keys.n'|'area._upl_addr.n'|'area._rflags.n'|'area._node_p.n ||crlf
  end

  else                  /* Zeilen neu erstellen */
  do
    out. = ''
    out  = 1
    out._base1 = 'ECHOAREA',
                left(area.n, squish._cfg._mltag),
                left(area._root.n, squish._cfg._mlroot),
                area._sflags.n
    if address.1 <> area._paddr.n
      then
      do
        parse var area._paddr.n pa(pnt_pattern)
        out._base1 = out._base1 '-p'pa
        out._base2 = area._sflags.n '-p'pa
      end
      else out._base2 = area._sflags.n

    max_len = squish._cfg._line_len - length(out._base1)

    if \squish._cfg._full_addr
      then
      do
        do y = 1 to words(area._node_u.n)
          out.out = out.out '-u'test_addr(area._paddr.n, word(area._node_u.n, y))
          if length(out.out) > max_len
            then out = out +1
        end
        do y = 1 to words(area._node_x.n)
          out.out = out.out '-x'test_addr(area._paddr.n, word(area._node_x.n, y))
          if length(out.out) > max_len
            then out = out +1
        end
        l_addr = area._paddr.n
        do y = 1 to words(area._node_l.n)
          z = word(area._node_l.n, y)
          out.out = out.out test_addr(l_addr, z)
          if length(out.out) > max_len
            then
            do
              out = out +1
              l_addr = area._paddr.n
            end
            else l_addr = z
        end

        l_addr = area._paddr.n
        do y = 1 to words(area._node_p.n)
          z = word(area._node_p.n, y)
          out.0 = out.0 test_addr(l_addr, z)
          l_addr = z
        end
      end
      else
      do
        do y = 1 to words(area._node_u.n)
          out.1 = out.1 '-u'word(area._node_u.n, y)
        end
        do y = 1 to words(area._node_x.n)
          out.1 = out.1 '-x'word(area._node_x.n, y)
        end
        out.1 = out.1 space(area._node_l.n)
        out.0 = area._node_p.n
        do y = 0 to 1
          p = pos(pnt_pattern, out.y)
          do while p > 0
            out.y = delstr(out.y, p, 2)
            p = pos(pnt_pattern, out.y, p)
          end
        end
      end


    squish._cfg.l = out._base1 || out.1 || crlf
    sqil = out._base2 || out.1 ||'|'
    do y = 2 while out.y <> ''
      squish._cfg.l = squish._cfg.l || out._base1 || out.y || crlf
      sqil = sqil || out._base2 || out.y || '|'
    end

    call charout squish._idx._file, sqil ||crlf


    if arg(2)
      then
      do
        rafx_line = '; *RAFX* ' || area._group.n area._deadline.n

        call charout squish._idx._file, rafx_line ||crlf
        call charout squish._idx._file, area._group.n'|'area._deadline.n ||crlf

      end
      else
      do
        rafx_line = '; *RAFX* ' || area._group.n,
                    left('-', area._acs.n)area._level.n'/'area._keys.n,
                    area._upl_addr.n space(area._rflags.n),
                    '"'area._desc.n'"',
                    out.0

        call charout squish._idx._file, rafx_line ||crlf
        call charout squish._idx._file, area._group.n'|'area._acs.n'|'area._level.n'|'area._keys.n'|'area._upl_addr.n'|'area._rflags.n'|'area._node_p.n ||crlf

      end
    squish._cfg.l = squish._cfg.l || rafx_line
  end

return




test_addr: procedure

arg rz':'rn'/'rd'.'. , tz':'tn'/'td'.'tp
select
  when tz <> rz
    then res = tz':'tn'/'td
  when tn <> rn
    then res = tn'/'td
  when td <> rd
    then res = td
  otherwise
    res = ''
end
if tp <> 0
  then res = res'.'tp
if res = ''
  then res = td

return res


/************************************************************************/

r1sort: procedure expose echo_sort.

arg v, w, z
call r1sort_0 v, w

return



r1sort_1: procedure expose echo_sort. hp. z

arg lf, re

i = (re + lf) %2
p  = i +1

if re -lf < 19
  then
  do
    do y = lf to i -1
      m = y
      do j = y +1 to i
        if echo_sort.z.j < echo_sort.z.m
          then m = j
      end
      t = echo_sort.z.m
      echo_sort.z.m = echo_sort.z.y
      echo_sort.z.y = t
    end

    do y = p to re -1
      m = y
      do j = y +1 to re
        if echo_sort.z.j < echo_sort.z.m
          then m = j
      end
      hp.y = echo_sort.z.m
      echo_sort.z.m  = echo_sort.z.y
    end
    hp.re = echo_sort.z.re

  end
  else
  do
    call r1sort_0 lf, i
    call r1sort_1 p, re
  end

do r = lf to re while lf <= i
  select
    when p > re
      then
      do r = r to re
        hp.r = echo_sort.z.lf
        lf = lf +1
      end
    when echo_sort.z.lf < hp.p
      then
      do
        hp.r = echo_sort.z.lf
        lf = lf +1
      end
    otherwise
      hp.r = hp.p
      p = p +1
  end
end

return



r1sort_0: procedure expose echo_sort. hp. z

arg lf, re

i = (re + lf) %2
p  = i +1
if re -lf < 19
  then
  do
    do y = lf to i -1
      m = y
      do j = y +1 to i
        if echo_sort.z.j < echo_sort.z.m
          then m = j
      end
      hp.y = echo_sort.z.m
      echo_sort.z.m  = echo_sort.z.y
    end
    hp.i = echo_sort.z.i

    do y = p to re -1
      m = y
      do j = y +1 to re
        if echo_sort.z.j < echo_sort.z.m
          then m = j
      end
      t = echo_sort.z.m
      echo_sort.z.m = echo_sort.z.y
      echo_sort.z.y = t
    end

  end
  else
  do
    call r1sort_1 lf, i
    call r1sort_0 p, re
  end

do r = lf to re while lf <= i
  select
    when p > re
      then
      do r = r to re
        echo_sort.z.r = hp.lf
        lf = lf +1
      end
    when hp.lf < echo_sort.z.p
      then
      do
        echo_sort.z.r = hp.lf
        lf = lf +1
      end
    otherwise
      echo_sort.z.r = echo_sort.z.p
      p = p +1
  end
end

return



/************************************************************************/

check_arg: procedure expose (common_var) input

errstr         = ''
opt. = 0
prg_cfg = ''
do y = 1 to words(input) until errstr <> ''
  z = word(input, y)
  select
    when z = '-I'                 /* Lastread-Pointer initialisieren */
      then opt._init_ptr = 1
    when z = '-R'                 /* ReScan, Lastread-Pointer auf 0 setzen */
      then opt._rescan = 1
    when z = '-S'                 /* MSG-Base scannen */
      then opt._scan_msgs = 1
    when z = '-B'                 /* BadMail scannen */
      then opt._scan_bad = 1
    when z = '-D'                 /* Bad-Mail lschen, die nicht erlaubt ist */
      then opt._del_bad = 1
    when z = '-M'                 /* Index fr Rules erstellen */
      then opt._rule_idx = 1
    when z = '-U'                 /* *.DSC-File updaten */
      then opt._update_dsc = 1
    when z = '-E'                 /* Schedules ausfhren */
      then opt._sched = 1
    when z = '-F'                 /* Area-Descs ersetzen */
      then opt._set_area = 1
    when z = '-F:1'
      then opt._set_area = 1
    when z = '-F:2'
      then opt._set_area = 2
    when z = '-F:3'
      then opt._set_area = 3

    when z = '-A'                 /* Areas Sortieren */
      then opt._sort_area = 1
    when z = '-A:1'
      then opt._sort_area = 1
    when z = '-A:2'
      then opt._sort_area = 2

    when z = '-K:1'               /* Autokill nach Listen */
      then opt._autokill_list = 1
    when z = '-K:2'               /* Autokill nach Zeit */
      then opt._autokill_days = 1
    when z = '-K:3'               /* Autokill nach Listen und Zeit */
      then
      do
        opt._autokill_list = 1
        opt._autokill_days = 1
      end

    when z = '-X'                 /* Maximus Area Setup */
      then opt._maximus = 1
    when z = '-X:1'
      then opt._maximus = 1
    when z = '-X:2'
      then opt._maximus = 2

    when z = '-Y'                 /* zustzliche Arealisten */
      then opt._ext_area = 1
    when z = '-Y:1'
      then opt._ext_area = 1
    when z = '-Y:2'
      then opt._ext_area = 2

    when z = '-W'                 /* Squish-Cfg neu aufbauen */
      then opt._rebuild_sqcfg = 1

    when abbrev(z, '-C:')
      then prg_cfg = substr(z, 4)
    when z = '-N'                 /* nur CFGs testen */
      then opt._nop = 1
    otherwise
      call error_254
  end
end

if prg_cfg <> ''
  then prg_cfg._file = prg_cfg


return


error_254:
call prg_error 1, z
call directory dir._act
exit 254

/************************************************************************/

init_ptr: procedure expose (common_var)

arg flag
status = 0
do n = 1 to netmail_in.0
  a = wordpos(netmail_in.n, net_area._idx)
  call init_ptr_1 net_area.a, net_area._root.a, net_area._format.a
end
call init_ptr_1 bad_area._tag, bad_area._root, bad_area._format
  /* Anzahl der bearbeiteten LR-Pointer ausgeben */
call wlog replace_str(def._log_str.139, '[%n]', status)

return


init_ptr_1:
arg atag, aroot, aformat
call wlog replace_str(def._log_str.140, '[%a]', atag)
select
  when sq_area_valid(aroot, aformat) < 0
    then call wlog def._log_str.141  /* Area existiert noch nicht */
  when aformat = ''
    then call write_timestamp aroot, flag
  when flag = 0
    then call write_sql aroot, 0
  when sq_open_area(1, aroot, aformat) = -4
    then call wlog def._log_str.142   /* Zugriff verweigert */
  when sq._result <0
    then call log_rsqa_error 'sq_open_area' atag
  when sq._hdr_num_msg.1 = 0
    then call init_ptr_2
  when sq_num_2_uid(1, sq._hdr_num_msg.1) > 0
    then call init_ptr_2
  otherwise
    call log_rsqa_error 'sq_num_2_uid' atag
    call sq_close_area 1
end
status = status +1
return


init_ptr_2:
call write_sql aroot, sq._result
call sq_close_area 1
return

/************************************************************************/

write_timestamp: procedure expose (common_var)

arg root, t
if directory(root) <> ''
  then
  do
    call sysfiledelete timestamp._file
    select
      when t = 1
        then call lineout timestamp._file, insert('/', insert('/', date('s'), 6), 4)'-'time('n')
      when t = 0
        then call lineout timestamp._file, timestamp._base
      otherwise
        call lineout timestamp._file, t
    end
    call stream timestamp._file, 'c', 'close'
  end
call directory dir._act

return

/************************************************************************/

read_timestamp: procedure expose (common_var)

arg root

f = root'\'timestamp._file
if stream(f, 'c', 'query size') <> 21
  then tstamp = timestamp._base
  else
  do
    tstamp = linein(f)
    call stream f, 'c', 'close'
  end

return tstamp

/************************************************************************/

write_sql: procedure expose (common_var)

arg root, uid

sql = root'.SQL'
l   = stream(sql, 'c', 'query size')
uid = reverse(d2c(uid, 4))
p   = usernumber *4

select
  when l = ''
    then call charout sql, copies('0'x, p) || uid
  when l < p
    then
    do
      p = p -l
      call charout sql, copies('0'x, p) || uid
    end
  otherwise
    call charout sql, uid, p +1
end
call stream sql, 'c', 'close'

return

/************************************************************************/

read_sql: procedure expose (common_var)

arg root

sql = root'.SQL'
l   = stream(sql, 'c', 'query size')
if l < (usernumber +1) *4
  then uid = 0
  else
  do
    data = charin(sql, usernumber *4 +1, 4)
    if length(data) <> 4
      then uid = 0
      else uid = c2d(reverse(data))
    call stream sql, 'c', 'close'
  end

return uid

/************************************************************************/

/* Ausgabe-Netarea unter Nummer 2 ffnen */

open_area_nm_out: procedure expose (common_var)

arg netmail_out
if wordpos(2, sq._open_areas) > 0  /* Ausgangs-Netarea schon offen */
  then status = 0
      /* Ausgangs-Netarea unter Nummer 2 ffnen */
  else status = open_area(2, net_area._root.netmail_out, net_area._format.netmail_out, 'n')

return status

/************************************************************************/

open_area: procedure expose (common_var)

arg n, root, type, flag
call sq_open_area n, root, type, flag
do y = timeout_open_area to 1 by -1 while sq._result = -4
  call charout, 'W:'format(y, 6)cr
  call syssleep 1
  call sq_open_area n, root, type, flag
end
select
  when sq._result = 0
    then nop
  when sq._result = -4
    then call wlog def._log_str.142   /* Zugriff verweigert */
  otherwise
    call log_rsqa_error 'open_area sq_open_area'
end

return sq._result

/************************************************************************/

log_rsqa_error:
call wlog '# RSQA-Error:' sq._result
if arg() > 0
  then call wlog '#' arg(1)
return

/************************************************************************/

scan_badmail: procedure expose (common_var)

narea_idx. = 0

/* Badmail scannen */
call wlogq replace_str(def._log_str.144, '[%a]', bad_area._tag)

select
  when sq_area_valid(bad_area._root, bad_area._format) < 0
    then nop  /* Area existiert noch nicht */
  when open_area(1, bad_area._root, bad_area._format) < 0
    then nop
  when bad_area._format <> '$'
    then                      /* *.MSG-Area */
    do
      if sq._sdm_idx.1.0 = 0           /* Area ist leer */
        then call write_timestamp bad_area._root, 1
        else call scan_badmail_sdm
      call sq_close_area 1
    end
                              /* Squish-Area */
  otherwise
    if sq._hdr_num_msg.1 = 0           /* Area ist leer */
      then call write_sql bad_area._root, 0
      else call scan_badmail_sq
    call sq_close_area 1
end

return



/* Squish-Area */
scan_badmail_sq:

if opt._rescan = 1
  then uid_lr = 0
  else uid_lr = read_sql(bad_area._root)
msg_next = sq_uid_2_num(1, uid_lr +1, '+')
if msg_next > 0
  then
  do
    k = 0
    do lfd = msg_next to sq._hdr_high_msg.1
      if sq_open_msg(1, 1, lfd, 2) < 1
        then leave
      call charout, 'S:'format(lfd, 6)cr
      call scan_badmail_1
      call sq_close_msg 1
    end
    call scan_badmail_kill
  end
if sq_num_2_uid(1, sq._hdr_high_msg.1) >= 0
  then call write_sql bad_area._root, sq._result

return


/* *.MSG-Area */
scan_badmail_sdm:
                      /* Area wurde geffnet.*/
if opt._rescan = 1
  then ts_ref = timestamp._base
  else ts_ref = read_timestamp(bad_area._root)

k = 0
do while sq_open_msg(1, 1, '+', 2) > 0
  lfd = sq._result
  call charout, 'S:'format(lfd, 6)cr

  if msg._date_arrived.1 < timestamp._base
    then ts_test = msg._date_written.1
    else ts_test = msg._date_arrived.1

  if ts_test > ts_ref
    then call scan_badmail_1
  call sq_close_msg 1

end
call scan_badmail_kill
call write_timestamp bad_area._root, 1

return



scan_badmail_1:

parse upper var msg._ctrl.1 'AREA:'area1''.
area = strip(area1)

select
  when area = ''
    then nop            /* Kein Area-Tag gefunden */
  when verify(area, char._ctrl || char._high' "*|\?><;,', 'm') > 0
    then nop            /* Area-Tag ungltig */
  when length(area) > 200
    then nop            /* Area-Tag zu lang */
  otherwise
               /* Bad-MSG ist eine Echomail */

    upl = wordpos(msg._from_addr.1, upl._addr_idx)
    select
      when upl = 0
        then call scan_badmail_1_1 /* Unbekannter Uplink */
      when wordpos(msg._dest_addr.1, address._idx) = 0
        then call scan_badmail_1_1 /* Falscher Empfnger */
      when upl._ac_group.upl.0 = 0
        then call scan_badmail_1_1 /* Uplink hat keine Erlaubnis fr Autocreate */
      when wordpos(area, del_area._idx) > 0
        then call scan_badmail_1_1 /* Area gehrt zur Gruppe DELETED_AREA */
      when datatype(area_idx.area, 'w')
        then res._badmail = res._badmail +1 /* Area ist schon eingerichtet */

      when scan_badmail_1_2() > upl._ac_group.upl.0
        then call scan_badmail_1_1 /* Area matcht nicht */

      otherwise

        do j = 1 to upl._area.upl.0 until query_area_file(area, upl, j) > 0
        end
        area.0 = area.0 +1
        a = area.0
        area.a       = area
        area._idx    = area._idx || area '*'a' '
        area_idx.area = a

        if opt._sort_area = 0
          then
          do
            squish._cfg.0 = squish._cfg.0 +1 /* Squish-Cfg neue Zeile */
            area._line.a = squish._cfg.0
          end

        if j <= upl._area.upl.0
          then
          do
              /* Einstellungen entsprechend Arealiste */
            area._group.a = upl._area_group.upl.j
            area._level.a = upl._area_level.upl.j
            area._acs.a   = upl._area_acs.upl.j
            area._keys.a  = upl._area_keys.upl.j
            area._paddr.a = upl._area_paddr.upl.j
            area._desc.a  = found.2.1
          end
          else
          do
              /* Einstellungen entsprechend AUTOCREATE */
            area._group.a = upl._ac_group.upl.acdef
            area._level.a = upl._ac_level.upl.acdef
            area._acs.a   = upl._ac_acs.upl.acdef
            area._keys.a  = upl._ac_keys.upl.acdef
            area._paddr.a = upl._ac_paddr.upl.acdef
            area._desc.a  = def._area_desc
          end

        area._node_u.a      = ' '
        area._node_x.a      = ' '
        area._node_p.a      = ' '
        area._node_l.a      = ' 'upl._addr.upl' '
        area._upl_addr.a    = upl._addr.upl
        area._rflags.a      = ''
        call set_area_sflags a, area._group.a
        area._root.a        = search_root_name(area.a, area._format.a, 1, area._group.a)
        squish._cfg._mlroot = max(squish._cfg._mlroot, length(area._root.a))
        squish._cfg._mltag  = max(squish._cfg._mltag,  length(area.a))
        area._sqdata.a      = ''
        area._rafx.a        = ''
        squish._cfg._changed = 1

        call add_new_area_stem area._group.a, a, -1

        if rules._copy_2_dsc > 0
          then call copy_rules_2_dsc a

        call wlog replace_str(def._log_str.145, '[%a]', area.a)
        call wlog replace_str(def._log_str.146, '[%g]', area._group.a,,
                                                '[%u]', area._upl_addr.a)
        res._badmail = res._badmail +1
    end

end

return



scan_badmail_1_2:
do acdef = 1 to upl._ac_group.upl.0
  do m = 1 to words(upl._ac_masks.upl.acdef)
    if match(word(upl._ac_masks.upl.acdef, m), area)
      then leave acdef
  end
end
return acdef




scan_badmail_1_1:
if opt._del_bad
  then
  do
    k = k +1
    kmsg.k = lfd
  end
return



scan_badmail_kill:
do y = k to 1 by -1
  call charout, 'K:'format(kmsg.y, 6)cr
  call sq_kill_msg 1, kmsg.y
end
return

/************************************************************************/

proc_msg_cmds: procedure expose (common_var)

do m = 1 to mcmd.0    /* alle Kommandoblcke durchgehen */

  call wlog replace_str(def._log_str.147, '[%a]', value('dnl._addr.'mcmd._dnl.m'.1'))
  if mcmd._dnl.m <> mcmd._dest_dnl.m
    then call wlog replace_str(def._log_str.148, '[%a]', value('dnl._addr.'mcmd._dest_dnl.m'.1'))

  if pos('X', mcmd._cmd.m) > 0        /* Passwort-Fehler */
    then call confirm_pw_err m
  if pos('F', mcmd._cmd.m) > 0        /* Kommando-Fehler */
    then call confirm_cmd_err m
  if pos('N', mcmd._cmd.m) > 0        /* Neue Einstellungen */
    then call proc_new_settings m

  if pos('A', mcmd._cmd.m) > 0        /* Area-Requests */
    then call proc_request m
  if pos('P', mcmd._cmd.m) > 0        /* Areas aktiv/passive schalten */
    then call proc_tempreq m
  if pos('U', mcmd._cmd.m) > 0        /* Rules angefordert */
    then call send_rules m

  if pos('C', mcmd._cmd.m) > 0        /* Areas umbenennen */
    then call proc_area_rename m
  if pos('M', mcmd._cmd.m) > 0        /* Areas erstellen */
    then call proc_area_create m
  if pos('D', mcmd._cmd.m) > 0        /* Areas lschen */
    then call proc_area_delete m

  if pos('Q', mcmd._cmd.m) > 0        /* Liste der geschalteten Areas */
    then call send_query_list m
  if pos('L', mcmd._cmd.m) > 0        /* Liste lokal verfgbarer Areas */
    then call send_area_list m
  if pos('V', mcmd._cmd.m) > 0        /* Liste aller verfgbarer Areas */
    then call send_avail_list m
  if pos('H', mcmd._cmd.m) > 0        /* Hilfe angefordert */
    then call send_rsp_help m
  if pos('I', mcmd._cmd.m) > 0        /* Info angefordert */
    then call send_rsp_info m
end

return

/************************************************************************/

scan_msg_base: procedure expose (common_var)

netmail_out = netmail_out._ptr
        /* Ausgangs-Netarea unter Nummer 2 ffnen */
if open_area_nm_out(netmail_out) = 0
  then
  do
    if net_area._format.netmail_out <> '$'
      then netmail_out._high = sq._sdm_idx.2.0
      else netmail_out._high = sq._hdr_high_msg.2

    do n = 1 to netmail_in.0
      a = wordpos(netmail_in.n, net_area._idx)
      call wlogq replace_str(def._log_str.149, '[%a]', net_area.a)
      select
        when netmail_out = a     /* Eingangsarea = Ausgangsarea */
          then
          do
            if net_area._format.a <> '$'
              then call scan_msg_base_sdm 2, netmail_out._high
              else call scan_msg_base_sq 2, netmail_out._high
          end
        when sq_area_valid(net_area._root.a, net_area._format.a) < 0
          then nop        /* Area existiert noch nicht */
        when open_area(1, net_area._root.a, net_area._format.a) < 0
          then nop        /* Fehler beim ffnen */
        otherwise
          if net_area._format.a <> '$'
            then call scan_msg_base_sdm 1, sq._sdm_idx.1.0
            else call scan_msg_base_sq 1, sq._hdr_num_msg.1
          call sq_close_area 1
      end
    end
  end

return



/* Squish-Area */
scan_msg_base_sq:

arg hopen, msg_high

if msg_high > 0
  then
  do
    if opt._rescan = 1
      then uid_lr = 0
      else uid_lr = read_sql(net_area._root.a)
    msg_next = sq_uid_2_num(hopen, uid_lr +1, '+')
    if msg_high >= msg_next
      then
      do
        k = 0
        do lfd = msg_next to msg_high while sq_open_msg(hopen, 1, lfd, 2) > 0
          if lfd // 10 = 0
            then call charout, 'S:'format(lfd, 6)cr
          call scan_msg_base_1
        end
        call scan_msg_base_2
      end
    if sq_num_2_uid(hopen, sq._hdr_high_msg.hopen) >= 0
      then call write_sql net_area._root.a, sq._result
  end
  else call write_sql net_area._root.a, 0
return



/* *.MSG-Area */
scan_msg_base_sdm:

arg hopen, msg_high
if msg_high > 0
  then
  do
    k = 0
    if opt._rescan = 1
      then
      do lfd = 1 to msg_high while sq_open_msg(hopen, 1, lfd, 2) > 0
        if lfd // 10 = 0
          then call charout, 'S:'format(lfd, 6)cr
        call scan_msg_base_1
      end
      else
      do
        ts_ref = read_timestamp(net_area._root.a)
        do lfd = 1 to msg_high while sq_open_msg(hopen, 1, lfd, 2) > 0
          if lfd // 10 = 0
            then call charout, 'S:'format(lfd, 6)cr
          select
            when msg._date_arrived.1 < timestamp._base
              then
              do
                if msg._date_written.1 > ts_ref
                  then call scan_msg_base_1
                  else call sq_close_msg hopen
              end
            when msg._date_arrived.1 > ts_ref
              then call scan_msg_base_1
            otherwise
              call sq_close_msg hopen
          end
        end
      end
    call scan_msg_base_2
  end
call write_timestamp net_area._root.a, 1
return



scan_msg_base_2:
do y = k to 1 by -1
  call charout, 'K:'format(kmsg.y, 6)cr
  call sq_kill_msg hopen, kmsg.y
end
return



scan_msg_base_1:

select
  when ignore_msg_attr
    then res = proc_msg(hopen)     /* MSG einlesen */
  when bitand(msg._attr.1, '0000000c'x) = '00000000'x  /* \SNT & \RCV */
    then res = proc_msg(hopen)     /* MSG einlesen */
  otherwise
    res = 0
end
call sq_close_msg hopen
select
  when res = 0     /* keine Request-MSG */
    then nop
  when res = 1
    then call proc_msg_cmds
  otherwise
    call proc_msg_cmds
    k = k +1
    kmsg.k = lfd
end
return


/************************************************************************/

/* Eingegangene Mail auswerten */

proc_msg: procedure expose (common_var)

arg hopen
res = 0
select
  when proc_msg_11() < 0 /* weder Sysop, noch Downlink */
    then nop
              /* Empfnger-Name */
  when words(msg._dest_name.1) <> 1
    then nop
  when wordpos(translate(msg._dest_name.1), alias._idx) = 0
    then nop
              /* Empfnger-Adr. */
  when wordpos(msg._dest_addr.1, address._idx) = 0
    then nop

  otherwise          /* Mail von Downlink oder Sysop */
    call proc_msg_1
      /* Flag zum Lschen setzen */
    if bitand(dnl._flags.dnl, '00000040'x) <> '00000000'x
      then res = 2      /* MSG wird gelscht */
      else
      do
        res = 1
        msg._attr.1 = bitor(msg._attr.1, '00000004'x)   /* RCV setzen */
        call sq_update_msg_hdr hopen, 1
      end
end

return res  /*  0 = kein Request
                1 = Request-Mail ausgewertet, nicht lschen
                2 = Request-Mail ausgewertet und lschen    */



proc_msg_1:

mcmd. = 0
mcmd  = 1     /* temporr fr mcmd.0 */
mcmd._dnl.1       = dnl
mcmd._dest_dnl.1  = dnl

if bitand(dnl._flags.dnl, '00000010'x) = '00000000'x
  then mcmd._dest_addr.1 = msg._from_addr.1
  else mcmd._dest_addr.1 = dnl._addr.dnl.1
if bitand(dnl._flags.dnl, '00000020'x) = '00000000'x
  then mcmd._from_addr.1 = msg._dest_addr.1
  else mcmd._from_addr.1 = address.1
mcmd._acs.1       = (dnl = 0)
mcmd._cmd.1       = ''

rescan_flag       = 0 /* Rescan-Schalter, 0 = kein Rescan bei Request  */

  /* MSGID ermitteln fr REPLY-Kludge */
parse var msg._ctrl.1 'MSGID:' mcmd._msgid.1 '' .
mcmd._msgid.1 = strip(mcmd._msgid.1)


select
               /* MSG lesen */
  when sq_read_msg(hopen) < 0
    then call log_rsqa_error 'proc_msg_1 sq_read_msg'
               /* Passwort prfen */
  when proc_msg_13() > 0
               /* Passwort-Fehler */
    then mcmd._cmd.1 = overlay('X', mcmd._cmd.1, 16)
  when sq._result = 0
    then nop        /* MSG ist leer */
  otherwise
    d = dnl         /* Zeiger auf Downlink, fr den der Befehl gilt,
                       <0 = ungltig */

               /* Linefeeds 0Ah im MSG-Text umsetzen nach 0Dh */
    msg._text.1 = translate(msg._text.1, 'd'x, 'a'x)
               /* MSG-Text zeilenweise bearbeiten */
    s_begin = 1
    do until rest == ''
      parse var msg._text.1 =(s_begin)data(cr)rest +1
      s_begin = s_begin +length(data) +1
      data = space(data)
      if data = ''        /* Leerzeilen ignorieren */
        then iterate
                          /* Zeile aufschlsseln */
      parse upper var data data1 data2 data3 =1 data1l +1 data1r .
            /* data1      1. Wort                  */
            /* data1l     1. Zeichen 1. Wort       */
            /* data1r     restl. Zeichen 1. Wort   */
            /* data2      2. Wort                  */
            /* data3      restl. Wrter            */

                          /* Abruch bei Text-Ende */
      if wordpos(data1, '--- VIA EOT') > 0
        then leave
      if translate(left(data, 9)) = '* ORIGIN'
        then leave

      select

        when data1 = '%FROM' & dnl = 0
          then call proc_msg_4
        when d < 0  /* ungltiger Downlink */
          then call proc_msg_2

                          /* Standard-Kommandos */
        when proc_msg_10() > 0
          then
          do
            if d = 0 & p > 4   /* %INFO fr Sysop nicht mglich */
              then call proc_msg_2
              else mcmd._cmd.mcmd = overlay(substr('LVQHI', p, 1), mcmd._cmd.mcmd, p)
          end

                          /* neues Passwort */
        when data1 = '%PWD'
          then
          do
            select
              when data2 = '' | data3 <> ''
                then  call proc_msg_2
              otherwise
                mcmd._pw_new.mcmd = data2
                mcmd._cmd.mcmd = overlay('N', mcmd._cmd.mcmd, 6)
                mcmd._settings.mcmd = overlay('P', mcmd._settings.mcmd, 1)
            end
          end

        when data1 = '%PAUSE'
          then call proc_msg_3 '-'
        when data1 = '%RESUME'
          then call proc_msg_3 '+'

          /* Schedules ndern */
        when data1 = '%SCHEDULE'
          then
          do
            sched = wordpos(data2, 'LIST AVAIL QUERY HELP INFO')
            parse var data3 s1 s2 s3 .
            select
              when d = 0                /* fr Sysop nicht mglich */
                then call proc_msg_2
              when sched = 0            /* Ungltig */
                then call proc_msg_2
              when s1 = 'OFF'
                then mcmd._sched.mcmd.sched = -1

              when \datatype(s1, 'w') | s1 < 1
                then call proc_msg_2
              when s2 = 'MONTH'
                then
                do
                  select
                    when s3 = ''
                      then mcmd._sched.mcmd.sched = min(48, s1) s2
                    when \datatype(s3, 'w') | s3 > 31 | s3 < 1
                      then call proc_msg_2
                    otherwise
                      mcmd._sched.mcmd.sched = min(48, s1) s2 s3
                  end
                end
              when s2 = 'WEEK'
                then
                do
                  select
                    when s3 = ''
                      then mcmd._sched.mcmd.sched = min(209, s1) s2
                    when \datatype(s3, 'w') | s3 > 6 | s3 < 0
                      then call proc_msg_2
                    otherwise
                      mcmd._sched.mcmd.sched = min(209, s1) s2 s3
                  end
                end
              when s2 = 'DAY'
                then mcmd._sched.mcmd.sched = min(1461, s1) s2
              otherwise
                call proc_msg_2
            end
            if mcmd._sched.mcmd.sched <> 0
              then
              do
                mcmd._cmd.mcmd = overlay('N', mcmd._cmd.mcmd, 6)
                mcmd._settings.mcmd = overlay('E', mcmd._settings.mcmd, 7)
              end
          end

          /* Neue Sprache */
        when data1 = '%LANGUAGE'
          then
          do
            select
              when data2 = '' | data3 <> ''
                then call proc_msg_2  /* Angabe fehlerhaft */
              otherwise
                mcmd._language.mcmd = data2
                mcmd._cmd.mcmd = overlay('N', mcmd._cmd.mcmd, 6)
                mcmd._settings.mcmd = overlay('L', mcmd._settings.mcmd, 2)
            end
          end

          /* Notify On/Off */
        when data1 = '%NOTIFY'
          then
          do
            select
              when data2 = '' | data3 <> ''
                then call proc_msg_2  /* Angabe fehlerhaft */
              when data2 = 'ON'
                then
                do
                  mcmd._cmd.mcmd = overlay('N', mcmd._cmd.mcmd, 6)
                  mcmd._settings.mcmd = overlay('+N', mcmd._settings.mcmd, 5)
                end
              when data2 <> 'OFF'
                then call proc_msg_2  /* Angabe fehlerhaft */
              otherwise
                mcmd._cmd.mcmd = overlay('N', mcmd._cmd.mcmd, 6)
                mcmd._settings.mcmd = overlay('-N', mcmd._settings.mcmd, 5)
            end
          end

        when data1 = '%RULES'
          then
          do
            select
              when d = 0 | data2 = '' | data3 <> ''
                then call proc_msg_2  /* Angabe fehlerhaft oder Sysop */
              when data2 = '@NETMAIL'
                then
                do
                  mcmd._cmd.mcmd = overlay('N', mcmd._cmd.mcmd, 6)
                  mcmd._settings.mcmd = overlay('-A', mcmd._settings.mcmd, 3)
                end
              when data2 = '@FILEATTACH'
                then
                do
                  mcmd._cmd.mcmd = overlay('N', mcmd._cmd.mcmd, 6)
                  mcmd._settings.mcmd = overlay('+A', mcmd._settings.mcmd, 3)
                end
              when length(data2) > 200 | pos('**', data2) > 0
                then call proc_msg_2  /* Angabe fehlerhaft */
              otherwise
                mcmd._rules.mcmd.0 = mcmd._rules.mcmd.0 +1
                z = mcmd._rules.mcmd.0
                mcmd._rules.mcmd.z = data2
                mcmd._cmd.mcmd = overlay('U', mcmd._cmd.mcmd, 7)
            end
          end

        when data1 = '%DAYS'
          then
          do
            select
              when d = 0 | data3 <> '' | \datatype(data2, 'w') | data2 <= 0
                then call proc_msg_2  /* Angabe fehlerhaft oder Sysop */
              when ext_cmd._rescan = ''
                then call proc_msg_2  /* Kein Rescan-Programm angegeben */
              otherwise
                rescan_flag = -data2
            end
          end
        when data1 = '%MSGS'
          then
          do
            select
              when d = 0 | data3 <> '' | \datatype(data2, 'w') | data2 <= 0
                then call proc_msg_2  /* Angabe fehlerhaft oder Sysop */
              when ext_cmd._rescan = ''
                then call proc_msg_2  /* Kein Rescan-Programm angegeben */
              otherwise
                rescan_flag = data2
            end
          end


        when data1 = '%RESCAN'
          then
          do
            select
              when d = 0 | data3 <> '' | pos('**', data2) > 0
                then call proc_msg_2  /* Angabe fehlerhaft oder Sysop */
              when ext_cmd._rescan = ''
                then call proc_msg_2  /* Kein Rescan-Programm angegeben */

              when data2 = ''         /* Rescan-Schalter ndern */
                then
                do
                  if rescan_flag <> 0
                    then rescan_flag = 0      /* Rescan abschalten */
                    else rescan_flag = 'ALL'  /* Kompletter Rescan */
                end

              when length(data2) > 200
                then call proc_msg_2  /* Angabe zu lang */
                          /* Link-Requests mit Wildcard nicht erlaubt */
              when pos('*', data2) > 0 &,
                   mcmd._acs.mcmd = 0 &,
                   bitand(dnl._flags.d, '00000002'x) = '00000000'x
                then call proc_msg_2
              otherwise
                                              /* Kompletter Rescan von Area(s) */
                mcmd._req.mcmd.0 = mcmd._req.mcmd.0 +1
                z = mcmd._req.mcmd.0
                mcmd._req.mcmd.z = '+'strip(data2, 'l', '+')
                mcmd._cmd.mcmd = overlay('A', mcmd._cmd.mcmd, 10)
                mcmd._rescan.mcmd.z = 'ALL'
            end
          end

                          /* Areas umbenennen */
        when data1l = '#' & d = 0
          then
          do
            select
              when data2 = '' | data3 <> ''
                then call proc_msg_2
              when pos('*', data1r) > 0 | pos('*', data2) > 0
                then call proc_msg_2
              when length(data1r) > 200 | length(data2) > 200
                then call proc_msg_2  /* Angaben zu lang */
              otherwise
                mcmd._rename.mcmd.0 = mcmd._rename.mcmd.0 +1
                z = mcmd._rename.mcmd.0
                mcmd._rename.mcmd.z = data1r word(data, 2)
                mcmd._cmd.mcmd = overlay('C', mcmd._cmd.mcmd, 13)
            end
          end

                          /* Areas lschen */
        when data1l = '~' & d = 0
          then
          do
            select
              when data1r = '' | data2 <> '' | pos('**', data1r) > 0
                then call proc_msg_2
              when length(data1r) > 200
                then call proc_msg_2  /* Angabe zu lang */
              otherwise
                mcmd._delete.mcmd.0 = mcmd._delete.mcmd.0 +1
                z = mcmd._delete.mcmd.0
                mcmd._delete.mcmd.z = data1r
                mcmd._cmd.mcmd = overlay('D', mcmd._cmd.mcmd, 9)
            end
          end
                          /* Area erstellen */
        when data1l = '&' & d = 0
          then
          do
            status = 0
            parse var data =2 area '"'desc'"'
            parse upper value space(area) with area group level
            select
              when verify(area, char._ver) > 0 | area = ''
                then status = 1
              when length(area) > 200
                then status = 1  /* Angabe zu lang */
              when level <> ''
                then
                do
                  parse var level level'/'keys
                  if proc_msg_12() = 0
                    then status = verify(group, char._ver) > 0 | length(group) > 200
                end
              when group = ''
                then
                do
                  group = def._area_group
                  level = def._area_acs def._area_level'/'def._area_keys
                end
              when pos('/', group) > 0
                then
                do
                  parse var group level'/'keys
                  group = def._area_group
                  call proc_msg_12
                end

              when verify(group, char._ver) > 0 | length(group) > 200
                then status = 1
              otherwise
                level = def._area_acs def._area_level'/'def._area_keys
            end

            if \status
              then
              do
                mcmd._create.mcmd.0 = mcmd._create.mcmd.0 +1
                z = mcmd._create.mcmd.0
                mcmd._create.mcmd.z = area group level '"'desc'"'
                mcmd._cmd.mcmd = overlay('M', mcmd._cmd.mcmd, 8)
              end
          end

                          /* unbekanntes/unerlaubtes Kommando */
        when pos(data1l, char._ctrl'%#~&') > 0
          then call proc_msg_2
        when data3 <> ''
          then call proc_msg_2
        when pos('**', data1) > 0  /* doppelter Wildcard geht nicht */
          then call proc_msg_2
        when length(data1) > 200
          then call proc_msg_2  /* Angabe zu lang */


                          /* Area-Requests */
        when data1l = '-'
          then
          do
            mcmd._req.mcmd.0 = mcmd._req.mcmd.0 +1
            z = mcmd._req.mcmd.0
            mcmd._req.mcmd.z = data1
            mcmd._cmd.mcmd = overlay('A', mcmd._cmd.mcmd, 10)
          end
                          /* Link-Requests mit Wildcard nicht erlaubt */
        when pos('*', data1) > 0 &,
             mcmd._acs.mcmd = 0 &,
             bitand(dnl._flags.d, '00000002'x) = '00000000'x
          then call proc_msg_2
        otherwise
          s2 = ''
          parse value translate(data1 data2, ' ', ',') with data1 s1 .
          select
            when ext_cmd._rescan = ''
              then s2 = 0   /* Rescan ignorieren, da kein Programm angegeben */
            when s1 = ''
              then s2 = rescan_flag
            when s1 = 'R'
              then s2 = 'ALL'
            when abbrev(s1, 'R=')
              then
              do
                s1 = substr(s1, 3)
                if datatype(s1, 'w') & s1 > 0
                  then s2 = s1
              end
            when abbrev(s1, 'D=')
              then
              do
                s1 = substr(s1, 3)
                if datatype(s1, 'w') & s1 > 0
                  then s2 = -s1
              end
            otherwise
          end

          if s2 = ''
            then call proc_msg_2
            else
            do
              mcmd._req.mcmd.0 = mcmd._req.mcmd.0 +1
              z = mcmd._req.mcmd.0
              mcmd._req.mcmd.z = '+'strip(data1, 'l', '+')
              mcmd._cmd.mcmd = overlay('A', mcmd._cmd.mcmd, 10)
              mcmd._rescan.mcmd.z = s2
            end
      end

    end

end

if mcmd._error.0 > 0
  then mcmd._cmd.1 = overlay('F', mcmd._cmd.1, 15)

mcmd.0 = mcmd

return



proc_msg_10:
p = wordpos(data1, '%LIST %AVAIL %QUERY %HELP %INFO')
                /*   1L    2V     3Q     4H    5I   */
return p



/* Absender-Adresse testen */
proc_msg_11:
dnl = wordpos(msg._from_addr.1, dnl._addr_idx)
select
  when dnl > 0          /* Mail von Downlink */
    then dnl = word(dnl._addr_idx, dnl +1)
  when wordpos(msg._from_addr.1, address._idx) = 0
    then dnl = -1       /* weder Downlink noch Sysop */
  otherwise             /* Mail vom Sysop */
end
return dnl



proc_msg_12:
select
  when verify(keys, char._anum) > 0
    then status = 1
  when level = ''
    then level = '0 0/'keys
  when \datatype(level, 'w')
    then status = 1
  when level < 0
    then level = '1' abs(level)'/'keys
  otherwise
    level = '0' level'/'keys
end
return status



proc_msg_13:

parse value translate(space(msg._subject.1), char._up, char._low) with pw scmd
select
  when pw <> dnl._pw.dnl | dnl._pw.dnl = ''
    then res = 1
  otherwise
    res = 0
    scmd = translate(scmd, 'H', '?')
    do y = 1 to words(scmd) until res > 0
      p = wordpos(word(scmd, y), '-L -A -Q -H -I -R')
      select
        when p = 0
          then res = 1      /* todo: ignorieren */
        when dnl = 0 & p > 4
          then nop    /* Bei Sysop -I und -R ignorieren */
        when p = 6
          then rescan_flag = 'ALL'
        otherwise
          mcmd._cmd.mcmd = overlay(substr('LVQHI', p, 1), mcmd._cmd.mcmd, p)
      end
    end
end

return res    /* 1 = Passwortfehler  */
              /* 0 = OK              */



proc_msg_4:

if data2 = ''
  then d = -1
  else
  do
    parse var data2 addr'.'pnt
    if pnt = ''
      then addr = addr'.0'
      else addr = data2
    do d = 1 to dnl.0 until wordpos(addr, dnl._addr.d) > 0
    end
    select
      when d > dnl.0
        then d = -1
      when data3 <> 'SYSOP' & data3 <> ''
        then d = -1
      otherwise
        mcmd = mcmd +1
        mcmd._dnl.mcmd = d
        mcmd._cmd.mcmd = ''
        rescan_flag    = 0
        if data3 = ''
          then
          do
            mcmd._dest_dnl.mcmd  = d
            mcmd._acs.mcmd       = 0
            mcmd._msgid.mcmd     = ''
          end
          else
          do
            mcmd._dest_dnl.mcmd  = 0
            addr = msg._from_addr.1
            mcmd._acs.mcmd       = 1
            mcmd._msgid.mcmd     = mcmd._msgid.1
          end
        z = mcmd._dest_dnl.mcmd
        if bitand(dnl._flags.z, '00000010'x) = '00000000'x
          then mcmd._dest_addr.mcmd = addr
          else mcmd._dest_addr.mcmd = dnl._addr.z.1
        if bitand(dnl._flags.z, '00000020'x) = '00000000'x
          then mcmd._from_addr.mcmd = msg._dest_addr.1
          else mcmd._from_addr.mcmd = address.1
    end
  end
if d < 0
  then call proc_msg_2

return




proc_msg_3:

select
  when d = 0 | data3 <> '' | pos('**', data2) > 0
    then call proc_msg_2    /* Fehlerhafte Angabe oder Sysop */

  when data2 = ''           /* alle Areas */
    then call proc_msg_3_1 arg(1) || 'A*'
  when left(data2, 1) <> '@'   /* bestimmte Areas */
    then call proc_msg_3_1 arg(1) || 'A' || data2
                            /* Gruppen */
  when pos('*', data2) > 0
    then call proc_msg_2
  otherwise
    call proc_msg_3_1 arg(1) || 'G' || substr(data2, 2)
end
return


proc_msg_3_1:

mcmd._tempreq.mcmd.0 = mcmd._tempreq.mcmd.0 +1
z = mcmd._tempreq.mcmd.0
mcmd._tempreq.mcmd.z = arg(1)
mcmd._cmd.mcmd = overlay('P', mcmd._cmd.mcmd, 11)
return




proc_msg_2:              /* Fehlerhafte Kommandos festhalten */

mcmd._error.0 = mcmd._error.0 +1
z = mcmd._error.0
mcmd._error.z = data

return

/************************************************************************/

set_full_name: procedure expose (common_var)
arg fvar, opt
pf = value(fvar)

select
  when pf = ''
    then nop
  when opt = 'P'      /* Pfadname vervollstndigen */
    then
    do
      pf = s_directory(pf)
      if pf <> ''
        then call value fvar, pf
      call directory dir._act
    end
  when opt = 'F'      /* Filename vervollstndigen, wenn vorhanden */
    then
    do
      pf = translate(stream(pf, 'c', 'query exists'))
      if pf <> ''
        then call value fvar, pf
    end
  otherwise           /* Nur Pfad eines Files vervollstndigen,
                         File nicht testen */
    file = filespec('n', pf)
    path = s_directory(filespec('d', pf) || filespec('p', pf))
    if path <> ''
      then
      do
        pf = path'\'file
        call value fvar, pf
      end
      else pf = ''
    call directory dir._act
end

return pf

/************************************************************************/

s_directory: procedure

arg y
select
  when right(y, 1) = ':'
    then y = y'\'
  when right(y, 2) <> ':\' & y <> '\'
    then y = strip(y, 't', '\')
  otherwise
end
return translate(strip(directory(y), 't', '\'))

/************************************************************************/

execute_prg: procedure expose (common_var)

parse arg prg
call close_logfile
prg
res = rc
call open_logfile
call wlog '# RC =' res

return

/************************************************************************/

/* Datum/Uhrzeit - Argumente in Logfile schreiben */

wlog: procedure expose log.

parse arg l1 l2
l2 = l1 right(subword(date(), 1, 2), 6, '0') time('n') 'RAFX' l2
say l2
if log._file <> ''
  then log._written = lineout(log._file, l2)

return


/* Datum/Uhrzeit - Argumente nur auf Bildschirm ausgeben */

wlogq: procedure

parse arg l1 l2
l2 = l1 right(subword(date(), 1, 2), 6, '0') time('n') 'RAFX' l2
say l2

return

/************************************************************************/

replace_str: procedure

parse arg dest, .

do y = 2 to arg() by 2
  l = length(arg(y))
  do forever
    p = pos(translate(arg(y)), translate(dest))
    if p > 0
      then dest = insert(arg(y +1), delstr(dest, p, l), p -1)
      else leave
  end
end

return dest

/************************************************************************/

close_logfile_sem: procedure expose (common_var)

  /* LogFile schliessen */
if log._written <> ''
  then call wlog ':' copies('-', 55)
  else call wlogq ':' copies('-', 55)
call close_logfile

  /* Semaphore schliessen */
if sem._name <> ''
  then
  do
    call stream sem._name, 'c', 'close'
    call sysfiledelete sem._name
  end

return

/************************************************************************/

open_logfile:

select
  when log._file = ''
    then nop
  when stream(log._file, 'c', 'open') <> 'READY:'
    then log._file = ''
  otherwise
    call stream log._file, 'c', 'seek <0'
end
return


close_logfile:

if log._file <> ''
  then call stream log._file, 'c', 'close'
return

/************************************************************************/

open_logfile_sem: procedure expose (common_var)

  /* LogFile ffnen */
select
  when log._prg = ''
    then nop
  when stream(log._prg, 'c', 'open') = 'READY:'
    then
    do
      log._file = stream(log._prg, 'c', 'query exists')
      call stream log._file, 'c', 'seek <0'
    end
  otherwise
    call wlog replace_str(def._log_str.105, '[%f]', log._prg)
end
drop log._prg

  /* Semaphore ffnen */
if sem._name <> ''
  then
  do
    do t = sem._timeout to 1 by -1 while stream(sem._name, 'c', 'open') <> 'READY:'
      call charout, 'W:'format(t, 6)cr
      call syssleep 1
    end
    if t < 1
      then signal error_250_1
  end

return


error_250_1:
call wlog def._log_str.150
signal error_250

error_250_2:
call wlog def._log_str.151
signal error_250

error_250:
call wlog ':' copies('-', 55)
call close_logfile
exit 250

/************************************************************************/

/* aktuelles Datum und Zeit im Unix-Format */

unix_date: procedure

dd = (date('b') -719162) * 86400 + time('s')

return dd

/************************************************************************/

/*========================================================================

XD2DATETIME wandelt Datum/Zeit im Unix-Format in lesbares Format

    Ergebnis = XD2DATE(Argument)

'Ergebnis' enthlt das Datum im Format yyyy/mm/dd-hh:mm:ss

========================================================================*/

xd2datetime: procedure

arg dd
ss = dd//86400 %1
return xd2date(dd%86400)'-' ||,
       right(ss %3600, 2, 0)':'      ||,
       right(ss //3600 %60, 2, 0)':' ||,
       right(ss //60, 2, 0)

/************************************************************************/

/*========================================================================

XD2DATE wandelt Tage seit 01.01.1970 in lesbares Format

    Ergebnis = XD2DATE(Argument)

'Ergebnis' enthlt das Datum im Format yyyy/mm/dd

========================================================================*/

xd2date: procedure

arg dd

dd = dd +1
z = (dd -0.5) %365.25
yy = z +1970
dd = dd -(z *365.25 +0.25) %1
do mm = 12 to 1 by -1
  z = word('0 31 60 91 121 152 182 213 244 274 305 335',
       '0 31 59 90 120 151 181 212 243 273 304 334',sign(yy//4)*12+mm)
  if dd > z
    then
    do
      dd = dd -z
      leave
    end
end

return yy'/'right(mm, 2, 0)'/'right(dd, 2, 0)

/************************************************************************/

/*========================================================================

DATE2XD liefert die Anzahl der Tage zwischen dem 01.01.1970 und dem
Argument.

    Ergebnis = DATE2XD(Argument)


'Argument' ist hierbei das Datum im Format 'yyyy/mm/dd'. Der zulssige
Bereich ist vom 01.01.1970 ... 31.12.2099

'Ergebnis' ist die Anzahl der Tage. 0 = 01.01.1970. Bei einem Fehler wird
-1 zurckgegeben.

========================================================================*/

date2xd: procedure

arg yy'/'mm'/'dd

select
  when \datatype(yy, 'w') | \datatype(mm, 'w') | \datatype(mm, 'w')
    then res = -1
  when yy > 2099 | yy < 1970 | mm < 1 | mm > 12 | dd < 1
    then res = -1
  when dd > word('31' 29 - sign(yy //4) '31 30 31 30 31 31 30 31 30 31', mm)
    then res = -1
  otherwise
    res = ((yy - 1970) * 365.25 + 0.25)%1 +dd -1 +,
      word('0 31 60 91 121 152 182 213 244 274 305 335',
      '0 31 59 90 120 151 181 212 243 273 304 334',sign(yy//4)*12+mm)
end

return res


/************************************************************************/



/************************************************************************\
*                                                                        *
*                             RSQA v1.05                                 *
*                                                                        *
*       REXX-Funktionen fr den Zugriff auf Squish- und *.MSG-Areas      *
*                                                                        *
*                  Autor: Rdiger Wilke 2:2432/314                       *
*                                                                        *
\************************************************************************/



sq_init:

arg sq._def_zone

sq._result = 0
select
  when sq._def_zone = ''
    then sq._def_zone = 2
  when \datatype(sq._def_zone, 'w') | sq._def_zone < 1
    then sq._result = -99
  otherwise
end
sq._open_areas = ''
sq._open_msgs  = ''
sq._open_roots = ''

return sq._result

/************************************************************************/

/* todo: Neue Routine */

sq_read_msg_frame: procedure expose sq. msg.

arg n, m, ser

numstr = '0123456789'
sq._result = 0
msg._frame_data = ''      /* Frame-Daten */
msg._frame_format = ''    /* Daten-Format */

select
  when wordpos(n, sq._open_areas) = 0
    then sq._result = -98         /* Area nicht offen */
  when \datatype(m, 'w') | m < 1
    then sq._result = -99         /* Fehler bei Argument m */
  when \datatype(ser, 'w') | ser < 1
    then sq._result = -99         /* Fehler bei Argumente ser */
  otherwise
end
select
  when sq._result <> 0
    then nop
  when sq._format.n = '$'
    then if ser <= sq._hdr_num_msg.n
      then call sq_read_msg_frame_sq
  when ser > sq._sdm_idx.n.0
    then nop                    /* *.MSG nicht vorhanden */
  otherwise
    call sq_read_msg__frame_sdm
end

return sq._result


sq_read_msg_frame_sdm:

call sq_sort_sdm_idx
msg_file = sq._root.n'\'sq._sdm_idx.n.ser'.MSG'
msg_len  = stream(msg_file, 'c', 'query size')
select
  when msg_len < 191
    then sq._result = -3        /* MSG ist zu klein oder nicht vorhanden */
  when stream(msg_curr, 'c', 'open') <> 'READY:'
    then sq._result = -3        /* Fehler beim ffnen */

  otherwise
    msg._frame_data.m = charin(sq._msg_curr_file.n,, msg_len)
    y = '0000'x || substr(msg._frame_data.m, 187, 2) || '0000'x
    msg._frame_data.m = overlay(y, msg._frame_data.m, 185)
end

return




sq_read_msg_frame_sq:

msg_curr = c2d(reverse(substr(sq._area_idx.n, ser * 12 -11, 4, '0'x)))
select
  when msg_curr = 0
    then sq._result = -1        /* MSG nicht vorhanden */
  otherwise
                                /* SQHDR einlesen */
    call stream sq._root_sqd.n, 'c', 'seek <'0

    data._sqhdr = charin(sq._root_sqd.n, msg_curr +1, sq._hdr_sz_sqhdr.n)
    parse value reverse(left(data._sqhdr, 26)) with,
                     frame_type    +2,
                     .             +4,
                     msg_curr_len  +4,
                  23 sqhdr_id
    select

      when length(data._sqhdr) <> sq._hdr_sz_sqhdr.n  /* Lnge der Daten testen */
        then sq._result = -1
                                /* SQHDR-ID testen */
      when sqhdr_id <> 'afae4453'x
        then sq._result = -1
                                /* Frame-Type testen */
      when frame_type \== '0000'x
        then sq._result = -1
      otherwise
        msg_curr_len  = c2d(msg_curr_len)

                                /* XMSG einlesen */
        data._msg = charin(sq._root_sqd.n,, msg_curr_len)
        if length(data._msg) < 238
          then sq._result = -1
          else
          do
              /* Reply-Linking lschen */
            data._msg = overlay(copies('00'x, 40), data._msg, 175)
            msg._frame_data.m = data._sqhdr || data._msg
            msg._frame_format.m = '$'
          end

    end
end

return

/************************************************************************/

/* todo: Neue Routine */

sq_write_msg_frame: procedure expose sq. msg.

arg n, m

sq._result = 0
select
  when wordpos(n, sq._open_areas) = 0
    then sq._result = -98
  when \datatype(m, 'w') | m < 1
    then sq._result = -99
  when msg._frame_format.m <> sq._format.n
    then sq._result = -90               /* Flasches Frame-Format */
  otherwise
    if sq._format.n = '$'
      then call sq_write_msg_frame_sq   /* Squish-MSG erstellen */
      else call sq_write_msg_frame_sdm  /* *.MSG erstellen */
end

return sq._result



sq_write_msg_frame_sq:

prev_frame   = sq._hdr_last_frame.n

sqhdr = left('5344aeaf'x ||,                 /* id */
             '00000000'x ||,                 /* next_frame */
             reverse(d2c(prev_frame, 4)) ||, /* prev_frame */
             '00000000'x ||,                 /* frame_length */
             '00000000'x ||,                 /* msg_length */
             '00000000'x ||,                 /* ctrl_length */
             '0300'x     ,,                  /* frame_type */
             sq._hdr_sz_sqhdr.n, '0'x)

parse var msg._frame_data.m =17 ,
          msg_length    +4,
          ctrl_length   +4,
          .

parse value substr(msg._frame_data.m, sq._hdr_sz_sqhdr.n +1, 238) with,
                attr        +4,
                xmsg.1     +36,
                dest_name  +36,
                xmsg.2    +138,
                .           +4,
                xmsg.3


umsgid = sq._hdr_uid.n
attr = bitor(reverse(attr), '00020000'x)
xmsg = reverse(attr) || xmsg.1 || dest_name || xmsg.2 || reverse(d2c(umsgid, 4)) || xmsg.3
dest_name = strip(dest_name, 't', '0'x)

select
                                /* Zeiger auf Dateiende */
  when stream(sq._root_sqd.n, 'c', 'seek <'0) <> sq._hdr_end_frame.n +1
    then sq._result = -1
                                /* SQHDR erstellen */
  when charout(sq._root_sqd.n, sqhdr, sq._hdr_end_frame.n +1) > 0
    then sq._result = -1
                                /* XMSG schreiben */
  when charout(sq._root_sqd.n, xmsg) > 0
    then sq._result = -1
                                /* MSG schreiben */
  when charout(sq._root_sqd.n, substr(msg._frame_data.m, sq._hdr_sz_sqhdr.n +1 +238)) > 0
    then sq._result = -1

                            /* SQHDR aktualisieren */
  when charout(sq._root_sqd.n, msg_length   ||,
                               msg_length   ||,
                               ctrl_length  ||,
                               '0000'x      , sq._hdr_end_frame.n +13) > 0
    then sq._result = -1
                            /* Vorletzte MSG linken */
  when sq_write_msg_frame_sq_1() <> 0
    then nop        /* SQ._RESULT = -1 */
  otherwise
                            /* Area-Header-Daten aktualisieren */
    sq._hdr_num_msg.n      = 1+ sq._hdr_num_msg.n
    sq._hdr_high_msg.n     = 1+ sq._hdr_high_msg.n
    sq._hdr_uid.n          = 1+ sq._hdr_uid.n
    sq._hdr_last_frame.n   = sq._hdr_end_frame.n
    sq._hdr_end_frame.n    = sq._hdr_end_frame.n + length(msg._frame_data.m)
    if sq._hdr_begin_frame.n = 0
      then sq._hdr_begin_frame.n = sq._hdr_last_frame.n
    if sq_write_header() <> 0
      then sq._result = -1
      else
      do
                            /* Area-Index aktualisieren */
        sq._area_idx.n = sq._area_idx.n ||,
                         reverse(sq_str_hash(dest_name,,
                                 (bitand('00000004'x, attr) <> '00000000'x)) ||,
                         d2c(umsgid, 4)               ||,
                         d2c(sq._hdr_last_frame.n, 4))

        sq._modified.n = 1                  /* MSG-Base wurde gendert */
        sq._result     = sq._hdr_num_msg.n  /* lfd. Nr. der neuen MSG */
      end
end

return


sq_write_msg_frame_sq_1:
if prev_frame > 0
  then if charout(sq._root_sqd.n, reverse(d2c(sq._hdr_end_frame.n, 4)), prev_frame +5) > 0
    then sq._result = -1
return sq._result



sq_write_msg_frame_sdm:

next_msg = sq._sdm_high.n +1
f_msg = sq._root.n'\'next_msg'.MSG'

select
  when stream(f_msg, 'c', 'query exists') <> ''
    then sq._result = -3
  when stream(f_msg, 'c', 'open write') <> 'READY:'
    then sq._result = -3
              /* MSG schreiben */
  when charout(f_msg, msg._frame_data.m) > 0
    then
    do
      call stream f_msg, 'c', 'close'
      call sysfiledelete f_msg
      sq._result = -3
    end
  otherwise
    call stream f_msg, 'c', 'close'
    sq._sdm_idx.n.0 = sq._sdm_idx.n.0 +1
    y = sq._sdm_idx.n.0
    sq._sdm_idx.n.y = next_msg
    sq._sdm_high.n  = next_msg
    sq._result      = y
end

return

/************************************************************************/

sq_open_msg: procedure expose sq. msg.

arg n, m, ser, addr_flag

numstr = '0123456789'
sq._result = 0
select
  when wordpos(n, sq._open_areas) = 0
    then sq._result = -98         /* Area nicht offen */
  when \datatype(m, 'w') | m < 1
    then sq._result = -99         /* Fehler bei Argumenten */
  when sq._msg_current.n > 0
    then sq._result = -5          /* schon eine MSG offen */
  when wordpos(m, sq._open_msgs) > 0
    then sq._result = -6          /* schon eine MSG mit dieser Nr. offen */
  when ser = '+'
    then ser = sq._msg_last.n +1  /* nchste MSG ffnen */
  when ser = '-'
    then ser = sq._msg_last.n -1  /* vorherige MSG ffnen */
  when ser = '='
    then ser = sq._msg_last.n     /* zuletzt geffnete MSG nochmals ffnen */
  when \datatype(ser, 'w') | ser < 1
    then sq._result = -99         /* Fehler bei Argumenten */
  otherwise
end
select
  when sq._result <> 0 | ser < 1
    then nop
  when sq._format.n = '$'
    then if ser <= sq._hdr_num_msg.n
      then call sq_open_msg_sq
  when ser > sq._sdm_idx.n.0
    then nop                    /* *.MSG nicht vorhanden */
  otherwise
    call sq_open_msg_sdm
end

return sq._result



sq_open_msg_sq:

sq._msg_curr_var.n = m
sq._msg_curr_file.n = c2d(reverse(substr(sq._area_idx.n, ser * 12 -11, 4, '0'x)))
select
  when sq._msg_curr_file.n = 0
    then sq._result = -1        /* MSG nicht vorhanden */
  otherwise
                                /* SQHDR einlesen */
    call stream sq._root_sqd.n, 'c', 'seek <'0
    data = charin(sq._root_sqd.n, sq._msg_curr_file.n +1, sq._hdr_sz_sqhdr.n)
    parse value reverse(left(data, 26)) with,
                     frame_type          +2,
                     sq._msg_curr_clen.n +4,
                     sq._msg_curr_len.n  +4,
                  23 sqhdr_id
    select

      when length(data) <> sq._hdr_sz_sqhdr.n  /* Lnge der Daten testen */
        then sq._result = -1
                                /* SQHDR-ID testen */
      when sqhdr_id <> 'afae4453'x
        then sq._result = -1
                                /* Frame-Type testen */
      when frame_type \== '0000'x
        then sq._result = -1
      otherwise
        sq._msg_curr_len.n  = c2d(sq._msg_curr_len.n)
        sq._msg_curr_clen.n = c2d(sq._msg_curr_clen.n)

                                /* XMSG einlesen */
        parse value charin(sq._root_sqd.n,, 238) with ,
                         msg._attr.m       +4,
                         msg._from_name.m +36,
                         msg._dest_name.m +36,
                         msg._subject.m   +72,
                         data             +70,
                         msg._ftsc_date.m

        msg._attr.m      = reverse(msg._attr.m)
        msg._from_name.m = strip(msg._from_name.m,, '0'x)
        msg._dest_name.m = strip(msg._dest_name.m,, '0'x)
        msg._subject.m   = strip(msg._subject.m  ,, '0'x)

        if length(msg._ftsc_date.m) = 20
          then
          do
            parse value reverse(data) with,
                              msg._umsgid.m        +4,
                              msg._replies.m.9     +4,   /* Replies */
                              msg._replies.m.8     +4,
                              msg._replies.m.7     +4,
                              msg._replies.m.6     +4,
                              msg._replies.m.5     +4,
                              msg._replies.m.4     +4,
                              msg._replies.m.3     +4,
                              msg._replies.m.2     +4,
                              msg._replies.m.1     +4,
                              msg._replyto.m       +4,   /* restl. Daten */
                              msg._utc_ofs.m       +2,
                              msg._date_arrived.m  +4,
                              msg._date_written.m  +4,
                              d_point              +2,
                              d_node               +2,
                              d_net                +2,
                              d_zone               +2,
                              f_point              +2,
                              f_node               +2,
                              f_net                +2,
                              f_zone               +2,
                            5 y +36                   /* nochmal Replies */

            msg._replies.m.0 = 9 - (compare(y'@', '0'x, '0'x) -1) % 4
            do y = 1 to msg._replies.m.0
              msg._replies.m.y = c2d(msg._replies.m.y)
            end

            msg._umsgid.m       = c2d(msg._umsgid.m)
            msg._replyto.m      = c2d(msg._replyto.m)
            msg._utc_ofs.m      = c2d(msg._utc_ofs.m, 2)
            msg._date_arrived.m = sq_c2datetime(msg._date_arrived.m)
            msg._date_written.m = sq_c2datetime(msg._date_written.m)
            msg._dest_addr.m    = c2d(d_zone) || ':' ||,
                                  c2d(d_net)  || '/' ||,
                                  c2d(d_node) || '.' ||,
                                  c2d(d_point)
            msg._from_addr.m    = c2d(f_zone) || ':' ||,
                                  c2d(f_net)  || '/' ||,
                                  c2d(f_node) || '.' ||,
                                  c2d(f_point)
            msg._ftsc_date.m    = left(strip(msg._ftsc_date.m, 't', '0'x), 19, '0'x)

            msg._times_read.m   = 0
            msg._cost.m         = 0

            /* CTRL-Lines einlesen */

            if sq._msg_curr_clen.n > 0
              then msg._ctrl.m = charin(sq._root_sqd.n,, sq._msg_curr_clen.n -1)
              else msg._ctrl.m = ''

            /* MSGID auswerten */

            select
              when addr_flag < 1
                then msg._src_addr.m = ''
              when msg._ctrl.m = ''
                then msg._src_addr.m = ''
              otherwise
                         /* todo: doch noch INTL etc. auswerten */
                call sq_open_msg_1
            end

            msg._text.m         = ''
            sq._result          = ser
            sq._msg_current.n   = ser
            sq._open_msgs       = sq._open_msgs m

          end
          else sq._result = -1
    end
end

return




sq_open_msg_sdm:

call sq_sort_sdm_idx
sq._msg_curr_var.n = m
sq._msg_curr_file.n = sq._root.n'\'sq._sdm_idx.n.ser'.MSG'

sq._msg_curr_len.n = stream(sq._msg_curr_file.n, 'c', 'query size')
select
  when sq._msg_curr_len.n < 191
    then sq._result = -3        /* MSG ist zu klein oder nicht vorhanden */
  when stream(sq._msg_curr_file.n, 'c', 'open') <> 'READY:'
    then sq._result = -3        /* Fehler beim ffnen */

  otherwise

    parse value charin(sq._msg_curr_file.n,, 190) with ,
                     msg._from_name.m  +36,
                     msg._dest_name.m  +36,
                     msg._subject.m    +72,
                     msg._ftsc_date.m  +20,
                     data

    msg._from_name.m = strip(msg._from_name.m,, '0'x)
    msg._dest_name.m = strip(msg._dest_name.m,, '0'x)
    msg._subject.m   = strip(msg._subject.m  ,, '0'x)
    msg._ftsc_date.m = left(strip(msg._ftsc_date.m, 't', '0'x), 19, '0'x)

    if length(data) = 26
      then
      do
        parse value reverse(data) with,
                     msg._replies.m.1    +2,
                     msg._attr.m         +2,
                     msg._replyto.m      +2,
                     msg._date_arrived.m +4,
                     msg._date_written.m +4,
                     d_net               +2,
                     f_net               +2,
                     msg._cost.m         +2,
                     f_node              +2,
                     d_node              +2,
                     msg._times_read.m   +2

        msg._times_read.m   = c2d(msg._times_read.m)
        msg._cost.m         = c2d(msg._cost.m)
        msg._date_arrived.m = sq_c2datetime(msg._date_arrived.m)
        msg._date_written.m = sq_c2datetime(msg._date_written.m)
        msg._replyto.m      = c2d(msg._replyto.m)
        msg._attr.m         = '0000'x || msg._attr.m
        msg._replies.m.1    = c2d(msg._replies.m.1)
        msg._replies.m.0    = sign(msg._replies.m.1)
        msg._dest_addr.m    = c2d(d_net)'/'c2d(d_node)
        msg._from_addr.m    = c2d(f_net)'/'c2d(f_node)

        msg._utc_ofs.m      = 0
        msg._umsgid.m       = sq._sdm_idx.n.ser

        /* CTRL-Lines einlesen */

        msg._ctrl.m = ''
        sq._msg_curr_clen.n = stream(sq._msg_curr_file.n, 'c', 'seek +0')
        do while lines(sq._msg_curr_file.n) > 0
          data = linein(sq._msg_curr_file.n)
          select
            when left(data, 5) = 'AREA:'
              then msg._ctrl.m = msg._ctrl.m || ''data
            when left(data, 1) <> '' | left(data, 4) = 'Via'
              then leave
            otherwise
              msg._ctrl.m = msg._ctrl.m || data
          end
          sq._msg_curr_clen.n = stream(sq._msg_curr_file.n, 'c', 'seek +0')
        end

        /* CTRL-Lines auswerten */

        select
          when addr_flag < 1
            then msg._src_addr.m = ''
          when msg._ctrl.m <> ''
            then
            do
              call sq_open_msg_1
              if addr_flag = 2
                then call sq_open_msg_sdm_1
            end
          otherwise
            msg._src_addr.m = ''
            if addr_flag = 2
              then
              do
                msg._from_addr.m = sq._def_zone.n':'msg._from_addr.m'.0'
                msg._dest_addr.m = sq._def_zone.n':'msg._dest_addr.m'.0'
              end
        end

        msg._text.m         = ''
        sq._msg_current.n   = ser
        sq._result          = ser
        sq._open_msgs       = sq._open_msgs m

      end
      else sq._result = -3
end

return


sq_open_msg_sdm_1:

parse var msg._ctrl.m 'INTL 'd_zone':'.' 'f_zone':' 1 'TOPT 'd_point'' 1 'FMPT 'f_point''
if verify(f_point, numstr) > 0 | f_point < 0
  then f_point = 0
if verify(d_point, numstr) > 0 | d_point < 0
  then d_point = 0
select
  when d_zone < 1
    then f_zone = ''
  when verify(d_zone, numstr) > 0
    then f_zone = ''
  when f_zone < 1
    then f_zone = ''
  when verify(f_zone, numstr) > 0
    then f_zone = ''
  otherwise
end
if f_zone <> ''
  then
  do
    msg._from_addr.m = f_zone':'msg._from_addr.m'.'f_point
    msg._dest_addr.m = d_zone':'msg._dest_addr.m'.'d_point
  end
  else
  do
    msg._from_addr.m = sq._def_zone.n':'msg._from_addr.m'.'f_point
    msg._dest_addr.m = sq._def_zone.n':'msg._dest_addr.m'.'d_point
  end

return




/* MSGID auswerten */
sq_open_msg_1:
parse var msg._ctrl.m 'MSGID: 'm_zone':'m_net'/'m_node' '.
signal on syntax name sq_open_msg_1_1
if m_zone <> ''
  then
  do
    parse var m_node m_node'@'
    parse var m_node m_node'.'m_point
    m_point = ('0'm_point) +0
    if min(m_zone, m_net, m_node) < 0
      then msg._src_addr.m = ''
      else msg._src_addr.m = m_zone':'m_net'/'m_node'.'m_point
  end
  else msg._src_addr.m = ''
signal off syntax
return

sq_open_msg_1_1:
msg._src_addr.m = ''
signal off syntax
return

/************************************************************************/

sq_read_msg: procedure expose sq. msg.

arg n, addr_flag
sq._result = 0

select
  when wordpos(n, sq._open_areas) = 0
    then sq._result = -98         /* Area nicht offen */
  when sq._msg_current.n = 0
    then sq._result = -5          /* Keine MSG in der Area offen */
  otherwise
    m = sq._msg_curr_var.n
    select
      when msg._text.m <> ''
        then nop                      /* Text nicht lesen, wenn schon geschehen */
      when sq._format.n = '$'
        then
        do
          p = sq._msg_curr_file.n +sq._hdr_sz_sqhdr.n +238 +sq._msg_curr_clen.n +1
          len = sq._msg_curr_len.n -sq._msg_curr_clen.n -238 -1
          select
            when stream(sq._root_sqd.n, 'c', 'seek <'0) = ''
              then sq._result = -1
            when len < 1
              then msg._text.m = ''
            otherwise
              msg._text.m = charin(sq._root_sqd.n, p, len)
              if length(msg._text.m) <> len
                then sq._result = -1
                else sq._result = len
          end
        end
      otherwise
        len = sq._msg_curr_len.n -sq._msg_curr_clen.n
        if len < 1
          then msg._text.m = ''
          else
          do
            msg._text.m = charin(sq._msg_curr_file.n, sq._msg_curr_clen.n, len)
            if length(msg._text.m) <> len
              then sq._result = -3
              else sq._result = len
          end
    end
end

select
  when addr_flag < 1
    then nop
  when sq._result < 1
    then nop
  when addr_flag = 2
    then msg._src_addr.m = sq_read_msg_1()
  when sq_read_msg_1() <> ''
    then msg._src_addr.m = addr
  otherwise
end
signal off syntax
return sq._result


sq_read_msg_1:
signal on syntax name sq_error_null
parse var msg._text.m ' * Origin: 'addr'd'x
parse value reverse(addr) with ')'addr'('
parse value reverse(addr) with zone':'net'/'node'.'point
point = (0||point) +0
if min(zone, net, node, point) >= 0
  then addr = zone':'net'/'node'.'point
  else addr = ''
return addr

/************************************************************************/

sq_ctrl_2_stem: procedure expose sq. msg.

arg m

select
  when \datatype(m, 'w') | m < 0
    then res = -99
  when symbol('msg._ctrl.m') <> 'VAR'
    then res = -98
  when msg._ctrl.m = ''
    then
    do
      msg._ctrl.m.0 = 0
      res = 0
    end
  otherwise
    s_begin = 1
    do v = 1
      s_next = pos('', msg._ctrl.m, s_begin +1)
      if s_next = 0
        then
        do
          msg._ctrl.m.v = substr(msg._ctrl.m, s_begin)
          leave
        end
      msg._ctrl.m.v = substr(msg._ctrl.m, s_begin, s_next -s_begin)
      s_begin = s_next
    end
    msg._ctrl.m.0 = v
    res = msg._ctrl.m.0
end

return res

/************************************************************************/

sq_stem_2_ctrl: procedure expose sq. msg.

arg m
select
  when \datatype(m, 'w') | m < 0
    then res = -99
  when \datatype(msg._ctrl.m.0, 'w') | msg._ctrl.m.0 < 0
    then res = -98
  otherwise
    msg._ctrl.m = ''
    do y = 1 to msg._ctrl.m.0
      msg._ctrl.m = msg._ctrl.m || msg._ctrl.m.y
    end
    res = msg._ctrl.m.0
end

return res

/************************************************************************/

sq_close_msg: procedure expose sq. msg.

arg n

select
  when wordpos(n, sq._open_areas) = 0
    then sq._result = -98         /* Area nicht offen */
  when sq._msg_current.n = 0
    then sq._result = -5          /* Keine MSG in der Area offen */
  when sq._format.n <> '$'
    then sq._result = (stream(sq._msg_curr_file.n, 'c', 'close') = 'READY:')
  otherwise
    sq._result = 1
end
if sq._result >= 0
  then
  do
    p = wordpos(sq._msg_curr_var.n, sq._open_msgs)
    if p > 0
      then sq._open_msgs = strip(delword(sq._open_msgs, p, 1))
    sq._msg_last.n = sq._msg_current.n
    sq._msg_current.n = 0
    if sq._result > 0
      then sq._result = sq._msg_last.n
      else sq._result = -3
  end

return sq._result

/************************************************************************/

sq_kill_msg: procedure expose sq. msg.

arg n, ser

sq._result = 0
select
  when wordpos(n, sq._open_areas) = 0   /* Area nicht offen */
    then sq._result = -98
  when \datatype(ser, 'w') | ser < 1    /* Argumentenfehler */
    then sq._result = -99
  when sq._msg_current.n > 0            /* eine MSG ist gerade offen */
    then sq._result = -5
  when sq._format.n = '$'
    then call sq_kill_msg_sq
  otherwise
    call sq_kill_msg_sdm
end
signal off syntax

return sq._result


sq_kill_msg_sq:

/*========================================================================
frame.i     = Frame-Offset
sqhdr.i     = SQHDR-Daten

i = 1       = zu lschender Frame
    2       = nachfolgender Frame
    3       = vorhergehende Frame
    4       = letzter Free-Frame

========================================================================*/

frame.1 = c2d(reverse(substr(sq._area_idx.n, ser * 12 -11, 4, '0'x)))
if frame.1 > 0
  then
  do
    frame.4 = sq._hdr_last_free_frame.n
    select
                      /* notwendige SQHDR-Daten lesen */
                      /* Daten Del-Frame */
      when sq_kill_msg_sq_1(1) > 0
        then sq._result = -1
                      /* Daten Next-Frame */
      when sq_kill_msg_sq_2(2, 3, 9, 0) > 0
        then sq._result = -1
                      /* Daten Prev-Frame */
      when sq_kill_msg_sq_2(3, 2, 5, 0) > 0
        then sq._result = -1
                      /* Daten Last-Free-Frame */
      when sq_kill_msg_sq_2(4, 1, 5, 1) > 0
        then sq._result = -1

      otherwise

        /* Daten Del-Frame anpassen , Zeiger und Frame-Type*/
        sqhdr.1 = overlay('00000000'x || reverse(d2c(frame.4, 4)), left(sqhdr.1, 24) || '0100'x, 5)

        /* Header-Daten anpassen */
        sq._hdr_num_msg.n  = sq._hdr_num_msg.n -1
        sq._hdr_high_msg.n = sq._hdr_high_msg.n -1

        if frame.2 = 0
          then sq._hdr_last_frame.n = frame.3
        if frame.3 = 0
          then sq._hdr_begin_frame.n = frame.2
        if sq._hdr_free_frame.n = 0
          then sq._hdr_free_frame.n = frame.1
        sq._hdr_last_free_frame.n = frame.1

        /* SQI anpassen */
        sq._area_idx.n = delstr(sq._area_idx.n, ser *12 -11, 12)

        /* Daten in *.SQD-File schreiben */
        do y = 1 to 4
          if frame.y > 0
            then
            do
              call stream sq._root_sqd.n, 'c', 'seek <'0
              if charout(sq._root_sqd.n, sqhdr.y, frame.y +1) > 0
                then leave
            end
        end
        select
          when y <= 4
            then sq._result = -1
          when sq_write_header() <> 0
            then sq._result = -1
          otherwise
            sq._result = ser
            sq._modified.n = 1
            if sq._msg_last.n >= ser
              then sq._msg_last.n = 0
        end
    end

  end
  else sq._result = 0   /* MSG nicht vorhanden oder ungltig */

return


                      /* SQHDR-Daten testen */
sq_kill_msg_sq_3:

call stream sq._root_sqd.n, 'c', 'seek <'0
sqhdr.i = charin(sq._root_sqd.n, frame.i +1, 26)
select
                      /* Anzahl der Bytes testen */
  when length(sqhdr.i) <> 26
    then res = 1
                      /* SQHDR-ID testen */
  when left(sqhdr.i, 4) <> '5344aeaf'x
    then res = 2
                      /* Frame-Type testen */
  when c2d(reverse(right(sqhdr.i, 2))) <> ft
    then res = 3
  otherwise
end
return res




/* Daten Frame lesen und Zeiger anpassen
   i    = Index fr den Frame
   fp   = Index des neu einzutragenden Wert (neuer Zeiger-Wert)
   pp   = Position des neuen Wertes in den Frame-Daten (zeiger-Position)
   ft   = geforderter Frame-Type
 */

sq_kill_msg_sq_2:
arg i, fp, pp, ft
if frame.i > 0
  then if sq_kill_msg_sq_3() = 0
    then sqhdr.i = overlay(reverse(d2c(frame.fp, 4)), sqhdr.i, pp)
return res


                      /* notwendige SQHDR-Daten lesen */
sq_kill_msg_sq_1:
arg i     /* i = 1 */
res = 0
ft = 0
if sq_kill_msg_sq_3() = 0
  then
  do
    frame.2 = c2d(reverse(substr(sqhdr.1, 5, 4)))
    frame.3 = c2d(reverse(substr(sqhdr.1, 9, 4)))
  end
return res




sq_kill_msg_sdm:

if ser <= sq._sdm_idx.n.0
  then
  do
    call sq_sort_sdm_idx
    if sysfiledelete(sq._root.n'\'sq._sdm_idx.n.ser'.MSG') = 0
      then
      do
        sq._sdm_idx.n.0 = sq._sdm_idx.n.0 -1
        do y = ser to sq._sdm_idx.n.0
          z = y +1
          sq._sdm_idx.n.y = sq._sdm_idx.n.z
        end
        sq._result = ser
        y = sq._sdm_idx.n.0
        sq._sdm_high.n = sq._sdm_idx.n.y
        if sq._msg_last.n >= ser
          then sq._msg_last.n = 0
      end
      else sq._result = -3
  end
  else sq._result = 0

return

/************************************************************************/

sq_update_msg_hdr: procedure expose sq. msg.

arg n, flag
sq._result = 0
m = sq._msg_curr_var.n
select
  when wordpos(n, sq._open_areas) = 0
    then sq._result = -98         /* Area nicht offen */
  when sq._msg_current.n = 0
    then sq._result = -5          /* Keine MSG in der Area offen */
  when sq._format.n = '$'
    then call sq_update_msg_hdr_sq

  when sq_msg_header_test() <> 0
    then nop /* sq._result = -20     Fehler MSG-Header-Daten */
  when charout(sq._msg_curr_file.n, msg_hdr, 1) > 0
    then sq._result = -3
  otherwise
    sq._result = sq._msg_current.n
end
signal off syntax

return sq._result



sq_update_msg_hdr_sq:

parse value reverse(substr(sq._area_idx.n, sq._msg_current.n * 12 -11, 8, '0'x)) with,
      umsgid +4 frame
umsgid = c2d(umsgid)
select
  when umsgid = 0 | c2d(frame) <> sq._msg_curr_file.n
    then sq._result = -2    /* Fehler in den SQI-Daten */
  when sq_msg_header_test(1) <> 0
    then nop /* sq._result = -20     Fehler MSG-Header-Daten */
  otherwise
            /* Zeiger auf Ende der Datei */
    call stream sq._root_sqd.n, 'c', 'seek <'0
    parse value charin(sq._root_sqd.n, sq._msg_curr_file.n +1, sq._hdr_sz_sqhdr.n) with,
            sqhdr_id +4 17 msg_length +4 25 frame_type +2
    select
            /* SQHDR-ID testen */
      when sqhdr_id <> '5344aeaf'x
        then sq._result = -1
            /* Frame-Type testen */
      when frame_type \== '0000'x
        then sq._result = -1
            /* Lnge der MSG testen (min. 238 +1 +1) */
      when c2d(reverse(msg_length)) < 240
        then sq._result = -1
            /* Zeiger-Position testen */
      when stream(sq._root_sqd.n, 'c', 'seek +'0) <> sq._msg_curr_file.n +sq._hdr_sz_sqhdr.n +1
        then sq._result = -1
            /* XMSG schreiben */
      when charout(sq._root_sqd.n, msg_hdr) > 0
        then sq._result = -1
      otherwise
        sq._result = sq._msg_current.n
                                /* Area-Index aktualisieren */
        if flag < 1
          then
          do
            sq._area_idx.n = overlay(reverse(sq_str_hash(msg._dest_name.m,,
                             (bitand('00000004'x, attr) <> '00000000'x))),,
                             sq._area_idx.n, sq._msg_current.n * 12 -3)
            sq._modified.n = 1
          end
    end
end
return

/************************************************************************/

sq_create_msg: procedure expose sq. msg.

arg n, m, ctrl_flag

sq._result = 0
select
  when wordpos(n, sq._open_areas) = 0
    then sq._result = -98
  when \datatype(m, 'w') | m < 1
    then sq._result = -99
  when sq_msg_header_test(0) <> 0
    then nop /* sq._result = -20     Fehler MSG-Header-Daten */
  otherwise
    call sq_msg_ctrl_mod            /* CTRL-Lines bearbeiten */
    if sq._format.n = '$'
      then call sq_create_msg_sq    /* Squish-MSG erstellen */
      else call sq_create_msg_sdm   /* *.MSG erstellen */
end
signal off syntax

return sq._result



sq_create_msg_sq:

signal on syntax name sq_error_1
prev_frame   = sq._hdr_last_frame.n
sqhdr = left('5344aeaf'x ||,                 /* id */
             '00000000'x ||,                 /* next_frame */
             reverse(d2c(prev_frame, 4)) ||, /* prev_frame */
             '00000000'x ||,                 /* frame_length */
             '00000000'x ||,                 /* msg_length */
             '00000000'x ||,                 /* ctrl_length */
             '0300'x     ,,                  /* frame_type */
             sq._hdr_sz_sqhdr.n, '0'x)

select
                                /* Zeiger auf Dateiende */
  when stream(sq._root_sqd.n, 'c', 'seek <'0) <> sq._hdr_end_frame.n +1
    then sq._result = -1
                                /* SQHDR erstellen */
  when charout(sq._root_sqd.n, sqhdr, sq._hdr_end_frame.n +1) > 0
    then sq._result = -1
                                /* XMSG schreiben */
  when charout(sq._root_sqd.n, msg_hdr) > 0
    then sq._result = -1

  otherwise

    ctrl_length   = length(msg._ctrl.m) +1
    msg_length    = 238 + ctrl_length + length(msg._text.m) +1
    msg_length_c  = reverse(d2c(msg_length, 4))

    select
                                /* CTRL-Lines schreiben */
      when charout(sq._root_sqd.n, msg._ctrl.m || '0'x) > 0
        then sq._result = -1
                                    /* MSG-Text schreiben */
      when charout(sq._root_sqd.n, msg._text.m || '0'x) > 0
        then sq._result = -1
                                /* SQHDR aktualisieren */
      when charout(sq._root_sqd.n, msg_length_c ||,
                   msg_length_c || reverse(d2c(ctrl_length, 4)) ||,
                   '0000'x, sq._hdr_end_frame.n +13) > 0
        then sq._result = -1
                                /* Vorletzte MSG linken */
      when sq_create_msg_sq_1() <> 0
        then nop /* SQ._RESULT = -1 */
      otherwise
                                /* Area-Header-Daten aktualisieren */
        sq._hdr_num_msg.n      = 1+ sq._hdr_num_msg.n
        sq._hdr_high_msg.n     = 1+ sq._hdr_high_msg.n
        sq._hdr_uid.n          = 1+ sq._hdr_uid.n
        sq._hdr_last_frame.n   = sq._hdr_end_frame.n
        sq._hdr_end_frame.n    = sq._hdr_end_frame.n + msg_length + sq._hdr_sz_sqhdr.n
        if sq._hdr_begin_frame.n = 0
          then sq._hdr_begin_frame.n = sq._hdr_last_frame.n
        if sq_write_header() <> 0
          then sq._result = -1
          else
          do
                                /* Area-Index aktualisieren */
            sq._area_idx.n = sq._area_idx.n ||,
                           reverse(sq_str_hash(msg._dest_name.m,,
                               (bitand('00000004'x, attr) <> '00000000'x)) ||,
                             d2c(umsgid, 4)               ||,
                             d2c(sq._hdr_last_frame.n, 4))

            sq._modified.n = 1                  /* MSG-Base wurde gendert */
            sq._result     = sq._hdr_num_msg.n  /* lfd. Nr. der neuen MSG */
          end
    end
end

return


sq_create_msg_sq_1:
if prev_frame > 0
  then if charout(sq._root_sqd.n, reverse(d2c(sq._hdr_end_frame.n, 4)),,
               prev_frame +5) > 0
    then sq._result = -1
return sq._result



sq_create_msg_sdm:

next_msg = sq._sdm_high.n +1
f_msg = sq._root.n'\'next_msg'.MSG'

select
  when stream(f_msg, 'c', 'query exists') <> ''
    then sq._result = -3
  when stream(f_msg, 'c', 'open write') <> 'READY:'
    then sq._result = -3
              /* MSG-Header schreiben */
  when charout(f_msg, msg_hdr) > 0
    then call sq_create_msg_sdm_1
              /* CTRL-Lines schreiben */
  when sq_create_msg_sdm_2() > 0
    then call sq_create_msg_sdm_1
              /* MSG-Text schreiben */
  when charout(f_msg, msg._text.m || '0'x) > 0
    then call sq_create_msg_sdm_1

  otherwise
    call stream f_msg, 'c', 'close'
    sq._sdm_idx.n.0 = sq._sdm_idx.n.0 +1
    y = sq._sdm_idx.n.0
    sq._sdm_idx.n.y = next_msg
    sq._sdm_high.n  = next_msg
    sq._result      = y
end

return



sq_create_msg_sdm_2:
res = 0
if msg._ctrl.m <> ''
  then
  do
    s_begin = 1
    do forever
      s_next = pos('', msg._ctrl.m, s_begin +1)
      if s_next = 0
        then
        do
          res = charout(f_msg, substr(msg._ctrl.m, s_begin) || 'd'x)
          leave
        end
      res = charout(f_msg, substr(msg._ctrl.m, s_begin, s_next -s_begin) || 'd'x)
      s_begin = s_next
    end
  end
return res



sq_create_msg_sdm_1:
call stream f_msg, 'c', 'close'
call sysfiledelete f_msg
sq._result = -3
return

/************************************************************************/

sq_msg_ctrl_mod:

select
  when ctrl_flag = 1
    then
    do
      parse var msg._ctrl.m k1'INTL '.'' +0 k2
      parse value (k1||k2) with k1'TOPT '.'' +0 k2
      parse value (k1||k2) with k1'FMPT '.'' +0 k2
      msg._ctrl.m = k1||k2
    end
  when ctrl_flag = 2
    then
    do
      parse var msg._ctrl.m k1'INTL '.'' +0 k2
      parse value (k1||k2) with k1'TOPT '.'' +0 k2
      parse value (k1||k2) with k1'FMPT '.'' +0 k2
      k0 = 'INTL 'd_zone':'d_net'/'d_node' 'f_zone':'f_net'/'f_node
      if d_point > 0
        then k0 = k0 || 'TOPT 'd_point
      if f_point > 0
        then msg._ctrl.m = k0 || 'FMPT 'f_point || k1 || k2
        else msg._ctrl.m = k0 || k1 || k2
    end
  otherwise
end

return

/************************************************************************/

sq_msg_header_test:

signal on syntax name sq_error_20
parse var msg._from_addr.m f_zone'/'f_node'.'f_point
parse var f_zone f_zone':'f_net'/'
if f_net = ''
  then
  do
    f_net = f_zone
    f_zone = sq._def_zone.n
  end
parse var msg._dest_addr.m d_zone'/'d_node'.'d_point
parse var d_zone d_zone':'d_net'/'
if d_net = ''
  then
  do
    d_net = d_zone
    d_zone = sq._def_zone.n
  end
f_point = ('0'f_point) +0
d_point = ('0'd_point) +0

date_written = sq_datetime2c(msg._date_written.m)
date_arrived = sq_datetime2c(msg._date_arrived.m)
if msg._ftsc_date.m = ''
  then ftsc_date = sq_datetime2ftsc(msg._date_written.m)
  else ftsc_date = msg._ftsc_date.m

select
  when date_written = '' | date_arrived = '' | length(ftsc_date) <> 19
    then sq._result = -20
  when sq._format.n = '$'
    then
    do
      if arg(1) = 0
        then umsgid = sq._hdr_uid.n     /* Neue UMSGID */
      attr = bitor(right(msg._attr.m, 4, '0'x), '00020000'x)
      replies = ''
      do y = msg._replies.m.0 to 1 by -1
        replies = replies || d2c(msg._replies.m.y, 4)
      end
      msg_hdr = reverse(attr)                         ||,
                left(msg._from_name.m, 36, '0'x)      ||,
                left(msg._dest_name.m, 36, '0'x)      ||,
                left(msg._subject.m,   72, '0'x)      ||,
                reverse(d2c(umsgid, 4)              ||,
                        right(replies, 36, '0'x)    ||,
                        d2c(msg._replyto.m, 4)      ||,
                        d2c(msg._utc_ofs.m, 2)      ||,
                        date_arrived                ||,
                        date_written                ||,
                        d2c(d_point, 2)             ||,
                        d2c(d_node, 2)              ||,
                        d2c(d_net, 2)               ||,
                        d2c(d_zone, 2)              ||,
                        d2c(f_point, 2)             ||,
                        d2c(f_node, 2)              ||,
                        d2c(f_net, 2)               ||,
                        d2c(f_zone, 2))               ||,
                ftsc_date || '0'x
    end
  otherwise
    if msg._replies.m.0 = 0
      then replies = 0
      else replies = msg._replies.m.1

    msg_hdr = left(msg._from_name.m, 36, '0'x)      ||,
              left(msg._dest_name.m, 36, '0'x)      ||,
              left(msg._subject.m,   72, '0'x)      ||,
              ftsc_date || '0'x                     ||,
              reverse(d2c(replies, 2)             ||,
                      right(msg._attr.m, 2, '0'x) ||,
                      d2c(msg._replyto.m, 2)      ||,
                      date_arrived                ||,
                      date_written                ||,
                      d2c(d_net, 2)               ||,
                      d2c(f_net, 2)               ||,
                      d2c(msg._cost.m, 2)         ||,
                      d2c(f_node, 2)              ||,
                      d2c(d_node, 2)              ||,
                      d2c(msg._times_read.m, 2))
end

return sq._result



/************************************************************************/

sq_uid_2_num: procedure expose sq. msg.

arg n, uid, flag

select
  when wordpos(n, sq._open_areas) = 0
    then sq._result = -98
  otherwise
    if sq._format.n = '$'
      then sum = length(sq._area_idx.n) % 12  /* Anzahl der Index-Eintrge */
      else
      do
        call sq_sort_sdm_idx
        sum = sq._sdm_idx.n.0
      end
    ug = 0; og = sum +1           /* Suchgrenzen */
    do forever
      i = (ug + og) % 2
      if ug = i                   /* nicht gefunden */
        then
        do
          if flag = '+'
            then i = (i +1) * (i < sum)
            else if flag <> '-'
              then i = 0
          leave
        end
      if sq._format.n = '$'
        then t = c2d(reverse(substr(sq._area_idx.n, i * 12 -7, 4, '0'x)))
        else t = sq._sdm_idx.n.i
      if uid < t
        then og = i           /* weiter unten suchen */
        else if uid > t
          then ug = i         /* weiter oben suchen */
          else leave          /* gefunden */
    end
    sq._result = i
end

return sq._result

/************************************************************************/

sq_num_2_uid: procedure expose sq. msg.

arg n, ser

select
  when wordpos(n, sq._open_areas) = 0
    then sq._result = -98
  when \datatype(ser, 'w') | ser < 1
    then sq._result = -99
  when sq._format.n = '$'
    then sq._result = c2d(reverse(substr(sq._area_idx.n, ser * 12 -7, 4, '0'x)))
  when ser > sq._sdm_idx.n.0
    then sq._result = 0
  otherwise
    call sq_sort_sdm_idx
    sq._result = sq._sdm_idx.n.ser
end

return sq._result

/************************************************************************/

sq_close_area: procedure expose sq. msg.

arg n .

sq._result = 0
p = wordpos(n, sq._open_areas)
select
  when p = 0
    then sq._result = -98
  when sq._msg_current.n <> 0
    then sq._result = -5
  when sq._format.n <> '$'    /* *.MSG-Area schliessen */
    then call sq_close_area_1
  otherwise
    select
      when sq._modified.n = 0
        then nop
      when sysfiledelete(sq._root_sqi.n) > 2
        then sq._result = -2
      when stream(sq._root_sqi.n, 'c', 'open') <> 'READY:'
        then sq._result = -2
      otherwise
        if charout(sq._root_sqi.n, sq._area_idx.n) > 0
          then sq._result = -2
        call stream sq._root_sqi.n, 'c', 'close'
    end
    call stream sq._root_sqd.n, 'c', 'close'
    call sq_close_area_1
end
signal off syntax

return sq._result


sq_close_area_1:
sq._open_areas = strip(delword(sq._open_areas, p, 1))
p = wordpos(sq._root.n, sq._open_roots)
if p > 0
  then sq._open_roots = strip(delword(sq._open_roots, p, words(sq._root)))
return

/************************************************************************/

sq_update_area_hdr: procedure expose sq. msg.

arg n

select
  when wordpos(n, sq._open_areas) = 0
    then sq._result = -98         /* Area nicht offen */
  when sq._format.n <> '$'
    then sq._result = -21         /* keine Squish-Area */
  otherwise
    sq._result = 0
    call sq_write_header
end

return sq._result

/************************************************************************/

sq_write_header:

signal on syntax name sq_error_1
if charout(sq._root_sqd.n,,
     reverse(d2c(sq._hdr_uid.n            , 4) ||,
             d2c(sq._hdr_high_water.n     , 4) ||,
             d2c(sq._hdr_skip_msg.n       , 4) ||,
             d2c(sq._hdr_high_msg.n       , 4) ||,
             d2c(sq._hdr_num_msg.n        , 4) ||,
             d2c(sq._hdr_reserved_1.n     , 2) ||,
             d2c(sq._hdr_len.n            , 2))   ||,
     left(sq._hdr_base.n, 80, '0'x)               ||,
     reverse(d2c(sq._hdr_sz_sqhdr.n       , 2) ||,
             d2c(sq._hdr_keep_days.n      , 2) ||,
             d2c(sq._hdr_max_msg.n        , 4) ||,
             d2c(sq._hdr_end_frame.n      , 4) ||,
             d2c(sq._hdr_last_free_frame.n, 4) ||,
             d2c(sq._hdr_free_frame.n     , 4) ||,
             d2c(sq._hdr_last_frame.n     , 4) ||,
             d2c(sq._hdr_begin_frame.n    , 4))   ||,
     left(sq._hdr_reserved_2.n, 124, '0'x) ,1) > 0
  then sq._result = -1

return sq._result

/************************************************************************/

sq_open_area: procedure expose sq. msg.

arg n, root, a_format, open_cmd, zone

actdir     = directory()
sq._result = 0

root_path = strip(filespec('d', root) || filespec('p', root), 't', '\')
if right(root_path, 1) = ':'
  then root_path = root_path'\'
root_path = translate(strip(directory(root_path), 't', '\'))

select
  when root_path = '' | \datatype(n, 'w') | n < 0 |,
       (zone <> '' & (\datatype(zone, 'w') | zone < 1))
    then sq._result = -99
  when wordpos(root, sq._open_roots) > 0
    then sq._result = -97
  when wordpos(n, sq._open_areas) > 0
    then sq._result = -98
  otherwise
    if zone = ''
      then sq._def_zone.n = sq._def_zone
      else sq._def_zone.n = zone
    sq._root.n          = root_path'\'filespec('n', root)
    sq._msg_current.n   = 0
    sq._msg_last.n      = 0
    if a_format = '$'
      then call sq_open_area_sq
      else call sq_open_area_sdm
end
call directory actdir

return sq._result



sq_open_area_sq:

sq._root_sqd.n      = sq._root.n'.SQD'
sq._root_sqi.n      = sq._root.n'.SQI'
sq._format.n        = '$'

if open_cmd = 'C'             /* Area neu erstellen */
  then
  do
    res = sysfiledelete(sq._root_sqd.n)
    select
      when res = 32 | res = 5
        then res = -1      /* Zugriff verweigert */
      when res > 2
        then res = 0       /* Fehler */
      otherwise
        call sq_open_area_sq_1
    end
  end
  else
  do
    size = stream(sq._root_sqd.n, 'c', 'query size')
    select
      when open_cmd = 'N' & size = ''  /* Area erstellen, wenn nicht vorhanden */
        then call sq_open_area_sq_1
      when size = ''
        then res = 0             /* Fehler, Area nicht vorhanden */
      otherwise                       /* Area ffnen, wenn vorhanden */
        parse value stream(sq._root_sqd.n, 'c', 'open') with ':'res
        select
          when res = ''
            then res = 2            /* Area geffnet */
          when res = 32 | res = 5
            then res = -1           /* Zugriff verweigert */
          otherwise
            res = 0                 /* Fehler */
        end
    end
  end

        /* Status RES: -1 = Zugriff verweigert
                        0 = Fehler
                        1 = Area erstellt
                        2 = geffnet */

select
  when res = -1             /* Zugriff verweigert */
    then sq._result = -4
  when res = 0              /* Fehler beim ffnen */
    then sq._result = -1
  when res = 1              /* File neu erstellt */
    then
    do
      sq._hdr_len.n             = 256    /* Lnge des Headers */
      sq._hdr_reserved_1.n      = 0
      sq._hdr_num_msg.n         = 0
      sq._hdr_high_msg.n        = 0
      sq._hdr_skip_msg.n        = 0
      sq._hdr_high_water.n      = 0
      sq._hdr_uid.n             = 1
      sq._hdr_base.n            = copies('0'x, 80)
      sq._hdr_begin_frame.n     = 0
      sq._hdr_last_frame.n      = 0
      sq._hdr_free_frame.n      = 0
      sq._hdr_last_free_frame.n = 0
      sq._hdr_end_frame.n       = sq._hdr_len.n
      sq._hdr_max_msg.n         = 0
      sq._hdr_keep_days.n       = 0
      sq._hdr_sz_sqhdr.n        = 28
      sq._hdr_reserved_2.n      = copies('0'x, 124)

      if sq_write_header() <> 0
        then sq._result = -1
        else
        do
          call sysfiledelete sq._root_sqi.n
          sq._area_idx.n = ''
          sq._modified.n = 1
          sq._open_areas = sq._open_areas n
          sq._open_roots = sq._open_roots sq._root.n
        end
    end
  otherwise

    parse value charin(sq._root_sqd.n,, 256) with,
                       data1           +24,
                       sq._hdr_base.n  +80,
                       data2           +28,
                       sq._hdr_reserved_2.n
    parse value reverse(data1) with,
                       sq._hdr_uid.n             +4,
                       sq._hdr_high_water.n      +4,
                       sq._hdr_skip_msg.n        +4,
                       sq._hdr_high_msg.n        +4,
                       sq._hdr_num_msg.n         +4,
                       sq._hdr_reserved_1.n      +2,
                       sq._hdr_len.n             +2
    parse value reverse(data2) with,
                       sq._hdr_sz_sqhdr.n        +2,
                       sq._hdr_keep_days.n       +2,
                       sq._hdr_max_msg.n         +4,
                       sq._hdr_end_frame.n       +4,
                       sq._hdr_last_free_frame.n +4,
                       sq._hdr_free_frame.n      +4,
                       sq._hdr_last_frame.n      +4,
                       sq._hdr_begin_frame.n     +4

    sq._hdr_len.n             = c2d(sq._hdr_len.n)
    sq._hdr_reserved_1.n      = c2d(sq._hdr_reserved_1.n)
    sq._hdr_num_msg.n         = c2d(sq._hdr_num_msg.n)
    sq._hdr_high_msg.n        = c2d(sq._hdr_high_msg.n)
    sq._hdr_skip_msg.n        = c2d(sq._hdr_skip_msg.n)
    sq._hdr_high_water.n      = c2d(sq._hdr_high_water.n)
    sq._hdr_uid.n             = c2d(sq._hdr_uid.n)

    sq._hdr_begin_frame.n     = c2d(sq._hdr_begin_frame.n)
    sq._hdr_last_frame.n      = c2d(sq._hdr_last_frame.n)
    sq._hdr_free_frame.n      = c2d(sq._hdr_free_frame.n)
    sq._hdr_last_free_frame.n = c2d(sq._hdr_last_free_frame.n)
    sq._hdr_end_frame.n       = c2d(sq._hdr_end_frame.n)
    sq._hdr_max_msg.n         = c2d(sq._hdr_max_msg.n)
    sq._hdr_keep_days.n       = c2d(sq._hdr_keep_days.n)
    sq._hdr_sz_sqhdr.n        = c2d(sq._hdr_sz_sqhdr.n)

    select
      when sq._hdr_num_msg.n <> sq._hdr_high_msg.n |,
           stream(sq._root_sqd.n, 'c', 'query size') <> sq._hdr_end_frame.n |,
           length(sq._hdr_reserved_2.n) < 124
        then
        do
          call stream sq._root_sqd.n, 'c', 'close'
          sq._result = -10
        end
      when sq_open_area_read_sqi() <> 0
        then call stream sq._root_sqd.n, 'c', 'close'
      otherwise
        sq._modified.n = 0
        sq._open_areas = sq._open_areas n
        sq._open_roots = sq._open_roots sq._root.n
    end
end

return



sq_open_area_sq_1:
if stream(sq._root_sqd.n, 'c', 'open') = 'READY:' &,
   charout(sq._root_sqd.n, '0'x) = 0
  then
  do
    call stream sq._root_sqd.n, 'c', 'close'
    res = (stream(sq._root_sqd.n, 'c', 'open') = 'READY:')
  end
  else res = 0
return


sq_open_area_read_sqi:

select
  when sq._hdr_num_msg.n = 0      /* SQI braucht nicht eingelesen werden */
    then sq._area_idx.n = ''
  when stream(sq._root_sqi.n, 'c', 'open read') <> 'READY:'
    then sq._result = -2          /* Fehler beim ffnen von SQI */
  otherwise
    req_sqi = sq._hdr_num_msg.n * 12
    sq._area_idx.n = charin(sq._root_sqi.n,, req_sqi)
    call stream sq._root_sqi.n, 'c', 'close'
    s = 0
    if length(sq._area_idx.n) <> req_sqi
      then sq._result = -11
      else
      do until sq._result < 0
        s = pos('00000000'x'ffffffff'x, sq._area_idx.n, s +1) -1
        select
          when s >= 0
            then if s // 12 = 0   /* Invalid Frames in SQI */
              then sq._result = -11
          when c2d(reverse(left(sq._area_idx.n, 4))) <> sq._hdr_begin_frame.n |,
               c2d(reverse(substr(sq._area_idx.n, req_sqi -11, 4))) <> sq._hdr_last_frame.n |,
               c2d(reverse(substr(sq._area_idx.n, req_sqi  -7, 4))) >= sq._hdr_uid.n
            then sq._result = -11
          otherwise
            leave
        end
      end
end
return sq._result



sq_open_area_sdm:

sq._format.n  = ''
select
  when open_cmd = 'C'    /* Area neu erstellen */
    then call sq_open_area_sdm_1

  when open_cmd <> 'N'   /* Area ffnen, wenn vorhanden */
    then sq._result = (directory(sq._root.n) = '')

  when directory(sq._root.n) = ''
                /* Area erstellen, wenn nicht vorhanden */
    then call sq_open_area_sdm_1
  otherwise
end
if sq._result = 0
  then
  do
    call sysfiletree '*.MSG', 'data', 'fo'
    z = 0
    do y = 1 to data.0
      parse upper value filespec('n', data.y) with uid'.MSG'
      if datatype('0'uid, 'w') & uid > 0
        then
        do
          z = z +1
          sq._sdm_idx.n.z = uid
        end
    end
    sq._sdm_idx.n.0 = z
    sq._sdm_sort.n  = 0
    sq._sdm_high.n  = 0
    do y = 1 to sq._sdm_idx.n.0
      if sq._sdm_idx.n.y > sq._sdm_high.n
        then sq._sdm_high.n = sq._sdm_idx.n.y
    end
    sq._open_areas = sq._open_areas n
    sq._open_roots = sq._open_roots sq._root.n
  end

sq._result = sq._result * -3

return sq._result


sq_open_area_sdm_1:
if sysmkdir(sq._root.n) = 0
  then sq._result = (directory(sq._root.n) = '')
  else sq._result = 1
return

/************************************************************************/

sq_area_valid: procedure expose sq. msg.

arg root, a_format

select
  when root = ''
    then sq._result = -99
  when a_format <> '$'    /* *.MSG-Area testen */
    then
    do
      actdir = directory()
      if directory(root) = ''
        then sq._result = -3
        else sq._result = 0
      call directory actdir
    end
                          /* Squish-Area testen */
  when stream(root'.SQD', 'c', 'query exists') = ''
    then sq._result = -1
  when stream(root'.SQI', 'c', 'query exists') = ''
    then sq._result = -2
  otherwise
    sq._result = 0
end

return sq._result

/************************************************************************/

sq_sort_sdm_idx:

if \sq._sdm_sort.n
  then
  do
    call sq_sort_sdm_idx_r 1, sq._sdm_idx.n.0
    sq._sdm_sort.n = 1
  end
return


sq_sort_sdm_idx_r: procedure expose n sq.

arg lf, re
if re -lf < 9
  then
  do lf = lf to re -1
    m = lf
    do j = lf +1 to re
      if sq._sdm_idx.n.j < sq._sdm_idx.n.m
        then m = j
    end
    t = sq._sdm_idx.n.m; sq._sdm_idx.n.m = sq._sdm_idx.n.lf; sq._sdm_idx.n.lf = t
  end
  else
  do
    i = (re + lf) %2
    call sq_sort_sdm_idx_r lf, i
    call sq_sort_sdm_idx_r i +1, re
    p  = i +1
    do r = lf to i
      hp.r = sq._sdm_idx.n.r
    end

    do r = lf to re while lf <= i
      select
        when p > re
          then
          do r = r to re
            sq._sdm_idx.n.r = hp.lf
            lf = lf +1
          end
        when hp.lf < sq._sdm_idx.n.p
          then
          do
            sq._sdm_idx.n.r = hp.lf
            lf = lf +1
          end
        otherwise
          sq._sdm_idx.n.r = sq._sdm_idx.n.p
          p = p +1
      end
    end
  end

return

/************************************************************************/

/* Datum/Zeit in FTSC-Format wandeln */
sq_datetime2ftsc: procedure

arg dt
signal on syntax name sq_error_null

if dt = ''
  then dt = insert(' 'word(date('n'), 2)' ', delstr(date('e'), 3, 4), 2)'  'time('n')
  else
  do
    parse var dt year'/'mon'/'day'-'hr':'min':'sec
    if mon < 13
      then dt = right(day+0, 2, 0)' '||,
           word('Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec', mon)' '||,
           right(year+0, 2, 0)'  '||,
           right(hr+0, 2, 0)':'right(min+0, 2, 0)':'right(sec+0, 2, 0)
      else dt = ''
  end
return dt

/************************************************************************/

/* Datum/Zeit in Squish-Format wandeln */
sq_datetime2c: procedure

arg dt
if dt = ''
  then dt = date('o')'-'time('n')
parse var dt year'/'mon'/'day'-'hr':'min':'sec
signal on syntax name sq_error_null
select
  when year > 99
    then year = year -1980
  when year >= 80
    then year = year - 80
  otherwise
    year = year +20
end
dt = d2c(sec %2 + min *32 + hr *2048, 2) || d2c(day + mon *32 + year *512, 2)
return dt

/************************************************************************/

/* Squish-Format in lesbares Format wandeln */
sq_c2datetime: procedure

parse arg tm +2 dt

dt = c2d(dt) % 512 +1980                        || '/' || ,
     right(c2d(bitand(dt, '01e0'x)) % 32, 2, 0) || '/' || ,
     right(c2d(bitand(dt, '001f'x))     , 2, 0) || '-' || ,
     right(c2d(tm) % 2048               , 2, 0) || ':' || ,
     right(c2d(bitand(tm, '07e0'x)) % 32, 2, 0) || ':' || ,
     right(c2d(bitand(tm, '001f'x)) *2  , 2, 0)

return dt

/************************************************************************/

/* HASH */

sq_str_hash: procedure

arg str, flag
str = translate(str, xrange('a', 'z'), xrange('A', 'Z'))
hash = '00000000'x
do y = 1 to length(str)
  hash = d2c(x2d(substr(c2x(hash), 2)'0') + c2d(substr(str, y, 1)), 4)
  g = bitand(hash, 'f0000000'x)
  if g <> '00000000'x
    then hash = bitor('000000'x || left(g ,1), bitor(g, hash))
end
if flag > 0
  then hash =  bitor(hash, '80000000'x)
  else hash = bitand(hash, '7fffffff'x)

return hash

/************************************************************************/

sq_error_20:
sq._result = -20
return sq._result

sq_error_1:
sq._result = -1
return sq._result

sq_error_null:
return ''

/************************************************************************/

